Package: RImmPort
Type: Package
Title: RImmPort: Enabling Ready-for-analysis Immunology Research Data
Version: 1.39.0
Author: Ravi Shankar <rshankar@stanford.edu>
Maintainer: Zicheng Hu <Zicheng.Hu@ucsf.edu>, Ravi Shankar <rshankar@stanford.edu>
URL: http://bioconductor.org/packages/RImmPort/
Description: The RImmPort package simplifies access to ImmPort data for
    analysis in the R environment. It provides a standards-based
    interface to the ImmPort study data that is in a proprietary
    format.
License: GPL-3
Imports: plyr, dplyr, DBI, data.table, reshape2, methods, sqldf, tools,
        utils, RSQLite
Suggests: knitr
biocViews: BiomedicalInformatics, DataImport, DataRepresentation
VignetteBuilder: knitr
RoxygenNote: 5.0.1
NeedsCompilation: no
git_url: https://git.bioconductor.org/packages/RImmPort
git_branch: devel
git_last_commit: 61765d4
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-30
Packaged: 2025-10-30 22:42:00 UTC; biocbuild

#' Substance Use Domain
#' 
#' @name Substance Use Domain
#' @description The Substance Use data of an ImmPort study is reformated to the CDISC SDTM Substance Use (SU) 
#' domain model, and is a list of 2 data frames containing 1) Substance Use data \code{\link{SU}} 
#' and 2) any supplemental Substance Use data \code{\link{SUPP}}
NULL
#> NULL 

# call to globalVariables to prevent from generating NOTE: no visible binding for global variable <variable name>
# this hack is to satisfy CRAN (http://stackoverflow.com/questions/9439256/how-can-i-handle-r-cmd-check-no-visible-binding-for-global-variable-notes-when)
globalVariables(c("SUSEQ"))

# Get Substance Use data of a specific study
# 
# The function \code{getSubstanceUse} queries the ImmPort database for getSubstanceUse data and 
# reformats it to the CDISC SDTM Substance Use (SU) domain model 
# 
# @param data_src A connection handle to ImmPort (MySQL or SQLite) database instance or 
# a directory handle to folder where study RDS files are located
# @param study_id Identifier of a specific study
# @return a list of 2 data frames containing 1) Substance Use data \code{\link{SU}} and 2) any supplemental 
#   Substance Use data \code{\link{SUPP}}
# @examples
# \dontrun{
#   getSubstanceUse(data_src, "SDY1")
# }
#' @importFrom DBI dbGetQuery
#' @importFrom data.table as.data.table is.data.table .N :=
getSubstanceUse <- function(data_src, study_id) {
    cat("loading Substance Use data....")

    su_cols <- c("STUDYID", "DOMAIN", "USUBJID", "SUSEQ", "SUTRT", "SUCAT", "SUDOSE", "SUDOSTXT", "SUDOSU", 
                "SUDOSFREQ", "SUROUTE", "SUSTDTC", "SUENDTC", "SUSTDY", "SUENDY")
  
  
    sql_stmt <- paste("SELECT distinct
                        sub.study_accession,
                        \"SU\" as domain,
                        sub.subject_accession,
                        cast(0 as UNSIGNED INTEGER) as seq,
                        sub.compound_name_reported,
                        sub.name_reported,
                        sub.dose,
                        sub.dose_reported,
                        sub.dose_units,
                        sub.dose_freq_per_interval, 
                        sub.route_of_admin_reported,
                        sub.start_time,
                        sub.end_time,
                        sub.start_day,                   
                        sub.end_day
                      FROM  intervention sub
                      WHERE sub.study_accession in ('", study_id, "') AND 
                        sub.compound_role='Substance Use'
                      ORDER BY sub.subject_accession", sep = "")
    
    if ((class(data_src)[1] == 'MySQLConnection') || 
        (class(data_src)[1] == 'SQLiteConnection')) {
      su_df <- dbGetQuery(data_src, statement = sql_stmt)
      colnames(su_df) <- su_cols
      suppsu_df <- data.frame()
      if (nrow(su_df) > 0) {
        su_df <- transform(su_df, SUSEQ = as.integer(SUSEQ))
        su_dt <- as.data.table(su_df)
        if (is.data.table(su_dt) == TRUE) {
          su_dt[, `:=`(SUSEQ, seq_len(.N)), by = "USUBJID"]
        }
        su_df <- as.data.frame(su_dt)
      }
    } else {
      l <- loadSerializedStudyData(data_src, study_id, "Substance Use")
      su_df <- l[[1]]
      suppsu_df <- l[[2]]
    }

    cat("done", "\n")  
    
    su_l <- list()
    if (nrow(su_df) > 0)
      su_l <- list(su_df=su_df, suppsu_df=suppsu_df)
    
    su_l
}

# Get count of Substance Use data of a specific study
# 
# The function \code{getCountOfSubstanceUse} queries the ImmPort database for count 
# of Substance Use data 
# 
# @param conn A connection handle to ImmPort database instance
# @param study_id Identifier of a specific study
# @return a count of Substance Use data 
# @examples
# \dontrun{
#   # get count of study SDY1's Substance Use data
#   count <- getCountOfSubstanceUse(conn, "SDY1")
# }
getCountOfSubstanceUse <- function(conn, study_id) {
    sql_stmt <- paste("SELECT count(*)
                      FROM  intervention sub
                      WHERE sub.study_accession in ('", study_id, "') AND 
                        sub.compound_role='Substance Use'", sep = "")
    
    count <- dbGetQuery(conn, statement = sql_stmt)
    
    count[1, 1]
} 

##' Substance Use Domain Variables
##' @name SU
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name  } \tab \strong{Variable Label} \cr
##'     STUDYID \tab Study Identifier \cr
##'     DOMAIN  \tab Domain Abbreviation \cr
##'     USUBJID \tab Unique Subject Identifier \cr
##'     SUSEQ \tab Sequence Number \cr
##'     SUTRT \tab Reported Name of Substance \cr
##'     SUCAT \tab Category of Substance Use \cr
##'     SUDOSE \tab Substance Use Consumption \cr
##'     SUDOSTXT \tab Substance Use Consumption Text \cr
##'     SUDOSU \tab Consumption Units \cr
##'     SUDOSFRQ \tab Use Frequency per Interval \cr
##'     SUROUTE \tab Route of Administration \cr
##'     SUSTDTC \tab Start Date/Time of Substance Use \cr
##'     SUENDTC \tab End Date/Time of Substance Use \cr
##'     SUSTDY \tab Study Day of Start of Substance Use \cr
##'     SUENDY \tab Study Day of End of Substance Use
##'   }
##' }
NULL
#> NULL 

#' Nucleic Acid Quantification Domain
#' 
#' @name Nucleic Acid Quantification Domain
#' @description The ImmPort study data generated from assays of types: PCR are grouped into the 
#' Nucleic Acid Quantification Domain. The data is reformated to a custom Nucleic Acid Quantification domain model in 
#' CDISC SDTM standards, and is a list of 2 data frames containing 1) Nucleic Acid Quantification data \code{\link{ZC}} and 2) any supplemental 
#'   Nucleic Acid Quantification data \code{\link{SUPP}}
NULL
#> NULL 

# call to globalVariables to prevent from generating NOTE: no visible binding for global variable <variable name>
# this hack is to satisfy CRAN (http://stackoverflow.com/questions/9439256/how-can-i-handle-r-cmd-check-no-visible-binding-for-global-variable-notes-when)
globalVariables(c("subject_id", "experiment_title", "assay_purpose", "measurement_technique",
                  "entrez_gene_id", "gene_name", "gene_symbol_preferred","gene_symbol_reported",
                  "value_reported", "unit_reported", "specimen_type",
                  "specimen_subtype", "specimen_treatment", 
                  "treatment_amount_value", "treatment_amount_unit",
                  "treatment_duration_value", "treatment_duration_unit",
                  "treatment_temperature_value", "treatment_temperature_unit",
                  "visit_name", "visit_min_start_day", "visit_max_start_day", "visit_order",
                  "elapsed_time_of_specimen_collection", "time_point_reference",
                  "biosample_accession", "experiment_sample_accession", "ZCSPECSB", "ZCREFIDP",
                  "VISITMIN", "VISITMAX",
                  "ZCSPTRT", 
                  "ZCTRTAMV", "ZCTRTAMU",
                  "ZCTRTDUV", "ZCTRTDUU",
                  "ZCTRTTMV", "ZCTRTTMU"))

## Get Nucleic Acid Quantification data of a specific study
## 
## The function \code{getNucleicAcidQuantification} queries the ImmPort database for Nucleic Acid Quantification data and 
## reformats it to a custom Nucleic Acid Quantification domain model in CDISC SDTM standards. 
## 
## @param data_src A data_srcection handle to ImmPort (MySQL or SQLite) database instance or 
## a directory handle to folder where study RDS files are located
## @param assay_type Assay Type **optional**
## @param study_id Identifier of a specific study
## @return a list of 2 data frames containing 1) Nucleic Acid Quantification data \code{\link{ZC}} and 2) any supplemental 
##   Nucleic Acid Quantification data \code{\link{SUPP}}
## @examples
## \dontrun{
##   # get all of study SDY1's Nucleic Acid Quantification data
##   nq_l <- getNucleicAcidQuantification(data_src, "SDY1")
##   
##   # get study SDY1's Nucleic Acid Quantification data that was generated using PCR technnology
##   nq_l <- getNucleicAcidQuantification(data_src, "SDY1", "PCR")
## }
##' @importFrom dplyr select
##' @importFrom plyr rename
getNucleicAcidQuantification <- function(data_src, study_id, assay_type="ALL") {
  cat("loading Nucleic Acid Quantification data....")

  nq_cols <- c("STUDYID", "DOMAIN", "USUBJID", "ZCSEQ", 
               "ZCTEST", "ZCCAT", "ZCMETHOD", 
               "ZCENTRZD", "ZCGENNAM", "ZCGENSYM",
               "ZCORRES", "ZCORRESU", 
               "ZCSPEC", "ZCREFID", 
               "VISITNUM", "VISIT", "ZCELTM", "ZCTPTREF")
  
  suppnq_cols <- c("STUDYID", "RDOMAIN", "USUBJID", "IDVAR", "IDVARVAL", "QNAM", "QLABEL", "QVAL")
  
  nq_df = data.frame()
  suppnq_df = data.frame()
  
  if ((class(data_src)[1] == 'MySQLConnection') || 
      (class(data_src)[1] == 'SQLiteConnection')) {
    if ((assay_type == "ALL") || (assay_type =="PCR")) {
      
      # get PCR results

    #   pcr_column_names <- c("study_id", "subject_id", "result_id",
    #                         "entrez_gene_id", "gene_name", "gene_symbol", 
    #                         "value_reported", "unit_reported",
    #                         "experiment_title", "assay_purpose", "measurement_technique",
    #                         "biosample_accession", "specimen_type", "specimen_subtype",
    #                         "visit_name", "elapsed_time_of_specimen_collection", "time_point_reference",
    #                         "study_time_t0_event", "study_time_t0_event_specify")
      
      pcr_df <- getPcrResults(data_src, study_id, "")
      if (nrow(pcr_df) > 0) {
        pcr_df <- select(pcr_df, STUDYID = study_id, USUBJID = subject_id, ZCSEQ = sequence, ZCTEST = experiment_title, 
                         ZCCAT = assay_purpose, ZCMETHOD = measurement_technique, 
                         ZCENTRZD = entrez_gene_id, ZCGENNAM = gene_name, ZCGENSYM = gene_symbol_preferred,
                         ZCORRES = value_reported, ZCORRESU = unit_reported,
                         ZCSPEC = specimen_type, ZCSPECSB = specimen_subtype,
                         ZCSPTRT = specimen_treatment, 
                         ZCTRTAMV = treatment_amount_value, ZCTRTAMU = treatment_amount_unit,
                         ZCTRTDUV = treatment_duration_value, ZCTRTDUU = treatment_duration_unit,
                         ZCTRTTMV = treatment_temperature_value, ZCTRTTMU = treatment_temperature_unit,
                         VISIT = visit_name, VISITNUM = visit_order,  VISITMIN = visit_min_start_day, VISITMAX = visit_max_start_day, 
                         ZCELTM = elapsed_time_of_specimen_collection, 
                         ZCTPTREF = time_point_reference, ZCREFID = experiment_sample_accession, ZCREFIDP = biosample_accession) 
        
        pcr_df$DOMAIN <- "ZC"
        
        qnam_values = c("ZCSPECSB", "ZCREFIDP",
                        "VISITMIN", "VISITMAX",
                        "ZCSPTRT", 
                        "ZCTRTAMV", "ZCTRTAMU",
                        "ZCTRTDUV", "ZCTRTDUU",
                        "ZCTRTTMV", "ZCTRTTMU")
        qlabel_values= c("Specimen Subtype", "Source Specimen Identifier",
                         "Planned Visit Minimum Start Day", "Planned Visit Maximum Start Day",
                         "Specimen Treatment", 
                         "Specimen Treatment Amount Value", "Specimen Treatment Amount Unit",
                         "Specimen Treatment Duration Value", "Specimen Treatment Duration Unit", 
                         "Specimen Treatment Temperature Value", "Specimen Treatment Temperature Unit")

        supppcr_df <- melt(pcr_df, 
                           id = c("STUDYID", "DOMAIN", "USUBJID", "ZCSEQ"), 
                           measure = qnam_values, 
                           variable.name = "QNAM", 
                           value.name = "QVAL")
        
        supppcr_df <- transform(supppcr_df, QLABEL = unlist(qlabel_values[QNAM]))
        supppcr_df <- plyr::rename(supppcr_df, c("DOMAIN" = "RDOMAIN", "ZCSEQ" = "IDVARVAL"))
        supppcr_df$IDVAR <- "ZCSEQ"
        
        
        supppcr_df <- supppcr_df[suppnq_cols]
        
        # remove rows that have empty QVAL values
        supppcr_df <- subset(supppcr_df,QVAL!="")      
        
        pcr_df <- subset(pcr_df, select = -c(ZCSPECSB, ZCREFIDP, ZCSPTRT, 
                                             VISITMIN, VISITMAX,
                                             ZCTRTAMV, ZCTRTAMU,
                                             ZCTRTDUV, ZCTRTDUU,
                                             ZCTRTTMV, ZCTRTTMU))
        
        pcr_df <- pcr_df[, nq_cols]
        
        nq_df <- rbind(nq_df, pcr_df)
        suppnq_df <- rbind(suppnq_df, supppcr_df)
        
      }
    }
  } else {
    l <- loadSerializedStudyData(data_src, study_id, "Nucleic Acid Quantification")
    if (assay_type == "ALL") {
      nq_df <- l[[1]]
      suppnq_df <- l[[2]]
    } else {
      
    }
  }   
  
  cat("done", "\n")

  nq_l <- list()
  if (nrow(nq_df) > 0)
    nq_l <- list(zc_df=nq_df, suppzc_df=suppnq_df)
  
  nq_l
} 

## Get count of Nucleic Acid Quantification data of a specific study
## 
## The function \code{getCountOfNucleicAcidQuantification} queries the ImmPort database for count 
## of Nucleic Acid Quantification data 
## 
## @param data_src A connection handle to ImmPort database instance
## @param assay_type Assay Type **optional**
## @param study_id Identifier of a specific study
## @return a count of Nucleic Acid Quantification data 
## @examples
## \dontrun{
##   # get count of all of study SDY1's Nucleic Acid Quantification data
##   count <- getCountOfNucleicAcidQuantification(data_src, "SDY1")
##   
##   # get count of study SDY1's Nucleic Acid Quantification data that was generated using PCR assay
##   count <- getCountOfNucleicAcidQuantification(data_src, "SDY1", "PCR")
## }
getCountOfNucleicAcidQuantification <- function(data_src, study_id, assay_type="ALL") {
  count <- 0
  if ((assay_type == "ALL") || (assay_type =="PCR")) 
    count <- count + getCountOfPcrResults(data_src, study_id)
  
  count
}

##' Nucleic Acid Quantification Domain Variables
##' @name ZC
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name  } \tab \strong{Variable Label} \cr
##'     STUDYID \tab Study Identifier \cr
##'     DOMAIN  \tab Domain Abbreviation \cr
##'     USUBJID \tab Unique Subject Identifier \cr
##'     ZCSEQ \tab Sequence Number \cr
##'     ZCTEST \tab Nucleic Acid Quantification Test Name \cr
##'     ZCCAT \tab Category for Nucleic Acid Quantification \cr
##'     ZCMETHOD \tab Measurement Technique \cr
##'     ZCENTRZD \tab Entrez Gene ID \cr
##'     ZCGENNAM \tab Gene Name \cr
##'     ZCGENSYM \tab Gene Symbol \cr
##'     ZCORRES \tab Result or Finding in Original Units \cr
##'     ZCORRESU \tab Original Units \cr
##'     ZCSPEC \tab Specimen Type \cr
##'     ZCREFID \tab Specimen Identifier \cr
##'     VISITNUM \tab Visit Number \cr
##'     VISIT \tab Visit Name \cr
##'     ZCELTM \tab Planned Elapsed Time from Time Point Ref \cr
##'     ZCTPTREF \tab Time Point Reference
##'   }
##' }
NULL
#> NULL 

##' Nucleic Acid Quantification Domain Supplemental Variables
##' @name SUPPZC
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name} \tab \strong{Variable Label} \cr
##'     STUDYID \tab Study Identifier \cr
##'     RDOMAIN  \tab Related Domain Abbreviation \cr
##'     USUBJID \tab Unique Subject Identifier \cr
##'     IDVAR \tab Identifying Variable \cr
##'     IDVARVAL \tab Identifying Variable Value \cr
##'     QNAM \tab Qualifier Variable Name \cr
##'     QLABEL \tab Qualifier Variable Label \cr
##'     QVAL \tab Data Value
##'   }
##' }
##' @note The following table enumerates the values in QNAM and QLABEL variables {
##'   \tabular{ll}{
##'     \strong{QNAM} \tab \strong{QLABEL} \cr
##'     ZCSPECSB \tab Specimen Subtype \cr
##'     ZCREFIDP \tab Source Specimen Identifier \cr
##'     VISITMIN \tab Planned Visit Minimum Start Day \cr
##'     VISITMAX \tab Planned Visit Maximum Start Day \cr
##'     ZCSPTRT \tab Specimen Treatment \cr
##'     ZCTRTAMV \tab Specimen Treatment Amount Value \cr
##'     ZCTRTAMU \tab Specimen Treatment Amount Unit \cr
##'     ZCTRTDUV \tab Specimen Treatment Duration Value \cr
##'     ZCTRTDUU \tab Specimen Treatment Duration Unit \cr
##'     ZCTRTTMV \tab Specimen Treatment Temperature Value \cr
##'     ZCTRTTMU \tab Specimen Treatment Temperature Unit
##'   }
##' }
NULL
#> NULL

#' RImmPort: Enabling ready-for-analysis immunology research data
#'
#' The `RImmPort` package simplifies access to ImmPort data for analysis, 
#' as the name implies, in the R statistical environment. It provides a 
#' standards-based interface to the ImmPort study data that is in a proprietary format.
#' 
#' @docType package
#' @name RImmPort
NULL
# > NULL 

#' Adverse Events Domain
#' 
#' @name Adverse Events Domain
#' @description The Adverse Events data of an ImmPort study is reformated to the CDISC SDTM Adverse 
#' Events (AE) domain model, and is a list of 2 data frames containing 1) Adverse Events data \code{\link{AE}} 
#' and 2) any supplemental Adverse Events data \code{\link{SUPP}}
NULL
#> NULL 


# call to globalVariables to prevent from generating NOTE: no visible binding for global variable <variable name>
# this hack is to satisfy CRAN (http://stackoverflow.com/questions/9439256/how-can-i-handle-r-cmd-check-no-visible-binding-for-global-variable-notes-when)
globalVariables(c("AESEQ"))

# Get Adverse Events data of a specific study
# 
# The function \code{getAdverseEvents} queries the ImmPort database for Adverse Events data and 
# reformats it to the CDISC SDTM Adverse Events (AE) domain model 
# 
# @param data_src A connection handle to ImmPort (MySQL or SQLite) database instance or 
# a directory handle to folder where study RDS files are located
# @param study_id Identifier of a specific study
# @return a list of 2 data frames containing 1) Adverse Events data \code{\link{AE}} and 2) any supplemental 
#   Adverse Events data \code{\link{SUPP}}
# @examples
# \dontrun{
#   getAdverseEvents(data_src, "SDY1")
# }
#' @importFrom DBI dbGetQuery
#' @importFrom data.table as.data.table is.data.table .N :=
getAdverseEvents <- function(data_src, study_id) {
    cat("loading Adverse Events data....")

    ae_cols <- c("STUDYID", "DOMAIN", "USUBJID", "AESEQ", "AESPID", "AETERM", "AEMODIFY", "AEBODYSYS", "AELOC", "AESEV", 
                "AEACN", "AEACNOTH", "AEREL", "AERELNST", "AEOUT", "AESTDY", "AEENDY")
  
    sql_stmt <- paste("SELECT distinct ae.study_accession,
                        \"AE\" as domain,                    
                        ae.subject_accession,                    
                        cast(0 as UNSIGNED INTEGER) as seq,
                        ae.adverse_event_accession,                    
                        ae.name_reported,                    
                        ae.name_preferred,                    
                        ae.organ_or_body_system_reported,                    
                        ae.location_of_reaction_reported,                    
                        ae.severity_reported,                    
                        ae.study_treatment_action_taken,                    
                        ae.other_action_taken,                    
                        ae.relation_to_study_treatment,                    
                        ae.relation_to_nonstudy_treatment,                    
                        ae.outcome_reported,                    
                        ae.start_study_day,                    
                        ae.end_study_day                    
                      FROM adverse_event ae                    
                      WHERE ae.study_accession in ('", study_id, "')                    
                      ORDER BY ae.subject_accession", sep = "")
    
    if ((class(data_src)[1] == 'MySQLConnection') || 
        (class(data_src)[1] == 'SQLiteConnection')) {
      ae_df <- dbGetQuery(data_src, statement = sql_stmt)
      colnames(ae_df) <- ae_cols
      suppae_df <- data.frame()
      if (nrow(ae_df) > 0) {
        ae_df <- transform(ae_df, AESEQ = as.integer(AESEQ))
        ae_dt <- as.data.table(ae_df)
        if (is.data.table(ae_dt) == TRUE) ae_dt[, `:=`(AESEQ, seq_len(.N)), by = "USUBJID"]
    
        ae_df <- as.data.frame(ae_dt)
      }
    } else {
      l <- loadSerializedStudyData(data_src, study_id, "Adverse Events")
      ae_df <- l[[1]]
      suppae_df <- l[[2]]
    }
        

    cat("done", "\n")
    
    ae_l <- list()
    if (nrow(ae_df) > 0)
      ae_l <- list(ae_df=ae_df, suppae_df=suppae_df)
    
    ae_l
}

# Get count of Adverse Events data of a specific study
# 
# The function \code{getCountOfAdverseEvents} queries the ImmPort database for count 
# of Adverse Events data 
# 
# @param conn A connection handle to ImmPort database instance
# @param study_id Identifier of a specific study
# @return a count of Adverse Events data 
# @examples
# \dontrun{
#   # get count of study SDY1's Adverse Events data
#   count <- getCountOfAdverseEvents(conn, "SDY1")
# }
getCountOfAdverseEvents <- function(conn, study_id) {
    sql_stmt <- paste("SELECT count(*)
                      FROM adverse_event ae
                      WHERE ae.study_accession in ('", study_id, "')", sep = "")
    
    count <- dbGetQuery(conn, statement = sql_stmt)
    
    count[1, 1]
} 

##' Adverse Events Domain Variables
##' @name AE
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name  } \tab \strong{Variable Label} \cr
##'     STUDYID \tab Study Identifier \cr
##'     DOMAIN  \tab Domain Abbreviation \cr
##'     USUBJID \tab Unique Subject Identifier \cr
##'     AESEQ \tab Sequence Number \cr
##'     AESPID \tab Sponsor-Defined Identifier \cr
##'     AETERM \tab Reported Term for the Adverse Event \cr
##'     AEMODIFY \tab Modified Reported Term \cr
##'     AEBODYSYS \tab Body System or Organ Class \cr
##'     AELOC \tab Location of Event \cr
##'     AESEV \tab Severity/Intensity \cr
##'     AEACN \tab Action Taken with Study Treatment \cr
##'     AEACNOTH \tab Other Action Taken \cr
##'     AEREL \tab Causality \cr
##'     AERELNST \tab Relationship to Non-Study Treatment \cr
##'     AEOUT \tab Outcome of Adverse Event \cr
##'     AESTDY \tab Study Day of Start of Adverse Event \cr
##'     AEENDY \tab Study Day of End of Adverse Event
##'   }
##' }
NULL
#> NULL

#' Trial Inclusion Exclusion Criteria Domain
#' 
#' @name Trial Inclusion Exclusion Criteria Domain
#' @description The Trial Inclusion Exclusion Criteria data of an ImmPort study is reformated to the 
#' CDISC SDTM Trial Inclusion Exclusion Criteria (TI) domain model, and is a list of 2 data frames 
#' containing 1) Trial Inclusion Exclusion Criteria data \code{\link{TI}} 
#' and 2) any supplemental Trial Inclusion Exclusion Criteria data \code{\link{SUPP}}
NULL
#> NULL 

# Get Trial Inclusion Exclusion Criteria data of a specific study
# 
# The function \code{getTrialInclusionExclusionCriteria} queries the ImmPort database for Trial Inclusion Exclusion Criteria  data and 
# reformats it to the CDISC SDTM Trial Inclusion Exclusion Criteria (TI) domain model 
# 
# @param data_src A connection handle to ImmPort (MySQL or SQLite) database instance or 
# a directory handle to folder where study RDS files are located
# @param study_id Identifier of a specific study
# @return a list of 2 data frames containing 1) Trial Inclusion Exclusion Criteria data \code{\link{TI}} and 2) any supplemental 
#   Trial Inclusion Exclusion Criteria data \code{\link{SUPP}}
# @examples
# \dontrun{
#   getTrialInclusionExclusionCriteria(data_src, "SDY1")
# }
getTrialInclusionExclusionCriteria <- function(data_src, study_id) {
    cat("loading  TrialInclusionExclusionCriteria data....")
    
    ti_cols <- c("STUDYID", "DOMAIN", "IETEST", "IECAT")
  
    sql_stmt <- paste("SELECT distinct
                         ie.study_accession,
                         \"TI\" as domain,
                         ie.criterion,
                         ie.criterion_category
                       FROM inclusion_exclusion ie
                       WHERE ie.study_accession in ('", study_id, "')
                       ORDER BY ie.criterion_accession", sep = "")
    
    if ((class(data_src)[1] == 'MySQLConnection') || 
        (class(data_src)[1] == 'SQLiteConnection')) {
      ti_df <- dbGetQuery(data_src, statement = sql_stmt)
      colnames(ti_df) <- ti_cols
      suppti_df <- data.frame()
      if (nrow(ti_df) > 0) {
      
      }
    } else {
      l <- loadSerializedStudyData(data_src, study_id, "Trial Inclusion Exclusion Criteria")
      ti_df <- l[[1]]
      suppti_df <- l[[2]]
    }

    cat("done", "\n")
    
    ti_l <- list()
    if (nrow(ti_df) > 0)
      ti_l <- list(ti_df=ti_df, suppti_df=suppti_df)
    
    ti_l
}

# Get count of Trial Inclusion Exclusion Criteria data of a specific study
# 
# The function \code{getCountOfTrialInclusionExclusionCriteria} queries the ImmPort database for count 
# of Trial Inclusion Exclusion Criteria data 
# 
# @param conn A connection handle to ImmPort database instance
# @param study_id Identifier of a specific study
# @return a count of Trial Inclusion Exclusion Criteria data 
# @examples
# \dontrun{
#   # get count of study SDY1's Trial Inclusion Exclusion Criteria data
#   count <- getCountOfTrialInclusionExclusionCriteria(conn, "SDY1")
# }
getCountOfTrialInclusionExclusionCriteria <- function(conn, study_id) {
    sql_stmt <- paste("SELECT count(*)
                      FROM inclusion_exclusion ie
                      WHERE ie.study_accession in ('", study_id, "')", sep = "")
    
    count <- dbGetQuery(conn, statement = sql_stmt)
    
    count
} 

##' Trial Inclusion Exclusion Criteria Domain Variables
##' @name TI
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name  } \tab \strong{Variable Label} \cr
##'     STUDYID \tab Study Identifier \cr
##'     DOMAIN  \tab Domain Abbreviation \cr
##'     IETEST \tab Inclusion/Exclusion Criterion \cr
##'     IECAT \tab Inclusion/Exclusion Category
##'   }
##' }
NULL
#> NULL 

#' Vital Signs Domain
#' 
#' @name Vital Signs Domain
#' @description The Vital Signs data of an ImmPort study is reformated to the CDISC SDTM Vital Signs (VS) 
#' domain model, and is a list of 2 data frames containing 1) Vital Signs data \code{\link{VS}} 
#' and 2) any supplemental Vital Signs data \code{\link{SUPPVS}}
NULL
#> NULL 

# call to globalVariables to prevent from generating NOTE: no visible binding for global variable <variable name>
# this hack is to satisfy CRAN (http://stackoverflow.com/questions/9439256/how-can-i-handle-r-cmd-check-no-visible-binding-for-global-variable-notes-when)
globalVariables(c("VSSEQ", "QNAM", "QVAL", "VSTOD"))

# Get Vital Signs data of a specific study
# 
# The function \code{getVitalSigns} queries the ImmPort database for Vital Signs data and 
# reformats it to the CDISC SDTM Vital Signs (VS) domain model 
# 
# @param data_src A connection handle to ImmPort (MySQL or SQLite) database instance or 
# a directory handle to folder where study RDS files are located
# @param study_id Identifier of a specific study
# @return a list of 2 data frames containing 1) Vital Signs data \code{\link{VS}} and 2) any supplemental 
#   Vital Signs data \code{\link{SUPPVS}}
# @examples
# \dontrun{
#   getVitalSigns(data_src, "SDY1")
# }
#' @importFrom DBI dbGetQuery
#' @importFrom plyr rename
#' @importFrom data.table as.data.table is.data.table .N :=
getVitalSigns <- function(data_src, study_id) {
    cat("loading Vital Signs data....")

    vs_cols <- c("STUDYID", "DOMAIN", "USUBJID", "VSSEQ", "VSTEST", "VSCAT", "VSORRES", "VSORRESU", "VSLOC", "VSTOD", "VISITNUM", "VISIT", "VSDY")
  
    suppvs_cols <- c("STUDYID", "RDOMAIN", "USUBJID", "IDVAR", "IDVARVAL", "QNAM", "QLABEL", "QVAL")
  
    sql_stmt <- paste("SELECT distinct
                        asmp.study_accession,
                        \"VS\" as domain,
                        asmc.subject_accession,
                        cast(0 as UNSIGNED INTEGER) as seq,
                        asmc.name_reported,
                        asmp.name_reported,
                        asmc.result_value_reported,
                        asmc.result_unit_reported,
                        asmc.location_of_finding_reported,
                        asmc.time_of_day,
                        pv.order_number,
                        pv.name,
                        asmc.study_day                    
                      FROM  assessment_component asmc
                      INNER JOIN
                      assessment_panel asmp ON asmc.assessment_panel_accession=asmp.assessment_panel_accession
                      INNER JOIN
                      planned_visit pv ON asmc.planned_visit_accession=pv.planned_visit_accession
                      WHERE (asmp.study_accession in ('", study_id, "')) AND 
                        (asmp.assessment_type='Physical Exam') AND
                        ((asmc.name_reported='Heart Rate') OR 
                         (asmc.name_reported='Diastolic Blood Pressure') OR
                         (asmc.name_reported='Systolic Blood Pressure') OR
                         (asmc.name_reported='Height') OR
                         (asmc.name_reported='Weight') OR
                         (asmc.name_reported='Respiration Rate') OR
                         (asmc.name_reported='Temperature')) 
                      ORDER BY asmc.subject_accession", sep = "")
    
    if ((class(data_src)[1] == 'MySQLConnection') || 
        (class(data_src)[1] == 'SQLiteConnection')) {
      vs_df <- dbGetQuery(data_src, statement = sql_stmt)
      colnames(vs_df) <- vs_cols
      suppvs_df <- data.frame()
      
      if (nrow(vs_df) > 0) {
        vs_df <- transform(vs_df, VSSEQ = as.integer(VSSEQ))
        vs_dt <- as.data.table(vs_df)
        if (is.data.table(vs_dt) == TRUE) {
          vs_dt[, `:=`(VSSEQ, seq_len(.N)), by = "USUBJID"]
        }
        vs_df <- as.data.frame(vs_dt)
        
        qnam_values = c("VSTOD")
        qlabel_values= c("Time of Day")
        
        suppvs_df <- reshape2::melt(vs_df, id = c("STUDYID", "DOMAIN", "USUBJID", "VSSEQ"), 
                                    measure = qnam_values, 
                                    variable.name = "QNAM", 
                                    value.name = "QVAL")
        suppvs_df <- transform(suppvs_df, QLABEL = unlist(qlabel_values[QNAM]))
        suppvs_df <- plyr::rename(suppvs_df, c("DOMAIN" = "RDOMAIN", "VSSEQ" = "IDVARVAL"))
        suppvs_df$IDVAR <- "VSSEQ"
        
        suppvs_df <- suppvs_df[suppvs_cols]
        
        # remove rows that have empty QVAL values
        suppvs_df <- subset(suppvs_df,QVAL!="")      
        
        vs_df <- subset(vs_df, select = -c(VSTOD))
      }
    } else {
      l <- loadSerializedStudyData(data_src, study_id, "Vital Signs")
      vs_df <- l[[1]]
      suppvs_df <- l[[2]]
    }
    
    cat("done", "\n")
    
    vs_l <- list()
    if (nrow(vs_df) > 0)
      vs_l <- list(vs_df=vs_df, suppvs_df=suppvs_df)
    
    vs_l
}

# Get count of Vital Signs data of a specific study
# 
# The function \code{getCountOfVitalSigns} queries the ImmPort database for count 
# of Vital Signs data 
# 
# @param conn A connection handle to ImmPort database instance
# @param study_id Identifier of a specific study
# @return a count of Vital Signs data 
# @examples
# \dontrun{
#   # get count of study SDY1's Vital Signs data
#   count <- getCountOfVitalSigns(conn, "SDY1")
# }
getCountOfVitalSigns <- function(conn, study_id) {
  sql_stmt <- paste("SELECT count(*)
                      FROM  assessment_component asmc
                      INNER JOIN
                      assessment_panel asmp ON asmc.assessment_panel_accession=asmp.assessment_panel_accession
                      WHERE asmp.study_accession in ('", study_id, "') AND 
                        (asmp.assessment_type='Physical Exam') AND
                        ((asmc.name_reported='Heart Rate') OR 
                        (asmc.name_reported='Diastolic Blood Pressure') OR
                        (asmc.name_reported='Systolic Blood Pressure') OR
                        (asmc.name_reported='Height') OR
                        (asmc.name_reported='Weight') OR
                        (asmc.name_reported='Respiration Rate') OR
                        (asmc.name_reported='Temperature'))", sep = "")
                    
    count <- dbGetQuery(conn, statement = sql_stmt)
    
    count[1, 1]
} 

##' Vital Signs Domain Variables
##' @name VS
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name  } \tab \strong{Variable Label} \cr
##'     STUDYID \tab Study Identifier \cr
##'     DOMAIN  \tab Domain Abbreviation \cr
##'     USUBJID \tab Unique Subject Identifier \cr
##'     VSSEQ \tab Sequence Number \cr
##'     VSTEST \tab Vital Signs Test Name \cr
##'     VSCAT \tab Category for Vital Signs \cr
##'     VSORRES \tab Result or Finding in Original Units \cr
##'     VSORRESU \tab Original Units \cr
##'     VSLOC \tab Location of Vital Signs Measurement \cr
##'     VISITNUM \tab Visit Number \cr
##'     VISIT \tab Visit Name \cr
##'     VSDY \tab Study Day of Vital Signs
##'   }
##' }
NULL
#> NULL 

##' Vital Signs Domain Supplemental Variables
##' @name SUPPVS
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name} \tab \strong{Variable Label} \cr
##'     STUDYID \tab Study Identifier \cr
##'     RDOMAIN  \tab Related Domain Abbreviation \cr
##'     USUBJID \tab Unique Subject Identifier \cr
##'     VSSEQ \tab Sequence Number \cr
##'     IDVAR \tab Identifying Variable \cr
##'     IDVARVAL \tab Identifying Variable Value \cr
##'     QNAM \tab Qualifier Variable Name \cr
##'     QLABEL \tab Qualifier Variable Label \cr
##'     QVAL \tab Data Value
##'   }
##' }
##' @note The following table enumerates the values in QNAM and QLABEL variables {
##'   \tabular{ll}{
##'     \strong{QNAM} \tab \strong{QLABEL} \cr
##'     VSTOD \tab Time of Day \cr
##'   }
##' }
NULL
#> NULL

#' Titer Assay Results Domain
#' 
#' @name Titer Assay Results Domain
#' @description The ImmPort study data generated from assays of types: HAI and Neut Ab Titer are grouped into the 
#' Titer Assay Results Domain. The data is reformated to a custom Titer Assay Results domain model in 
#' CDISC SDTM standards, and is a list of 2 data frames containing 1) Titer Assay Results data \code{\link{ZD}} 
#' and 2) any supplemental Titer Assay Results data \code{\link{SUPP}}
NULL
#> NULL 


# call to globalVariables to prevent from generating NOTE: no visible binding for global variable <variable name>
# this hack is to satisfy CRAN (http://stackoverflow.com/questions/9439256/how-can-i-handle-r-cmd-check-no-visible-binding-for-global-variable-notes-when)
globalVariables(c("subject_id", "sequence", "experiment_title", "assay_purpose", "measurement_technique",
                  "virus_strain", "result_in_original_units", "original_units",
                  "specimen_type", "specimen_subtype", "specimen_treatment", 
                  "treatment_amount_value", "treatment_amount_unit",
                  "treatment_duration_value", "treatment_duration_unit",
                  "treatment_temperature_value", "treatment_temperature_unit",
                  "visit_name", "visit_min_start_day", "visit_max_start_day", "visit_order",
                  "elapsed_time_of_specimen_collection", "time_point_reference",
                  "biosample_accession","experiment_sample_accession", "ZDSPECSB", "ZDREFIDP",
                  "VISITMIN", "VISITMAX",
                  "ZDSPTRT", 
                  "ZDTRTAMV", "ZDTRTAMU",
                  "ZDTRTDUV", "ZDTRTDUU",
                  "ZDTRTTMV", "ZDTRTTMU"))

# Get Titer Assay Results data of a specific study
# 
# The function \code{getTiterAssayResults} queries the ImmPort database for Titer Assay Results data and 
# reformats it to a custom Titer Assay Results domain model in CDISC SDTM standards. 
# 
# @param data_src A data_srcection handle to ImmPort (MySQL or SQLite) database instance or 
# a directory handle to folder where study RDS files are located
# @param assay_type Assay Type **optional**
# @param study_id Identifier of a specific study
# @return a list of 2 data frames containing 1) Titer Assay Results data \code{\link{ZD}} and 2) any supplemental 
#   Titer Assay Results data \code{\link{SUPP}}
# @examples
# \dontrun{
#   # get all of study SDY1's Titer Assay Results data
#   ta_l <- getTiterAssayResults(data_src, "SDY1")
#   
#   # get study SDY1's Titer Assay data that was generated using HAI assay
#   ta_l <- getTiterAssayResults(data_src, "SDY1", "HAI")
# }
#' @importFrom plyr rename
getTiterAssayResults <- function(data_src, study_id, assay_type="ALL") {
  cat("loading Titer Assay Results data....")
  
  ta_df = data.frame()
  suppta_df = data.frame()
  
  ta_cols <- c("STUDYID", "DOMAIN", "USUBJID", "ZDSEQ", "ZDTEST", "ZDCAT", "ZDMETHOD", "ZDSTRAIN", "ZDORRES", 
               "ZDORRESU",  "ZDSPEC", "ZDREFID", "VISITNUM", "VISIT", "ZDELTM", "ZDTPTREF")
  
  suppta_cols <- c("STUDYID", "RDOMAIN", "USUBJID", "IDVAR", "IDVARVAL", "QNAM", "QLABEL", "QVAL")
  
  
  if ((class(data_src)[1] == 'MySQLConnection') || 
      (class(data_src)[1] == 'SQLiteConnection')) {
    if ((assay_type == "ALL") || (assay_type =="HAI")) {
      # get HAI results
      
      #   hai_assay_column_names <- c("study_id", "subject_id", "sequence",
      #                               "result_in_original_units", "original_units", 
      #                               "experiment_title", "assay_purpose", "measurement_technique",
      #                               "biosample_accession", "specimen_type", "specimen_subtype",
      #                               "elapsed_time_of_specimen_collection", "time_point_reference",
      #                               "study_time_t0_event", "study_time_t0_event_specify",
      #                               "virus_strain")  
  
      hai_df <- getHaiResults(data_src, study_id, "")
      if (nrow(hai_df) > 0) {
        hai_df <- select(hai_df, STUDYID = study_id, USUBJID = subject_id, ZDSEQ = sequence, ZDTEST = experiment_title, 
                          ZDCAT = assay_purpose, ZDMETHOD = measurement_technique, ZDSTRAIN = virus_strain, 
                          ZDORRES = result_in_original_units, ZDORRESU = original_units,  
                          ZDSPEC = specimen_type, ZDSPECSB = specimen_subtype, 
                           ZDSPTRT = specimen_treatment, 
                           ZDTRTAMV = treatment_amount_value, ZDTRTAMU = treatment_amount_unit,
                           ZDTRTDUV = treatment_duration_value, ZDTRTDUU = treatment_duration_unit,
                           ZDTRTTMV = treatment_temperature_value, ZDTRTTMU = treatment_temperature_unit,
                          VISIT = visit_name, VISITNUM = visit_order,  VISITMIN = visit_min_start_day, VISITMAX = visit_max_start_day, 
                          ZDELTM = elapsed_time_of_specimen_collection, ZDTPTREF = time_point_reference, 
                          ZDREFID = experiment_sample_accession, ZDREFIDP = biosample_accession)
        
        hai_df$DOMAIN <- "ZD"
        
        qnam_values = c("ZDSPECSB", "ZDREFIDP",
                        "VISITMIN", "VISITMAX",
                        "ZDSPTRT", 
                        "ZDTRTAMV", "ZDTRTAMU",
                        "ZDTRTDUV", "ZDTRTDUU",
                        "ZDTRTTMV", "ZDTRTTMU")
        qlabel_values= c("Specimen Subtype", "Source Specimen Identifier",
                         "Planned Visit Minimum Start Day", "Planned Visit Maximum Start Day",
                         "Specimen Treatment", 
                         "Specimen Treatment Amount Value", "Specimen Treatment Amount Unit",
                         "Specimen Treatment Duration Value", "Specimen Treatment Duration Unit", 
                         "Specimen Treatment Temperature Value", "Specimen Treatment Temperature Unit")
        
        supphai_df <- melt(hai_df, 
                           id = c("STUDYID", "DOMAIN", "USUBJID", "ZDSEQ"), 
                           measure = qnam_values, 
                           variable.name = "QNAM", 
                           value.name = "QVAL")
        
        supphai_df <- transform(supphai_df, QLABEL = unlist(qlabel_values[QNAM]))
        supphai_df <- plyr::rename(supphai_df, c("DOMAIN" = "RDOMAIN", "ZDSEQ" = "IDVARVAL"))
        supphai_df$IDVAR <- "ZDSEQ"
        
        
        supphai_df <- supphai_df[suppta_cols]
        
        # remove rows that have empty QVAL values
        supphai_df <- subset(supphai_df,QVAL!="")      
        
        hai_df <- subset(hai_df, select = -c(ZDSPECSB, ZDREFIDP,
                                             VISITMIN, VISITMAX,
                                             ZDSPTRT, 
                                             ZDTRTAMV, ZDTRTAMU,
                                             ZDTRTDUV, ZDTRTDUU,
                                             ZDTRTTMV, ZDTRTTMU))
                
        hai_df <- hai_df[, ta_cols]
    
        ta_df <- rbind(ta_df, hai_df)
        suppta_df <- rbind(suppta_df, supphai_df)
        
      }
    }
    
    if ((assay_type == "ALL") || (assay_type =="Neut Ab Titer")) {
      # get Neut Ab Titer results
      
      nat_df <- getNeutAbTiterResults(data_src, study_id, "")
      if (nrow(nat_df) > 0) {
        nat_df <- select(nat_df, STUDYID = study_id, USUBJID = subject_id, ZDSEQ = sequence, ZDTEST = experiment_title, 
                         ZDCAT = assay_purpose, ZDMETHOD = measurement_technique, ZDSTRAIN = virus_strain, 
                         ZDORRES = result_in_original_units, ZDORRESU = original_units,  
                         ZDSPEC = specimen_type, ZDSPECSB = specimen_subtype, 
                         ZDSPTRT = specimen_treatment, 
                         ZDTRTAMV = treatment_amount_value, ZDTRTAMU = treatment_amount_unit,
                         ZDTRTDUV = treatment_duration_value, ZDTRTDUU = treatment_duration_unit,
                         ZDTRTTMV = treatment_temperature_value, ZDTRTTMU = treatment_temperature_unit,
                         VISIT = visit_name, VISITNUM = visit_order,  VISITMIN = visit_min_start_day, VISITMAX = visit_max_start_day, 
                         ZDELTM = elapsed_time_of_specimen_collection, ZDTPTREF = time_point_reference, 
                         ZDREFID = experiment_sample_accession, ZDREFIDP = biosample_accession)
        
        nat_df$DOMAIN <- "ZD"

        qnam_values = c("ZDSPECSB", "ZDREFIDP",
                        "VISITMIN", "VISITMAX",
                        "ZDSPTRT", 
                        "ZDTRTAMV", "ZDTRTAMU",
                        "ZDTRTDUV", "ZDTRTDUU",
                        "ZDTRTTMV", "ZDTRTTMU")
        qlabel_values= c("Specimen Subtype", "Source Specimen Identifier",
                         "Planned Visit Minimum Start Day", "Planned Visit Maximum Start Day",
                         "Specimen Treatment", 
                         "Specimen Treatment Amount Value", "Specimen Treatment Amount Unit",
                         "Specimen Treatment Duration Value", "Specimen Treatment Duration Unit", 
                         "Specimen Treatment Temperature Value", "Specimen Treatment Temperature Unit")
        
        suppnat_df <- melt(nat_df, 
                           id = c("STUDYID", "DOMAIN", "USUBJID", "ZDSEQ"), 
                           measure = qnam_values, 
                           variable.name = "QNAM", 
                           value.name = "QVAL")
        
        suppnat_df <- transform(suppnat_df, QLABEL = unlist(qlabel_values[QNAM]))
        suppnat_df <- plyr::rename(suppnat_df, c("DOMAIN" = "RDOMAIN", "ZDSEQ" = "IDVARVAL"))
        suppnat_df$IDVAR <- "ZDSEQ"
        
        
        suppnat_df <- suppnat_df[suppta_cols]
        
        # remove rows that have empty QVAL values
        suppnat_df <- subset(suppnat_df,QVAL!="")      
        
        nat_df <- subset(nat_df, select = -c(ZDSPECSB, ZDREFIDP,
                                             VISITMIN, VISITMAX,
                                             ZDSPTRT, 
                                             ZDTRTAMV, ZDTRTAMU,
                                             ZDTRTDUV, ZDTRTDUU,
                                             ZDTRTTMV, ZDTRTTMU))
        
        nat_df <- nat_df[, ta_cols]
        
        ta_df <- rbind(ta_df, nat_df)
        suppta_df <- rbind(suppta_df, suppnat_df)
        
      }
    }
  } else {
    l <- loadSerializedStudyData(data_src, study_id, "Titer Assay Results")
    if (assay_type == "ALL") {
      ta_df <- l[[1]]
      suppta_df <- l[[2]]
    } else {
      
    }
  }   
  
  cat("done", "\n")
  
  ta_l <- list()
  if (nrow(ta_df) > 0)
    ta_l <- list(zd_df=ta_df, suppzd_df=suppta_df)
  
  ta_l
  
} 

# Get count of Titer Assay Results data of a specific study
# 
# The function \code{getCountOfTiterAssayResults} queries the ImmPort database for count 
# of Titer Assay Results data 
# 
# @param data_src A data_srcection handle to ImmPort (MySQL or SQLite) database instance or 
# a directory handle to folder where study RDS files are located
# @param assay_type Assay Type **optional**
# @param study_id Identifier of a specific study
# @return a count of Titer Assay Results data 
# @examples
# \dontrun{
#   # get count of all of study SDY1's Titer Assay Results data
#   count <- getCountOfTiterAssayResults(data_src, "SDY1")
#   
#   # get count of study SDY1's Titer Assay Results data that was generated using HAI assay
#   count <- getCountOfTiterAssayResults(data_src, "SDY1", "HAI")
# }
getCountOfTiterAssayResults <- function(data_src, study_id, assay_type="ALL") {
  count <- 0
  if ((assay_type == "ALL") || (assay_type =="HAI")) 
    count <- count + getCountOfHaiResults(data_src, study_id)
  if ((assay_type == "ALL") || (assay_type =="Neut Ab Titer")) 
    count <- count + getCountOfNeutAbTiterResults(data_src, study_id)
  
  count
}

##' Titer Assay Results Domain Variables
##' @name ZD
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name  } \tab \strong{Variable Label} \cr
##'     STUDYID \tab Study Identifier \cr
##'     DOMAIN  \tab Domain Abbreviation \cr
##'     USUBJID \tab Unique Subject Identifier \cr
##'     ZDSEQ \tab Sequence Number \cr
##'     ZDTEST \tab Titer Assay Results Test Name \cr
##'     ZDCAT \tab Category for Titer Assay Results \cr
##'     ZDMETHOD \tab Measurement Technique \cr
##'     ZDSTRAIN \tab Virus Strain \cr
##'     ZDORRES \tab Result or Finding in Original Units \cr
##'     ZDORRESU \tab Original Units \cr
##'     ZDSPEC \tab Specimen Type \cr
##'     ZDREFID \tab Specimen Identifier \cr
##'     VISITNUM \tab Visit Number \cr
##'     VISIT \tab Visit Name \cr
##'     ZDELTM \tab Planned Elapsed Time from Time Point Ref \cr
##'     ZDTPTREF \tab Time Point Reference \cr
##'     ZDXFN \tab Raw Data File or Life Science Identifier
##'   }
##' }
NULL
#> NULL 

##' Titer Assay Results Domain Supplemental Variables
##' @name SUPPZD
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name} \tab \strong{Variable Label} \cr
##'     STUDYID \tab Study Identifier \cr
##'     RDOMAIN  \tab Related Domain Abbreviation \cr
##'     USUBJID \tab Unique Subject Identifier \cr
##'     IDVAR \tab Identifying Variable \cr
##'     IDVARVAL \tab Identifying Variable Value \cr
##'     QNAM \tab Qualifier Variable Name \cr
##'     QLABEL \tab Qualifier Variable Label \cr
##'     QVAL \tab Data Value
##'   }
##' }
##' @note The following table enumerates the values in QNAM and QLABEL variables {
##'   \tabular{ll}{
##'     \strong{QNAM} \tab \strong{QLABEL} \cr
##'     ZDSPECSB \tab Specimen Subtype \cr
##'     ZDREFIDP \tab Source Specimen Identifier \cr
##'     VISITMIN \tab Planned Visit Minimum Start Day \cr
##'     VISITMAX \tab Planned Visit Maximum Start Day \cr
##'     ZDSPTRT \tab Specimen Treatment \cr
##'     ZDTRTAMV \tab Specimen Treatment Amount Value \cr
##'     ZDTRTAMU \tab Specimen Treatment Amount Unit \cr
##'     ZDTRTDUV \tab Specimen Treatment Duration Value \cr
##'     ZDTRTDUU \tab Specimen Treatment Duration Unit \cr
##'     ZDTRTTMV \tab Specimen Treatment Temperature Value \cr
##'     ZDTRTTMU \tab Specimen Treatment Temperature Unit
##'   }
##' }
NULL
#> NULL

db_table_stmts <- c(
  "CREATE  TABLE IF NOT EXISTS `lk_gender` (
  `name` VARCHAR(20) NOT NULL ,
  `description` VARCHAR(1000) NULL DEFAULT NULL ,
  `link` VARCHAR(2000) NULL DEFAULT NULL ,
  PRIMARY KEY (`name`) )",
  "CREATE  TABLE IF NOT EXISTS `lk_ethnicity` (
  `name` VARCHAR(50) NOT NULL ,
  `description` VARCHAR(1000) NULL DEFAULT NULL ,
  `link` VARCHAR(2000) NULL DEFAULT NULL ,
  PRIMARY KEY (`name`) )",
  "CREATE  TABLE IF NOT EXISTS `lk_race` (
  `name` VARCHAR(50) NOT NULL ,
  `description` VARCHAR(1000) NULL DEFAULT NULL ,
  `link` VARCHAR(2000) NULL DEFAULT NULL ,
  PRIMARY KEY (`name`) )",
  "CREATE  TABLE IF NOT EXISTS `lk_species` (
  `name` VARCHAR(30) NOT NULL ,
  `common_name` VARCHAR(100) NULL DEFAULT NULL ,
  `link` VARCHAR(2000) NULL DEFAULT NULL ,
  `taxonomy_id` VARCHAR(10) NOT NULL ,
  PRIMARY KEY (`name`) )",
  "CREATE  TABLE IF NOT EXISTS `workspace` (
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  `category` VARCHAR(50) NOT NULL ,
  `name` VARCHAR(125) NOT NULL ,
  `type` VARCHAR(20) NOT NULL ,
  PRIMARY KEY (`workspace_id`) )",
  "CREATE  TABLE IF NOT EXISTS `subject` (
  `subject_accession` VARCHAR(15) NOT NULL ,
  `ancestral_population` VARCHAR(100) NULL DEFAULT NULL ,
  `description` VARCHAR(4000) NULL DEFAULT NULL ,
  `ethnicity` VARCHAR(50) NULL DEFAULT 'Not Specified' ,
  `gender` VARCHAR(20) NOT NULL DEFAULT 'Not Specified' ,
  `race` VARCHAR(50) NULL DEFAULT 'Not Specified' ,
  `race_specify` VARCHAR(1000) NULL DEFAULT NULL ,
  `species` VARCHAR(50) NOT NULL ,
  `strain` VARCHAR(50) NULL DEFAULT NULL ,
  `strain_characteristics` VARCHAR(500) NULL DEFAULT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`subject_accession`) ,
  CONSTRAINT `fk_subject_1`
  FOREIGN KEY (`gender` )
  REFERENCES `lk_gender` (`name` ),
  CONSTRAINT `fk_subject_2`
  FOREIGN KEY (`ethnicity` )
  REFERENCES `lk_ethnicity` (`name` ),
  CONSTRAINT `fk_subject_3`
  FOREIGN KEY (`race` )
  REFERENCES `lk_race` (`name` ),
  CONSTRAINT `fk_subject_4`
  FOREIGN KEY (`species` )
  REFERENCES `lk_species` (`name` ),
  CONSTRAINT `fk_subject_5`
  FOREIGN KEY (`workspace_id` )
  REFERENCES `workspace` (`workspace_id` ))",
  "CREATE  TABLE IF NOT EXISTS `lk_study_type` (
  `name` VARCHAR(50) NOT NULL ,
  `description` VARCHAR(1000) NULL DEFAULT NULL ,
  `link` VARCHAR(2000) NULL DEFAULT NULL ,
  PRIMARY KEY (`name`) )",
  "CREATE  TABLE IF NOT EXISTS `lk_data_completeness` (
  `id` INT(11) NOT NULL ,
  `description` VARCHAR(1000) NULL DEFAULT NULL ,
  PRIMARY KEY (`id`) )",
  "CREATE  TABLE IF NOT EXISTS `study` (
  `study_accession` VARCHAR(15) NOT NULL ,
  `actual_completion_date` DATE NULL DEFAULT NULL ,
  `actual_enrollment` INT(11) NULL DEFAULT NULL ,
  `actual_start_date` DATE NULL DEFAULT NULL ,
  `age_unit` VARCHAR(40) NULL DEFAULT NULL ,
  `brief_description` VARCHAR(4000) NULL DEFAULT NULL ,
  `brief_title` VARCHAR(250) NULL DEFAULT NULL ,
  `clinical_trial` VARCHAR(1) NOT NULL DEFAULT 'N' ,
  `condition_studied` VARCHAR(1000) NULL DEFAULT NULL ,
  `dcl_id` INT(11) NOT NULL DEFAULT '0' ,
  `description` LONGTEXT NULL DEFAULT NULL ,
  `doi` VARCHAR(250) NULL DEFAULT NULL ,
  `endpoints` MEDIUMTEXT NULL DEFAULT NULL ,
  `gender_included` VARCHAR(50) NULL DEFAULT NULL ,
  `hypothesis` VARCHAR(4000) NULL DEFAULT NULL ,
  `initial_data_release_date` DATE NULL DEFAULT NULL ,
  `initial_data_release_version` VARCHAR(10) NULL DEFAULT NULL ,
  `intervention_agent` VARCHAR(1000) NULL DEFAULT NULL ,
  `latest_data_release_date` DATE NULL DEFAULT NULL ,
  `latest_data_release_version` VARCHAR(10) NULL DEFAULT NULL ,
  `maximum_age` VARCHAR(40) NULL DEFAULT NULL ,
  `minimum_age` VARCHAR(40) NULL DEFAULT NULL ,
  `objectives` MEDIUMTEXT NULL DEFAULT NULL ,
  `official_title` VARCHAR(500) NULL DEFAULT NULL ,
  `sponsoring_organization` VARCHAR(250) NULL DEFAULT NULL ,
  `target_enrollment` INT(11) NULL DEFAULT NULL ,
  `type` VARCHAR(50) NOT NULL ,
  `workspace_id` INT(11) NOT NULL ,
  PRIMARY KEY (`study_accession`) ,
  CONSTRAINT `fk_study_1`
  FOREIGN KEY (`workspace_id` )
  REFERENCES `workspace` (`workspace_id` ),
  CONSTRAINT `fk_study_2`
  FOREIGN KEY (`type` )
  REFERENCES `lk_study_type` (`name` ),
  CONSTRAINT `fk_study_3`
  FOREIGN KEY (`dcl_id` )
  REFERENCES `lk_data_completeness` (`id` ))",
  "CREATE  TABLE IF NOT EXISTS `lk_adverse_event_severity` (
  `name` VARCHAR(60) NOT NULL ,
  `description` VARCHAR(1000) NULL DEFAULT NULL ,
  `link` VARCHAR(2000) NULL DEFAULT NULL ,
  PRIMARY KEY (`name`) )",
  "CREATE  TABLE IF NOT EXISTS `adverse_event` (
  `adverse_event_accession` VARCHAR(15) NOT NULL ,
  `causality` VARCHAR(250) NULL DEFAULT NULL ,
  `description` VARCHAR(4000) NULL DEFAULT NULL ,
  `end_study_day` FLOAT NULL DEFAULT NULL ,
  `end_time` VARCHAR(40) NULL DEFAULT NULL ,
  `location_of_reaction_preferred` VARCHAR(126) NULL DEFAULT NULL ,
  `location_of_reaction_reported` VARCHAR(126) NULL DEFAULT NULL ,
  `name_preferred` VARCHAR(126) NULL DEFAULT NULL ,
  `name_reported` VARCHAR(126) NULL DEFAULT NULL ,
  `organ_or_body_system_preferred` VARCHAR(126) NULL DEFAULT NULL ,
  `organ_or_body_system_reported` VARCHAR(126) NULL DEFAULT NULL ,
  `other_action_taken` VARCHAR(250) NULL DEFAULT NULL ,
  `outcome_preferred` VARCHAR(40) NULL DEFAULT NULL ,
  `outcome_reported` VARCHAR(40) NULL DEFAULT NULL ,
  `relation_to_nonstudy_treatment` VARCHAR(250) NULL DEFAULT NULL ,
  `relation_to_study_treatment` VARCHAR(250) NULL DEFAULT NULL ,
  `severity_preferred` VARCHAR(60) NULL DEFAULT NULL ,
  `severity_reported` VARCHAR(60) NOT NULL ,
  `start_study_day` FLOAT NULL DEFAULT NULL ,
  `start_time` VARCHAR(40) NULL DEFAULT NULL ,
  `study_accession` VARCHAR(15) NOT NULL ,
  `study_treatment_action_taken` VARCHAR(250) NULL DEFAULT NULL ,
  `subject_accession` VARCHAR(15) NOT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`adverse_event_accession`) ,
  CONSTRAINT `fk_adverse_event_1`
  FOREIGN KEY (`subject_accession` )
  REFERENCES `subject` (`subject_accession` ),
  CONSTRAINT `fk_adverse_event_2`
  FOREIGN KEY (`workspace_id` )
  REFERENCES `workspace` (`workspace_id` ),
  CONSTRAINT `fk_adverse_event_3`
  FOREIGN KEY (`study_accession` )
  REFERENCES `study` (`study_accession` ),
  CONSTRAINT `fk_adverse_event_4`
  FOREIGN KEY (`severity_preferred` )
  REFERENCES `lk_adverse_event_severity` (`name` ))",
  "CREATE  TABLE IF NOT EXISTS `arm_or_cohort` (
  `arm_accession` VARCHAR(15) NOT NULL ,
  `description` VARCHAR(4000) NULL DEFAULT NULL ,
  `name` VARCHAR(126) NULL DEFAULT NULL ,
  `study_accession` VARCHAR(15) NOT NULL ,
  `type` VARCHAR(20) NULL DEFAULT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`arm_accession`) ,
  CONSTRAINT `fk_arm_or_cohort_1`
  FOREIGN KEY (`study_accession` )
  REFERENCES `study` (`study_accession` ),
  CONSTRAINT `fk_arm_or_cohort_2`
  FOREIGN KEY (`workspace_id` )
  REFERENCES `workspace` (`workspace_id` ))",
  "CREATE  TABLE IF NOT EXISTS `lk_time_unit` (
  `name` VARCHAR(25) NOT NULL ,
  `description` VARCHAR(1000) NOT NULL ,
  `link` VARCHAR(2000) NULL DEFAULT NULL ,
  PRIMARY KEY (`name`) )",
  "CREATE  TABLE IF NOT EXISTS `lk_age_event` (
  `name` VARCHAR(40) NOT NULL ,
  `description` VARCHAR(1000) NOT NULL ,
  `link` VARCHAR(2000) NULL DEFAULT NULL ,
  PRIMARY KEY (`name`) )",
  "CREATE  TABLE IF NOT EXISTS `arm_2_subject` (
  `arm_accession` VARCHAR(15) NOT NULL ,
  `subject_accession` VARCHAR(15) NOT NULL ,
  `age_event` VARCHAR(50) NOT NULL DEFAULT 'Not Specified' ,
  `age_event_specify` VARCHAR(50) NULL DEFAULT NULL ,
  `age_unit` VARCHAR(50) NOT NULL DEFAULT 'Not Specified' ,
  `max_subject_age` FLOAT NULL DEFAULT NULL ,
  `min_subject_age` FLOAT NULL DEFAULT NULL ,
  `subject_phenotype` VARCHAR(200) NULL DEFAULT NULL ,
  PRIMARY KEY (`arm_accession`, `subject_accession`) ,
  CONSTRAINT `fk_arm_2_subject_1`
  FOREIGN KEY (`arm_accession` )
  REFERENCES `arm_or_cohort` (`arm_accession` ),
  CONSTRAINT `fk_arm_2_subject_2`
  FOREIGN KEY (`subject_accession` )
  REFERENCES `subject` (`subject_accession` ),
  CONSTRAINT `fk_arm_2_subject_3`
  FOREIGN KEY (`age_unit` )
  REFERENCES `lk_time_unit` (`name` ),
  CONSTRAINT `fk_arm_2_subject_4`
  FOREIGN KEY (`age_event` )
  REFERENCES `lk_age_event` (`name` ))",
  "CREATE  TABLE IF NOT EXISTS `lk_file_detail` (
  `name` VARCHAR(100) NOT NULL ,
  `description` VARCHAR(1000) NULL DEFAULT NULL ,
  `link` VARCHAR(2000) NULL DEFAULT NULL ,
  PRIMARY KEY (`name`) )",
  "CREATE  TABLE IF NOT EXISTS `file_info` (
  `file_info_id` INT(11) NOT NULL ,
  `detail` VARCHAR(100) NOT NULL ,
  `filesize_bytes` INT(11) NOT NULL ,
  `name` VARCHAR(250) NOT NULL ,
  `original_file_name` VARCHAR(250) NOT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`file_info_id`) ,
  CONSTRAINT `fk_file_info_1`
  FOREIGN KEY (`workspace_id` )
  REFERENCES `workspace` (`workspace_id` ),
  CONSTRAINT `fk_file_info_2`
  FOREIGN KEY (`detail` )
  REFERENCES `lk_file_detail` (`name` ))",
  "CREATE  TABLE IF NOT EXISTS `assessment_panel` (
  `assessment_panel_accession` VARCHAR(15) NOT NULL ,
  `assessment_type` VARCHAR(125) NULL DEFAULT NULL ,
  `name_preferred` VARCHAR(40) NULL DEFAULT NULL ,
  `name_reported` VARCHAR(125) NULL DEFAULT NULL ,
  `status` VARCHAR(40) NULL DEFAULT NULL ,
  `study_accession` VARCHAR(15) NOT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`assessment_panel_accession`) ,
  CONSTRAINT `fk_assessment_1`
  FOREIGN KEY (`study_accession` )
  REFERENCES `study` (`study_accession` ),
  CONSTRAINT `fk_assessment_2`
  FOREIGN KEY (`workspace_id` )
  REFERENCES `workspace` (`workspace_id` ))",
  "CREATE  TABLE IF NOT EXISTS `lk_expsample_result_schema` (
  `name` VARCHAR(50) NOT NULL ,
  `description` VARCHAR(1000) NULL DEFAULT NULL ,
  `table_name` VARCHAR(30) NOT NULL DEFAULT 'NONE' ,
  PRIMARY KEY (`name`) )",
  "CREATE  TABLE IF NOT EXISTS `assessment_2_file_info` (
  `assessment_panel_accession` VARCHAR(15) NOT NULL ,
  `file_info_id` INT(11) NOT NULL ,
  `result_schema` VARCHAR(50) NOT NULL ,
  PRIMARY KEY (`assessment_panel_accession`, `file_info_id`) ,
  CONSTRAINT `fk_assessment_2_file_info_1`
  FOREIGN KEY (`file_info_id` )
  REFERENCES `file_info` (`file_info_id` ),
  CONSTRAINT `fk_assessment_2_file_info_2`
  FOREIGN KEY (`assessment_panel_accession` )
  REFERENCES `assessment_panel` (`assessment_panel_accession` ),
  CONSTRAINT `fk_assessment_2_file_info_4`
  FOREIGN KEY (`result_schema` )
  REFERENCES `lk_expsample_result_schema` (`name` ))",
  "CREATE  TABLE IF NOT EXISTS `reference_range` (
  `reference_range_accession` VARCHAR(15) NOT NULL ,
  `age_range` VARCHAR(40) NULL DEFAULT NULL ,
  `category` VARCHAR(40) NULL DEFAULT NULL ,
  `gender` VARCHAR(40) NULL DEFAULT NULL ,
  `lab_or_study_source` VARCHAR(256) NULL DEFAULT NULL ,
  `lower_limit` VARCHAR(40) NOT NULL ,
  `study_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `subject_condition` VARCHAR(40) NULL DEFAULT NULL ,
  `test_or_assessment_name` VARCHAR(125) NULL DEFAULT NULL ,
  `unit_of_measure` VARCHAR(40) NOT NULL ,
  `upper_limit` VARCHAR(40) NOT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`reference_range_accession`) ,
  CONSTRAINT `fk_reference_range_1`
  FOREIGN KEY (`workspace_id` )
  REFERENCES `workspace` (`workspace_id` ),
  CONSTRAINT `fk_reference_range_2`
  FOREIGN KEY (`study_accession` )
  REFERENCES `study` (`study_accession` ))",
  "CREATE  TABLE IF NOT EXISTS `lk_unit_of_measure` (
  `name` VARCHAR(50) NOT NULL ,
  `description` VARCHAR(1000) NULL DEFAULT NULL ,
  `link` VARCHAR(2000) NULL DEFAULT NULL ,
  `type` VARCHAR(50) NOT NULL ,
  PRIMARY KEY (`name`) )",
  "CREATE  TABLE IF NOT EXISTS `assessment_component` (
  `assessment_component_accession` VARCHAR(15) NOT NULL ,
  `age_at_onset_preferred` FLOAT NULL DEFAULT NULL ,
  `age_at_onset_reported` VARCHAR(100) NULL DEFAULT NULL ,
  `age_at_onset_unit_preferred` VARCHAR(40) NULL DEFAULT NULL ,
  `age_at_onset_unit_reported` VARCHAR(25) NULL DEFAULT NULL ,
  `assessment_panel_accession` VARCHAR(15) NOT NULL ,
  `is_clinically_significant` VARCHAR(1) NULL DEFAULT 'U' ,
  `location_of_finding_preferred` VARCHAR(256) NULL DEFAULT NULL ,
  `location_of_finding_reported` VARCHAR(256) NULL DEFAULT NULL ,
  `name_preferred` VARCHAR(150) NULL DEFAULT NULL ,
  `name_reported` VARCHAR(150) NOT NULL ,
  `organ_or_body_system_preferred` VARCHAR(100) NULL DEFAULT NULL ,
  `organ_or_body_system_reported` VARCHAR(100) NULL DEFAULT NULL ,
  `planned_visit_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `reference_range_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `result_unit_preferred` VARCHAR(40) NULL DEFAULT NULL ,
  `result_unit_reported` VARCHAR(40) NULL DEFAULT NULL ,
  `result_value_category` VARCHAR(40) NULL DEFAULT NULL ,
  `result_value_preferred` FLOAT NULL DEFAULT NULL ,
  `result_value_reported` VARCHAR(250) NULL DEFAULT NULL ,
  `study_day` FLOAT NULL DEFAULT NULL ,
  `subject_accession` VARCHAR(15) NOT NULL ,
  `subject_position_preferred` VARCHAR(40) NULL DEFAULT NULL ,
  `subject_position_reported` VARCHAR(40) NULL DEFAULT NULL ,
  `time_of_day` VARCHAR(40) NULL DEFAULT NULL ,
  `verbatim_question` VARCHAR(250) NULL DEFAULT NULL ,
  `who_is_assessed` VARCHAR(40) NULL DEFAULT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`assessment_component_accession`) ,
  CONSTRAINT `fk_assessment_component_1`
  FOREIGN KEY (`workspace_id` )
  REFERENCES `workspace` (`workspace_id` ),
  CONSTRAINT `fk_assessment_component_2`
  FOREIGN KEY (`subject_accession` )
  REFERENCES `subject` (`subject_accession` ),
  CONSTRAINT `fk_assessment_component_4`
  FOREIGN KEY (`assessment_panel_accession` )
  REFERENCES `assessment_panel` (`assessment_panel_accession` ),
  CONSTRAINT `fk_assessment_component_5`
  FOREIGN KEY (`reference_range_accession` )
  REFERENCES `reference_range` (`reference_range_accession` ),
  CONSTRAINT `fk_assessment_component_6`
  FOREIGN KEY (`result_unit_preferred` )
  REFERENCES `lk_unit_of_measure` (`name` ),
  CONSTRAINT `fk_assessment_component_7`
  FOREIGN KEY (`age_at_onset_unit_preferred` )
  REFERENCES `lk_time_unit` (`name` ))",
  "CREATE  TABLE IF NOT EXISTS `lk_t0_event` (
  `name` VARCHAR(50) NOT NULL ,
  `description` VARCHAR(1000) NOT NULL ,
  `link` VARCHAR(2000) NULL DEFAULT NULL ,
  PRIMARY KEY (`name`) )",
  "CREATE  TABLE IF NOT EXISTS `period` (
  `period_accession` VARCHAR(15) NOT NULL ,
  `name` VARCHAR(250) NULL DEFAULT NULL ,
  `order_number` INT(11) NULL DEFAULT NULL ,
  `study_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`period_accession`) ,
  CONSTRAINT `fk_period_1`
  FOREIGN KEY (`study_accession` )
  REFERENCES `study` (`study_accession` ),
  CONSTRAINT `fk_period_2`
  FOREIGN KEY (`workspace_id` )
  REFERENCES `workspace` (`workspace_id` ))",
  "CREATE  TABLE IF NOT EXISTS `planned_visit` (
  `planned_visit_accession` VARCHAR(15) NOT NULL ,
  `end_rule` VARCHAR(256) NULL DEFAULT NULL ,
  `max_start_day` FLOAT NULL DEFAULT NULL ,
  `min_start_day` FLOAT NULL DEFAULT NULL ,
  `name` VARCHAR(125) NULL DEFAULT NULL ,
  `order_number` INT(11) NULL DEFAULT NULL ,
  `period_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `start_rule` VARCHAR(256) NULL DEFAULT NULL ,
  `study_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`planned_visit_accession`) ,
  CONSTRAINT `fk_planned_visit_1`
  FOREIGN KEY (`study_accession` )
  REFERENCES `study` (`study_accession` ),
  CONSTRAINT `fk_planned_visit_2`
  FOREIGN KEY (`period_accession` )
  REFERENCES `period` (`period_accession` ),
  CONSTRAINT `fk_planned_visit_3`
  FOREIGN KEY (`workspace_id` )
  REFERENCES `workspace` (`workspace_id` ))",
  "CREATE  TABLE IF NOT EXISTS `lk_sample_type` (
  `name` VARCHAR(50) NOT NULL ,
  `description` VARCHAR(1000) NULL DEFAULT NULL ,
  `link` VARCHAR(2000) NULL DEFAULT NULL ,
  PRIMARY KEY (`name`) )",
  "CREATE  TABLE IF NOT EXISTS `biosample` (
  `biosample_accession` VARCHAR(15) NOT NULL ,
  `description` VARCHAR(4000) NULL DEFAULT NULL ,
  `name` VARCHAR(200) NULL DEFAULT NULL ,
  `planned_visit_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `study_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `study_time_collected` FLOAT NULL DEFAULT NULL ,
  `study_time_collected_unit` VARCHAR(25) NOT NULL DEFAULT 'Not Specified' ,
  `study_time_t0_event` VARCHAR(50) NOT NULL DEFAULT 'Not Specified' ,
  `study_time_t0_event_specify` VARCHAR(50) NULL DEFAULT NULL ,
  `subject_accession` VARCHAR(15) NOT NULL ,
  `subtype` VARCHAR(50) NULL DEFAULT NULL ,
  `type` VARCHAR(50) NOT NULL DEFAULT 'Not Specified' ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`biosample_accession`) ,
  CONSTRAINT `fk_biosample_1`
  FOREIGN KEY (`subject_accession` )
  REFERENCES `subject` (`subject_accession` ),
  CONSTRAINT `fk_biosample_2`
  FOREIGN KEY (`study_accession` )
  REFERENCES `study` (`study_accession` ),
  CONSTRAINT `fk_biosample_4`
  FOREIGN KEY (`workspace_id` )
  REFERENCES `workspace` (`workspace_id` ),
  CONSTRAINT `fk_biosample_5`
  FOREIGN KEY (`study_time_collected_unit` )
  REFERENCES `lk_time_unit` (`name` ),
  CONSTRAINT `fk_biosample_6`
  FOREIGN KEY (`study_time_t0_event` )
  REFERENCES `lk_t0_event` (`name` ),
  CONSTRAINT `fk_biosample_7`
  FOREIGN KEY (`planned_visit_accession` )
  REFERENCES `planned_visit` (`planned_visit_accession` ),
  CONSTRAINT `fk_biosample_8`
  FOREIGN KEY (`type` )
  REFERENCES `lk_sample_type` (`name` ))",
  "CREATE  TABLE IF NOT EXISTS `treatment` (
  `treatment_accession` VARCHAR(15) NOT NULL ,
  `amount_unit` VARCHAR(50) NULL DEFAULT 'Not Specified' ,
  `amount_value` VARCHAR(50) NULL DEFAULT 'Not Specified' ,
  `comments` VARCHAR(500) NULL DEFAULT NULL ,
  `duration_unit` VARCHAR(50) NULL DEFAULT 'Not Specified' ,
  `duration_value` VARCHAR(200) NULL DEFAULT 'Not Specified' ,
  `name` VARCHAR(100) NULL DEFAULT NULL ,
  `temperature_unit` VARCHAR(50) NULL DEFAULT 'Not Specified' ,
  `temperature_value` VARCHAR(50) NULL DEFAULT 'Not Specified' ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`treatment_accession`) ,
  CONSTRAINT `fk_treatment_1`
  FOREIGN KEY (`workspace_id` )
  REFERENCES `workspace` (`workspace_id` ),
  CONSTRAINT `fk_treatment_2`
  FOREIGN KEY (`amount_unit` )
  REFERENCES `lk_unit_of_measure` (`name` ),
  CONSTRAINT `fk_treatment_3`
  FOREIGN KEY (`duration_unit` )
  REFERENCES `lk_time_unit` (`name` ),
  CONSTRAINT `fk_treatment_4`
  FOREIGN KEY (`temperature_unit` )
  REFERENCES `lk_unit_of_measure` (`name` ))",
  "CREATE  TABLE IF NOT EXISTS `biosample_2_treatment` (
  `biosample_accession` VARCHAR(15) NOT NULL ,
  `treatment_accession` VARCHAR(15) NOT NULL ,
  PRIMARY KEY (`biosample_accession`, `treatment_accession`) ,
  CONSTRAINT `fk_biosample_2_treatment_1`
  FOREIGN KEY (`biosample_accession` )
  REFERENCES `biosample` (`biosample_accession` ),
  CONSTRAINT `fk_biosample_2_treatment_2`
  FOREIGN KEY (`treatment_accession` )
  REFERENCES `treatment` (`treatment_accession` ))",
  "CREATE  TABLE IF NOT EXISTS `lk_visibility_category` (
  `name` VARCHAR(50) NOT NULL ,
  `description` VARCHAR(1000) NULL DEFAULT NULL ,
  PRIMARY KEY (`name`) )",
  "CREATE  TABLE IF NOT EXISTS `program` (
  `program_id` INT(11) NOT NULL ,
  `category` VARCHAR(50) NOT NULL ,
  `description` VARCHAR(4000) NULL DEFAULT NULL ,
  `end_date` DATE NULL DEFAULT NULL ,
  `link` VARCHAR(2000) NULL DEFAULT NULL ,
  `name` VARCHAR(200) NOT NULL ,
  `start_date` DATE NULL DEFAULT NULL ,
  PRIMARY KEY (`program_id`) ,
  CONSTRAINT `fk_program_1`
  FOREIGN KEY (`category` )
  REFERENCES `lk_visibility_category` (`name` ))",
  "CREATE  TABLE IF NOT EXISTS `contract_grant` (
  `contract_grant_id` INT(11) NOT NULL ,
  `category` VARCHAR(50) NOT NULL ,
  `description` VARCHAR(4000) NULL DEFAULT NULL ,
  `end_date` DATE NULL DEFAULT NULL ,
  `external_id` VARCHAR(200) NOT NULL ,
  `link` VARCHAR(2000) NULL DEFAULT NULL ,
  `name` VARCHAR(1000) NULL DEFAULT NULL ,
  `program_id` INT(11) NULL DEFAULT NULL ,
  `start_date` DATE NULL DEFAULT NULL ,
  PRIMARY KEY (`contract_grant_id`) ,
  CONSTRAINT `fk_contract_1`
  FOREIGN KEY (`program_id` )
  REFERENCES `program` (`program_id` ))",
  "CREATE  TABLE IF NOT EXISTS `personnel` (
  `personnel_id` INT(11) NOT NULL ,
  `email` VARCHAR(100) NULL DEFAULT NULL ,
  `first_name` VARCHAR(50) NOT NULL ,
  `last_name` VARCHAR(50) NOT NULL ,
  `organization` VARCHAR(125) NOT NULL ,
  PRIMARY KEY (`personnel_id`) )",
  "CREATE  TABLE IF NOT EXISTS `lk_user_role_type` (
  `name` VARCHAR(2) NOT NULL ,
  `description` VARCHAR(1000) NULL DEFAULT NULL ,
  PRIMARY KEY (`name`) )",
  "CREATE  TABLE IF NOT EXISTS `contract_grant_2_personnel` (
  `contract_grant_id` INT(11) NOT NULL ,
  `personnel_id` INT(11) NOT NULL ,
  `role_type` VARCHAR(12) NULL DEFAULT NULL ,
  PRIMARY KEY (`contract_grant_id`, `personnel_id`) ,
  CONSTRAINT `fk_contract_2_personnel_1`
  FOREIGN KEY (`contract_grant_id` )
  REFERENCES `contract_grant` (`contract_grant_id` ),
  CONSTRAINT `fk_contract_2_personnel_2`
  FOREIGN KEY (`personnel_id` )
  REFERENCES `personnel` (`personnel_id` ),
  CONSTRAINT `fk_contract_2_personnel_3`
  FOREIGN KEY (`role_type` )
  REFERENCES `lk_user_role_type` (`name` ))",
  "CREATE  TABLE IF NOT EXISTS `contract_grant_2_study` (
  `contract_grant_id` INT(11) NOT NULL ,
  `study_accession` VARCHAR(15) NOT NULL ,
  PRIMARY KEY (`contract_grant_id`, `study_accession`) ,
  CONSTRAINT `fk_contract_2_study_1`
  FOREIGN KEY (`contract_grant_id` )
  REFERENCES `contract_grant` (`contract_grant_id` ),
  CONSTRAINT `fk_contract_2_study_3`
  FOREIGN KEY (`study_accession` )
  REFERENCES `study` (`study_accession` ))",
  "CREATE  TABLE IF NOT EXISTS `lk_exp_measurement_tech` (
  `name` VARCHAR(50) NOT NULL ,
  `description` VARCHAR(1000) NULL DEFAULT NULL ,
  `link` VARCHAR(2000) NULL DEFAULT NULL ,
  PRIMARY KEY (`name`) )",
  "CREATE  TABLE IF NOT EXISTS `experiment` (
  `experiment_accession` VARCHAR(15) NOT NULL ,
  `description` VARCHAR(4000) NULL DEFAULT NULL ,
  `measurement_technique` VARCHAR(50) NOT NULL ,
  `name` VARCHAR(500) NULL DEFAULT NULL ,
  `study_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`experiment_accession`) ,
  CONSTRAINT `fk_experiment_1`
  FOREIGN KEY (`workspace_id` )
  REFERENCES `workspace` (`workspace_id` ),
  CONSTRAINT `fk_experiment_3`
  FOREIGN KEY (`measurement_technique` )
  REFERENCES `lk_exp_measurement_tech` (`name` ),
  CONSTRAINT `fk_experiment_4`
  FOREIGN KEY (`study_accession` )
  REFERENCES `study` (`study_accession` ))",
  "CREATE  TABLE IF NOT EXISTS `control_sample` (
  `control_sample_accession` VARCHAR(15) NOT NULL ,
  `assay_group_id` VARCHAR(100) NULL DEFAULT NULL ,
  `assay_id` VARCHAR(100) NULL DEFAULT NULL ,
  `catalog_id` VARCHAR(100) NULL DEFAULT NULL ,
  `dilution_factor` VARCHAR(100) NULL DEFAULT NULL ,
  `experiment_accession` VARCHAR(15) NOT NULL ,
  `lot_number` VARCHAR(100) NULL DEFAULT NULL ,
  `result_schema` VARCHAR(50) NOT NULL DEFAULT 'OTHER' ,
  `source` VARCHAR(100) NULL DEFAULT NULL ,
  `upload_result_status` VARCHAR(20) NULL DEFAULT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`control_sample_accession`) ,
  CONSTRAINT `fk_control_sample_1`
  FOREIGN KEY (`workspace_id` )
  REFERENCES `workspace` (`workspace_id` ),
  CONSTRAINT `fk_control_sample_2`
  FOREIGN KEY (`experiment_accession` )
  REFERENCES `experiment` (`experiment_accession` ),
  CONSTRAINT `fk_control_sample_3`
  FOREIGN KEY (`result_schema` )
  REFERENCES `lk_expsample_result_schema` (`name` ))",
  "CREATE  TABLE IF NOT EXISTS `control_sample_2_file_info` (
  `control_sample_accession` VARCHAR(15) NOT NULL ,
  `file_info_id` INT(11) NOT NULL ,
  `result_schema` VARCHAR(50) NOT NULL ,
  PRIMARY KEY (`control_sample_accession`, `file_info_id`) ,
  CONSTRAINT `fk_control_sample_2_file_info_1`
  FOREIGN KEY (`control_sample_accession` )
  REFERENCES `control_sample` (`control_sample_accession` ),
  CONSTRAINT `fk_control_sample_2_file_info_2`
  FOREIGN KEY (`file_info_id` )
  REFERENCES `file_info` (`file_info_id` ),
  CONSTRAINT `fk_control_sample_2_file_info_4`
  FOREIGN KEY (`result_schema` )
  REFERENCES `lk_expsample_result_schema` (`name` ))",
  "CREATE  TABLE IF NOT EXISTS `expsample` (
  `expsample_accession` VARCHAR(15) NOT NULL ,
  `description` VARCHAR(4000) NULL DEFAULT NULL ,
  `experiment_accession` VARCHAR(15) NOT NULL ,
  `name` VARCHAR(200) NULL DEFAULT NULL ,
  `result_schema` VARCHAR(50) NOT NULL DEFAULT 'OTHER' ,
  `upload_result_status` VARCHAR(20) NULL DEFAULT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`expsample_accession`) ,
  CONSTRAINT `fk_expsample_1`
  FOREIGN KEY (`experiment_accession` )
  REFERENCES `experiment` (`experiment_accession` ),
  CONSTRAINT `fk_expsample_3`
  FOREIGN KEY (`workspace_id` )
  REFERENCES `workspace` (`workspace_id` ))",
  "CREATE  TABLE IF NOT EXISTS `elisa_result` (
  `result_id` INT(11) NOT NULL ,
  `analyte_preferred` VARCHAR(100) NULL DEFAULT NULL ,
  `analyte_reported` VARCHAR(100) NOT NULL ,
  `arm_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `biosample_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `comments` VARCHAR(500) NULL DEFAULT NULL ,
  `experiment_accession` VARCHAR(15) NOT NULL ,
  `expsample_accession` VARCHAR(15) NOT NULL ,
  `study_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `study_time_collected` FLOAT NULL DEFAULT NULL ,
  `study_time_collected_unit` VARCHAR(25) NULL DEFAULT NULL ,
  `subject_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `unit_preferred` VARCHAR(50) NULL DEFAULT NULL ,
  `unit_reported` VARCHAR(200) NULL DEFAULT NULL ,
  `value_preferred` FLOAT NULL DEFAULT NULL ,
  `value_reported` VARCHAR(50) NULL DEFAULT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`result_id`) ,
  CONSTRAINT `fk_elisa_result_1`
  FOREIGN KEY (`expsample_accession` )
  REFERENCES `expsample` (`expsample_accession` ),
  CONSTRAINT `fk_elisa_result_2`
  FOREIGN KEY (`experiment_accession` )
  REFERENCES `experiment` (`experiment_accession` ),
  CONSTRAINT `fk_elisa_result_3`
  FOREIGN KEY (`study_accession` )
  REFERENCES `study` (`study_accession` ),
  CONSTRAINT `fk_elisa_result_4`
  FOREIGN KEY (`arm_accession` )
  REFERENCES `arm_or_cohort` (`arm_accession` ),
  CONSTRAINT `fk_elisa_result_5`
  FOREIGN KEY (`biosample_accession` )
  REFERENCES `biosample` (`biosample_accession` ),
  CONSTRAINT `fk_elisa_result_6`
  FOREIGN KEY (`subject_accession` )
  REFERENCES `subject` (`subject_accession` ),
  CONSTRAINT `fk_elisa_result_7`
  FOREIGN KEY (`workspace_id` )
  REFERENCES `workspace` (`workspace_id` ),
  CONSTRAINT `fk_elisa_result_9`
  FOREIGN KEY (`unit_preferred` )
  REFERENCES `lk_unit_of_measure` (`name` ))",
  "CREATE  TABLE IF NOT EXISTS `elispot_result` (
  `result_id` INT(11) NOT NULL ,
  `analyte_preferred` VARCHAR(100) NULL DEFAULT NULL ,
  `analyte_reported` VARCHAR(100) NOT NULL ,
  `arm_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `biosample_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `cell_number_preferred` FLOAT NULL DEFAULT NULL ,
  `cell_number_reported` VARCHAR(50) NULL DEFAULT NULL ,
  `comments` VARCHAR(500) NULL DEFAULT NULL ,
  `experiment_accession` VARCHAR(15) NOT NULL ,
  `expsample_accession` VARCHAR(15) NOT NULL ,
  `spot_number_preferred` FLOAT NULL DEFAULT NULL ,
  `spot_number_reported` VARCHAR(50) NULL DEFAULT NULL ,
  `study_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `study_time_collected` FLOAT NULL DEFAULT NULL ,
  `study_time_collected_unit` VARCHAR(25) NULL DEFAULT NULL ,
  `subject_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`result_id`) ,
  CONSTRAINT `fk_elispot_result_1`
  FOREIGN KEY (`expsample_accession` )
  REFERENCES `expsample` (`expsample_accession` ),
  CONSTRAINT `fk_elispot_result_2`
  FOREIGN KEY (`experiment_accession` )
  REFERENCES `experiment` (`experiment_accession` ),
  CONSTRAINT `fk_elispot_result_3`
  FOREIGN KEY (`study_accession` )
  REFERENCES `study` (`study_accession` ),
  CONSTRAINT `fk_elispot_result_4`
  FOREIGN KEY (`arm_accession` )
  REFERENCES `arm_or_cohort` (`arm_accession` ),
  CONSTRAINT `fk_elispot_result_5`
  FOREIGN KEY (`biosample_accession` )
  REFERENCES `biosample` (`biosample_accession` ),
  CONSTRAINT `fk_elispot_result_6`
  FOREIGN KEY (`subject_accession` )
  REFERENCES `subject` (`subject_accession` ),
  CONSTRAINT `fk_elispot_result_7`
  FOREIGN KEY (`workspace_id` )
  REFERENCES `workspace` (`workspace_id` ))",
  "CREATE  TABLE IF NOT EXISTS `lk_protocol_type` (
  `name` VARCHAR(100) NOT NULL ,
  `description` VARCHAR(1000) NULL DEFAULT NULL ,
  `link` VARCHAR(2000) NULL DEFAULT NULL ,
  PRIMARY KEY (`name`) )",
  "CREATE  TABLE IF NOT EXISTS `protocol` (
  `protocol_accession` VARCHAR(15) NOT NULL ,
  `description` VARCHAR(4000) NULL DEFAULT NULL ,
  `file_name` VARCHAR(250) NOT NULL ,
  `name` VARCHAR(250) NOT NULL ,
  `original_file_name` VARCHAR(250) NOT NULL ,
  `type` VARCHAR(100) NOT NULL DEFAULT 'Not Specified' ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`protocol_accession`) ,
  CONSTRAINT `fk_protocol_1`
  FOREIGN KEY (`type` )
  REFERENCES `lk_protocol_type` (`name` ),
  CONSTRAINT `fk_protocol_2`
  FOREIGN KEY (`workspace_id` )
  REFERENCES `workspace` (`workspace_id` ))",
  "CREATE  TABLE IF NOT EXISTS `experiment_2_protocol` (
  `experiment_accession` VARCHAR(15) NOT NULL ,
  `protocol_accession` VARCHAR(15) NOT NULL ,
  PRIMARY KEY (`experiment_accession`, `protocol_accession`) ,
  CONSTRAINT `fk_experiment_2_protocol_1`
  FOREIGN KEY (`experiment_accession` )
  REFERENCES `experiment` (`experiment_accession` ),
  CONSTRAINT `fk_exp_2_protocol_2`
  FOREIGN KEY (`protocol_accession` )
  REFERENCES `protocol` (`protocol_accession` ))",
  "CREATE  TABLE IF NOT EXISTS `expsample_2_biosample` (
  `biosample_accession` VARCHAR(15) NOT NULL ,
  `expsample_accession` VARCHAR(15) NOT NULL ,
  PRIMARY KEY (`expsample_accession`, `biosample_accession`) ,
  CONSTRAINT `fk_expsample_2_biosample_1`
  FOREIGN KEY (`expsample_accession` )
  REFERENCES `expsample` (`expsample_accession` ),
  CONSTRAINT `fk_expsample_2_biosample_2`
  FOREIGN KEY (`biosample_accession` )
  REFERENCES `biosample` (`biosample_accession` ))",
  "CREATE  TABLE IF NOT EXISTS `expsample_2_file_info` (
  `expsample_accession` VARCHAR(15) NOT NULL ,
  `file_info_id` INT(11) NOT NULL ,
  `result_schema` VARCHAR(50) NOT NULL ,
  PRIMARY KEY (`expsample_accession`, `file_info_id`) ,
  CONSTRAINT `fk_expsample_2_file_info_1`
  FOREIGN KEY (`expsample_accession` )
  REFERENCES `expsample` (`expsample_accession` ),
  CONSTRAINT `fk_expsample_2_file_info_2`
  FOREIGN KEY (`file_info_id` )
  REFERENCES `file_info` (`file_info_id` ),
  CONSTRAINT `fk_expsample_2_file_info_4`
  FOREIGN KEY (`result_schema` )
  REFERENCES `lk_expsample_result_schema` (`name` ))",
  "CREATE  TABLE IF NOT EXISTS `lk_reagent_type` (
  `name` VARCHAR(50) NOT NULL ,
  `description` VARCHAR(1000) NULL DEFAULT NULL ,
  `link` VARCHAR(2000) NULL DEFAULT NULL ,
  PRIMARY KEY (`name`) )",
  "CREATE  TABLE IF NOT EXISTS `reagent` (
  `reagent_accession` VARCHAR(15) NOT NULL ,
  `analyte_preferred` VARCHAR(200) NULL DEFAULT NULL ,
  `analyte_reported` VARCHAR(200) NULL DEFAULT NULL ,
  `antibody_registry_id` VARCHAR(250) NULL DEFAULT NULL ,
  `catalog_number` VARCHAR(250) NULL DEFAULT NULL ,
  `clone_name` VARCHAR(200) NULL DEFAULT NULL ,
  `contact` VARCHAR(1000) NULL DEFAULT NULL ,
  `description` VARCHAR(4000) NULL DEFAULT NULL ,
  `is_set` VARCHAR(1) NULL DEFAULT 'N' ,
  `lot_number` VARCHAR(250) NULL DEFAULT NULL ,
  `manufacturer` VARCHAR(100) NULL DEFAULT NULL ,
  `name` VARCHAR(200) NULL DEFAULT NULL ,
  `reporter_name` VARCHAR(200) NULL DEFAULT NULL ,
  `type` VARCHAR(50) NULL DEFAULT NULL ,
  `weblink` VARCHAR(250) NULL DEFAULT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`reagent_accession`) ,
  CONSTRAINT `fk_reagent_1`
  FOREIGN KEY (`workspace_id` )
  REFERENCES `workspace` (`workspace_id` ),
  CONSTRAINT `fk_reagent_2`
  FOREIGN KEY (`type` )
  REFERENCES `lk_reagent_type` (`name` ))",
  "CREATE  TABLE IF NOT EXISTS `expsample_2_reagent` (
  `expsample_accession` VARCHAR(15) NOT NULL ,
  `reagent_accession` VARCHAR(15) NOT NULL ,
  PRIMARY KEY (`expsample_accession`, `reagent_accession`) ,
  CONSTRAINT `fk_expsample_2_reagent_1`
  FOREIGN KEY (`expsample_accession` )
  REFERENCES `expsample` (`expsample_accession` ),
  CONSTRAINT `fk_expsample_2_reagent_2`
  FOREIGN KEY (`reagent_accession` )
  REFERENCES `reagent` (`reagent_accession` ))",
  "CREATE  TABLE IF NOT EXISTS `expsample_2_treatment` (
  `expsample_accession` VARCHAR(15) NOT NULL ,
  `treatment_accession` VARCHAR(15) NOT NULL ,
  PRIMARY KEY (`expsample_accession`, `treatment_accession`) ,
  CONSTRAINT `fk_expsample_2_treatment_1`
  FOREIGN KEY (`expsample_accession` )
  REFERENCES `expsample` (`expsample_accession` ),
  CONSTRAINT `fk_expsample_2_treatment_2`
  FOREIGN KEY (`treatment_accession` )
  REFERENCES `treatment` (`treatment_accession` ))",
  "CREATE  TABLE IF NOT EXISTS `lk_plate_type` (
  `name` VARCHAR(50) NOT NULL ,
  `description` VARCHAR(1000) NULL DEFAULT NULL ,
  `link` VARCHAR(2000) NULL DEFAULT NULL ,
  PRIMARY KEY (`name`) )",
  "CREATE  TABLE IF NOT EXISTS `expsample_mbaa_detail` (
  `expsample_accession` VARCHAR(15) NOT NULL ,
  `assay_group_id` VARCHAR(100) NULL DEFAULT NULL ,
  `assay_id` VARCHAR(100) NULL DEFAULT NULL ,
  `dilution_factor` VARCHAR(100) NULL DEFAULT NULL ,
  `plate_type` VARCHAR(100) NULL DEFAULT NULL ,
  PRIMARY KEY (`expsample_accession`) ,
  CONSTRAINT `fk_expsample_mbaa_detail_1`
  FOREIGN KEY (`expsample_accession` )
  REFERENCES `expsample` (`expsample_accession` ),
  CONSTRAINT `fk_expsample_mbaa_detail_2`
  FOREIGN KEY (`plate_type` )
  REFERENCES `lk_plate_type` (`name` ))",
  "CREATE  TABLE IF NOT EXISTS `lk_public_repository` (
  `name` VARCHAR(50) NOT NULL ,
  `description` VARCHAR(1000) NULL DEFAULT NULL ,
  `link` VARCHAR(2000) NULL DEFAULT NULL ,
  PRIMARY KEY (`name`) )",
  "CREATE  TABLE IF NOT EXISTS `expsample_public_repository` (
  `expsample_accession` VARCHAR(15) NOT NULL ,
  `repository_accession` VARCHAR(20) NOT NULL ,
  `repository_name` VARCHAR(50) NOT NULL ,
  PRIMARY KEY (`expsample_accession`, `repository_accession`) ,
  CONSTRAINT `fk_expsample_public_1`
  FOREIGN KEY (`expsample_accession` )
  REFERENCES `expsample` (`expsample_accession` ),
  CONSTRAINT `fk_expsample_public_2`
  FOREIGN KEY (`repository_name` )
  REFERENCES `lk_public_repository` (`name` ))",
  "CREATE  TABLE IF NOT EXISTS `fcs_analyzed_result` (
  `result_id` INT(11) NOT NULL ,
  `arm_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `biosample_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `comments` VARCHAR(500) NULL DEFAULT NULL ,
  `experiment_accession` VARCHAR(15) NOT NULL ,
  `expsample_accession` VARCHAR(15) NOT NULL ,
  `parent_population_preferred` VARCHAR(150) NULL DEFAULT NULL ,
  `parent_population_reported` VARCHAR(150) NULL DEFAULT NULL ,
  `population_defnition_preferred` VARCHAR(150) NULL DEFAULT NULL ,
  `population_defnition_reported` VARCHAR(150) NULL DEFAULT NULL ,
  `population_name_preferred` VARCHAR(150) NULL DEFAULT NULL ,
  `population_name_reported` VARCHAR(150) NULL DEFAULT NULL ,
  `population_stat_unit_preferred` VARCHAR(50) NULL DEFAULT NULL ,
  `population_stat_unit_reported` VARCHAR(50) NULL DEFAULT NULL ,
  `population_statistic_preferred` FLOAT NULL DEFAULT NULL ,
  `population_statistic_reported` VARCHAR(50) NULL DEFAULT NULL ,
  `study_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `study_time_collected` FLOAT NULL DEFAULT NULL ,
  `study_time_collected_unit` VARCHAR(25) NULL DEFAULT NULL ,
  `subject_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `workspace_file_info_id` INT(11) NULL DEFAULT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`result_id`) ,
  CONSTRAINT `fk_fcs_analyzed_result_1`
  FOREIGN KEY (`expsample_accession` )
  REFERENCES `expsample` (`expsample_accession` ),
  CONSTRAINT `fk_fcs_analyzed_result_12`
  FOREIGN KEY (`population_stat_unit_preferred` )
  REFERENCES `lk_unit_of_measure` (`name` ),
  CONSTRAINT `fk_fcs_analyzed_result_13`
  FOREIGN KEY (`workspace_file_info_id` )
  REFERENCES `file_info` (`file_info_id` ),
  CONSTRAINT `fk_fcs_analyzed_result_2`
  FOREIGN KEY (`experiment_accession` )
  REFERENCES `experiment` (`experiment_accession` ),
  CONSTRAINT `fk_fcs_analyzed_result_3`
  FOREIGN KEY (`study_accession` )
  REFERENCES `study` (`study_accession` ),
  CONSTRAINT `fk_fcs_analyzed_result_4`
  FOREIGN KEY (`arm_accession` )
  REFERENCES `arm_or_cohort` (`arm_accession` ),
  CONSTRAINT `fk_fcs_analyzed_result_5`
  FOREIGN KEY (`biosample_accession` )
  REFERENCES `biosample` (`biosample_accession` ),
  CONSTRAINT `fk_fcs_analyzed_result_6`
  FOREIGN KEY (`subject_accession` )
  REFERENCES `subject` (`subject_accession` ),
  CONSTRAINT `fk_fcs_analyzed_result_8`
  FOREIGN KEY (`workspace_id` )
  REFERENCES `workspace` (`workspace_id` ))",
  "CREATE  TABLE IF NOT EXISTS `fcs_analyzed_result_marker` (
  `fcs_analyzed_result_marker_id` INT(11) NOT NULL ,
  `population_marker_preferred` VARCHAR(500) NULL DEFAULT NULL ,
  `population_marker_reported` VARCHAR(500) NULL DEFAULT NULL ,
  `result_id` INT(11) NOT NULL ,
  PRIMARY KEY (`fcs_analyzed_result_marker_id`) ,
  CONSTRAINT `fk_fcs_analyzed_result_marker_1`
  FOREIGN KEY (`result_id` )
  REFERENCES `fcs_analyzed_result` (`result_id` ))",
  "CREATE  TABLE IF NOT EXISTS `fcs_header` (
  `fcs_header_id` INT(11) NOT NULL ,
  `compensation_flag` VARCHAR(1) NULL DEFAULT NULL ,
  `expsample_accession` VARCHAR(15) NOT NULL ,
  `fcs_file_name` VARCHAR(250) NULL DEFAULT NULL ,
  `fcs_header_text` LONGTEXT NULL DEFAULT NULL ,
  `fcs_version` FLOAT NULL DEFAULT NULL ,
  `file_info_id` INT(11) NULL DEFAULT NULL ,
  `maximum_intensity` FLOAT NULL DEFAULT NULL ,
  `minimum_intensity` FLOAT NULL DEFAULT NULL ,
  `number_of_events` INT(11) NULL DEFAULT NULL ,
  `number_of_markers` INT(11) NULL DEFAULT NULL ,
  `panel_preferred` VARCHAR(2000) NULL DEFAULT NULL ,
  `panel_reported` VARCHAR(2000) NULL DEFAULT NULL ,
  PRIMARY KEY (`fcs_header_id`) ,
  CONSTRAINT `fk_fcs_header_1`
  FOREIGN KEY (`expsample_accession` )
  REFERENCES `expsample` (`expsample_accession` ),
  CONSTRAINT `fk_fcs_header_2`
  FOREIGN KEY (`file_info_id` )
  REFERENCES `file_info` (`file_info_id` ))",
  "CREATE  TABLE IF NOT EXISTS `fcs_header_marker` (
  `fcs_header_id` INT(11) NOT NULL ,
  `parameter_number` INT(11) NOT NULL ,
  `pnn_preferred` VARCHAR(50) NULL DEFAULT NULL ,
  `pnn_reported` VARCHAR(50) NULL DEFAULT NULL ,
  `pns_preferred` VARCHAR(50) NULL DEFAULT NULL ,
  `pns_reported` VARCHAR(50) NULL DEFAULT NULL ,
  PRIMARY KEY (`fcs_header_id`, `parameter_number`) ,
  CONSTRAINT `fk_fcs_header_marker_1`
  FOREIGN KEY (`fcs_header_id` )
  REFERENCES `fcs_header` (`fcs_header_id` ))",
  "CREATE  TABLE IF NOT EXISTS `fcs_header_marker_2_reagent` (
  `fcs_header_id` INT(11) NOT NULL ,
  `parameter_number` INT(11) NOT NULL ,
  `reagent_accession` VARCHAR(15) NOT NULL ,
  PRIMARY KEY (`fcs_header_id`, `parameter_number`, `reagent_accession`) )",
  "CREATE  TABLE IF NOT EXISTS `lk_virus_strain` (
  `name` VARCHAR(200) NOT NULL ,
  `center_id_name_season_list` VARCHAR(500) NULL DEFAULT NULL ,
  `description` VARCHAR(1000) NULL DEFAULT NULL ,
  `link` VARCHAR(2000) NULL DEFAULT NULL ,
  `season_list` VARCHAR(100) NULL DEFAULT NULL ,
  `taxonomy_id` INT(11) NULL DEFAULT NULL ,
  `virus_name` VARCHAR(10) NULL DEFAULT NULL ,
  PRIMARY KEY (`name`) )",
  "CREATE  TABLE IF NOT EXISTS `hai_result` (
  `result_id` INT(11) NOT NULL ,
  `arm_accession` VARCHAR(15) NOT NULL ,
  `biosample_accession` VARCHAR(15) NOT NULL ,
  `comments` VARCHAR(500) NULL DEFAULT NULL ,
  `experiment_accession` VARCHAR(15) NOT NULL ,
  `expsample_accession` VARCHAR(15) NOT NULL ,
  `study_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `study_time_collected` FLOAT NULL DEFAULT NULL ,
  `study_time_collected_unit` VARCHAR(25) NULL DEFAULT NULL ,
  `subject_accession` VARCHAR(15) NOT NULL ,
  `unit_preferred` VARCHAR(50) NULL DEFAULT NULL ,
  `unit_reported` VARCHAR(200) NULL DEFAULT NULL ,
  `value_preferred` FLOAT NULL DEFAULT NULL ,
  `value_reported` VARCHAR(50) NULL DEFAULT NULL ,
  `virus_strain_preferred` VARCHAR(200) NULL DEFAULT NULL ,
  `virus_strain_reported` VARCHAR(200) NULL DEFAULT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`result_id`) ,
  CONSTRAINT `fk_hai_result_1`
  FOREIGN KEY (`expsample_accession` )
  REFERENCES `expsample` (`expsample_accession` ),
  CONSTRAINT `fk_hai_result_2`
  FOREIGN KEY (`experiment_accession` )
  REFERENCES `experiment` (`experiment_accession` ),
  CONSTRAINT `fk_hai_result_3`
  FOREIGN KEY (`study_accession` )
  REFERENCES `study` (`study_accession` ),
  CONSTRAINT `fk_hai_result_4`
  FOREIGN KEY (`arm_accession` )
  REFERENCES `arm_or_cohort` (`arm_accession` ),
  CONSTRAINT `fk_hai_result_5`
  FOREIGN KEY (`biosample_accession` )
  REFERENCES `biosample` (`biosample_accession` ),
  CONSTRAINT `fk_hai_result_6`
  FOREIGN KEY (`subject_accession` )
  REFERENCES `subject` (`subject_accession` ),
  CONSTRAINT `fk_hai_result_7`
  FOREIGN KEY (`workspace_id` )
  REFERENCES `workspace` (`workspace_id` ),
  CONSTRAINT `fk_hai_result_8`
  FOREIGN KEY (`virus_strain_preferred` )
  REFERENCES `lk_virus_strain` (`name` ),
  CONSTRAINT `fk_hai_result_9`
  FOREIGN KEY (`unit_preferred` )
  REFERENCES `lk_unit_of_measure` (`name` ))",
  "CREATE  TABLE IF NOT EXISTS `hla_typing_result` (
  `result_id` INT(11) NOT NULL ,
  `allele_1` VARCHAR(250) NULL DEFAULT NULL ,
  `allele_2` VARCHAR(250) NULL DEFAULT NULL ,
  `ancestral_population` VARCHAR(250) NULL DEFAULT NULL ,
  `arm_accession` VARCHAR(15) NOT NULL ,
  `biosample_accession` VARCHAR(15) NOT NULL ,
  `comments` VARCHAR(500) NULL DEFAULT NULL ,
  `experiment_accession` VARCHAR(15) NOT NULL ,
  `expsample_accession` VARCHAR(15) NOT NULL ,
  `locus_name` VARCHAR(25) NULL DEFAULT NULL ,
  `result_set_id` INT(11) NOT NULL ,
  `study_accession` VARCHAR(15) NOT NULL ,
  `study_time_collected` FLOAT NULL DEFAULT NULL ,
  `study_time_collected_unit` VARCHAR(25) NULL DEFAULT NULL ,
  `subject_accession` VARCHAR(15) NOT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`result_id`) ,
  CONSTRAINT `fk_hla_typing_result_1`
  FOREIGN KEY (`expsample_accession` )
  REFERENCES `expsample` (`expsample_accession` ),
  CONSTRAINT `fk_hla_typing_result_2`
  FOREIGN KEY (`experiment_accession` )
  REFERENCES `experiment` (`experiment_accession` ),
  CONSTRAINT `fk_hla_typing_result_3`
  FOREIGN KEY (`study_accession` )
  REFERENCES `study` (`study_accession` ),
  CONSTRAINT `fk_hla_typing_result_4`
  FOREIGN KEY (`arm_accession` )
  REFERENCES `arm_or_cohort` (`arm_accession` ),
  CONSTRAINT `fk_hla_typing_result_5`
  FOREIGN KEY (`biosample_accession` )
  REFERENCES `biosample` (`biosample_accession` ),
  CONSTRAINT `fk_hla_typing_result_6`
  FOREIGN KEY (`subject_accession` )
  REFERENCES `subject` (`subject_accession` ),
  CONSTRAINT `fk_hla_typing_result_7`
  FOREIGN KEY (`workspace_id` )
  REFERENCES `workspace` (`workspace_id` ))",
  "CREATE  TABLE IF NOT EXISTS `lk_criterion_category` (
  `name` VARCHAR(40) NOT NULL ,
  `description` VARCHAR(1000) NULL DEFAULT NULL ,
  `link` VARCHAR(2000) NULL DEFAULT NULL ,
  PRIMARY KEY (`name`) )",
  "CREATE  TABLE IF NOT EXISTS `inclusion_exclusion` (
  `criterion_accession` VARCHAR(15) NOT NULL ,
  `criterion` VARCHAR(750) NULL DEFAULT NULL ,
  `criterion_category` VARCHAR(40) NULL DEFAULT NULL ,
  `study_accession` VARCHAR(15) NOT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`criterion_accession`) ,
  CONSTRAINT `fk_inclusion_exclusion_1`
  FOREIGN KEY (`study_accession` )
  REFERENCES `study` (`study_accession` ),
  CONSTRAINT `fk_inclusion_exclusion_2`
  FOREIGN KEY (`workspace_id` )
  REFERENCES `workspace` (`workspace_id` ),
  CONSTRAINT `fk_inclusion_exclusion_3`
  FOREIGN KEY (`criterion_category` )
  REFERENCES `lk_criterion_category` (`name` ))",
  "CREATE  TABLE IF NOT EXISTS `lk_compound_role` (
  `name` VARCHAR(40) NOT NULL ,
  `description` VARCHAR(1000) NULL DEFAULT NULL ,
  `link` VARCHAR(2000) NULL DEFAULT NULL ,
  PRIMARY KEY (`name`) )",
  "CREATE  TABLE IF NOT EXISTS `intervention` (
  `intervention_accession` VARCHAR(15) NOT NULL ,
  `compound_name_reported` VARCHAR(250) NULL DEFAULT NULL ,
  `compound_role` VARCHAR(40) NOT NULL ,
  `dose` FLOAT NULL DEFAULT NULL ,
  `dose_freq_per_interval` VARCHAR(40) NULL DEFAULT NULL ,
  `dose_reported` VARCHAR(150) NULL DEFAULT NULL ,
  `dose_units` VARCHAR(40) NULL DEFAULT NULL ,
  `duration` FLOAT NULL DEFAULT NULL ,
  `duration_unit` VARCHAR(10) NULL DEFAULT NULL ,
  `end_day` FLOAT NULL DEFAULT NULL ,
  `end_time` VARCHAR(40) NULL DEFAULT NULL ,
  `formulation` VARCHAR(125) NULL DEFAULT NULL ,
  `is_ongoing` VARCHAR(40) NULL DEFAULT NULL ,
  `name_preferred` VARCHAR(40) NULL DEFAULT NULL ,
  `name_reported` VARCHAR(125) NOT NULL ,
  `reported_indication` VARCHAR(255) NULL DEFAULT NULL ,
  `route_of_admin_preferred` VARCHAR(40) NULL DEFAULT NULL ,
  `route_of_admin_reported` VARCHAR(40) NULL DEFAULT NULL ,
  `start_day` FLOAT NULL DEFAULT NULL ,
  `start_time` VARCHAR(40) NULL DEFAULT NULL ,
  `status` VARCHAR(40) NULL DEFAULT NULL ,
  `study_accession` VARCHAR(15) NOT NULL ,
  `subject_accession` VARCHAR(15) NOT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`intervention_accession`) ,
  CONSTRAINT `fk_intervention_1`
  FOREIGN KEY (`study_accession` )
  REFERENCES `study` (`study_accession` ),
  CONSTRAINT `fk_intervention_2`
  FOREIGN KEY (`workspace_id` )
  REFERENCES `workspace` (`workspace_id` ),
  CONSTRAINT `fk_intervention_3`
  FOREIGN KEY (`subject_accession` )
  REFERENCES `subject` (`subject_accession` ),
  CONSTRAINT `fk_intervention_4`
  FOREIGN KEY (`compound_role` )
  REFERENCES `lk_compound_role` (`name` ))",
  "CREATE  TABLE IF NOT EXISTS `kir_typing_result` (
  `result_id` INT(11) NOT NULL ,
  `allele_1` VARCHAR(500) NULL DEFAULT NULL ,
  `allele_2` VARCHAR(500) NULL DEFAULT NULL ,
  `arm_accession` VARCHAR(15) NOT NULL ,
  `biosample_accession` VARCHAR(15) NOT NULL ,
  `comments` VARCHAR(500) NULL DEFAULT NULL ,
  `experiment_accession` VARCHAR(15) NOT NULL ,
  `expsample_accession` VARCHAR(15) NOT NULL ,
  `study_accession` VARCHAR(15) NOT NULL ,
  `study_time_collected` FLOAT NULL DEFAULT NULL ,
  `study_time_collected_unit` VARCHAR(25) NULL DEFAULT NULL ,
  `subject_accession` VARCHAR(15) NOT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`result_id`) ,
  CONSTRAINT `fk_kir_typing_result_1`
  FOREIGN KEY (`expsample_accession` )
  REFERENCES `expsample` (`expsample_accession` ),
  CONSTRAINT `fk_kir_typing_result_2`
  FOREIGN KEY (`experiment_accession` )
  REFERENCES `experiment` (`experiment_accession` ),
  CONSTRAINT `fk_kir_typing_result_3`
  FOREIGN KEY (`study_accession` )
  REFERENCES `study` (`study_accession` ),
  CONSTRAINT `fk_kir_typing_result_4`
  FOREIGN KEY (`arm_accession` )
  REFERENCES `arm_or_cohort` (`arm_accession` ),
  CONSTRAINT `fk_kir_typing_result_5`
  FOREIGN KEY (`biosample_accession` )
  REFERENCES `biosample` (`biosample_accession` ),
  CONSTRAINT `fk_kir_typing_result_6`
  FOREIGN KEY (`subject_accession` )
  REFERENCES `subject` (`subject_accession` ),
  CONSTRAINT `fk_kir_typing_result_7`
  FOREIGN KEY (`workspace_id` )
  REFERENCES `workspace` (`workspace_id` ))",
  "CREATE  TABLE IF NOT EXISTS `lab_test_panel` (
  `lab_test_panel_accession` VARCHAR(15) NOT NULL ,
  `name_preferred` VARCHAR(125) NULL DEFAULT NULL ,
  `name_reported` VARCHAR(125) NULL DEFAULT NULL ,
  `study_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`lab_test_panel_accession`) ,
  CONSTRAINT `fk_lab_test_panel_1`
  FOREIGN KEY (`workspace_id` )
  REFERENCES `workspace` (`workspace_id` ),
  CONSTRAINT `fk_lab_test_panel_2`
  FOREIGN KEY (`study_accession` )
  REFERENCES `study` (`study_accession` ))",
  "CREATE  TABLE IF NOT EXISTS `lk_lab_test_name` (
  `name` VARCHAR(50) NOT NULL ,
  `cdisc_lab_test_code` VARCHAR(50) NULL DEFAULT NULL ,
  `description` VARCHAR(1000) NULL DEFAULT NULL ,
  `lab_test_panel_name` VARCHAR(50) NULL DEFAULT NULL ,
  `link` VARCHAR(2000) NULL DEFAULT NULL ,
  PRIMARY KEY (`name`) )",
  "CREATE  TABLE IF NOT EXISTS `lab_test` (
  `lab_test_accession` VARCHAR(15) NOT NULL ,
  `lab_test_panel_accession` VARCHAR(15) NOT NULL ,
  `biosample_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `name_preferred` VARCHAR(40) NULL DEFAULT NULL ,
  `name_reported` VARCHAR(125) NULL DEFAULT NULL ,
  `reference_range_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `result_unit_preferred` VARCHAR(40) NULL DEFAULT NULL ,
  `result_unit_reported` VARCHAR(40) NULL DEFAULT NULL ,
  `result_value_preferred` FLOAT NULL DEFAULT NULL ,
  `result_value_reported` VARCHAR(250) NULL DEFAULT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`lab_test_accession`) ,
  CONSTRAINT `fk_lab_test_1`
  FOREIGN KEY (`workspace_id` )
  REFERENCES `workspace` (`workspace_id` ),
  CONSTRAINT `fk_lab_test_2`
  FOREIGN KEY (`biosample_accession` )
  REFERENCES `biosample` (`biosample_accession` ),
  CONSTRAINT `fk_lab_test_3`
  FOREIGN KEY (`lab_test_panel_accession` )
  REFERENCES `lab_test_panel` (`lab_test_panel_accession` ),
  CONSTRAINT `fk_lab_test_4`
  FOREIGN KEY (`name_preferred` )
  REFERENCES `lk_lab_test_name` (`name` ),
  CONSTRAINT `fk_lab_test_5`
  FOREIGN KEY (`result_unit_preferred` )
  REFERENCES `lk_unit_of_measure` (`name` ))",
  "CREATE  TABLE IF NOT EXISTS `lab_test_panel_2_protocol` (
  `lab_test_panel_accession` VARCHAR(15) NOT NULL ,
  `protocol_accession` VARCHAR(15) NOT NULL ,
  PRIMARY KEY (`lab_test_panel_accession`, `protocol_accession`) ,
  CONSTRAINT `fk_lab_test_2_protocol_2`
  FOREIGN KEY (`protocol_accession` )
  REFERENCES `protocol` (`protocol_accession` ),
  CONSTRAINT `fk_lab_test__panel_2_protocol_1`
  FOREIGN KEY (`lab_test_panel_accession` )
  REFERENCES `lab_test_panel` (`lab_test_panel_accession` ))",
  "CREATE  TABLE IF NOT EXISTS `lk_analyte` (
  `analyte_accession` VARCHAR(15) NOT NULL ,
  `gene_aliases` TEXT NULL DEFAULT NULL ,
  `gene_id` VARCHAR(10) NULL DEFAULT NULL ,
  `genetic_nomenclature_id` VARCHAR(15) NULL DEFAULT NULL ,
  `immunology_gene_symbol` VARCHAR(100) NULL DEFAULT NULL ,
  `link` VARCHAR(2000) NULL DEFAULT NULL ,
  `official_gene_name` VARCHAR(255) NULL DEFAULT NULL ,
  `protein_ontology_id` VARCHAR(15) NULL DEFAULT NULL ,
  `protein_ontology_name` VARCHAR(100) NULL DEFAULT NULL ,
  `protein_ontology_synonyms` TEXT NULL DEFAULT NULL ,
  `taxonomy_id` VARCHAR(10) NULL DEFAULT NULL ,
  PRIMARY KEY (`analyte_accession`) )",
  "CREATE UNIQUE INDEX `idx_lk_analyte_1` ON `lk_analyte` (`analyte_accession` ASC)",
  "CREATE  TABLE IF NOT EXISTS `lk_ancestral_population` (
  `name` VARCHAR(30) NOT NULL ,
  `abbreviation` VARCHAR(3) NULL DEFAULT NULL ,
  `description` VARCHAR(4000) NOT NULL ,
  `link` VARCHAR(2000) NULL DEFAULT NULL ,
  PRIMARY KEY (`name`) )",
  "CREATE  TABLE IF NOT EXISTS `lk_cell_population` (
  `name` VARCHAR(150) NOT NULL ,
  `comments` VARCHAR(500) NULL DEFAULT NULL ,
  `definition` VARCHAR(150) NULL DEFAULT NULL ,
  `description` VARCHAR(1000) NULL DEFAULT NULL ,
  `link` VARCHAR(2000) NULL DEFAULT NULL ,
  PRIMARY KEY (`name`) )",
  "CREATE  TABLE IF NOT EXISTS `lk_lab_test_panel_name` (
  `name` VARCHAR(125) NOT NULL ,
  `description` VARCHAR(1000) NULL DEFAULT NULL ,
  `link` VARCHAR(2000) NULL DEFAULT NULL ,
  PRIMARY KEY (`name`) )",
  "CREATE  TABLE IF NOT EXISTS `lk_locus_name` (
  `name` VARCHAR(100) NOT NULL ,
  `description` VARCHAR(250) NULL DEFAULT NULL ,
  `link` VARCHAR(2000) NULL DEFAULT NULL ,
  PRIMARY KEY (`name`) )",
  "CREATE  TABLE IF NOT EXISTS `lk_organization` (
  `name` VARCHAR(125) NOT NULL ,
  `link` VARCHAR(2000) NULL DEFAULT NULL ,
  PRIMARY KEY (`name`) )",
  "CREATE  TABLE IF NOT EXISTS `lk_personnel_role` (
  `name` VARCHAR(40) NOT NULL ,
  `description` VARCHAR(1000) NULL DEFAULT NULL ,
  `link` VARCHAR(2000) NULL DEFAULT NULL ,
  PRIMARY KEY (`name`) )",
  "CREATE  TABLE IF NOT EXISTS `lk_research_focus` (
  `name` VARCHAR(50) NOT NULL ,
  `description` VARCHAR(1000) NULL DEFAULT NULL ,
  `link` VARCHAR(2000) NULL DEFAULT NULL ,
  PRIMARY KEY (`name`) )",
  "CREATE  TABLE IF NOT EXISTS `lk_source_type` (
  `name` VARCHAR(30) NOT NULL ,
  `description` VARCHAR(1000) NULL DEFAULT NULL ,
  `link` VARCHAR(2000) NULL DEFAULT NULL ,
  PRIMARY KEY (`name`) )",
  "CREATE  TABLE IF NOT EXISTS `lk_study_file_type` (
  `name` VARCHAR(50) NOT NULL ,
  `description` VARCHAR(1000) NULL DEFAULT NULL ,
  `link` VARCHAR(2000) NULL DEFAULT NULL ,
  PRIMARY KEY (`name`) )",
  "CREATE  TABLE IF NOT EXISTS `lk_study_panel` (
  `name` VARCHAR(100) NOT NULL ,
  `collapsible` VARCHAR(1) NULL DEFAULT NULL ,
  `description` VARCHAR(1000) NULL DEFAULT NULL ,
  `display_name` VARCHAR(100) NULL DEFAULT NULL ,
  `sort_order` INT(11) NULL DEFAULT NULL ,
  `visible` VARCHAR(1) NULL DEFAULT NULL ,
  PRIMARY KEY (`name`) )",
  "CREATE  TABLE IF NOT EXISTS `mbaa_result` (
  `result_id` INT(11) NOT NULL ,
  `analyte_preferred` VARCHAR(100) NULL DEFAULT NULL ,
  `analyte_reported` VARCHAR(100) NULL DEFAULT NULL ,
  `arm_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `assay_group_id` VARCHAR(100) NULL DEFAULT NULL ,
  `assay_id` VARCHAR(100) NULL DEFAULT NULL ,
  `biosample_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `comments` VARCHAR(500) NULL DEFAULT NULL ,
  `concentration_unit_reported` VARCHAR(100) NULL DEFAULT NULL ,
  `concentration_unit_preferred` VARCHAR(100) NULL DEFAULT NULL ,
  `concentration_value_reported` VARCHAR(100) NULL DEFAULT NULL ,
  `concentration_value_preferred` VARCHAR(100) NULL DEFAULT NULL ,
  `experiment_accession` VARCHAR(15) NOT NULL ,
  `mfi` VARCHAR(100) NULL DEFAULT NULL ,
  `mfi_coordinate` VARCHAR(100) NULL DEFAULT NULL ,
  `source_accession` VARCHAR(15) NOT NULL ,
  `source_type` VARCHAR(30) NOT NULL ,
  `study_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `study_time_collected` FLOAT NULL DEFAULT NULL ,
  `study_time_collected_unit` VARCHAR(25) NULL DEFAULT NULL ,
  `subject_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`result_id`) ,
  CONSTRAINT `fk_mbaa_result_1`
  FOREIGN KEY (`experiment_accession` )
  REFERENCES `experiment` (`experiment_accession` ),
  CONSTRAINT `fk_mbaa_result_2`
  FOREIGN KEY (`study_accession` )
  REFERENCES `study` (`study_accession` ),
  CONSTRAINT `fk_mbaa_result_3`
  FOREIGN KEY (`arm_accession` )
  REFERENCES `arm_or_cohort` (`arm_accession` ),
  CONSTRAINT `fk_mbaa_result_4`
  FOREIGN KEY (`biosample_accession` )
  REFERENCES `biosample` (`biosample_accession` ),
  CONSTRAINT `fk_mbaa_result_5`
  FOREIGN KEY (`subject_accession` )
  REFERENCES `subject` (`subject_accession` ),
  CONSTRAINT `fk_mbaa_result_6`
  FOREIGN KEY (`workspace_id` )
  REFERENCES `workspace` (`workspace_id` ),
  CONSTRAINT `fk_mbaa_result_7`
  FOREIGN KEY (`source_type` )
  REFERENCES `lk_source_type` (`name` ))",
  "CREATE  TABLE IF NOT EXISTS `neut_ab_titer_result` (
  `result_id` INT(11) NOT NULL ,
  `arm_accession` VARCHAR(15) NOT NULL ,
  `biosample_accession` VARCHAR(15) NOT NULL ,
  `comments` VARCHAR(500) NULL DEFAULT NULL ,
  `experiment_accession` VARCHAR(15) NOT NULL ,
  `expsample_accession` VARCHAR(15) NOT NULL ,
  `study_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `study_time_collected` FLOAT NULL DEFAULT NULL ,
  `study_time_collected_unit` VARCHAR(25) NULL DEFAULT NULL ,
  `subject_accession` VARCHAR(15) NOT NULL ,
  `unit_preferred` VARCHAR(50) NULL DEFAULT NULL ,
  `unit_reported` VARCHAR(200) NULL DEFAULT NULL ,
  `value_preferred` FLOAT NULL DEFAULT NULL ,
  `value_reported` VARCHAR(50) NULL DEFAULT NULL ,
  `virus_strain_preferred` VARCHAR(200) NULL DEFAULT NULL ,
  `virus_strain_reported` VARCHAR(200) NULL DEFAULT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`result_id`) ,
  CONSTRAINT `fk_neut_result_1`
  FOREIGN KEY (`expsample_accession` )
  REFERENCES `expsample` (`expsample_accession` ),
  CONSTRAINT `fk_neut_result_2`
  FOREIGN KEY (`experiment_accession` )
  REFERENCES `experiment` (`experiment_accession` ),
  CONSTRAINT `fk_neut_result_3`
  FOREIGN KEY (`study_accession` )
  REFERENCES `study` (`study_accession` ),
  CONSTRAINT `fk_neut_result_4`
  FOREIGN KEY (`arm_accession` )
  REFERENCES `arm_or_cohort` (`arm_accession` ),
  CONSTRAINT `fk_neut_result_5`
  FOREIGN KEY (`biosample_accession` )
  REFERENCES `biosample` (`biosample_accession` ),
  CONSTRAINT `fk_neut_result_6`
  FOREIGN KEY (`subject_accession` )
  REFERENCES `subject` (`subject_accession` ),
  CONSTRAINT `fk_neut_result_7`
  FOREIGN KEY (`workspace_id` )
  REFERENCES `workspace` (`workspace_id` ),
  CONSTRAINT `fk_neut_result_8`
  FOREIGN KEY (`virus_strain_preferred` )
  REFERENCES `lk_virus_strain` (`name` ),
  CONSTRAINT `fk_neut_result_9`
  FOREIGN KEY (`unit_preferred` )
  REFERENCES `lk_unit_of_measure` (`name` ))",
  "CREATE  TABLE IF NOT EXISTS `pcr_result` (
  `result_id` INT(11) NOT NULL ,
  `arm_accession` VARCHAR(15) NOT NULL ,
  `biosample_accession` VARCHAR(15) NOT NULL ,
  `comments` VARCHAR(500) NULL DEFAULT NULL ,
  `experiment_accession` VARCHAR(15) NOT NULL ,
  `expsample_accession` VARCHAR(15) NOT NULL ,
  `gene_id` VARCHAR(10) NULL DEFAULT NULL ,
  `gene_name` VARCHAR(4000) NULL DEFAULT NULL ,
  `gene_symbol_preferred` VARCHAR(100) NULL DEFAULT NULL ,
  `gene_symbol_reported` VARCHAR(100) NULL DEFAULT NULL ,
  `other_gene_accession` VARCHAR(250) NULL DEFAULT NULL ,
  `study_accession` VARCHAR(15) NOT NULL ,
  `study_time_collected` FLOAT NULL DEFAULT NULL ,
  `study_time_collected_unit` VARCHAR(25) NULL DEFAULT NULL ,
  `subject_accession` VARCHAR(15) NOT NULL ,
  `unit_preferred` VARCHAR(200) NULL DEFAULT NULL ,
  `unit_reported` VARCHAR(200) NULL DEFAULT NULL ,
  `value_preferred` FLOAT NULL DEFAULT NULL ,
  `value_reported` VARCHAR(50) NULL DEFAULT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`result_id`) ,
  CONSTRAINT `fk_pcr_result_1`
  FOREIGN KEY (`expsample_accession` )
  REFERENCES `expsample` (`expsample_accession` ),
  CONSTRAINT `fk_pcr_result_2`
  FOREIGN KEY (`experiment_accession` )
  REFERENCES `experiment` (`experiment_accession` ),
  CONSTRAINT `fk_pcr_result_3`
  FOREIGN KEY (`study_accession` )
  REFERENCES `study` (`study_accession` ),
  CONSTRAINT `fk_pcr_result_4`
  FOREIGN KEY (`arm_accession` )
  REFERENCES `arm_or_cohort` (`arm_accession` ),
  CONSTRAINT `fk_pcr_result_5`
  FOREIGN KEY (`biosample_accession` )
  REFERENCES `biosample` (`biosample_accession` ),
  CONSTRAINT `fk_pcr_result_6`
  FOREIGN KEY (`subject_accession` )
  REFERENCES `subject` (`subject_accession` ),
  CONSTRAINT `fk_pcr_result_7`
  FOREIGN KEY (`workspace_id` )
  REFERENCES `workspace` (`workspace_id` ),
  CONSTRAINT `fk_pcr_result_8`
  FOREIGN KEY (`unit_preferred` )
  REFERENCES `lk_unit_of_measure` (`name` ))",
  "CREATE  TABLE IF NOT EXISTS `planned_visit_2_arm` (
  `planned_visit_accession` VARCHAR(15) NOT NULL ,
  `arm_accession` VARCHAR(15) NOT NULL ,
  PRIMARY KEY (`planned_visit_accession`, `arm_accession`) ,
  CONSTRAINT `fk_planned_visit_2_arm_1`
  FOREIGN KEY (`planned_visit_accession` )
  REFERENCES `planned_visit` (`planned_visit_accession` ),
  CONSTRAINT `fk_planned_visit_2_arm_2`
  FOREIGN KEY (`arm_accession` )
  REFERENCES `arm_or_cohort` (`arm_accession` ))",
  "CREATE  TABLE IF NOT EXISTS `program_2_personnel` (
  `program_id` INT(11) NOT NULL ,
  `personnel_id` INT(11) NOT NULL ,
  `role_type` VARCHAR(12) NULL DEFAULT NULL ,
  PRIMARY KEY (`program_id`, `personnel_id`) ,
  CONSTRAINT `fk_program_2_personnel_1`
  FOREIGN KEY (`program_id` )
  REFERENCES `program` (`program_id` ),
  CONSTRAINT `fk_program_2_personnel_2`
  FOREIGN KEY (`personnel_id` )
  REFERENCES `personnel` (`personnel_id` ),
  CONSTRAINT `fk_program_2_personnel_3`
  FOREIGN KEY (`role_type` )
  REFERENCES `lk_user_role_type` (`name` ))",
  "CREATE  TABLE IF NOT EXISTS `protocol_deviation` (
  `protocol_deviation_accession` VARCHAR(15) NOT NULL ,
  `description` VARCHAR(4000) NOT NULL ,
  `is_adverse_event_related` VARCHAR(1) NULL DEFAULT NULL ,
  `reason_for_deviation` VARCHAR(250) NULL DEFAULT NULL ,
  `resolution_of_deviation` VARCHAR(500) NULL DEFAULT NULL ,
  `study_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `study_end_day` INT(11) NULL DEFAULT NULL ,
  `study_start_day` INT(11) NULL DEFAULT NULL ,
  `subject_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `subject_continued_study` VARCHAR(1) NULL DEFAULT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`protocol_deviation_accession`) ,
  CONSTRAINT `fk_protocol_deviation_1`
  FOREIGN KEY (`subject_accession` )
  REFERENCES `subject` (`subject_accession` ),
  CONSTRAINT `fk_protocol_deviation_2`
  FOREIGN KEY (`study_accession` )
  REFERENCES `study` (`study_accession` ),
  CONSTRAINT `fk_protocol_deviation_3`
  FOREIGN KEY (`workspace_id` )
  REFERENCES `workspace` (`workspace_id` ))",
  "CREATE  TABLE IF NOT EXISTS `reagent_set_2_reagent` (
  `reagent_set_accession` VARCHAR(15) NOT NULL ,
  `reagent_accession` VARCHAR(15) NOT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`reagent_set_accession`, `reagent_accession`) ,
  CONSTRAINT `fk_reagent_set_1`
  FOREIGN KEY (`workspace_id` )
  REFERENCES `workspace` (`workspace_id` ),
  CONSTRAINT `fk_reagent_set_2`
  FOREIGN KEY (`reagent_accession` )
  REFERENCES `reagent` (`reagent_accession` ),
  CONSTRAINT `fk_reagent_set_3`
  FOREIGN KEY (`reagent_set_accession` )
  REFERENCES `reagent` (`reagent_accession` ))",
  "CREATE  TABLE IF NOT EXISTS `reported_early_termination` (
  `early_termination_accession` VARCHAR(15) NOT NULL ,
  `is_adverse_event_related` VARCHAR(1) NULL DEFAULT NULL ,
  `is_subject_requested` VARCHAR(1) NULL DEFAULT NULL ,
  `reason_preferred` VARCHAR(40) NULL DEFAULT NULL ,
  `reason_reported` VARCHAR(250) NULL DEFAULT NULL ,
  `study_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `study_day_reported` INT(11) NULL DEFAULT NULL ,
  `subject_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`early_termination_accession`) ,
  CONSTRAINT `fk_reported_early_1`
  FOREIGN KEY (`workspace_id` )
  REFERENCES `workspace` (`workspace_id` ),
  CONSTRAINT `fk_reported_early_2`
  FOREIGN KEY (`study_accession` )
  REFERENCES `study` (`study_accession` ),
  CONSTRAINT `fk_reported_early_3`
  FOREIGN KEY (`subject_accession` )
  REFERENCES `subject` (`subject_accession` ))",
  "CREATE  TABLE IF NOT EXISTS `standard_curve` (
  `standard_curve_accession` VARCHAR(15) NOT NULL ,
  `analyte_preferred` VARCHAR(100) NULL DEFAULT NULL ,
  `analyte_reported` VARCHAR(100) NULL DEFAULT NULL ,
  `assay_group_id` VARCHAR(100) NULL DEFAULT NULL ,
  `assay_id` VARCHAR(100) NULL DEFAULT NULL ,
  `experiment_accession` VARCHAR(15) NOT NULL ,
  `formula` VARCHAR(500) NULL DEFAULT NULL ,
  `lower_limit` VARCHAR(100) NULL DEFAULT NULL ,
  `lower_limit_unit` VARCHAR(100) NULL DEFAULT NULL ,
  `result_schema` VARCHAR(50) NOT NULL DEFAULT 'OTHER' ,
  `upload_result_status` VARCHAR(20) NULL DEFAULT NULL ,
  `upper_limit` VARCHAR(100) NULL DEFAULT NULL ,
  `upper_limit_unit` VARCHAR(100) NULL DEFAULT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`standard_curve_accession`) ,
  CONSTRAINT `fk_standard_curve_1`
  FOREIGN KEY (`workspace_id` )
  REFERENCES `workspace` (`workspace_id` ),
  CONSTRAINT `fk_standard_curve_2`
  FOREIGN KEY (`experiment_accession` )
  REFERENCES `experiment` (`experiment_accession` ),
  CONSTRAINT `fk_standard_curve_3`
  FOREIGN KEY (`result_schema` )
  REFERENCES `lk_expsample_result_schema` (`name` ))",
  "CREATE  TABLE IF NOT EXISTS `standard_curve_2_file_info` (
  `standard_curve_accession` VARCHAR(15) NOT NULL ,
  `file_info_id` INT(11) NOT NULL ,
  `result_schema` VARCHAR(50) NOT NULL ,
  PRIMARY KEY (`standard_curve_accession`, `file_info_id`) ,
  CONSTRAINT `fk_standard_curve_2_file_info_1`
  FOREIGN KEY (`standard_curve_accession` )
  REFERENCES `standard_curve` (`standard_curve_accession` ),
  CONSTRAINT `fk_standard_curve_2_file_info_2`
  FOREIGN KEY (`file_info_id` )
  REFERENCES `file_info` (`file_info_id` ),
  CONSTRAINT `fk_standard_curve_2_file_info_4`
  FOREIGN KEY (`result_schema` )
  REFERENCES `lk_expsample_result_schema` (`name` ))",
  "CREATE  TABLE IF NOT EXISTS `study_2_panel` (
  `study_accession` VARCHAR(15) NOT NULL ,
  `panel_name` VARCHAR(100) NOT NULL ,
  PRIMARY KEY (`study_accession`, `panel_name`) ,
  CONSTRAINT `fk_study_2_panel_1`
  FOREIGN KEY (`study_accession` )
  REFERENCES `study` (`study_accession` ),
  CONSTRAINT `fk_study_2_panel_2`
  FOREIGN KEY (`panel_name` )
  REFERENCES `lk_study_panel` (`name` ))",
  "CREATE  TABLE IF NOT EXISTS `study_2_protocol` (
  `study_accession` VARCHAR(15) NOT NULL ,
  `protocol_accession` VARCHAR(15) NOT NULL ,
  PRIMARY KEY (`study_accession`, `protocol_accession`) ,
  CONSTRAINT `fk_study_2_protocol_1`
  FOREIGN KEY (`study_accession` )
  REFERENCES `study` (`study_accession` ),
  CONSTRAINT `fk_study_2_protocol_2`
  FOREIGN KEY (`protocol_accession` )
  REFERENCES `protocol` (`protocol_accession` ))",
  "CREATE  TABLE IF NOT EXISTS `study_categorization` (
  `study_categorization_id` INT(11) NOT NULL ,
  `research_focus` VARCHAR(50) NOT NULL ,
  `study_accession` VARCHAR(15) NOT NULL ,
  PRIMARY KEY (`study_categorization_id`) ,
  CONSTRAINT `fk_study_categorization_1`
  FOREIGN KEY (`study_accession` )
  REFERENCES `study` (`study_accession` ),
  CONSTRAINT `fk_study_categorization_2`
  FOREIGN KEY (`research_focus` )
  REFERENCES `lk_research_focus` (`name` ))",
  "CREATE  TABLE IF NOT EXISTS `study_file` (
  `study_file_accession` VARCHAR(15) NOT NULL ,
  `description` VARCHAR(4000) NULL DEFAULT NULL ,
  `file_name` VARCHAR(250) NOT NULL ,
  `study_accession` VARCHAR(15) NOT NULL ,
  `study_file_type` VARCHAR(50) NOT NULL DEFAULT 'Study Summary Description' ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`study_file_accession`) ,
  CONSTRAINT `fk_study_file_1`
  FOREIGN KEY (`study_accession` )
  REFERENCES `study` (`study_accession` ),
  CONSTRAINT `fk_study_file_2`
  FOREIGN KEY (`study_file_type` )
  REFERENCES `lk_study_file_type` (`name` ))",
  "CREATE  TABLE IF NOT EXISTS `study_glossary` (
  `study_accession` VARCHAR(15) NOT NULL ,
  `definition` VARCHAR(500) NOT NULL ,
  `term` VARCHAR(125) NULL DEFAULT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`study_accession`, `term`) ,
  CONSTRAINT `fk_study_glossary_1`
  FOREIGN KEY (`workspace_id` )
  REFERENCES `workspace` (`workspace_id` ),
  CONSTRAINT `fk_study_glossary_2`
  FOREIGN KEY (`study_accession` )
  REFERENCES `study` (`study_accession` ))",
  "CREATE  TABLE IF NOT EXISTS `study_image` (
  `schematic_accession` VARCHAR(15) NOT NULL ,
  `description` VARCHAR(4000) NULL DEFAULT NULL ,
  `image_filename` VARCHAR(250) NULL DEFAULT NULL ,
  `image_type` VARCHAR(40) NULL DEFAULT NULL ,
  `name` VARCHAR(40) NULL DEFAULT NULL ,
  `study_accession` VARCHAR(15) NOT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`schematic_accession`) ,
  CONSTRAINT `fk_study_image_1`
  FOREIGN KEY (`study_accession` )
  REFERENCES `study` (`study_accession` ))",
  "CREATE  TABLE IF NOT EXISTS `study_link` (
  `study_link_id` INT(11) NOT NULL ,
  `name` VARCHAR(500) NULL DEFAULT NULL ,
  `study_accession` VARCHAR(15) NOT NULL ,
  `type` VARCHAR(50) NULL DEFAULT NULL ,
  `value` VARCHAR(2000) NULL DEFAULT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`study_link_id`) ,
  CONSTRAINT `fk_study_link_1`
  FOREIGN KEY (`study_accession` )
  REFERENCES `study` (`study_accession` ))",
  "CREATE  TABLE IF NOT EXISTS `study_personnel` (
  `person_accession` VARCHAR(15) NOT NULL ,
  `site_name` VARCHAR(100) NULL DEFAULT NULL ,
  `email` VARCHAR(40) NULL DEFAULT NULL ,
  `first_name` VARCHAR(40) NULL DEFAULT NULL ,
  `honorific` VARCHAR(20) NULL DEFAULT NULL ,
  `last_name` VARCHAR(40) NULL DEFAULT NULL ,
  `organization` VARCHAR(125) NULL DEFAULT NULL ,
  `role_in_study` VARCHAR(40) NULL DEFAULT NULL ,
  `study_accession` VARCHAR(15) NOT NULL ,
  `suffixes` VARCHAR(40) NULL DEFAULT NULL ,
  `title_in_study` VARCHAR(100) NULL DEFAULT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`person_accession`) ,
  CONSTRAINT `fk_study_personnel_1`
  FOREIGN KEY (`study_accession` )
  REFERENCES `study` (`study_accession` ),
  CONSTRAINT `fk_study_personnel_2`
  FOREIGN KEY (`role_in_study` )
  REFERENCES `lk_personnel_role` (`name` ))",
  "CREATE  TABLE IF NOT EXISTS `study_pubmed` (
  `study_accession` VARCHAR(15) NOT NULL ,
  `pubmed_id` VARCHAR(16) NULL DEFAULT NULL ,
  `authors` VARCHAR(4000) NULL DEFAULT NULL ,
  `doi` VARCHAR(100) NULL DEFAULT NULL ,
  `issue` VARCHAR(20) NULL DEFAULT NULL ,
  `journal` VARCHAR(250) NULL DEFAULT NULL ,
  `month` VARCHAR(12) NULL DEFAULT NULL ,
  `pages` VARCHAR(20) NULL DEFAULT NULL ,
  `title` VARCHAR(4000) NULL DEFAULT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  `year` VARCHAR(4) NULL DEFAULT NULL ,
  PRIMARY KEY (`study_accession`, `pubmed_id`) ,
  CONSTRAINT `fk_study_pubmed_1`
  FOREIGN KEY (`study_accession` )
  REFERENCES `study` (`study_accession` ))",
  "CREATE  TABLE IF NOT EXISTS `subject_measure_definition` (
  `subject_measure_accession` VARCHAR(15) NOT NULL ,
  `algorithm` VARCHAR(1024) NULL DEFAULT NULL ,
  `description` VARCHAR(4000) NULL DEFAULT NULL ,
  `measureofcentraltendency` VARCHAR(40) NULL DEFAULT NULL ,
  `measureofdispersion` VARCHAR(40) NULL DEFAULT NULL ,
  `measuretype` VARCHAR(40) NULL DEFAULT NULL ,
  `name` VARCHAR(125) NULL DEFAULT NULL ,
  `outcometype` VARCHAR(70) NULL DEFAULT NULL ,
  `study_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `timeframe` VARCHAR(256) NULL DEFAULT NULL ,
  `unitofmeasure` VARCHAR(40) NULL DEFAULT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  PRIMARY KEY (`subject_measure_accession`) ,
  CONSTRAINT `fk_subject_measure_def_1`
  FOREIGN KEY (`study_accession` )
  REFERENCES `study` (`study_accession` ))",
  "CREATE  TABLE IF NOT EXISTS `subject_measure_result` (
  `subject_measure_res_accession` VARCHAR(15) NOT NULL ,
  `centraltendencymeasurevalue` VARCHAR(40) NULL DEFAULT NULL ,
  `datavalue` VARCHAR(40) NULL DEFAULT NULL ,
  `dispersionmeasurevalue` VARCHAR(40) NULL DEFAULT NULL ,
  `study_accession` VARCHAR(15) NULL DEFAULT NULL ,
  `study_day` FLOAT NULL DEFAULT NULL ,
  `subject_accession` VARCHAR(15) NOT NULL ,
  `subject_measure_accession` VARCHAR(15) NOT NULL ,
  `time_of_day` VARCHAR(40) NULL DEFAULT NULL ,
  `workspace_id` INT(11) NULL DEFAULT NULL ,
  `year_of_measure` DATE NULL DEFAULT NULL ,
  PRIMARY KEY (`subject_measure_res_accession`) ,
  CONSTRAINT `fk_subject_measure_result_1`
  FOREIGN KEY (`subject_accession` )
  REFERENCES `subject` (`subject_accession` ),
  CONSTRAINT `fk_subject_measure_result_2`
  FOREIGN KEY (`subject_measure_accession` )
  REFERENCES `subject_measure_definition` (`subject_measure_accession` ),
  CONSTRAINT `fk_subject_measure_result_3`
  FOREIGN KEY (`study_accession` )
  REFERENCES `study` (`study_accession` ))"
  )

db_index_stmts <- c(
  "CREATE INDEX `idx_subject_gender` ON `subject` (`gender` ASC)",
  "CREATE INDEX `idx_subject_race` ON `subject` (`race` ASC)",
  "CREATE INDEX `idx_subject_species` ON `subject` (`species` ASC)",
  "CREATE INDEX `idx_subject_workspace` ON `subject` (`workspace_id` ASC)",
  "CREATE INDEX `fk_subject_2` ON `subject` (`ethnicity` ASC)",
  "CREATE INDEX `idx_study_type` ON `study` (`type` ASC)",
  "CREATE INDEX `idx_study_workspace` ON `study` (`workspace_id` ASC)",
  "CREATE INDEX `fk_study_3` ON `study` (`dcl_id` ASC)",
  "CREATE INDEX `idx_adverse_event_subject` ON `adverse_event` (`subject_accession` ASC)",
  "CREATE INDEX `idx_adverse_event_study` ON `adverse_event` (`study_accession` ASC)",
  "CREATE INDEX `idx_adverse_event_workspace` ON `adverse_event` (`workspace_id` ASC)",
  "CREATE INDEX `fk_adverse_event_4` ON `adverse_event` (`severity_preferred` ASC)",
  "CREATE INDEX `idx_arm_or_cohort_study` ON `arm_or_cohort` (`study_accession` ASC, `arm_accession` ASC)",
  "CREATE INDEX `idx_arm_or_cohort_workspace` ON `arm_or_cohort` (`workspace_id` ASC)",
  "CREATE INDEX `idx_arm_2_subject_1` ON `arm_2_subject` (`subject_accession` ASC, `arm_accession` ASC)",
  "CREATE INDEX `fk_arm_2_subject_3` ON `arm_2_subject` (`age_unit` ASC)",
  "CREATE INDEX `fk_arm_2_subject_4` ON `arm_2_subject` (`age_event` ASC)",
  "CREATE INDEX `idx_file_info_file_info_id` ON `file_info` (`file_info_id` ASC)",
  "CREATE INDEX `idx_file_info_workspace` ON `file_info` (`workspace_id` ASC)",
  "CREATE INDEX `fk_file_info_2` ON `file_info` (`detail` ASC)",
  "CREATE INDEX `idx_assessment_panel_study` ON `assessment_panel` (`study_accession` ASC)",
  "CREATE INDEX `idx_assessment_panel_workspace` ON `assessment_panel` (`workspace_id` ASC)",
  "CREATE INDEX `idx_assessment_2_file_info` ON `assessment_2_file_info` (`file_info_id` ASC, `assessment_panel_accession` ASC)",
  "CREATE INDEX `fk_assessment_2_file_info_4` ON `assessment_2_file_info` (`result_schema` ASC)",
  "CREATE INDEX `idx_reference_range_study` ON `reference_range` (`study_accession` ASC)",
  "CREATE INDEX `idx_reference_range_workspace` ON `reference_range` (`workspace_id` ASC)",
  "CREATE INDEX `idx_assessment_component_assessment_panel` ON `assessment_component` (`assessment_panel_accession` ASC)",
  "CREATE INDEX `idx_assessment_component_subject` ON `assessment_component` (`subject_accession` ASC)",
  "CREATE INDEX `idx_assessment_component_planned_visit` ON `assessment_component` (`planned_visit_accession` ASC)",
  "CREATE INDEX `idx_assessment_component_workspace` ON `assessment_component` (`workspace_id` ASC)",
  "CREATE INDEX `fk_assessment_component_5` ON `assessment_component` (`reference_range_accession` ASC)",
  "CREATE INDEX `fk_assessment_component_6` ON `assessment_component` (`result_unit_preferred` ASC)",
  "CREATE INDEX `fk_assessment_component_7` ON `assessment_component` (`age_at_onset_unit_preferred` ASC)",
  "CREATE INDEX `idx_period_study` ON `period` (`study_accession` ASC)",
  "CREATE INDEX `idx_period_workspace` ON `period` (`workspace_id` ASC)",
  "CREATE INDEX `idx_planned_visit_workspace` ON `planned_visit` (`workspace_id` ASC)",
  "CREATE INDEX `idx_planned_visit_period` ON `planned_visit` (`period_accession` ASC)",
  "CREATE INDEX `fk_planned_visit_1` ON `planned_visit` (`study_accession` ASC)",
  "CREATE INDEX `idx_biosample_subject` ON `biosample` (`subject_accession` ASC)",
  "CREATE INDEX `idx_biosample_study` ON `biosample` (`study_accession` ASC)",
  "CREATE INDEX `idx_biosample_planned_visit` ON `biosample` (`planned_visit_accession` ASC)",
  "CREATE INDEX `idx_biosample_workspace` ON `biosample` (`workspace_id` ASC)",
  "CREATE INDEX `fk_biosample_5` ON `biosample` (`study_time_collected_unit` ASC)",
  "CREATE INDEX `fk_biosample_6` ON `biosample` (`study_time_t0_event` ASC)",
  "CREATE INDEX `fk_biosample_8` ON `biosample` (`type` ASC)",
  "CREATE INDEX `idx_treatment_workspace` ON `treatment` (`workspace_id` ASC)",
  "CREATE INDEX `fk_treatment_2` ON `treatment` (`amount_unit` ASC)",
  "CREATE INDEX `fk_treatment_3` ON `treatment` (`duration_unit` ASC)",
  "CREATE INDEX `fk_treatment_4` ON `treatment` (`temperature_unit` ASC)",
  "CREATE INDEX `idx_biosample_2_treatment` ON `biosample_2_treatment` (`treatment_accession` ASC, `biosample_accession` ASC)",
  "CREATE INDEX `fk_program_1` ON `program` (`category` ASC)",
  "CREATE INDEX `idx_contract_program` ON `contract_grant` (`program_id` ASC)",
  "CREATE INDEX `idx_contract_2_personnel` ON `contract_grant_2_personnel` (`personnel_id` ASC, `contract_grant_id` ASC)",
  "CREATE INDEX `fk_contract_2_personnel_3` ON `contract_grant_2_personnel` (`role_type` ASC)",
  "CREATE INDEX `idx_contract_grant_2_study_study` ON `contract_grant_2_study` (`study_accession` ASC, `contract_grant_id` ASC)",
  "CREATE INDEX `idx_experiment_study` ON `experiment` (`study_accession` ASC)",
  "CREATE INDEX `idx_experiment_workspace` ON `experiment` (`workspace_id` ASC)",
  "CREATE INDEX `fk_experiment_3` ON `experiment` (`measurement_technique` ASC)",
  "CREATE INDEX `idx_control_sample_workspace` ON `control_sample` (`workspace_id` ASC)",
  "CREATE INDEX `fk_control_sample_2` ON `control_sample` (`experiment_accession` ASC)",
  "CREATE INDEX `fk_control_sample_3` ON `control_sample` (`result_schema` ASC)",
  "CREATE INDEX `idx_control_sample_2_file_info` ON `control_sample_2_file_info` (`file_info_id` ASC, `control_sample_accession` ASC)",
  "CREATE INDEX `fk_control_sample_2_file_info_4` ON `control_sample_2_file_info` (`result_schema` ASC)",
  "CREATE INDEX `idx_expsample_experiment` ON `expsample` (`experiment_accession` ASC)",
  "CREATE INDEX `idx_expsample_workspace` ON `expsample` (`workspace_id` ASC)",
  "CREATE INDEX `idx_elisa_study_accession` ON `elisa_result` (`study_accession` ASC)",
  "CREATE INDEX `idx_elisa_arm_accession` ON `elisa_result` (`arm_accession` ASC)",
  "CREATE INDEX `idx_elisa_biosample_accession` ON `elisa_result` (`biosample_accession` ASC)",
  "CREATE INDEX `idx_elisa_experiment_accession` ON `elisa_result` (`experiment_accession` ASC)",
  "CREATE INDEX `idx_elisa_expsample_accession` ON `elisa_result` (`expsample_accession` ASC)",
  "CREATE INDEX `idx_elisa_subject_accession` ON `elisa_result` (`subject_accession` ASC)",
  "CREATE INDEX `idx_elisa_workspace` ON `elisa_result` (`workspace_id` ASC)",
  "CREATE INDEX `fk_elisa_result_9` ON `elisa_result` (`unit_preferred` ASC)",
  "CREATE INDEX `idx_elispot_study_accession` ON `elispot_result` (`study_accession` ASC)",
  "CREATE INDEX `idx_elispot_arm_accession` ON `elispot_result` (`arm_accession` ASC)",
  "CREATE INDEX `idx_elispot_biosample_accession` ON `elispot_result` (`biosample_accession` ASC)",
  "CREATE INDEX `idx_elispot_experiment_accession` ON `elispot_result` (`experiment_accession` ASC)",
  "CREATE INDEX `idx_elispot_expsample_accession` ON `elispot_result` (`expsample_accession` ASC)",
  "CREATE INDEX `idx_elispot_subject_accession` ON `elispot_result` (`subject_accession` ASC)",
  "CREATE INDEX `idx_elispot_workspace` ON `elispot_result` (`workspace_id` ASC)",
  "CREATE INDEX `fk_protocol_1` ON `protocol` (`type` ASC)",
  "CREATE INDEX `fk_protocol_2` ON `protocol` (`workspace_id` ASC)",
  "CREATE INDEX `idx_experiment_2_protocol` ON `experiment_2_protocol` (`protocol_accession` ASC, `experiment_accession` ASC)",
  "CREATE INDEX `idx_expsample_2_biosample` ON `expsample_2_biosample` (`biosample_accession` ASC, `expsample_accession` ASC)",
  "CREATE INDEX `idx_expsample_2_file_info` ON `expsample_2_file_info` (`file_info_id` ASC, `expsample_accession` ASC)",
  "CREATE INDEX `idx_expsample_2_file_info_id` ON `expsample_2_file_info` (`file_info_id` ASC)",
  "CREATE INDEX `fk_expsample_2_file_info_4` ON `expsample_2_file_info` (`result_schema` ASC)",
  "CREATE INDEX `idx_reagent_workspace` ON `reagent` (`workspace_id` ASC)",
  "CREATE INDEX `fk_reagent_2` ON `reagent` (`type` ASC)",
  "CREATE INDEX `idx_expsample_2_reagent` ON `expsample_2_reagent` (`reagent_accession` ASC, `expsample_accession` ASC)",
  "CREATE INDEX `idx_expsample_2_treatment` ON `expsample_2_treatment` (`treatment_accession` ASC, `expsample_accession` ASC)",
  "CREATE INDEX `fk_expsample_mbaa_detail_2` ON `expsample_mbaa_detail` (`plate_type` ASC)",
  "CREATE INDEX `fk_expsample_public_2` ON `expsample_public_repository` (`repository_name` ASC)",
  "CREATE INDEX `idx_fcs_analyzed_study_accession` ON `fcs_analyzed_result` (`study_accession` ASC)",
  "CREATE INDEX `idx_fcs_analyzed_arm_accession` ON `fcs_analyzed_result` (`arm_accession` ASC)",
  "CREATE INDEX `idx_fcs_analyzed_biosample_accession` ON `fcs_analyzed_result` (`biosample_accession` ASC)",
  "CREATE INDEX `idx_fcs_analyzed_experiment_accession` ON `fcs_analyzed_result` (`experiment_accession` ASC)",
  "CREATE INDEX `idx_fcs_analyzed_expsample_accession` ON `fcs_analyzed_result` (`expsample_accession` ASC)",
  "CREATE INDEX `idx_fcs_analyzed_subject_accession` ON `fcs_analyzed_result` (`subject_accession` ASC)",
  "CREATE INDEX `idx_fcs_analyzed_workspace` ON `fcs_analyzed_result` (`workspace_id` ASC)",
  "CREATE INDEX `fk_fcs_analyzed_result_12` ON `fcs_analyzed_result` (`population_stat_unit_preferred` ASC)",
  "CREATE INDEX `fk_fcs_analyzed_result_13` ON `fcs_analyzed_result` (`workspace_file_info_id` ASC)",
  "CREATE INDEX `fk_fcs_analyzed_result_marker_1` ON `fcs_analyzed_result_marker` (`result_id` ASC)",
  "CREATE INDEX `idx_fcs_header_expsample_accession` ON `fcs_header` (`expsample_accession` ASC)",
  "CREATE INDEX `idx_fcs_header_file_info_id` ON `fcs_header` (`file_info_id` ASC)",
  "CREATE INDEX `idx_fcs_header_marker_2_reagent` ON `fcs_header_marker_2_reagent` (`reagent_accession` ASC, `fcs_header_id` ASC)",
  "CREATE INDEX `idx_hai_arm_accession` ON `hai_result` (`arm_accession` ASC)",
  "CREATE INDEX `idx_hai_biosample_accession` ON `hai_result` (`biosample_accession` ASC)",
  "CREATE INDEX `idx_hai_experiment_accession` ON `hai_result` (`experiment_accession` ASC)",
  "CREATE INDEX `idx_hai_expsample_accession` ON `hai_result` (`expsample_accession` ASC)",
  "CREATE INDEX `idx_hai_study_accession` ON `hai_result` (`study_accession` ASC)",
  "CREATE INDEX `idx_hai_subject_accession` ON `hai_result` (`subject_accession` ASC)",
  "CREATE INDEX `idx_hai_workspace` ON `hai_result` (`workspace_id` ASC)",
  "CREATE INDEX `fk_hai_result_8` ON `hai_result` (`virus_strain_preferred` ASC)",
  "CREATE INDEX `fk_hai_result_9` ON `hai_result` (`unit_preferred` ASC)",
  "CREATE INDEX `fk_hla_typing_result_1` ON `hla_typing_result` (`expsample_accession` ASC)",
  "CREATE INDEX `fk_hla_typing_result_2` ON `hla_typing_result` (`experiment_accession` ASC)",
  "CREATE INDEX `fk_hla_typing_result_3` ON `hla_typing_result` (`study_accession` ASC)",
  "CREATE INDEX `fk_hla_typing_result_4` ON `hla_typing_result` (`arm_accession` ASC)",
  "CREATE INDEX `fk_hla_typing_result_5` ON `hla_typing_result` (`biosample_accession` ASC)",
  "CREATE INDEX `fk_hla_typing_result_6` ON `hla_typing_result` (`subject_accession` ASC)",
  "CREATE INDEX `fk_hla_typing_result_7` ON `hla_typing_result` (`workspace_id` ASC)",
  "CREATE INDEX `fk_inclusion_exclusion_1` ON `inclusion_exclusion` (`study_accession` ASC)",
  "CREATE INDEX `fk_inclusion_exclusion_2` ON `inclusion_exclusion` (`workspace_id` ASC)",
  "CREATE INDEX `fk_inclusion_exclusion_3` ON `inclusion_exclusion` (`criterion_category` ASC)",
  "CREATE INDEX `idx_intervention_subject` ON `intervention` (`subject_accession` ASC)",
  "CREATE INDEX `idx_intervention_study` ON `intervention` (`study_accession` ASC)",
  "CREATE INDEX `idx_intervention_workspace` ON `intervention` (`workspace_id` ASC)",
  "CREATE INDEX `fk_intervention_4` ON `intervention` (`compound_role` ASC)",
  "CREATE INDEX `idx_kir_arm_accession` ON `kir_typing_result` (`arm_accession` ASC)",
  "CREATE INDEX `idx_kir_biosample_accession` ON `kir_typing_result` (`biosample_accession` ASC)",
  "CREATE INDEX `idx_kir_experiment_accession` ON `kir_typing_result` (`experiment_accession` ASC)",
  "CREATE INDEX `idx_kir_expsample_accession` ON `kir_typing_result` (`expsample_accession` ASC)",
  "CREATE INDEX `idx_kir_subject_accession` ON `kir_typing_result` (`subject_accession` ASC)",
  "CREATE INDEX `idx_kir_study_accession` ON `kir_typing_result` (`study_accession` ASC)",
  "CREATE INDEX `idx_kir_workspace` ON `kir_typing_result` (`workspace_id` ASC)",
  "CREATE INDEX `idx_lab_test_panel_study` ON `lab_test_panel` (`study_accession` ASC)",
  "CREATE INDEX `fk_lab_test_panel_1` ON `lab_test_panel` (`workspace_id` ASC)",
  "CREATE INDEX `idx_lab_test_biosample` ON `lab_test` (`biosample_accession` ASC)",
  "CREATE INDEX `idx_lab_test_workspace` ON `lab_test` (`workspace_id` ASC)",
  "CREATE INDEX `fk_lab_test_3` ON `lab_test` (`lab_test_panel_accession` ASC)",
  "CREATE INDEX `fk_lab_test_4` ON `lab_test` (`name_preferred` ASC)",
  "CREATE INDEX `fk_lab_test_5` ON `lab_test` (`result_unit_preferred` ASC)",
  "CREATE INDEX `idx_lab_test_2_protocol` ON `lab_test_panel_2_protocol` (`protocol_accession` ASC, `lab_test_panel_accession` ASC)",
  "CREATE INDEX `idx_mbaa_arm_accession` ON `mbaa_result` (`arm_accession` ASC)",
  "CREATE INDEX `idx_mbaa_biosample_accession` ON `mbaa_result` (`biosample_accession` ASC)",
  "CREATE INDEX `idx_mbaa_experiment_accession` ON `mbaa_result` (`experiment_accession` ASC)",
  "CREATE INDEX `idx_mbaa_source_accession` ON `mbaa_result` (`source_accession` ASC)",
  "CREATE INDEX `idx_mbaa_study_accession` ON `mbaa_result` (`study_accession` ASC)",
  "CREATE INDEX `idx_mbaa_subject_accession` ON `mbaa_result` (`subject_accession` ASC)",
  "CREATE INDEX `idx_mbaa_workspace` ON `mbaa_result` (`workspace_id` ASC)",
  "CREATE INDEX `fk_mbaa_result_7` ON `mbaa_result` (`source_type` ASC)",
  "CREATE INDEX `idx_neut_arm_accession` ON `neut_ab_titer_result` (`arm_accession` ASC)",
  "CREATE INDEX `idx_neut_biosample_accession` ON `neut_ab_titer_result` (`biosample_accession` ASC)",
  "CREATE INDEX `idx_neut_experiment_accession` ON `neut_ab_titer_result` (`experiment_accession` ASC)",
  "CREATE INDEX `idx_neut_expsample_accession` ON `neut_ab_titer_result` (`expsample_accession` ASC)",
  "CREATE INDEX `idx_neut_study_accession` ON `neut_ab_titer_result` (`study_accession` ASC)",
  "CREATE INDEX `idx_neut_subject_accession` ON `neut_ab_titer_result` (`subject_accession` ASC)",
  "CREATE INDEX `idx__workspace` ON `neut_ab_titer_result` (`workspace_id` ASC)",
  "CREATE INDEX `fk_neut_result_8` ON `neut_ab_titer_result` (`virus_strain_preferred` ASC)",
  "CREATE INDEX `fk_neut_result_9` ON `neut_ab_titer_result` (`unit_preferred` ASC)",
  "CREATE INDEX `fk_pcr_result_1` ON `pcr_result` (`expsample_accession` ASC)",
  "CREATE INDEX `fk_pcr_result_2` ON `pcr_result` (`experiment_accession` ASC)",
  "CREATE INDEX `fk_pcr_result_3` ON `pcr_result` (`study_accession` ASC)",
  "CREATE INDEX `fk_pcr_result_4` ON `pcr_result` (`arm_accession` ASC)",
  "CREATE INDEX `fk_pcr_result_5` ON `pcr_result` (`biosample_accession` ASC)",
  "CREATE INDEX `fk_pcr_result_6` ON `pcr_result` (`subject_accession` ASC)",
  "CREATE INDEX `fk_pcr_result_7` ON `pcr_result` (`workspace_id` ASC)",
  "CREATE INDEX `fk_pcr_result_8` ON `pcr_result` (`unit_preferred` ASC)",
  "CREATE INDEX `fk_planned_visit_2_arm_2` ON `planned_visit_2_arm` (`arm_accession` ASC)",
  "CREATE INDEX `idx_program_2_personnel` ON `program_2_personnel` (`personnel_id` ASC, `program_id` ASC)",
  "CREATE INDEX `fk_program_2_personnel_3` ON `program_2_personnel` (`role_type` ASC)",
  "CREATE INDEX `idx_procotol_deviation_study` ON `protocol_deviation` (`study_accession` ASC)",
  "CREATE INDEX `idx_procotol_deviation_subject` ON `protocol_deviation` (`subject_accession` ASC)",
  "CREATE INDEX `idx_procotol_deviation_workspace` ON `protocol_deviation` (`workspace_id` ASC)",
  "CREATE INDEX `idx_reagent_set_reagent` ON `reagent_set_2_reagent` (`reagent_accession` ASC, `reagent_set_accession` ASC)",
  "CREATE INDEX `idx_reagent_set_workspace` ON `reagent_set_2_reagent` (`workspace_id` ASC)",
  "CREATE INDEX `idx_early_termination_study` ON `reported_early_termination` (`study_accession` ASC)",
  "CREATE INDEX `idx_early_termination_subject` ON `reported_early_termination` (`subject_accession` ASC)",
  "CREATE INDEX `idx_early_termination_workspace` ON `reported_early_termination` (`workspace_id` ASC)",
  "CREATE INDEX `fk_standard_curve_1` ON `standard_curve` (`workspace_id` ASC)",
  "CREATE INDEX `fk_standard_curve_2` ON `standard_curve` (`experiment_accession` ASC)",
  "CREATE INDEX `fk_standard_curve_3` ON `standard_curve` (`result_schema` ASC)",
  "CREATE INDEX `fk_standard_curve_2_file_info_2` ON `standard_curve_2_file_info` (`file_info_id` ASC)",
  "CREATE INDEX `fk_standard_curve_2_file_info_4` ON `standard_curve_2_file_info` (`result_schema` ASC)",
  "CREATE INDEX `fk_study_2_panel_2` ON `study_2_panel` (`panel_name` ASC)",
  "CREATE INDEX `fk_study_2_protocol_2` ON `study_2_protocol` (`protocol_accession` ASC)",
  "CREATE INDEX `fk_study_categorization_1` ON `study_categorization` (`study_accession` ASC)",
  "CREATE INDEX `fk_study_categorization_2` ON `study_categorization` (`research_focus` ASC)",
  "CREATE INDEX `idx_study_file_study` ON `study_file` (`study_accession` ASC)",
  "CREATE INDEX `idx_study_file_type` ON `study_file` (`study_file_type` ASC)",
  "CREATE INDEX `idx_study_file_workspace` ON `study_file` (`workspace_id` ASC)",
  "CREATE INDEX `idx_study_glossaryworkspace` ON `study_glossary` (`workspace_id` ASC)",
  "CREATE INDEX `idx_study_image_study` ON `study_image` (`study_accession` ASC)",
  "CREATE INDEX `idx_study_image_workspace` ON `study_image` (`workspace_id` ASC)",
  "CREATE INDEX `fk_study_link_1` ON `study_link` (`study_accession` ASC)",
  "CREATE INDEX `fk_study_personnel_1` ON `study_personnel` (`study_accession` ASC)",
  "CREATE INDEX `fk_study_personnel_2` ON `study_personnel` (`role_in_study` ASC)",
  "CREATE INDEX `idx_subject_measure_study` ON `subject_measure_definition` (`study_accession` ASC)",
  "CREATE INDEX `idx_subject_measure_workspace` ON `subject_measure_definition` (`workspace_id` ASC)",
  "CREATE INDEX `idx_subject_measure_result_study` ON `subject_measure_result` (`study_accession` ASC)",
  "CREATE INDEX `idx_subject_measure_result_subject` ON `subject_measure_result` (`subject_accession` ASC)",
  "CREATE INDEX `idx_subject_measure_result_workspace` ON `subject_measure_result` (`workspace_id` ASC)",
  "CREATE INDEX `fk_subject_measure_result_2` ON `subject_measure_result` (`subject_measure_accession` ASC)"
)


##' buildNewSqliteDb
##' 
##' The function \code{buildSqliteDb} builds a sqlite db of ImmPort study data. It takes in as input the 
##' study files in the TSV (Tab) format. 
##' 
##' @param data_dir File directory where the study TSV files are stored
##' @param db_dir File directory where the sqlite database will be stored
##' @return The SQLite database name
##' @examples
##' studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")
##' # set tab_dir to the folder where the zip files are located
##' tab_dir <- file.path(studies_dir, "Tab")
##' # set db_dir to the folder where the database file 'ImmPort.sqlite' should be stored
##' db_dir <- file.path(studies_dir, "Db")
##' # build a new ImmPort SQLite database with the data in the downloaded zip files
##' # dbname <- buildNewSqliteDb(tab_dir, db_dir) 
##' @importFrom DBI dbGetQuery dbConnect dbListFields
##' @importFrom RSQLite SQLite
##' @importFrom RSQLite dbWriteTable
##' @importFrom sqldf sqldf
##' @importFrom tools file_path_sans_ext
##' @importFrom data.table setnames
##' @importFrom utils unzip
##' @importFrom utils read.table
##' @export
##' 
buildNewSqliteDb <- function(data_dir, db_dir) {
  dbname="ImmPort.sqlite"
  
  prevWD <- getwd()
  on.exit(setwd(prevWD))
  
  setwd(db_dir)
  if (file.exists(dbname)) {
    stop(paste("ImmPort.sqlite database already exists. Please remove the file ImmPort.sqlite in ", 
               db_dir, " before building a new ImmPort database"))
  }
  
  sqldf::sqldf(paste("attach \'", dbname, "\' as new", sep=""), drv = "SQLite") 
  
  db <- dbConnect(SQLite(), dbname)
  for (i in db_table_stmts) {
    dbGetQuery(db, i)
  }
  
  setwd(data_dir)
  
  # unzip study files into data directory
  zipfiles <- list.files(pattern = "Tab\\.zip$")
  for (zf in zipfiles) {
    #      zipname <- file_path_sans_ext(zf)
    #      study_dir <- file.path(data_dir, zipname)
    #      dir.create(study_dir)
    unzip(zf)
  }
  
  # process each study dir and load data into SQLite db
  tableInDb = paste0(dbListTables(db),".txt")#zicheng mod
  
  study_dirs <- list.files(pattern = "Tab$")
  for (sd in study_dirs) {
    study_dir <- file.path(data_dir, sd)
    cat("study dir = ", study_dir, "\n")
    if (dir.exists(study_dir) == FALSE) {
      cat("skipping = ", study_dir, "\n")
      next
    }
    
    if (dir.exists(file.path(study_dir, "Tab")))
      setwd(file.path(study_dir, "Tab"))
    else
      setwd(study_dir)
    cat("processing files of study dir = ", study_dir, "\n")
    files <- list.files(pattern = "\\.txt$")
    for (f in files) {
      if(!f%in% tableInDb){next}
      fname <- tools::file_path_sans_ext(f)
      cat("processing file = ", fname, "\n")
      
      df <- read.table(f, sep="\t", header=TRUE, fill=TRUE, quote = "", stringsAsFactors = FALSE)
      df <- df[rowSums(is.na(df)) != ncol(df),]
      colnames(df) <- tolower(colnames(df))
      
      tb_col_names <- dbListFields(conn = db, name = fname)
      #cat("tb_col_names = ", tolower(tb_col_names), "\n")
      #cat("df_col_names = ", tolower(colnames(df)), "\n")
      t1 = intersect(tolower(tb_col_names), tolower(colnames(df)))# zicheng mod
      df = df[,t1]# zicheng mod
      if (all(tolower(tb_col_names) != tolower(colnames(df)))) {
         cat("column mismatch in ", fname, " file \n")
      }
      if (length(tb_col_names) != length(colnames(df))) {
        cat("length of tb_col_names = ", length(tb_col_names), "\n")
        cat("length of df_col_names = ", length(colnames(df)), "\n")
        cat("column mismatch in ", fname, " file \n")
      }
      if ((substr(fname, 1,3) == "lk_") || (fname == "personnel") || 
          (fname == "program_2_personnel") || (fname == "program")){
        dbWriteTable(conn = db, name = fname, value = df, overwrite = TRUE, row.names = FALSE)
      }else{
        dbWriteTable(conn = db, name = fname, value = df, append = TRUE, row.names = FALSE)
      }
    }
  }

  for (i in db_index_stmts) {
    dbGetQuery(db, i)
  }
  
  dbname
}

#' Skin Response Domain
#' 
#' @name Skin Response Domain
#' @description The Skin Response data of an ImmPort study is reformated to the CDISC SDTM Skin Response (SR) 
#' domain model, and is a list of 2 data frames containing 1) Skin Response data \code{\link{SR}} 
#' and 2) any supplemental Skin Response data \code{\link{SUPP}}
NULL
#> NULL 

# call to globalVariables to prevent from generating NOTE: no visible binding for global variable <variable name>
# this hack is to satisfy CRAN (http://stackoverflow.com/questions/9439256/how-can-i-handle-r-cmd-check-no-visible-binding-for-global-variable-notes-when)
globalVariables(c("SRSEQ"))

# Get Skin Response data of a specific study
# 
# The function \code{getSkinResponse} queries the ImmPort database for Skin Response data and 
# reformats it to the CDISC SDTM Skin Response (SR) domain model 
# 
# @param data_src A connection handle to ImmPort (MySQL or SQLite) database instance or 
# a directory handle to folder where study RDS files are located
# @param study_id Identifier of a specific study
# @return a list of 2 data frames containing 1) Skin Response data \code{\link{SR}} and 2) any supplemental 
#   Skin Response data \code{\link{SUPP}}
# @examples
# \dontrun{
#   getSkinResponse(data_src, "SDY1")
# }
#' @importFrom DBI dbGetQuery
#' @importFrom data.table as.data.table is.data.table .N :=
getSkinResponse <- function(data_src, study_id) {
  cat("loading Skin Response data....")

  sr_cols <- c("STUDYID", "DOMAIN", "USUBJID", "SRSEQ", "SRTEST", "SRCAT", "SROBJ", 
               "SRORRES", "SRORRESU", "SRLOC", "VISITNUM", "VISIT", "SRDY")
  
  sql_stmt <- paste("SELECT distinct
                    asmp.study_accession,
                    \"SR\" as domain,
                    asmc.subject_accession,
                    cast(0 as UNSIGNED INTEGER) as seq,
                    asmc.name_reported,
                    asmp.name_reported,
                    asmc.organ_or_body_system_reported,
                    asmc.result_value_reported,
                    asmc.result_unit_reported,
                    asmc.location_of_finding_reported,
                    asmc.time_of_day,
                    pv.order_number,
                    pv.name,
                    asmc.study_day                    
                    FROM  assessment_component asmc
                    INNER JOIN
                    assessment_panel asmp ON asmc.assessment_panel_accession=asmp.assessment_panel_accession
                    INNER JOIN
                    planned_visit pv ON asmc.planned_visit_accession=pv.planned_visit_accession
                    WHERE (asmp.study_accession in ('", study_id, "')) AND 
                      (asmp.assessment_type='Skin Assessment') 
                    ORDER BY asmc.subject_accession", sep = "")
  
  if ((class(data_src)[1] == 'MySQLConnection') || 
      (class(data_src)[1] == 'SQLiteConnection')) {
    sr_df <- dbGetQuery(data_src, statement = sql_stmt)
    colnames(sr_df) <- sr_cols
    suppsr_df <- data.frame()
    if (nrow(sr_df) > 0) {
      sr_df <- transform(sr_df, SRSEQ = as.integer(SRSEQ))
      sr_dt <- as.data.table(sr_df)
      if (is.data.table(sr_dt) == TRUE) {
        sr_dt[, `:=`(SRSEQ, seq_len(.N)), by = "USUBJID"]
      }
      sr_df <- as.data.frame(sr_dt)
    }
  } else {
    l <- loadSerializedStudyData(data_src, study_id, "Skin Response")
    sr_df <- l[[1]]
    suppsr_df <- l[[2]]
  }

  cat("done", "\n")
  
  sr_l <- list()
  if (nrow(sr_df) > 0)
    sr_l <- list(sr_df=sr_df, suppsr_df=suppsr_df)
  
  sr_l
}

# Get count of Skin Response data of a specific study
# 
# The function \code{getCountOfSkinResponse} queries the ImmPort database for count 
# of Skin Response data 
# 
# @param conn A connection handle to ImmPort database instance
# @param study_id Identifier of a specific study
# @return a count of Skin Response data 
# @examples
# \dontrun{
#   # get count of study SDY1's Skin Response data
#   count <- getCountOfSkinResponse(conn, "SDY1")
# }
getCountOfSkinResponse <- function(conn, study_id) {
  sql_stmt <- paste("SELECT count(*)
                    FROM  assessment_component asmc
                    INNER JOIN
                    assessment_panel asmp ON asmc.assessment_panel_accession=asmp.assessment_panel_accession 
                    WHERE (asmp.study_accession in ('", study_id, "')) AND 
                    asmp.assessment_type='Skin Assessment'", sep = "")
  
  count <- dbGetQuery(conn, statement = sql_stmt)
  
  count[1, 1]
} 

##' Skin Response Domain Variables
##' @name SR
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name  } \tab \strong{Variable Label} \cr
##'     STUDYID \tab Study Identifier \cr
##'     DOMAIN  \tab Domain Abbreviation \cr
##'     USUBJID \tab Unique Subject Identifier \cr
##'     SRSEQ \tab Sequence Number \cr
##'     SRTEST \tab Skin Response Test or Examination Name \cr
##'     SROBJ \tab Object of the Observation \cr
##'     SRCAT \tab Category for Test \cr
##'     SRORRES \tab Results or Findings in Original Units \cr
##'     SRORRESU \tab Original Units \cr
##'     SRLOC \tab Location used for Measurement \cr
##'     VISITNUM \tab Visit Number \cr
##'     VISIT \tab Visit Name \cr
##'     SRDY \tab Study Day of Visit/Collection/Exam
##'   }
##' }
NULL
#> NULL 

#' Associated Persons Medical History Domain
#' 
#' @name Associated Persons Medical History Domain
#' @description The Associated Persons Medical History data of an ImmPort study is reformated to the CDISC 
#' SDTM AAssociated Persons Medical History (APMH) domain model, and is a list of 2 data frames 
#' containing 1) Associated Persons Medical History data \code{\link{APMH}} and 2) any supplemental 
#' Associated Persons Medical History data \code{\link{SUPP}}
NULL
#> NULL 

# call to globalVariables to prevent from generating NOTE: no visible binding for global variable <variable name>
# this hack is to satisfy CRAN (http://stackoverflow.com/questions/9439256/how-can-i-handle-r-cmd-check-no-visible-binding-for-global-variable-notes-when)
globalVariables(c("APID", "MHSEQ", "RSUBJID", "SREL"))

# medical_history_column_names <- c('study_id', 'domain', 'subject_id', 'reported_term_for_the_medical_history',
# 'category_for_medical_history', 'body_system_or_organ_class', 'age_at_onset', 'age_at_onset_unit',
# 'date_time_of_collection', 'study_day_of_collection')

# Get Associated Persons Medical History data of a specific study
# 
# The function \code{getAssociatedPersonsMedicalHistory} queries the ImmPort database for Associated Persons Medical History data and 
# reformats it to the CDISC SDTM Associated Persons Medical History (APMH) domain model 
# 
# @param data_src A connection handle to ImmPort (MySQL or SQLite) database instance or 
# a directory handle to folder where study RDS files are located
# @param study_id Identifier of a specific study
# @return a list of 2 data frames containing 1) Associated Persons Medical History data \code{\link{APMH}} and 2) any supplemental 
#   Associated Persons Medical History data \code{\link{SUPP}}
# @examples
# \dontrun{
#   getAssociatedPersonsMedicalHistory(data_src, "SDY1")
# }
#' @importFrom DBI dbGetQuery
#' @importFrom plyr .
#' @importFrom data.table as.data.table is.data.table := .N .SD
getAssociatedPersonsMedicalHistory <- function(data_src, study_id) {
  cat("loading Associated Persons Medical History data....")

  apmh_cols <- c("STUDYID", "DOMAIN", "APID", "MHSEQ", "RSUBJID", "SREL", "MHTERM", "MHCAT", "MHBODSYS", "MHDY")
  
  suppapmh_cols <- c("STUDYID", "RDOMAIN", "USUBJID", "IDVAR", "IDVARVAL", "QNAM", "QLABEL", "QVAL")
  
  sql_stmt <- paste("SELECT distinct
                      asmp.study_accession,
                      \"MH\" as domain,
                      cast(0 as UNSIGNED INTEGER) as apid,
                      cast(0 as UNSIGNED INTEGER) as seq,
                      asmc.subject_accession,
                      asmc.who_is_assessed,
                      asmc.name_reported,
                      asmc.name_reported,
                      asmc.organ_or_body_system_reported,
                      asmc.study_day                    
                      FROM  assessment_component asmc
                      INNER JOIN
                      assessment_panel asmp ON asmc.assessment_panel_accession=asmp.assessment_panel_accession
                      WHERE asmp.study_accession in ('", study_id, "') AND 
                        asmp.assessment_type='Family History'
                      ORDER BY asmc.subject_accession", sep = "")
  
  if ((class(data_src)[1] == 'MySQLConnection') || 
      (class(data_src)[1] == 'SQLiteConnection')) {
    apmh_df <- dbGetQuery(data_src, statement = sql_stmt)
    colnames(apmh_df) <- apmh_cols
  
    suppapmh_df <- data.frame()
  
    if (nrow(apmh_df) > 0) {
      apmh_df <- transform(apmh_df, APID = as.integer(APID))
      apmh_df <- transform(apmh_df, MHSEQ = as.integer(MHSEQ))
      apmh_dt <- as.data.table(apmh_df)
      if (is.data.table(apmh_dt) == TRUE) {
        apmh_dt[, `:=`(MHSEQ, seq_len(.N)), by = .(RSUBJID,SREL)]
      }
      if (is.data.table(apmh_dt) == TRUE) {
        apmh_dt[, `:=`(APID, seq_len(.N)), by = "MHSEQ"]
      }
      apmh_df <- as.data.frame(apmh_dt)
    }
  } else {
    l <- loadSerializedStudyData(data_src, study_id, "Associated Persons Medical History")
    apmh_df <- l[[1]]
    suppapmh_df <- l[[2]]
  }
  
  
  
  cat("done", "\n")
  
  apmh_l <- list()
  if (nrow(apmh_df) > 0)
    apmh_l <- list(apmh_df=apmh_df, suppapmh_df=suppapmh_df)
  
  apmh_l
}

# Get count of Associated Persons Medical History data of a specific study
# 
# The function \code{getCountOfAssociatedPersonsMedicalHistory} queries the ImmPort database for count 
# of Associated Persons Medical History data 
# 
# @param conn A connection handle to ImmPort database instance
# @param study_id Identifier of a specific study
# @return a count of Associated Persons Medical History data 
# @examples
# \dontrun{
#   # get count of study SDY1's Associated Persons Medical History data
#   count <- getCountOfAssociatedPersonsMedicalHistory(conn, "SDY1")
# }
getCountOfAssociatedPersonsMedicalHistory <- function(conn, study_id) {
  sql_stmt <- paste("SELECT count(*)
                    FROM  assessment_component asmc
                    INNER JOIN
                    assessment_panel asmp ON asmc.assessment_panel_accession=asmp.assessment_panel_accession
                    WHERE asmp.study_accession in ('", study_id, "') AND 
                    asmp.assessment_type='Family History'", sep = "")
  
  count <- dbGetQuery(conn, statement = sql_stmt)
  
  count[1, 1]
} 

##' Associated Persons Medical History Domain Variables
##' @name APMH
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name  } \tab \strong{Variable Label} \cr
##'     
##'     STUDYID \tab Study Identifier \cr
##'     DOMAIN  \tab Domain Abbreviation \cr
##'     APID \tab Associated Persons Identifier \cr
##'     MHSEQ \tab Sequence Number \cr
##'     RSUBJID \tab Related Subject \cr
##'     SREL \tab Subject Relationship \cr
##'     MHTERM \tab Reported Term for the Medical History \cr
##'     MHCAT \tab Category for Medical History \cr
##'     MHBODSYS \tab Body System or Organ Class \cr
##'     MHDTC \tab Date/Time of History Collection \cr
##'     MHDY \tab RStudy Day of History Collection
##'   }
##' }
NULL
#> NULL 

#' Genetics Findings Domain
#' 
#' @name Genetics Findings Domain
#' @description The ImmPort study data generated from assays of types: HLA Typing and Array are grouped into the 
#' Genetics Findings Domain. The data is reformated to  a PharmacoGenomics and Genetics Findings (PF) model in 
#' CDISC SDTM standards, and is a list of 2 data frames containing 1) Genetics Findings data \code{\link{PF}} 
#' and 2) any supplemental Genetics Findings data \code{\link{SUPP}}
NULL
#> NULL 

# call to globalVariables to prevent from generating NOTE: no visible binding for global variable <variable name>
# this hack is to satisfy CRAN (http://stackoverflow.com/questions/9439256/how-can-i-handle-r-cmd-check-no-visible-binding-for-global-variable-notes-when)
globalVariables(c("subject_id", "result_id", "result_set_id", "experiment_title", "assay_purpose", "measurement_technique",
                  "locus_name", "allele_1", "allele_2",
                  "pop_area_name", "specimen_type", "specimen_subtype",
                  "specimen_treatment", 
                  "treatment_amount_value", "treatment_amount_unit",
                  "treatment_duration_value", "treatment_duration_unit",
                  "treatment_temperature_value", "treatment_temperature_unit",
                  "visit_name", "visit_min_start_day", "visit_max_start_day", "visit_order", 
                  "elapsed_time_of_specimen_collection", "time_point_reference",
                  "biosample_accession", "experiment_sample_accession", "repository_id", 
                  "QNAM", "QVAL", "PFSPECSB", "PFREFIDP", "PFPOPAR", 
                  "VISITMIN", "VISITMAX",
                  "PFSPTRT", 
                  "PFTRTAMV", "PFTRTAMU",
                  "PFTRTDUV", "PFTRTDUU",
                  "PFTRTTMV", "PFTRTTMU"))

# Get Genetics Findings data of a specific study
# 
# The function \code{getGeneticsFindings} queries the ImmPort database for Genetics Findings data and 
# reformats it to a PharmacoGenomics and Genetics Findings (PF) domain model in CDISC SDTM standards. 
# 
# @param data_src A data_srcection handle to ImmPort (MySQL or SQLite) database instance or 
# a directory handle to folder where study RDS files are located
# @param assay_type Assay Type **optional**
# @param study_id Identifier of a specific study
# @return a list of 2 data frames containing 1) Genetics Findings data \code{\link{PF}} and 2) any supplemental 
#   Genetics Findings data \code{\link{SUPPPF}}
# @examples
# \dontrun{
#   # get all of study SDY1's Genetics Findings data
#   gf_l <- getGeneticsFindings(data_src, "SDY1")
#   
#   # get study SDY1's Genetics Findings data that was generated using Array assay
#   gf_l <- getGeneticsFindings(data_src,  "SDY1", "Array")
# }
#' @importFrom reshape2 melt 
#' @importFrom plyr rename
#' @importFrom dplyr %>% mutate
getGeneticsFindings <- function(data_src, study_id, assay_type="ALL") {
  cat("loading Genetics Findings data....")

  gf_cols <- c("STUDYID", "DOMAIN", "USUBJID", "PFSEQ", "PFGRPID", "PFTEST","PFCAT", "PFMETHOD", "PFGENRI", "PFORRES",  
               "PFALLELC", "PFXFN", "PFSPEC", "PFREFID", "VISITNUM", "VISIT", "PFELTM", "PFTPTREF")
  
  suppgf_cols <- c("STUDYID", "RDOMAIN", "USUBJID", "IDVAR", "IDVARVAL", "QNAM", "QLABEL", "QVAL")
  
  
  gf_df = data.frame()
  suppgf_df = data.frame()
  if ((class(data_src)[1] == 'MySQLConnection') || 
      (class(data_src)[1] == 'SQLiteConnection')) {
    if ((assay_type == "ALL") || (assay_type =="HLA Typing")) {
      # get HLA Typing results
        
      #   hla_column_names <- c("study_id", "subject_id", "sequence", "result_set_id",
      #                         "allele_1", "allele_2", 
      #                         "locus_name", "pop_area_name", 
      #                         "experiment_title", "assay_purpose", "measurement_technique",
      #                         "biosample_accession", "specimen_type", "specimen_subtype",
      #                         "visit_name", "elapsed_time_of_specimen_collection", "time_point_reference",
      #                         "study_time_t0_event", "study_time_t0_event_specify")
    
      hla_df <- getHlaTypingResults(data_src, study_id, "")
      if (nrow(hla_df) > 0) {
        hla_df <- select(hla_df, STUDYID = study_id, USUBJID = subject_id, PFSEQ = result_id, PFGRPID = result_set_id,
                         PFTEST = experiment_title, PFCAT = assay_purpose, PFMETHOD = measurement_technique, 
                         PFGENRI = locus_name, PFALLEL1 = allele_1, PFALLEL2 = allele_2, PFPOPAR = pop_area_name, 
                         PFSPEC = specimen_type, PFSPECSB = specimen_subtype, 
                         PFSPTRT = specimen_treatment, 
                         PFTRTAMV = treatment_amount_value, PFTRTAMU = treatment_amount_unit,
                         PFTRTDUV = treatment_duration_value, PFTRTDUU = treatment_duration_unit,
                         PFTRTTMV = treatment_temperature_value, PFTRTTMU = treatment_temperature_unit,
                         VISIT = visit_name, VISITNUM = visit_order,  VISITMIN = visit_min_start_day, VISITMAX = visit_max_start_day, 
                         PFELTM = elapsed_time_of_specimen_collection, PFTPTREF = time_point_reference,
                         PFREFID = experiment_sample_accession, PFREFIDP = biosample_accession )
    
        hla_df$DOMAIN <- "PF"
        hla_df$PFXFN <- ""
        
        qnam_values = c("PFSPECSB", "PFREFIDP", "PFPOPAR", 
                        "VISITMIN", "VISITMAX",
                        "PFSPTRT", 
                        "PFTRTAMV", "PFTRTAMU",
                        "PFTRTDUV", "PFTRTDUU",
                        "PFTRTTMV", "PFTRTTMU")
        qlabel_values= c("Specimen Subtype", "Source Specimen Identifier", "Geographic Area of the Population", 
                         "Planned Visit Minimum Start Day", "Planned Visit Maximum Start Day",
                         "Specimen Treatment", 
                         "Specimen Treatment Amount Value", "Specimen Treatment Amount Unit",
                         "Specimen Treatment Duration Value", "Specimen Treatment Duration Unit", 
                         "Specimen Treatment Temperature Value", "Specimen Treatment Temperature Unit")
        
        supphla_df <- melt(hla_df, 
                                    id = c("STUDYID", "DOMAIN", "USUBJID", "PFSEQ"), 
                                    measure = qnam_values, 
                                    variable.name = "QNAM", 
                                    value.name = "QVAL")
        
        supphla_df <- transform(supphla_df, QLABEL = unlist(qlabel_values[QNAM]))
        supphla_df <- plyr::rename(supphla_df, c("DOMAIN" = "RDOMAIN", "PFSEQ" = "IDVARVAL"))
        supphla_df$IDVAR <- "PFSEQ"
        
        
        supphla_df <- supphla_df[suppgf_cols]
        
        # remove rows that have empty QVAL values
        supphla_df <- subset(supphla_df,QVAL!="")      
        
        hla_df <- subset(hla_df, select = -c(PFSPECSB, PFREFIDP, PFPOPAR, 
                                             VISITMIN, VISITMAX,
                                             PFSPTRT, 
                                             PFTRTAMV, PFTRTAMU,
                                             PFTRTDUV, PFTRTDUU,
                                             PFTRTTMV, PFTRTTMU))
        
        hla_df <- melt(hla_df, 
                                     id = c("STUDYID", "DOMAIN", "USUBJID", "PFSEQ", "PFGRPID", "PFTEST", "PFGENRI",  "PFCAT", "PFMETHOD", 
                                            "PFSPEC", "VISITNUM", "VISIT", "PFELTM", "PFTPTREF", "PFREFID", "PFXFN"), 
                                     measure = c("PFALLEL1", "PFALLEL2"), 
                                     variable.name = "PFALLELC", 
                                     value.name = "PFORRES")
        hla_df <- hla_df[with(hla_df, order(PFSEQ)), ]
        rownames(hla_df) <- c()
        hla_df <- hla_df[, gf_cols]
    
        gf_df <- rbind(gf_df, hla_df)
        suppgf_df <- rbind(suppgf_df, supphla_df)
        
      }
    }
    
    if ((assay_type == "ALL") || (assay_type =="Array")) {
      # get Array results
      
      #   array_column_names <- c("study_id", "subject_id", "result_id", "dataset_id", 
      #                           "experiment_title", "assay_purpose", "measurement_technique",
      #                           "biosample_accession", "specimen_type", "specimen_subtype", 
      #                           "visit_name", "elapsed_time_of_specimen_collection", "time_point_reference")
  
      arr_df <- getArrayResults(data_src, study_id, "")
      if (nrow(arr_df) > 0) {
        arr_df <- arr_df %>% 
          select(STUDYID = study_id, USUBJID = subject_id, PFSEQ = sequence, PFXFN = dataset_id,
                         PFTEST = experiment_title, PFCAT = assay_purpose, PFMETHOD = measurement_technique, 
                         PFSPEC = specimen_type, PFSPECSB = specimen_subtype, 
                         PFSPTRT = specimen_treatment, 
                         PFTRTAMV = treatment_amount_value, PFTRTAMU = treatment_amount_unit,
                         PFTRTDUV = treatment_duration_value, PFTRTDUU = treatment_duration_unit,
                         PFTRTTMV = treatment_temperature_value, PFTRTTMU = treatment_temperature_unit,
                         VISIT = visit_name, VISITNUM = visit_order,  VISITMIN = visit_min_start_day, VISITMAX = visit_max_start_day, 
                         PFELTM = elapsed_time_of_specimen_collection, PFTPTREF = time_point_reference,
                         PFREFID = experiment_sample_accession, PFREFIDP = biosample_accession )
        arr_df$DOMAIN <- "PF"
        arr_df$PFGRPID <- ""
        arr_df$PFGENRI <- ""
        arr_df$PFORRES <- ""
        arr_df$PFALLELC <- ""
    
        qnam_values = c("PFSPECSB", "PFREFIDP",
                        "VISITMIN", "VISITMAX",
                        "PFSPTRT", 
                        "PFTRTAMV", "PFTRTAMU",
                        "PFTRTDUV", "PFTRTDUU",
                        "PFTRTTMV", "PFTRTTMU")
        qlabel_values= c("Specimen Subtype", "Source Specimen Identifier", 
                         "Planned Visit Minimum Start Day", "Planned Visit Maximum Start Day",
                         "Specimen Treatment", 
                         "Specimen Treatment Amount Value", "Specimen Treatment Amount Unit",
                         "Specimen Treatment Duration Value", "Specimen Treatment Duration Unit", 
                         "Specimen Treatment Temperature Value", "Specimen Treatment Temperature Unit")
        
        supparr_df <- melt(arr_df, 
                                     id = c("STUDYID", "DOMAIN", "USUBJID", "PFSEQ"), 
                                     measure = qnam_values, 
                                     variable.name = "QNAM", 
                                     value.name = "QVAL")
        
        supparr_df <- transform(supparr_df, QLABEL = unlist(qlabel_values[QNAM]))
        supparr_df <- plyr::rename(supparr_df, c("DOMAIN" = "RDOMAIN", "PFSEQ" = "IDVARVAL"))
        supparr_df$IDVAR <- "PFSEQ"
        
        
        supparr_df <- supparr_df[suppgf_cols]
        
        # remove rows that have empty QVAL values
        supparr_df <- subset(supparr_df,QVAL!="")      
        
        arr_df <- subset(arr_df, select = -c(PFSPECSB, PFREFIDP, PFSPTRT, 
                                             VISITMIN, VISITMAX,
                                             PFTRTAMV, PFTRTAMU,
                                             PFTRTDUV, PFTRTDUU,
                                             PFTRTTMV, PFTRTTMU))
        
        arr_df <- arr_df[, gf_cols]
    
        gf_df <- rbind(gf_df, arr_df)
        suppgf_df <- rbind(suppgf_df, supparr_df)
        
      }  
    }
  } else {
    l <- loadSerializedStudyData(data_src, study_id, "Genetics Findings")
    if (assay_type == "ALL") {
      gf_df <- l[[1]]
      suppgf_df <- l[[2]]
    } else {
      
    }
  }   
  
  cat("done", "\n")

  gf_l <- list()
  if (nrow(gf_df) > 0)
    gf_l <- list(pf_df=gf_df, supppf_df=suppgf_df)
  
  gf_l
} 

# Get count of Genetics Findings data of a specific study
# 
# The function \code{getCountOfGeneticsFindings} queries the ImmPort database for count 
# of Genetics Findings data 
# 
# @param data_src A connection handle to ImmPort database instance
# @param assay_type Assay Type **optional**
# @param study_id Identifier of a specific study
# @return a count of Genetics Findings data 
# @examples
# \dontrun{
#   # get count of all of study SDY1's Genetics Findings data
#   count <- getCountOfGeneticsFindings(data_src, "SDY1")
#   
#   # get count of study SDY1's Genetics Findings data that was generated using Array assay
#   count <- getCountOfGeneticsFindings(data_src, "SDY1", "Array")
# }
getCountOfGeneticsFindings <- function(data_src, study_id, assay_type="ALL") {
  count <- 0
  if ((assay_type == "ALL") || (assay_type =="HLA Typing")) 
    count <- count + getCountOfHlaTypingResults(data_src, study_id)
  if ((assay_type == "ALL") || (assay_type =="Array")) 
    count <- count + getCountOfArrayResults(data_src, study_id)
  
  count
}

##' Genetics Findings Domain Variables
##' @name PF
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name  } \tab \strong{Variable Label} \cr
##'     STUDYID \tab Study Identifier \cr
##'     DOMAIN  \tab Domain Abbreviation \cr
##'     USUBJID \tab Unique Subject Identifier \cr
##'     PFSEQ \tab Sequence Number \cr
##'     PFGRPID \tab Group Identifier \cr
##'     PFTEST \tab  Test Name \cr
##'     PFCAT \tab Category for Test \cr
##'     PFMETHOD \tab Method of the Test \cr
##'     PFGENRI \tab Genetic Region of Interest \cr
##'     PFORRES \tab Result or Finding in Original Units \cr
##'     PFALLELC \tab Allele (Chromosome) Identifier \cr
##'     PFSPEC \tab Specimen Type \cr
##'     PFREFID \tab Reference ID (Specimen Identifier) \cr
##'     VISITNUM \tab Visit Number \cr
##'     VISIT \tab Visit Name \cr
##'     PFELTM \tab Planned Elapsed Time from Time Point Ref \cr
##'     PFTPTREF \tab Time Point Reference \cr
##'     PFXFN \tab Raw Data File or Life Science Identifier
##'   }
##' }
NULL
#> NULL 

##' Genetics Findings Domain Supplemental Variables
##' @name SUPPPF
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name} \tab \strong{Variable Label} \cr
##'     STUDYID \tab Study Identifier \cr
##'     RDOMAIN  \tab Related Domain Abbreviation \cr
##'     USUBJID \tab Unique Subject Identifier \cr
##'     IDVAR \tab Identifying Variable \cr
##'     IDVARVAL \tab Identifying Variable Value \cr
##'     QNAM \tab Qualifier Variable Name \cr
##'     QLABEL \tab Qualifier Variable Label \cr
##'     QVAL \tab Data Value
##'   }
##' }
##' @note The following table enumerates the values in QNAM and QLABEL variables {
##'   \tabular{ll}{
##'     \strong{QNAM} \tab \strong{QLABEL} \cr
##'     PFPOPAR \tab Geographic Area of the Population \cr
##'     PFSPECSB \tab Specimen Subtype \cr
##'     PFREFIDP \tab Source Specimen Identifier \cr
##'     VISITMIN \tab Planned Visit Minimum Start Day \cr
##'     VISITMAX \tab Planned Visit Maximum Start Day \cr
##'     PFSPTRT \tab Specimen Treatment \cr
##'     PFTRTAMV \tab Specimen Treatment Amount Value \cr
##'     PFTRTAMU \tab Specimen Treatment Amount Unit \cr
##'     PFTRTDUV \tab Specimen Treatment Duration Value \cr
##'     PFTRTDUU \tab Specimen Treatment Duration Unit \cr
##'     PFTRTTMV \tab Specimen Treatment Temperature Value \cr
##'     PFTRTTMU \tab Specimen Treatment Temperature Unit
##'   }
##' }
NULL
#> NULL

#' Concomitant Medications Domain
#' 
#' @name Concomitant Medications Domain
#' @description The Concomitant Medications data of an ImmPort study is reformated to the CDISC SDTM 
#' Concomitant Medications (CM) domain model, and is a list of 2 data frames containing 
#' 1) Concomitant Medications data \code{\link{CM}} and 2) any supplemental Concomitant 
#' Medications data \code{\link{SUPP}}
NULL
#> NULL 

# call to globalVariables to prevent from generating NOTE: no visible binding for global variable <variable name>
# this hack is to satisfy CRAN (http://stackoverflow.com/questions/9439256/how-can-i-handle-r-cmd-check-no-visible-binding-for-global-variable-notes-when)
globalVariables(c("CMSEQ"))

# Get Concomitant Medications data of a specific study
# 
# The function \code{getConcomitantMedications} queries the ImmPort database for Concomitant Medications data and 
# reformats it to the CDISC SDTM Concomitant Medications (CM) domain model 
# 
# @param data_src A connection handle to ImmPort (MySQL or SQLite) database instance or 
# a directory handle to folder where study RDS files are located
# @param study_id Identifier of a specific study
# @return a list of 2 data frames containing 1) Concomitant Medications data \code{\link{CM}} and 2) any supplemental 
#   Concomitant Medications data \code{\link{SUPP}}
# @examples
# \dontrun{
#   getConcomitantMedications(data_src, "SDY1")
# }
#' @importFrom DBI dbGetQuery
#' @importFrom data.table as.data.table is.data.table .N :=
getConcomitantMedications <- function(data_src, study_id) {
    cat("loading Concomitant Medications data....")
    
    cm_cols <- c("STUDYID", "DOMAIN", "USUBJID", "CMSEQ", "CMTRT", "CMCAT", "CMDOSE", "CMDOSTXT", 
               "CMDOSU", "CMDOSFREQ", "CMROUTE", "CMSTDTC", "CMENDTC", "CMSTDY", "CMENDY")
 
  
    sql_stmt <- paste("SELECT distinct
                        sub.study_accession,
                        \"CM\" as domain,
                        sub.subject_accession,
                        cast(0 as UNSIGNED INTEGER) as seq,
                        sub.compound_name_reported,
                        sub.name_reported,
                        sub.dose,
                        sub.dose_reported,
                        sub.dose_units,
                        sub.dose_freq_per_interval,
                        sub.route_of_admin_reported,
                        sub.start_time,
                        sub.end_time,
                        sub.start_day,                    
                        sub.end_day
                      FROM  intervention sub
                      WHERE sub.study_accession in ('", study_id, "') AND 
                        sub.compound_role='Concomitant Medication'
                      ORDER BY sub.subject_accession", sep = "")

    if ((class(data_src)[1] == 'MySQLConnection') || 
        (class(data_src)[1] == 'SQLiteConnection')) {
      cm_df <- dbGetQuery(data_src, statement = sql_stmt)
      colnames(cm_df) <- cm_cols
      suppcm_df <- data.frame()
  
      if (nrow(cm_df) > 0) {
        cm_df <- transform(cm_df, CMSEQ = as.integer(CMSEQ))
        cm_dt <- as.data.table(cm_df)
        if (is.data.table(cm_dt) == TRUE) {
          cm_dt[, `:=`(CMSEQ, seq_len(.N)), by = "USUBJID"]
        }
        cm_df <- as.data.frame(cm_dt)
      }
    } else {
      l <- loadSerializedStudyData(data_src, study_id, "Concomitant Medications")
      cm_df <- l[[1]]
      suppcm_df <- l[[2]]
    }  
    
    cat("done", "\n")
    
    cm_l <- list()
    if (nrow(cm_df) > 0)
      cm_l <- list(cm_df=cm_df, suppcm_df=suppcm_df)
    
    cm_l
}

# Get count of Concomitant Medications data of a specific study
# 
# The function \code{getCountOfConcomitantMedications} queries the ImmPort database for count 
# of Concomitant Medications data 
# 
# @param conn A connection handle to ImmPort database instance
# @param study_id Identifier of a specific study
# @return a count of Concomitant Medications data 
# @examples
# \dontrun{
#   # get count of study SDY1's Concomitant Medications data
#   count <- getCountOfConcomitantMedications(conn, "SDY1")
# }
getCountOfConcomitantMedications <- function(conn, study_id) {
    sql_stmt <- paste("SELECT count(*)                    
                      FROM  intervention sub                    
                      WHERE sub.study_accession in ('", study_id, "') AND 
                      sub.compound_role='Concomitant Medication'", sep = "")
    
    count <- dbGetQuery(conn, statement = sql_stmt)
    
    count[1, 1]
} 

##' Concomitant Medications Domain Variables
##' @name CM
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name  } \tab \strong{Variable Label} \cr
##'     STUDYID \tab Study Identifier \cr
##'     DOMAIN  \tab Domain Abbreviation \cr
##'     USUBJID \tab Unique Subject Identifier \cr
##'     CMSEQ \tab Sequence Number \cr
##'     CMTRT \tab Reported Name of Drug, Med, or Therapy \cr
##'     CMCAT \tab Category for Medication \cr
##'     CMDOSE \tab Dose per Administration \cr
##'     CMDOSTXT \tab Dose Description \cr
##'     CMDOSU \tab Dose Units \cr
##'     CMDOSFREQ \tab Dosing Frequency per Interval  \cr
##'     CMROUTE \tab Route of Administration \cr
##'     CMSTDTC \tab Start Date/Time of Medication \cr
##'     CMENDTC \tab End Date/Time of Medication \cr
##'     CMSTDY \tab Study Day of Start of Medication \cr
##'     CMENDY \tab Study Day of End of Medication
##'   }
##' }
NULL
#> NULL

#' Cellular Quantification Domain
#' 
#' @name Cellular Quantification Domain
#' @description The ImmPort study data generated from assays of types: Flow and ELISPOT are grouped into the 
#' Cellular Quantification Domain. The data is reformated to a custom Cellular Quantification domain model in 
#' CDISC SDTM standards, and is a list of 2 data frames containing 1) Cellular Quantification data \code{\link{ZB}} and 2) any supplemental 
#'   Cellular Quantification data \code{\link{SUPP}}
NULL
#> NULL 

# call to globalVariables to prevent from generating NOTE: no visible binding for global variable <variable name>
# this hack is to satisfy CRAN (http://stackoverflow.com/questions/9439256/how-can-i-handle-r-cmd-check-no-visible-binding-for-global-variable-notes-when)
globalVariables(c("subject_id", "experiment_title", "assay_purpose", "measurement_technique",
                  "base_parent_population", "population_cell_number", "population_cell_number_unit",
                  "population_defnition_reported", "population_name_reported", "specimen_type",
                  "specimen_subtype", "specimen_treatment", 
                  "treatment_amount_value", "treatment_amount_unit",
                  "treatment_duration_value", "treatment_duration_unit",
                  "treatment_temperature_value", "treatment_temperature_unit",
                  "visit_name", "visit_min_start_day", "visit_max_start_day", "visit_order",
                  "elapsed_time_of_specimen_collection", "time_point_reference",
                  "biosample_accession", "experiment_sample_accession", "file_name", "control_files_names", "ZBSEQ", "result_id", "cell_type", "spot_number",
                  "analyte", "cell_number", "ZBBASPOP", "ZBPOPDEF", "ZBSPECSB", "ZBFCF",
                  "ZBREFID", "ZBREFIDP",
                  "VISITMIN", "VISITMAX",
                  "ZBSPTRT", 
                  "ZBTRTAMV", "ZBTRTAMU",
                  "ZBTRTDUV", "ZBTRTDUU",
                  "ZBTRTTMV", "ZBTRTTMU"))

## Get Cellular Quantification data of a specific study
## 
## The function \code{getCellularQuantification} queries the ImmPort database for Cellular Quantification data and 
## reformats it to a custom Cellular Quantification domain model in CDISC SDTM standards. 
## 
## @param data_src A data_srcection handle to ImmPort (MySQL or SQLite) database instance or 
## a directory handle to folder where study RDS files are located
## @param assay_type Assay Type **optional**
## @param study_id Identifier of a specific study
## @return a list of 2 data frames containing 1) Cellular Quantification data \code{\link{ZB}} and 2) any supplemental 
##   Cellular Quantification data \code{\link{SUPP}}
## @examples
## \dontrun{
##   # get all of study SDY1's Cellular Quantification data
##   cq_l <- getCellularQuantification(data_src, "SDY1")
##   
##   # get study SDY1's Cellular Quantification data that was generated using Flow assay
##   cq_l <- getCellularQuantification(data_src, "SDY1", "Flow")
## }
##' @importFrom dplyr %>%
##' @importFrom plyr rename
##' @importFrom data.table as.data.table is.data.table setDT setDF := .N 
getCellularQuantification <- function(data_src, study_id, assay_type="ALL") {
    cat("loading Cellular Quantification data....")
  
    cq_cols <- c("STUDYID", "DOMAIN", "USUBJID", "ZBSEQ", "ZBTEST", "ZBCAT", "ZBMETHOD", 
                  "ZBPOPDEF", "ZBPOPNAM", "ZBORRES", "ZBORRESU", "ZBBASPOP", 
                 "ZBSPEC", "VISITNUM", "VISIT", "ZBELTM", "ZBTPTREF", "ZBREFID", 
               "ZBXFN")
  
    suppcq_cols <- c("STUDYID", "RDOMAIN", "USUBJID", "IDVAR", "IDVARVAL", "QNAM", "QLABEL", "QVAL")
  
  
    cq_df = data.frame()
    suppcq_df = data.frame()
    
    if ((class(data_src)[1] == 'MySQLConnection') || 
        (class(data_src)[1] == 'SQLiteConnection')) {
      if ((assay_type == "ALL") || (assay_type =="Flow")) {
        # get Flow results
        flow_df <- getFcsResults(data_src, study_id, "")
        if (nrow(flow_df) > 0) {
            flow_df <- select(flow_df, STUDYID = study_id, USUBJID = subject_id, ZBSEQ = sequence, ZBTEST = experiment_title, 
                ZBCAT = assay_purpose, ZBMETHOD = measurement_technique, 
                ZBBASPOP = base_parent_population, ZBORRES = population_cell_number, 
                ZBORRESU = population_cell_number_unit, ZBPOPDEF = population_defnition_reported, ZBPOPNAM = population_name_reported, 
                ZBSPEC = specimen_type, ZBSPECSB = specimen_subtype, 
                ZBSPTRT = specimen_treatment, 
                ZBTRTAMV = treatment_amount_value, ZBTRTAMU = treatment_amount_unit,
                ZBTRTDUV = treatment_duration_value, ZBTRTDUU = treatment_duration_unit,
                ZBTRTTMV = treatment_temperature_value, ZBTRTTMU = treatment_temperature_unit,
                VISIT = visit_name, VISITNUM = visit_order,  VISITMIN = visit_min_start_day, VISITMAX = visit_max_start_day, 
                ZBELTM = elapsed_time_of_specimen_collection, ZBTPTREF = time_point_reference, 
                ZBREFID = experiment_sample_accession, ZBREFIDP = biosample_accession, ZBXFN = file_name, ZBFCF=control_files_names)
            
            flow_df$DOMAIN <- "ZB"
            
            qnam_values = c("ZBSPECSB", "ZBREFIDP", "ZBFCF",
                            "VISITMIN", "VISITMAX",
                            "ZBSPTRT", 
                            "ZBTRTAMV", "ZBTRTAMU",
                            "ZBTRTDUV", "ZBTRTDUU",
                            "ZBTRTTMV", "ZBTRTTMU")
            qlabel_values= c("Specimen Subtype", "Source Specimen Identifier", "Control Files Names",
                             "Planned Visit Minimum Start Day", "Planned Visit Maximum Start Day",
                             "Specimen Treatment", 
                             "Specimen Treatment Amount Value", "Specimen Treatment Amount Unit",
                             "Specimen Treatment Duration Value", "Specimen Treatment Duration Unit", 
                             "Specimen Treatment Temperature Value", "Specimen Treatment Temperature Unit")
            
            
#             flow_df <- transform(flow_df, ZBSEQ = as.integer(ZBSEQ))
#             setDT(flow_df)[, `:=`(ZBSEQ, seq_len(.N)), by = "USUBJID"]
#             flow_df <- as.data.frame(flow_df)
             
            suppflow_df <- melt(flow_df, 
                               id = c("STUDYID", "DOMAIN", "USUBJID", "ZBSEQ"), 
                               measure = qnam_values, 
                               variable.name = "QNAM", 
                               value.name = "QVAL")
            
            suppflow_df <- transform(suppflow_df, QLABEL = unlist(qlabel_values[QNAM]))
            suppflow_df <- plyr::rename(suppflow_df, c("DOMAIN" = "RDOMAIN", "ZBSEQ" = "IDVARVAL"))
            suppflow_df$IDVAR <- "ZBSEQ"
            
            
            suppflow_df <- suppflow_df[suppcq_cols]
            
            # remove rows that have empty QVAL values
            suppflow_df <- subset(suppflow_df,QVAL!="")      
            
            flow_df <- subset(flow_df, select = -c(ZBSPECSB, ZBREFIDP, ZBFCF,
                                                   VISITMIN, VISITMAX,
                                                   ZBSPTRT, 
                                                   ZBTRTAMV, ZBTRTAMU,
                                                   ZBTRTDUV, ZBTRTDUU,
                                                   ZBTRTTMV, ZBTRTTMU))
            
            flow_df <- flow_df[, cq_cols]
            
            cq_df <- rbind(cq_df, flow_df)
            suppcq_df <- rbind(suppcq_df, suppflow_df)
            
        }
      }

      
      if ((assay_type == "ALL") || (assay_type =="ELISPOT")) {
        # get ELISPOT results
        
        # elispot_column_names <- c('study_id', 'subject_id', 'result_id', 'analyte', 'comments', 'cell_number',
        # 'cell_type', 'spot_number', 'experiment_title', 'assay_purpose', 'measurement_technique', 'biosample_accession',
        # 'specimen_type', 'specimen_subtype', 'visit_name', 'study_time_of_specimen_collection',
        # 'unit_of_study_time_of_specimen_collection', 'study_time_t0_event', 'study_time_t0_event_specify', 'file_name')
        
        measurement_types <- list("Protein_Quantification", "Cytokine_Quantification")
        elp_df <- getElispotResults(data_src, study_id, "")
        if (nrow(elp_df) > 0) {
          elp_df <- elp_df %>% 
            select(STUDYID = study_id, USUBJID = subject_id, ZBSEQ = sequence, ZBTEST = experiment_title, 
                                      ZBCAT = assay_purpose, ZBMETHOD = measurement_technique, 
                                      ZBBASPOP=cell_type, ZBORRES = spot_number, ZBPOPDEF = analyte, cell_number, 
                                      ZBSPEC = specimen_type, ZBSPECSB = specimen_subtype,
                                      ZBSPTRT = specimen_treatment, 
                                      ZBTRTAMV = treatment_amount_value, ZBTRTAMU = treatment_amount_unit,
                                      ZBTRTDUV = treatment_duration_value, ZBTRTDUU = treatment_duration_unit,
                                      ZBTRTTMV = treatment_temperature_value, ZBTRTTMU = treatment_temperature_unit,
                                      VISIT = visit_name, VISITNUM = visit_order,  VISITMIN = visit_min_start_day, VISITMAX = visit_max_start_day, 
                                      ZBELTM = elapsed_time_of_specimen_collection, ZBTPTREF = time_point_reference,  
                                      ZBREFID = experiment_sample_accession, ZBREFIDP = biosample_accession, ZBXFN = file_name) %>% 
            mutate(ZBORRESU = paste(cell_number, ZBBASPOP))  %>% 
            mutate(ZBPOPNAM = ZBPOPDEF) 
            
          elp_df$DOMAIN <- "ZB"

          qnam_values = c("ZBSPECSB", "ZBREFIDP",
                          "VISITMIN", "VISITMAX",
                          "ZBSPTRT", 
                          "ZBTRTAMV", "ZBTRTAMU",
                          "ZBTRTDUV", "ZBTRTDUU",
                          "ZBTRTTMV", "ZBTRTTMU")
          qlabel_values= c("Specimen Subtype",
                           "Planned Visit Minimum Start Day", "Planned Visit Maximum Start Day",
                           "Specimen Treatment", 
                           "Specimen Treatment Amount Value", "Specimen Treatment Amount Unit",
                           "Specimen Treatment Duration Value", "Specimen Treatment Duration Unit", 
                           "Specimen Treatment Temperature Value", "Specimen Treatment Temperature Unit")
          
          
#           elp_df <- elp_df[, c("STUDYID", "DOMAIN", "USUBJID", "ZBSEQ", "ZBTEST", "ZBCAT", "ZBMETHOD", "ZBPOPDEF", "ZBPOPNAM", "ZBORRES", 
#                                "ZBORRESU", "ZBBASPOP", "ZBSPEC", "VISIT", "ZBELTM", "ZBTPTREF", "ZBREFID", 
#                                "ZBXFN")]

          suppelp_df <- melt(elp_df, 
                              id = c("STUDYID", "DOMAIN", "USUBJID", "ZBSEQ"), 
                              measure = qnam_values, 
                              variable.name = "QNAM", 
                              value.name = "QVAL")
          
          suppelp_df <- transform(suppelp_df, QLABEL = unlist(qlabel_values[QNAM]))
          suppelp_df <- plyr::rename(suppelp_df, c("DOMAIN" = "RDOMAIN", "ZBSEQ" = "IDVARVAL"))
          suppelp_df$IDVAR <- "ZBSEQ"
          
          
          suppelp_df <- suppelp_df[suppcq_cols]
          
          # remove rows that have empty QVAL values
          suppelp_df <- subset(suppelp_df,QVAL!="")      
          
          elp_df <- subset(elp_df, select = -c(ZBSPECSB, ZBREFIDP,
                                               VISITMIN, VISITMAX,
                                               ZBSPTRT, 
                                               ZBTRTAMV, ZBTRTAMU,
                                               ZBTRTDUV, ZBTRTDUU,
                                               ZBTRTTMV, ZBTRTTMU))
          
          elp_df <- elp_df[, cq_cols]
          
          cq_df <- rbind(cq_df, elp_df)
          suppcq_df <- rbind(suppcq_df, suppelp_df)
          
        }
      }
    } else {
      l <- loadSerializedStudyData(data_src, study_id, "Cellular Quantification")
      if (assay_type == "ALL") {
        cq_df <- l[[1]]
        suppcq_df <- l[[2]]
      } else {
        
      }
    }   
    
    
    cat("done", "\n")
    
    cq_l <- list()
    if (nrow(cq_df) > 0)
      cq_l <- list(zb_df=cq_df, suppzb_df=suppcq_df)
    
    cq_l
} 

## Get count of Cellular Quantification data of a specific study
## 
## The function \code{getCountOfCellularQuantification} queries the ImmPort database for count 
## of Cellular Quantification data 
## 
## @param data_src A connection handle to ImmPort database instance
## @param assay_type Assay Type **optional**
## @param study_id Identifier of a specific study
## @return a count of Cellular Quantification data 
## @examples
## \dontrun{
##   # get count of all of study SDY1's Cellular Quantification data
##   count <- getCountOfCellularQuantification(data_src, "SDY1")
##   
##   # get count of study SDY1's Cellular Quantification data that was generated using Flow assay
##   count <- getCountOfCellularQuantification(data_src,"SDY1",  "Flow")
## }
getCountOfCellularQuantification <- function(data_src, study_id, assay_type="ALL") {
  count <- 0
  if ((assay_type == "ALL") || (assay_type =="Flow")) 
    count <- count + getCountOfFcsResults(data_src, study_id)
  if ((assay_type == "ALL") || (assay_type =="ELISPOT")) 
    count <- count + getCountOfElispotResults(data_src, study_id)
  
  count
}
  

##' Cellular Quantification Domain Variables
##' @name ZB
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name  } \tab \strong{Variable Label} \cr
##'     STUDYID \tab Study Identifier \cr
##'     DOMAIN  \tab Domain Abbreviation \cr
##'     USUBJID \tab Unique Subject Identifier \cr
##'     ZBSEQ \tab Sequence Number \cr
##'     ZBTEST \tab Cellular Quantification Test Name \cr
##'     ZBCAT \tab Category for Cellular Quantification \cr
##'     ZBMETHOD \tab Measurement Technique \cr
##'     ZBPOPDEF \tab Cell Population Definition \cr
##'     ZBPOPNAM \tab Cell Population Name \cr
##'     ZBORRES \tab Result or Finding in Original Units \cr
##'     ZBORRESU \tab Original Units \cr
##'     ZBBASPOP \tab Base Parent Population \cr
##'     ZBSPEC \tab Specimen Type \cr
##'     VISITNUM \tab Visit Number \cr
##'     VISIT \tab Visit Name \cr
##'     ZBELTM \tab Planned Elapsed Time from Time Point Ref \cr
##'     ZBTPTREF \tab Time Point Reference \cr
##'     ZBREFID \tab Specimen Identifier \cr
##'     ZBXFN \tab Raw Data File or Life Science Identifier
##'   }
##' }
NULL
#> NULL 

##' Cellular Quantification Domain Supplemental Variables
##' @name SUPPZB
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name} \tab \strong{Variable Label} \cr
##'     STUDYID \tab Study Identifier \cr
##'     RDOMAIN  \tab Related Domain Abbreviation \cr
##'     USUBJID \tab Unique Subject Identifier \cr
##'     IDVAR \tab Identifying Variable \cr
##'     IDVARVAL \tab Identifying Variable Value \cr
##'     QNAM \tab Qualifier Variable Name \cr
##'     QLABEL \tab Qualifier Variable Label \cr
##'     QVAL \tab Data Value
##'   }
##' }
##' @note The following table enumerates the values in QNAM and QLABEL variables {
##'   \tabular{ll}{
##'     \strong{QNAM} \tab \strong{QLABEL} \cr
##'     ZBSPECSB \tab Specimen Subtype \cr
##'     ZBREFIDP \tab Source Specimen Identifier \cr
##'     ZBFCF \tab Control Files Names \cr
##'     VISITMIN \tab Planned Visit Minimum Start Day \cr
##'     VISITMAX \tab Planned Visit Maximum Start Day \cr
##'     ZBSPTRT \tab Specimen Treatment \cr
##'     ZBTRTAMV \tab Specimen Treatment Amount Value \cr
##'     ZBTRTAMU \tab Specimen Treatment Amount Unit \cr
##'     ZBTRTDUV \tab Specimen Treatment Duration Value \cr
##'     ZBTRTDUU \tab Specimen Treatment Duration Unit \cr
##'     ZBTRTTMV \tab Specimen Treatment Temperature Value \cr
##'     ZBTRTTMU \tab Specimen Treatment Temperature Unit
##'   }
##' }
NULL
#> NULL

# call to globalVariables to prevent from generating NOTE: no visible binding for global variable <variable name>
# this hack is to satisfy CRAN (http://stackoverflow.com/questions/9439256/how-can-i-handle-r-cmd-check-no-visible-binding-for-global-variable-notes-when)
globalVariables(c("study_time_of_specimen_collection", "unit_of_study_time_of_specimen_collection",
                  "study_time_t0_event", "study_time_t0_event_specify"))


getElispotResults <- function(conn,study_id, measurement_types) {
  cat("loading ELISPOT Results data....")
  
#   old <- options(stringsAsFactors = FALSE)
#   on.exit(options(old), add = TRUE)
#   options(useFancyQuotes = FALSE)
#   measurement_types <- paste(mapply(sQuote, measurement_types), collapse=", ")
  
  elispot_cols <- c("study_id", "subject_id", "sequence",
                    "analyte", "comments", 
                    "cell_number", "cell_type", "spot_number", 
                    "experiment_title", "assay_purpose", "measurement_technique",
                    "experiment_sample_accession",
                    "biosample_accession", "specimen_type", "specimen_subtype",
                    "visit_name", "visit_min_start_day", "visit_max_start_day", "visit_order",
                    "study_time_of_specimen_collection", "unit_of_study_time_of_specimen_collection",
                    "study_time_t0_event", "study_time_t0_event_specify",
                    "file_name")

  tr_cols <- c("experiment_sample_accession",
               "specimen_treatment", 
               "treatment_amount_value", "treatment_amount_unit",
               "treatment_duration_value", "treatment_duration_unit",
               "treatment_temperature_value", "treatment_temperature_unit")
  
  sql_stmt <- paste("
                    SELECT distinct
                    elp.study_accession,
                    elp.subject_accession,
                    elp.result_id,
                    elp.analyte_reported, 
                    elp.comments, 
                    elp.cell_number_reported, 
                    '' as cell_type, 
                    elp.spot_number_reported, 
                    ex.name,
                    'Cellular Quantification' as purpose,
                    ex.measurement_technique,
                    elp.expsample_accession,
                    bs.biosample_accession,
                    bs.type,
                    bs.subtype,
                    pv.name,
                    pv.min_start_day,
                    pv.max_start_day,
                    pv.order_number,
                    bs.study_time_collected,
                    bs.study_time_collected_unit,
                    bs.study_time_t0_event,
                    bs.study_time_t0_event_specify,
                    \"\"
                    FROM  
                      elispot_result elp
					          INNER JOIN
						          experiment ex ON elp.experiment_accession=ex.experiment_accession
					          INNER JOIN
						          biosample bs ON elp.biosample_accession=bs.biosample_accession
                    INNER JOIN
                      planned_visit pv ON bs.planned_visit_accession=pv.planned_visit_accession
                    WHERE elp.study_accession in (\'", study_id,"\')  
                    ORDER BY elp.subject_accession",sep="")
  
  elispot_df <- dbGetQuery(conn,statement=sql_stmt)

  if (nrow(elispot_df) > 0) {
    colnames(elispot_df) <- elispot_cols 

    elispot_df$elapsed_time_of_specimen_collection = mapply(covertElaspsedTimeToISO8601Format, elispot_df$study_time_of_specimen_collection, 
                                                        elispot_df$unit_of_study_time_of_specimen_collection)
    
    elispot_df$time_point_reference = mapply(getTimePointReference, elispot_df$study_time_t0_event, 
                                         elispot_df$study_time_t0_event_specify)
    
    sql_stmt <- paste("
                      SELECT distinct
                      elp.expsample_accession,
                      tr.name,
                      tr.amount_value,
                      tr.amount_unit,
                      tr.duration_value,
                      tr.duration_unit,
                      tr.temperature_value,
                      tr.temperature_unit
                      FROM  
                      elispot_result elp
                      INNER JOIN
                      expsample_2_treatment es2tr ON elp.expsample_accession=es2tr.expsample_accession
                      INNER JOIN
                      treatment tr ON es2tr.treatment_accession=tr.treatment_accession
                      WHERE 
                      elp.study_accession in (\'", study_id,"\')",sep="")
    
    tr_df <- dbGetQuery(conn,statement=sql_stmt)
    colnames(tr_df) <- tr_cols 
    
    if (nrow(tr_df) >0) {
#      tr_df <- aggregate(. ~ experiment_sample_accession,paste,collapse="||",data=tr_df)
      tr_df <- setDF(setDT(tr_df)[, lapply(.SD, paste, collapse="||"), by="experiment_sample_accession"])
      elispot_df <- merge(elispot_df ,tr_df, by="experiment_sample_accession", all.x = TRUE)
    } else {
      elispot_df["specimen_treatment"] = ""
      elispot_df["treatment_amount_value"] = ""
      elispot_df["treatment_amount_unit"] = ""
      elispot_df["treatment_duration_value"] = ""
      elispot_df["treatment_duration_unit"] = ""
      elispot_df["treatment_temperature_value"] = ""
      elispot_df["treatment_temperature_unit"] = ""
    }
    
#     elispot_df <- transform(elispot_df, sequence = as.integer(sequence))
#     setDT(elispot_df)[, `:=`(sequence, seq_len(.N)), by = "subject_id"]
    setDT(elispot_df)
    setorder(elispot_df, "subject_id")
    elispot_df <- as.data.frame(elispot_df)
    
    
#     elispot_df <- ddply(elispot_df, .(study_id, subject_id, sequence), mutate, elapsed_time_of_specimen_collection = 
#                       covertElaspsedTimeToISO8601Format(study_time_of_specimen_collection, 
#                                                         unit_of_study_time_of_specimen_collection))
#     
#     elispot_df <- ddply(elispot_df, .(study_id, subject_id, sequence), mutate, time_point_reference = 
#                       getTimePointReference(study_time_t0_event, study_time_t0_event_specify))
    
  }
  
  cat("done", "\n")
  elispot_df
}

getCountOfElispotResults <- function(conn,study_id) {  
  sql_stmt <- paste("
                    SELECT count(*)
                    FROM  
                      elispot_result elp
					          INNER JOIN
						          experiment ex ON elp.experiment_accession=ex.experiment_accession
					          INNER JOIN
						          biosample bs ON elp.biosample_accession=bs.biosample_accession
                    WHERE elp.study_accession in (\'", study_id,"\')", sep="")
  
  count <- dbGetQuery(conn,statement=sql_stmt)
  
  count[1,1]
}

#' Trial Arms Domain
#' 
#' @name Trial Arms Domain
#' @description The Trial Arms data of an ImmPort study is reformated to the CDISC SDTM Trial Arms (TA) 
#' domain model, and is a list of 2 data frames containing 1) Trial Arms data \code{\link{TA}} 
#' and 2) any supplemental Trial Arms data \code{\link{SUPP}}
NULL
#> NULL 

# Get Trial Arms data of a specific study
# 
# The function \code{getTrialArms} queries the ImmPort database for Trial Arms data and 
# reformats it to the CDISC SDTM Trial Arms (TA) domain model 
# 
# @param data_src A connection handle to ImmPort (MySQL or SQLite) database instance or 
# a directory handle to folder where study RDS files are located
# @param study_id Identifier of a specific study
# @return a list of 2 data frames containing 1) Trial Arms data \code{\link{TA}} and 2) any supplemental 
#   Trial Arms data \code{\link{SUPP}}
# @examples
# \dontrun{
#   getTrialArms(data_src, "SDY1")
# }
getTrialArms <- function(data_src, study_id) {
    cat("loading TrialArms data....")

    ta_cols <- c("STUDYID", "DOMAIN", "ARMCD", "ARM", "ARMDESC", "ARMRULE")
  
    sql_stmt <- paste("SELECT distinct
                        ac.study_accession,
                        \"TA\" as domain,
                        ac.arm_accession,
                        ac.name as arm_name,
                        ac.description as arm_description,
                        ac.description as population_selection_rule
                      FROM arm_or_cohort ac
                      WHERE ac.study_accession in ('", study_id, "')", sep = "")
    
    if ((class(data_src)[1] == 'MySQLConnection') || 
        (class(data_src)[1] == 'SQLiteConnection')) {
      ta_df <- dbGetQuery(data_src, statement = sql_stmt)
      suppta_df <- data.frame()
      colnames(ta_df) <- ta_cols
      if (nrow(ta_df) > 0) {
        
      }
    } else {
      l <- loadSerializedStudyData(data_src, study_id, "Trial Arms")
      ta_df <- l[[1]]
      suppta_df <- l[[2]]
    }
    
    cat("done", "\n")
    
    ta_l <- list()
    if (nrow(ta_df) > 0)
      ta_l <- list(ta_df=ta_df, suppta_df=suppta_df)
    
    ta_l
    
    
    
}

# Get count of Trial Arms data of a specific study
# 
# The function \code{getCountOfTrialArms} queries the ImmPort database for count 
# of Trial Arms data 
# 
# @param conn A connection handle to ImmPort database instance
# @param study_id Identifier of a specific study
# @return a count of Trial Arms data 
# @examples
# \dontrun{
#   # get count of study SDY1's Trial Arms data
#   count <- getCountOfTrialArms(conn, "SDY1")
# }
getCountOfTrialArms <- function(conn, study_id) {
    sql_stmt <- paste("SELECT count(*)
                      FROM arm_or_cohort ac
                      WHERE ac.study_accession in ('", study_id, "')", sep = "")
    
    count <- dbGetQuery(conn, statement = sql_stmt)
    
    count[1, 1]
} 

##' Trial Arms Domain Variables
##' @name TA
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name  } \tab \strong{Variable Label} \cr
##'     STUDYID \tab Study Identifier \cr
##'     DOMAIN  \tab Domain Abbreviation \cr
##'     ARMCD \tab Planned Arm Code \cr
##'     ARM \tab Name of Planned Arm \cr
##'     ARMDESC \tab Description of Planned Arm \cr
##'     ARMRULE \tab Population Selection Rule
##'   }
##' }
NULL
#> NULL

# call to globalVariables to prevent from generating NOTE: no visible binding for global variable <variable name>
# this hack is to satisfy CRAN (http://stackoverflow.com/questions/9439256/how-can-i-handle-r-cmd-check-no-visible-binding-for-global-variable-notes-when)
globalVariables(c("study_time_of_specimen_collection", "unit_of_study_time_of_specimen_collection",
                  "study_time_t0_event", "study_time_t0_event_specify"))


getMbaaResults <- function(conn,study_id, measurement_types) {
  cat("loading MBAA Results data....")
  
#   old <- options(stringsAsFactors = FALSE)
#   on.exit(options(old), add = TRUE)
#   options(useFancyQuotes = FALSE)
#   measurement_types <- paste(mapply(sQuote, measurement_types), collapse=", ")
  
  mbaa_cols <- c("study_id", "subject_id", "sequence",
                 "analyte", 
                 "concentration_unit_preferred", "concentration_unit_reported",
                 "concentration_value_preferred", "concentration_value_reported",
                 "mfi", "mfi_coordinate", 
                 "experiment_title", "assay_purpose", "measurement_technique",
                 "experiment_sample_accession", "biosample_accession", "specimen_type", "specimen_subtype",
                 "visit_name", "visit_min_start_day", "visit_max_start_day", "visit_order",
                 "study_time_of_specimen_collection", "unit_of_study_time_of_specimen_collection",
                 "study_time_t0_event", "study_time_t0_event_specify", 
                 "file_name")

  tr_cols <- c("experiment_sample_accession",
               "specimen_treatment", 
               "treatment_amount_value", "treatment_amount_unit",
               "treatment_duration_value", "treatment_duration_unit",
               "treatment_temperature_value", "treatment_temperature_unit")
  
  sql_stmt <- paste("
                    SELECT distinct
                      mbaa.study_accession,
                      mbaa.subject_accession,
                      mbaa.result_id,
                      mbaa.analyte_reported, 
                      mbaa.concentration_unit_preferred, 
                      mbaa.concentration_unit_reported, 
                      mbaa.concentration_value_preferred, 
                      mbaa.concentration_value_reported, 
                      mbaa.mfi, 
                      mbaa.mfi_coordinate, 
                      ex.name,
                      'Protein Quantification' as purpose,
                      ex.measurement_technique,
                      mbaa.source_accession,
                      bs.biosample_accession,
                      bs.type,
                      bs.subtype,
                      pv.name,
                      pv.min_start_day,
                      pv.max_start_day,
                      pv.order_number,
                      bs.study_time_collected,
                      bs.study_time_collected_unit,
                      bs.study_time_t0_event,
                      bs.study_time_t0_event_specify,
                      \"\"
                    FROM  
                      mbaa_result mbaa
                    INNER JOIN
                      experiment ex ON mbaa.experiment_accession=ex.experiment_accession
                    INNER JOIN
                      biosample bs ON mbaa.biosample_accession=bs.biosample_accession
                    INNER JOIN
                      planned_visit pv ON bs.planned_visit_accession=pv.planned_visit_accession
                    WHERE mbaa.study_accession in (\'", study_id,"\') 
                    ORDER BY mbaa.subject_accession",sep="")
  
  mbaa_df <- dbGetQuery(conn,statement=sql_stmt)
  if (nrow(mbaa_df) > 0) {
    colnames(mbaa_df) <- mbaa_cols 

    mbaa_df$elapsed_time_of_specimen_collection = mapply(covertElaspsedTimeToISO8601Format, mbaa_df$study_time_of_specimen_collection, 
                                                        mbaa_df$unit_of_study_time_of_specimen_collection)
    
    mbaa_df$time_point_reference = mapply(getTimePointReference, mbaa_df$study_time_t0_event, 
                                         mbaa_df$study_time_t0_event_specify)
    
    sql_stmt <- paste("
                      SELECT distinct
                        mbaa.source_accession,
                        tr.name,
                        tr.amount_value,
                        tr.amount_unit,
                        tr.duration_value,
                        tr.duration_unit,
                        tr.temperature_value,
                        tr.temperature_unit
                      FROM  
                        mbaa_result mbaa
                      INNER JOIN
                        expsample_2_treatment es2tr ON mbaa.source_accession=es2tr.expsample_accession
                      INNER JOIN
                        treatment tr ON es2tr.treatment_accession=tr.treatment_accession
                      WHERE 
                        mbaa.study_accession in (\'", study_id,"\')",sep="")
    
    tr_df <- dbGetQuery(conn,statement=sql_stmt)
    colnames(tr_df) <- tr_cols 
    
    if (nrow(tr_df) >0) {
#      tr_df <- aggregate(. ~ experiment_sample_accession,paste,collapse="||",data=tr_df)
      tr_df <- setDF(setDT(tr_df)[, lapply(.SD, paste, collapse="||"), by="experiment_sample_accession"])
      mbaa_df <- merge(mbaa_df ,tr_df, by="experiment_sample_accession", all.x = TRUE)
    } else {
      mbaa_df["specimen_treatment"] = ""
      mbaa_df["treatment_amount_value"] = ""
      mbaa_df["treatment_amount_unit"] = ""
      mbaa_df["treatment_duration_value"] = ""
      mbaa_df["treatment_duration_unit"] = ""
      mbaa_df["treatment_temperature_value"] = ""
      mbaa_df["treatment_temperature_unit"] = ""
    }
    
#    mbaa_df <- transform(mbaa_df, sequence = as.integer(sequence))
#    setDT(mbaa_df)[, `:=`(sequence, seq_len(.N)), by = "subject_id"]
    setDT(mbaa_df)
    setorder(mbaa_df, "subject_id")
    mbaa_df <- as.data.frame(mbaa_df)
    
#     mbaa_df <- ddply(mbaa_df, .(study_id, subject_id, result_id), mutate, elapsed_time_of_specimen_collection = 
#                       covertElaspsedTimeToISO8601Format(study_time_of_specimen_collection, 
#                                                         unit_of_study_time_of_specimen_collection))
#     
#     mbaa_df <- ddply(mbaa_df, .(study_id, subject_id, result_id), mutate, time_point_reference = 
#                       getTimePointReference(study_time_t0_event, study_time_t0_event_specify))
  }
  
  cat("done", "\n")
  mbaa_df
}

getCountOfMbaaResults <- function(conn,study_id) {  
  sql_stmt <- paste("
                    SELECT count(*)
                    FROM  
                      mbaa_result mbaa
                    INNER JOIN
                      experiment ex ON mbaa.experiment_accession=ex.experiment_accession
                    INNER JOIN
                      biosample bs ON mbaa.biosample_accession=bs.biosample_accession
                    WHERE mbaa.study_accession in (\'", study_id,"\')", sep="")
  
  count <- dbGetQuery(conn,statement=sql_stmt)
  
  count[1,1]
}

#' Protocol Deviations Domain
#' 
#' @name Protocol Deviations Domain
#' @description The Protocol Deviations data of an ImmPort study is reformated to the CDISC SDTM 
#' Protocol Deviations (DV) domain model, and is a list of 2 data frames containing 1) Protocol 
#' Deviations data \code{\link{DV}} and 2) any supplemental Protocol Deviations data \code{\link{SUPPDV}}
NULL
#> NULL 

# call to globalVariables to prevent from generating NOTE: no visible binding for global variable <variable name>
# this hack is to satisfy CRAN (http://stackoverflow.com/questions/9439256/how-can-i-handle-r-cmd-check-no-visible-binding-for-global-variable-notes-when)
globalVariables(c("DVSEQ", "QNAM", "QVAL", "DVRELAE", "DVREASON", "DVRESOL", 
                  "DVCONT", "DVSTDY", "DVENDY"))

# Get Protocol Deviations data of a specific study
# 
# The function \code{getProtocolDeviations} queries the ImmPort database for Protocol Deviations data and 
# reformats it to the CDISC SDTM Protocol Deviations (DV) domain model 
# 
# @param data_src A connection handle to ImmPort (MySQL or SQLite) database instance or 
# a directory handle to folder where study RDS files are located
# @param study_id Identifier of a specific study
# @return a list of 2 data frames containing 1) Protocol Deviations data \code{\link{DV}} and 2) any supplemental 
#   Protocol Deviations data \code{\link{SUPPDV}}
# @examples
# \dontrun{
#   getProtocolDeviations(data_src, "SDY1")
# }
#' @importFrom DBI dbGetQuery
##' @importFrom plyr rename
#' @importFrom data.table as.data.table is.data.table .N :=
getProtocolDeviations <- function(data_src, study_id) {
    cat("loading Protocol Deviations data....")
    
    dv_cols <- c("STUDYID", "DOMAIN", "USUBJID", "DVSEQ", "DVTERM", "DVRELAE", "DVREASON", "DVRESOL", 
               "DVCONT", "DVSTDY", "DVENDY")
  
    suppdv_cols <- c("STUDYID", "RDOMAIN", "USUBJID", "IDVAR", "IDVARVAL", "QNAM", "QLABEL", "QVAL")
  
  
    sql_stmt <- paste("SELECT distinct
                        pd.study_accession,
                        \"DV\" as domain,
                        pd.subject_accession,
                        cast(0 as UNSIGNED INTEGER) as seq,
                        pd.description,
                        pd.is_adverse_event_related,
                        pd.reason_for_deviation,
                        pd.resolution_of_deviation,
                        pd.subject_continued_study,
                        pd.study_start_day,
                        pd.study_end_day
                      FROM  protocol_deviation pd
                      WHERE pd.study_accession in ('", study_id, "')
                      ORDER BY pd.subject_accession", sep = "")

    if ((class(data_src)[1] == 'MySQLConnection') || 
        (class(data_src)[1] == 'SQLiteConnection')) {
      dv_df <- dbGetQuery(data_src, statement = sql_stmt)
      colnames(dv_df) <- dv_cols
      suppdv_df <- data.frame()
      if (nrow(dv_df) > 0) {
        dv_df <- transform(dv_df, DVSEQ = as.integer(DVSEQ))
        dv_dt <- as.data.table(dv_df)
        if (is.data.table(dv_dt) == TRUE) {
          dv_dt[, `:=`(DVSEQ, seq_len(.N)), by = "USUBJID"]
        }
        dv_df <- as.data.frame(dv_dt)
      
      
      
        qnam_values = c("DVRELAE", "DVREASON", "DVRESOL", "DVCONT", "DVSTDY", "DVENDY")
  
        qlabel_values= c("Is Deviation Related to an Adverse Event?", "Reason for Deviation", 
                         "Resulotion of Deviation", "Did Subject continued in Study?",
                         "Study Day of Start of Deviation", "Study Day of End of Deviation")
      
        suppdv_df <- reshape2::melt(dv_df, id = c("STUDYID", "DOMAIN", "USUBJID", "DVSEQ"), 
                                    measure = qnam_values, 
                                    variable.name = "QNAM", 
                                    value.name = "QVAL")
        suppdv_df <- transform(suppdv_df, QLABEL = unlist(qlabel_values[QNAM]))
        suppdv_df <- plyr::rename(suppdv_df, c("DOMAIN" = "RDOMAIN", "DVSEQ" = "IDVARVAL"))
        suppdv_df$IDVAR <- "DVSEQ"
      
        suppdv_df <- suppdv_df[suppdv_cols]
        
        # remove rows that have empty QVAL values
        suppdv_df <- subset(suppdv_df,QVAL!="")      
        
        dv_df <- subset(dv_df, select = -c(DVRELAE, DVREASON, DVRESOL, DVCONT, DVSTDY, DVENDY))
      }
    } else {
      l <- loadSerializedStudyData(data_src, study_id, "Protocol Deviations")
      dv_df <- l[[1]]
      suppdv_df <- l[[2]]
    }
    cat("done", "\n")

    dv_l <- list()
    if (nrow(dv_df) > 0)
      dv_l <- list(dv_df=dv_df, suppdv_df=suppdv_df)
    
    dv_l
}

# Get count of Protocol Deviations data of a specific study
# 
# The function \code{getCountOfProtocolDeviations} queries the ImmPort database for count 
# of Protocol Deviations data 
# 
# @param conn A connection handle to ImmPort database instance
# @param study_id Identifier of a specific study
# @return a count of Protocol Deviations data 
# @examples
# \dontrun{
#   # get count of study SDY1's Protocol Deviations data
#   count <- getCountOfProtocolDeviations(conn, "SDY1")
# }
getCountOfProtocolDeviations <- function(conn, study_id) {
    sql_stmt <- paste("SELECT count(*)
                      FROM  protocol_deviation pd
                      WHERE pd.study_accession in ('", study_id, "')", sep = "")
    
    count <- dbGetQuery(conn, statement = sql_stmt)
    
    count[1, 1]
} 

##' Protocol Deviations Domain Variables
##' @name DV
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name  } \tab \strong{Variable Label} \cr
##'     STUDYID \tab Study Identifier \cr
##'     DOMAIN  \tab Domain Abbreviation \cr
##'     USUBJID \tab Unique Subject Identifier \cr
##'     DVSEQ \tab Sequence Number \cr
##'     DVTERM \tab Protocol Deviation Term
##'   }
##' }
NULL
#> NULL 

##' Protocol Deviations Domain Supplemental Variables
##' @name SUPPDV
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name} \tab \strong{Variable Label} \cr
##'     STUDYID \tab Study Identifier \cr
##'     RDOMAIN  \tab Related Domain Abbreviation \cr
##'     USUBJID \tab Unique Subject Identifier \cr
##'     IDVAR \tab Identifying Variable \cr
##'     IDVARVAL \tab Identifying Variable Value \cr
##'     QNAM \tab Qualifier Variable Name \cr
##'     QLABEL \tab Qualifier Variable Label \cr
##'     QVAL \tab Data Value
##'   }
##' }
##' @note The following table enumerates the values in QNAM and QLABEL variables {
##'   \tabular{ll}{
##'     \strong{QNAM} \tab \strong{QLABEL} \cr
##'     DVRELAE \tab Is Deviation Related to an Adverse Event? \cr
##'     DVREASON \tab Reason for Deviation \cr
##'     DVRESOL \tab Resulotion of Deviation \cr
##'     DVCONT \tab Did Subject continued in Study? \cr
##'     DVSTDY \tab Study Day of Start of Deviation \cr
##'     DVENDY \tab Study Day of End of Deviation
##'   }
##' }
NULL
#> NULL

# call to globalVariables to prevent from generating NOTE: no visible binding for global variable <variable name>
# this hack is to satisfy CRAN (http://stackoverflow.com/questions/9439256/how-can-i-handle-r-cmd-check-no-visible-binding-for-global-variable-notes-when)
globalVariables(c("study_time_of_specimen_collection", "unit_of_study_time_of_specimen_collection",
                  "study_time_t0_event", "study_time_t0_event_specify"))


getHlaTypingResults <- function(conn,study_id, measurement_type) {
  cat("loading HLA Typing Results data....")
  
  hla_cols <- c("study_id", "subject_id", "result_id", "result_set_id",
                "allele_1", "allele_2", 
                "locus_name", "pop_area_name", 
                "experiment_title", "assay_purpose", "measurement_technique",
                "experiment_sample_accession", "biosample_accession", "specimen_type", "specimen_subtype",
                "visit_name", "visit_min_start_day", "visit_max_start_day", "visit_order",
                "study_time_of_specimen_collection", "unit_of_study_time_of_specimen_collection",
                "study_time_t0_event", "study_time_t0_event_specify")

  tr_cols <- c("experiment_sample_accession",
               "specimen_treatment", 
               "treatment_amount_value", "treatment_amount_unit",
               "treatment_duration_value", "treatment_duration_unit",
               "treatment_temperature_value", "treatment_temperature_unit")
  
  sql_stmt <- paste("
                    SELECT distinct
                    hla.study_accession,
                    hla.subject_accession,
                    hla.result_id,
                    hla.result_set_id,
                    hla.allele_1, 
                    hla.allele_2, 
                    hla.locus_name, 
                    hla.ancestral_population, 
                    ex.name,
                    'Genetics Findings' as purpose,
                    ex.measurement_technique,
                    hla.expsample_accession,
                    bs.biosample_accession, 
                    bs.type,
                    bs.subtype,
                    pv.name,
                    pv.min_start_day,
                    pv.max_start_day,
                    pv.order_number,
                    bs.study_time_collected,
                    bs.study_time_collected_unit,
                    bs.study_time_t0_event,
                    bs.study_time_t0_event_specify
                    FROM  
                      hla_typing_result hla
                    INNER JOIN
                      experiment ex ON hla.experiment_accession=ex.experiment_accession
                    INNER JOIN
                      biosample bs ON hla.biosample_accession=bs.biosample_accession
                    INNER JOIN
                      planned_visit pv ON bs.planned_visit_accession=pv.planned_visit_accession
                    WHERE hla.study_accession in (\'", study_id,"\') 
                    ORDER BY hla.subject_accession",sep="")
  
  hla_df <- dbGetQuery(conn,statement=sql_stmt)
  if (nrow(hla_df) > 0) {
    colnames(hla_df) <- hla_cols 

    hla_df$elapsed_time_of_specimen_collection = mapply(covertElaspsedTimeToISO8601Format, hla_df$study_time_of_specimen_collection, 
                                                        hla_df$unit_of_study_time_of_specimen_collection)
    
    hla_df$time_point_reference = mapply(getTimePointReference, hla_df$study_time_t0_event, 
                                         hla_df$study_time_t0_event_specify)
    
    sql_stmt <- paste("
                      SELECT distinct
                      hla.expsample_accession,
                      tr.name,
                      tr.amount_value,
                      tr.amount_unit,
                      tr.duration_value,
                      tr.duration_unit,
                      tr.temperature_value,
                      tr.temperature_unit
                      FROM  
                      hla_typing_result hla
                      INNER JOIN
                      expsample_2_treatment es2tr ON hla.expsample_accession=es2tr.expsample_accession
                      INNER JOIN
                      treatment tr ON es2tr.treatment_accession=tr.treatment_accession
                      WHERE 
                      hla.study_accession in (\'", study_id,"\')",sep="")
    
    tr_df <- dbGetQuery(conn,statement=sql_stmt)
    colnames(tr_df) <- tr_cols 
    
    if (nrow(tr_df) >0) {
#      tr_df <- aggregate(. ~ experiment_sample_accession,paste,collapse="||",data=tr_df)
      tr_df <- setDF(setDT(tr_df)[, lapply(.SD, paste, collapse="||"), by="experiment_sample_accession"])
      hla_df <- merge(hla_df ,tr_df, by="experiment_sample_accession", all.x = TRUE)
    } else {
      hla_df["specimen_treatment"] = ""
      hla_df["treatment_amount_value"] = ""
      hla_df["treatment_amount_unit"] = ""
      hla_df["treatment_duration_value"] = ""
      hla_df["treatment_duration_unit"] = ""
      hla_df["treatment_temperature_value"] = ""
      hla_df["treatment_temperature_unit"] = ""
    }
    
    # hla_df <- transform(hla_df, sequence = as.integer(sequence))
    #setDT(hla_df)[, `:=`(sequence, seq_len(.N)), by = "subject_id"]
    #setorder(hla_df, "subject_id")
    #hla_df <- as.data.frame(hla_df)
    
    setDT(hla_df)
    setorder(hla_df, "subject_id")
    hla_df <- as.data.frame(hla_df)
    
    
#     hla_df <- ddply(hla_df, .(study_id, subject_id, result_id), mutate, elapsed_time_of_specimen_collection = 
#                       covertElaspsedTimeToISO8601Format(study_time_of_specimen_collection, 
#                                                         unit_of_study_time_of_specimen_collection))
#     
#     hla_df <- ddply(hla_df, .(study_id, subject_id, result_id), mutate, time_point_reference = 
#                       getTimePointReference(study_time_t0_event, study_time_t0_event_specify))
    
  }
  
  cat("done", "\n")
  hla_df
}

getCountOfHlaTypingResults <- function(conn,study_id) {  
  sql_stmt <- paste("
                    SELECT count(*)
                    FROM  
                      hla_typing_result hla
                    INNER JOIN
                      experiment ex ON hla.experiment_accession=ex.experiment_accession
                    INNER JOIN
                      biosample bs ON hla.biosample_accession=bs.biosample_accession
                    WHERE hla.study_accession in (\'", study_id,"\' )", sep="")
  
  count <- dbGetQuery(conn,statement=sql_stmt)
  
  count[1,1]
}

#' Trial Summary Domain
#' 
#' @name Trial Summary Domain
#' @description The Trial Summary data of an ImmPort study is reformated to the CDISC SDTM Trial Summary (TS) 
#' domain model, and is a list of 2 data frames containing 1) Trial Summary data \code{\link{TS}} 
#' and 2) any supplemental Trial Summary data \code{\link{SUPP}}
NULL
#> NULL 


# call to globalVariables to prevent from generating NOTE: no visible binding for global variable <variable name>
# this hack is to satisfy CRAN (http://stackoverflow.com/questions/9439256/how-can-i-handle-r-cmd-check-no-visible-binding-for-global-variable-notes-when)
globalVariables(c("TSPARMCD"))

# Get Trial Summary data of a specific study
# 
# The function \code{getTrialSummary} queries the ImmPort database for Trial Summary data and 
# reformats it to the CDISC SDTM getTrialSummary (TS) domain model 
# 
# @param data_src A connection handle to ImmPort (MySQL or SQLite) database instance or 
# a directory handle to folder where study RDS files are located
# @param study_id Identifier of a specific study
# @return a list of 2 data frames containing 1) Trial Summary data \code{\link{TS}} and 2) any supplemental 
#   Trial Summary data \code{\link{SUPP}}
# @examples
# \dontrun{
#   getTrialSummary(data_src, "SDY1")
# }
getTrialSummary <- function(data_src,study_id) {
  cat("loading TrialSummary data....", study_id, " ")

  ts_cols  <- c("STUDYID", "DOMAIN","TSSEQ",
                "TSPARMCD", "TSPARM", "TSVAL")
  
  ts_col_codes <- c("STUDYID", "DOMAIN", "TSSEQ", "TITLE", "DESCR", "INDIC", 
                    "TRT", "HYPOTHS", "SSTDTC", 
                    "SENDTC", "PLANSUB", "ACTSUB", 
                    "AGEMAX", "AGEMIN", "AGEU", 
                    "SEXPOP", "SPONSOR", "PUBRLDAT", "STYPE", 
                    "ISTRIAL","RESFOCUS")
  
  ts_col_labels <- c("Study Identifier", "Domain", "Sequence", "Trial Title", "Trial Description", "Trial Indication", 
                     "Investigational Therapy or Treatment", "Trial Hypotheses", "Study Start Date", 
                     "Study End Date", "Planned Number of Subjects", "Actual Number of Subjects", 
                     "Planned Maximum Age of Subjects", "Planned Minimum Age of Subjects", "Age Units", 
                     "Sex of Participants", "Clinical Study Sponsor", "Public Release Date", "Study Type", 
                     "Is Clinical Trial?", "Trial Research Focus")
  code_label.l <- as.list(ts_col_labels)
  names(code_label.l) <- ts_col_codes
  
  sql_stmt <- paste("
                    SELECT distinct
                    st.study_accession,
                    \"TS\" as domain,
                    cast(1 as UNSIGNED INTEGER) as seq,
                    st.brief_title,
                    st.brief_description,
                    st.condition_studied,
                    st.intervention_agent,
                    st.hypothesis,
                    st.actual_start_date,
                    st.actual_completion_date,
                    st.target_enrollment,
                    st.actual_enrollment,
                    st.maximum_age,
                    st.minimum_age,
                    st.age_unit,
                    st.gender_included,
                    st.sponsoring_organization,
                    st.latest_data_release_date,
                    st.type,
                    st.clinical_trial,
                    \"\"                 
                    FROM study st, study_categorization sc
                    WHERE st.study_accession = sc.study_accession AND
                          st.study_accession in (\'", study_id,"\')", sep="")
  
  if ((class(data_src)[1] == 'MySQLConnection') || 
      (class(data_src)[1] == 'SQLiteConnection')) {
    temp_ts_df <- dbGetQuery(data_src,statement=sql_stmt)
    ts_df <- data.frame()
    suppts_df <- data.frame()
    
    if (nrow(temp_ts_df) > 0) {
      colnames(temp_ts_df) <- ts_col_codes   
    
      sql_stmt <- paste("
                      SELECT distinct
                      sc.research_focus
                      FROM  study_categorization sc
                      WHERE sc.study_accession in (\'", study_id,"\')", sep="")
    
      rf <- dbGetQuery(data_src,statement=sql_stmt)
      if (nrow(rf) > 0) {
        temp_ts_df$RESFOCUS <- paste(rf[,1], collapse = "|")
      }
  
      ts_df <- reshape2::melt(temp_ts_df, id = c("STUDYID", "DOMAIN", "TSSEQ"), 
                            measure = c("TITLE", "DESCR", "INDIC", 
                                        "TRT", "HYPOTHS", "SSTDTC", 
                                        "SENDTC", "PLANSUB", "ACTSUB", 
                                        "AGEMAX", "AGEMIN", "AGEU", 
                                        "SEXPOP", "SPONSOR", "PUBRLDAT", "STYPE", 
                                        "ISTRIAL","RESFOCUS"), 
                            variable.name = "TSPARMCD", 
                            value.name = "TSVAL")
    
      code_label.l <-  code_label.l[-c(1, 2, 3)]
      ts_df <- transform(ts_df, TSPARM = unlist(code_label.l[TSPARMCD]))
      row.names(ts_df) <- NULL
    
      #ts_df$TSPARM <- code_label.l[[ts_df$TSPARMCD]]
    
      ts_df <- ts_df[ts_cols]
    }
  } else {
    l <- loadSerializedStudyData(data_src, study_id, "Trial Summary")
    ts_df <- l[[1]]
    suppts_df <- l[[2]]
  }
  
  cat("done", "\n")
  
  ts_l <- list()
  if (nrow(ts_df) > 0)
    ts_l <- list(ts_df=ts_df, suppts_df=suppts_df)
  
  ts_l
}

# Get count of Trial Summary data of a specific study
# 
# The function \code{getCountOfTrialSummary} queries the ImmPort database for count 
# of Trial Summary data 
# 
# @param conn A connection handle to ImmPort database instance
# @param study_id Identifier of a specific study
# @return a count of Trial Summary data 
# @examples
# \dontrun{
#   # get count of study SDY1's Trial Summary data
#   count <- getCountOfTrialSummary(conn, "SDY1")
# }
getCountOfTrialSummary <- function(conn,study_id) {  
  sql_stmt <- paste("
                    SELECT count(*)
                    FROM study st
                    WHERE st.study_accession in (\'", study_id,"\')", sep="")
  
  count <- dbGetQuery(conn,statement=sql_stmt)
  
  count[1,1]
}

##' Trial Summary Domain Variables
##' @name TS
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name} \tab \strong{Variable Label} \cr
##'     STUDYID \tab Study Identifier \cr
##'     DOMAIN  \tab Domain Abbreviation \cr
##'     TSSEQ \tab Sequence Number \cr
##'     TSPARMCD \tab Trial Summary Parameter Short Name \cr
##'     TSPARM \tab Trial Summary Parameter \cr
##'     TSVAL \tab Parameter Value
##'   }
##' }
##' @note The following table enumerates the values in TSPARMCD and TSPARM variables {
##'   \tabular{ll}{
##'     \strong{TSPARMCD} \tab \strong{TSPARM} \cr
##'     TITLE \tab Trial Title \cr
##'     DESCR \tab Trial Description \cr
##'     INDIC \tab Trial Indication \cr
##'     TRT \tab Investigational Therapy or Treatment \cr
##'     HYPOTHS \tab Trial Hypotheses \cr
##'     SSTDTC \tab Study Start Date \cr
##'     SENDTC \tab Study End Date \cr
##'     PLANSUB \tab Planned Number of Subjects \cr
##'     ACTSUB \tab Actual Number of Subjects \cr
##'     AGEMAX \tab Planned Maximum Age of Subjects \cr
##'     AGEMIN \tab Planned Minimum Age of Subjects \cr
##'     AGEU \tab Age Units \cr
##'     SEXPOP \tab Sex of Participants \cr
##'     SPONSOR \tab Clinical Study Sponsor \cr
##'     PUBRLDAT \tab Public Release Date \cr
##'     ISTRIAL \tab Study Type \cr
##'     RESFOCUS \tab Trial Research Focus 
##'   }
##' }
NULL
#> NULL

getSubjectBasicAnalyses <- function(conn, study_id) {
    cat("loading Subject Basic Analyses data....")

  subject_basic_analyses_column_names <- c("study_id", "subject_id", "visit_num", "parameter", "parameter_code", "parameter_id", 
                                           "analysis_value", "analysis_timepoint", "outcome_type")
  
    sql_stmt <- paste("SELECT distinct
                        smr.study_accession,
                        smr.subject_accession,
                        smr.study_day,
                        smd.description,
                        smd.title,
                        smd.subject_measure_accession,
                        smr.datavalue,
                        smd.timeframe,
                        smd.outcometype
                      FROM subject_measure_result smr,
                        subject_measure_definition smd
                      WHERE smr.subject_measure_accession = smd.subject_measure_accession AND 
                        smr.study_accession in ('", study_id, "')
                      ORDER BY smr.subject_accession", sep = "")
    
    subject_basic_analyses <- dbGetQuery(conn, statement = sql_stmt)
    if (nrow(subject_basic_analyses) > 0) 
        colnames(subject_basic_analyses) <- subject_basic_analyses_column_names
    
    cat("done", "\n")
    subject_basic_analyses
}

getCountOfSubjectBasicAnalyses <- function(conn, study_id) {
    sql_stmt <- paste("SELECT count(*)
                      FROM subject_measure_result smr,
                        subject_measure_definition smd
                      WHERE smr.subject_measure_accession = smd.subject_measure_accession AND 
                        smr.study_accession in ('", study_id, "')", sep = "")
    
    count <- dbGetQuery(conn, statement = sql_stmt)
    
    count[1, 1]
} 

#' Findings About Domain
#' 
#' @name Findings About Domain
#' @description The Findings About data of an ImmPort study is reformated to the CDISC SDTM Findings 
#' About (FA) domain model, and is a list of 2 data frames containing 1) Findings About data \code{\link{FA}} 
#' and 2) any supplemental Findings About data \code{\link{SUPPFA}}
NULL
#> NULL 

# call to globalVariables to prevent from generating NOTE: no visible binding for global variable <variable name>
# this hack is to satisfy CRAN (http://stackoverflow.com/questions/9439256/how-can-i-handle-r-cmd-check-no-visible-binding-for-global-variable-notes-when)
globalVariables(c("FASEQ", "QNAM", "QVAL", "FATOD"))

# Get Findings About data of a specific study
# 
# The function \code{getFindingsAbout} queries the ImmPort database for Findings About data and 
# reformats it to the CDISC SDTM Findings About (FA) domain model 
# 
# @param data_src A connection handle to ImmPort (MySQL or SQLite) database instance or 
# a directory handle to folder where study RDS files are located
# @param study_id Identifier of a specific study
# @return a list of 2 data frames containing 1) Findings About data \code{\link{FA}} and 2) any supplemental 
#   Findings About data \code{\link{SUPPFA}}
# @examples
# \dontrun{
#   getFindingsAbout(data_src, "SDY1")
# }
#' @importFrom DBI dbGetQuery
#' @importFrom plyr rename
#' @importFrom data.table as.data.table is.data.table .N :=
getFindingsAbout <- function(data_src, study_id) {
    cat("loading Findings About data....")
  
    fa_cols <- c("STUDYID", "DOMAIN", "USUBJID", "FASEQ", "FATEST", "FACAT", "FAOBJ",  
                "FAORRES", "FAORRESU", "FALOC", "FATOD", "VISITNUM", "VISIT", "FADY")
  
    suppfa_cols <- c("STUDYID", "RDOMAIN", "USUBJID", "IDVAR", "IDVARVAL", "QNAM", "QLABEL", "QVAL")
  
  
    sql_stmt <- paste("SELECT distinct
                      asmp.study_accession,
                      \"FA\" as domain,
                      asmc.subject_accession,
                      cast(0 as UNSIGNED INTEGER) as seq,
                      asmc.name_reported,
                      asmp.name_reported,
                      asmc.organ_or_body_system_reported,
                      asmc.result_value_reported,
                      asmc.result_unit_reported,
                      asmc.location_of_finding_reported,
                      asmc.time_of_day,
                      pv.order_number,
                      pv.name,
                      asmc.study_day                    
                      FROM  assessment_component asmc
                      INNER JOIN
                      assessment_panel asmp ON asmc.assessment_panel_accession=asmp.assessment_panel_accession
                      INNER JOIN
                      planned_visit pv ON asmc.planned_visit_accession=pv.planned_visit_accession
                      WHERE (asmp.study_accession in ('", study_id, "')) AND 
                      (asmp.assessment_type='Other') 
                      ORDER BY asmc.subject_accession", sep = "")

    if ((class(data_src)[1] == 'MySQLConnection') || 
        (class(data_src)[1] == 'SQLiteConnection')) {
      fa_df <- dbGetQuery(data_src, statement = sql_stmt)
      colnames(fa_df) <- fa_cols
      suppfa_df <- data.frame()
      if (nrow(fa_df) > 0) {
        fa_df <- transform(fa_df, FASEQ = as.integer(FASEQ))
        fa.dt <- as.data.table(fa_df)
        if (is.data.table(fa.dt) == TRUE) fa.dt[, `:=`(FASEQ, seq_len(.N)), by = "USUBJID"]
        fa_df <- as.data.frame(fa.dt)
  
        qnam_values = c("FATOD")
        qlabel_values= c("Time of Day")
        
        suppfa_df <- reshape2::melt(fa_df, id = c("STUDYID", "DOMAIN", "USUBJID", "FASEQ"), 
                                    measure = qnam_values, 
                                    variable.name = "QNAM", 
                                    value.name = "QVAL")
        suppfa_df <- transform(suppfa_df, QLABEL = unlist(qlabel_values[QNAM]))
        suppfa_df <- plyr::rename(suppfa_df, c("DOMAIN" = "RDOMAIN", "FASEQ" = "IDVARVAL"))
        suppfa_df$IDVAR <- "FASEQ"
        
        suppfa_df <- suppfa_df[suppfa_cols]
        
        # remove rows that have empty QVAL values
        suppfa_df <- subset(suppfa_df,QVAL!="")      
  
        fa_df <- subset(fa_df, select = -c(FATOD))
      }
    } else {
      l <- loadSerializedStudyData(data_src, study_id, "Findings About")
      fa_df <- l[[1]]
      suppfa_df <- l[[2]]
    }
    
    cat("done", "\n")
    
    fa_l <- list()
    if (nrow(fa_df) > 0)
      fa_l <- list(fa_df=fa_df, suppfa_df=suppfa_df)
    
    fa_l
}

# Get count of Findings About data of a specific study
# 
# The function \code{getCountOfFindingsAbout} queries the ImmPort database for count 
# of Findings About data 
# 
# @param conn A connection handle to ImmPort database instance
# @param study_id Identifier of a specific study
# @return a count of Findings About data 
# @examples
# \dontrun{
#   # get count of study SDY1's Findings About data
#   count <- getCountOfFindingsAbout(conn, "SDY1")
# }
getCountOfFindingsAbout <- function(conn, study_id) {
    sql_stmt <- paste("SELECT count(*)
                    FROM  assessment_component asmc
                    INNER JOIN
                      assessment_panel asmp ON asmc.assessment_panel_accession=asmp.assessment_panel_accession 
                      WHERE (asmp.study_accession in ('", study_id, "')) AND 
                      asmp.assessment_type='Other'", sep = "")
    
    count <- dbGetQuery(conn, statement = sql_stmt)
    
    count[1, 1]
} 

##' Findings About Domain Variables
##' @name FA
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name  } \tab \strong{Variable Label} \cr
##'     STUDYID \tab Study Identifier \cr
##'     DOMAIN  \tab Domain Abbreviation \cr
##'     USUBJID \tab Unique Subject Identifier \cr
##'     FASEQ \tab Sequence Number \cr
##'     FATEST \tab Findings About Test Name \cr
##'     FAOBJ \tab Object of the Observation \cr
##'     FACAT \tab Category for Findings About \cr
##'     FAORRES \tab Results or Findings in Original Units \cr
##'     FAORRESU \tab Original Units \cr
##'     FALOC \tab Location of the Finding About \cr
##'     VISITNUM \tab Visit Number \cr
##'     VISIT \tab Visit Name \cr
##'     FADY \tab Study Day of Collection
##'   }
##' }
NULL
#> NULL 

##' Findings About Domain Supplemental Variables
##' @name SUPPFA
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name} \tab \strong{Variable Label} \cr
##'     STUDYID \tab Study Identifier \cr
##'     RDOMAIN  \tab Related Domain Abbreviation \cr
##'     USUBJID \tab Unique Subject Identifier \cr
##'     FASEQ \tab Sequence Number \cr
##'     IDVAR \tab Identifying Variable \cr
##'     IDVARVAL \tab Identifying Variable Value \cr
##'     QNAM \tab Qualifier Variable Name \cr
##'     QLABEL \tab Qualifier Variable Label \cr
##'     QVAL \tab Data Value
##'   }
##' }
##' @note The following table enumerates the values in QNAM and QLABEL variables {
##'   \tabular{ll}{
##'     \strong{QNAM} \tab \strong{QLABEL} \cr
##'     FATOD \tab Time of Day of Collection \cr
##'   }
##' }
NULL
#> NULL

## -----------------------------------------------------------------------------
library(RImmPort)
library(DBI)
library(sqldf)
library(plyr)


## ----eval=FALSE---------------------------------------------------------------
# 
# # provide appropriate connection parameters
# mysql_conn <- dbConnect(MySQL(), user="username", password="password",
#                    dbname="database",host="host")
# 

## ----eval=FALSE---------------------------------------------------------------
# setImmPortDataSource(mysql_conn)

## ----eval=FALSE---------------------------------------------------------------
# # get the directory where ImmPort sample data is stored in the directory structure of RImmPort package
# studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")
# 
# # set tab_dir to the folder where the zip files are located
# tab_dir <- file.path(studies_dir, "Tab")
# list.files(tab_dir)

## ----eval=FALSE---------------------------------------------------------------
# # set db_dir to the folder where the database file 'ImmPort.sqlite' should be stored
# db_dir <- file.path(studies_dir, "Db")

## ----eval=FALSE---------------------------------------------------------------
# # build a new ImmPort SQLite database with the data in the downloaded zip files
# buildNewSqliteDb(tab_dir, db_dir)

## ----eval=FALSE---------------------------------------------------------------
# list.files(db_dir)

## -----------------------------------------------------------------------------
# get the directory of a sample SQLite database that has been bundled into the RImmPort package
db_dir <- system.file("extdata", "ImmPortStudies", "Db", package = "RImmPort")

# connect to the private instance of the ImmPort database
sqlite_conn <- dbConnect(SQLite(), dbname=file.path(db_dir, "ImmPort.sqlite"))

## -----------------------------------------------------------------------------
setImmPortDataSource(sqlite_conn)

## -----------------------------------------------------------------------------
getListOfStudies()

## -----------------------------------------------------------------------------
?Study

# load all the data of study: `SDY139`
study_id <- 'SDY139'
sdy139 <- getStudy(study_id)

# access Demographics data of SDY139
dm_df <- sdy139$special_purpose$dm_l$dm_df
head(dm_df)

# access Concomitant Medications data of SDY139
cm_df <- sdy139$interventions$cm_l$cm_df
head(cm_df)

# get Trial Title from Trial Summary
ts_df <- sdy139$trial_design$ts_l$ts_df
title <- ts_df$TSVAL[ts_df$TSPARMCD== "TITLE"]
title

## -----------------------------------------------------------------------------

# get the list of names of all supported Domains
getListOfDomains()

?"Demographics Domain"


## -----------------------------------------------------------------------------
# get list of studies with Cellular Quantification data
domain_name <- "Cellular Quantification"
study_ids_l <- getStudiesWithSpecificDomainData(domain_name)
study_ids_l

## -----------------------------------------------------------------------------
# get Cellular Quantification data of studies `SDY139` and `SDY208`

# get domain code of Cellular Quantification domain
domain_name <- "Cellular Quantification"
getDomainCode(domain_name)

study_ids <- c("SDY139", "SDY208")
domain_name <- "Cellular Quantification"
zb_l <- getDomainDataOfStudies(domain_name, study_ids)
if (length(zb_l) > 0) 
  names(zb_l)
head(zb_l$zb_df)

## -----------------------------------------------------------------------------
getListOfAssayTypes()

## -----------------------------------------------------------------------------

# get 'ELISPOT' data of study `SDY139`
assay_type <- "ELISPOT"
study_id = "SDY139"
elispot_l <- getAssayDataOfStudies(study_id, assay_type)
if (length(elispot_l) > 0)
  names(elispot_l)
head(elispot_l$zb_df)


## ----eval=FALSE---------------------------------------------------------------
# 
# # serialize all of the data of studies `SDY139` and `SDY208'
# study_ids <- c('SDY139', 'SDY208')
# 
# # the folder where the .rds files will be stored
# rds_dir <- file.path(studies_dir, "Rds")
# 
# serialzeStudyData(study_ids, rds_dir)
# list.files(rds_dir)
# 

## -----------------------------------------------------------------------------
# get the directory where ImmPort sample data is stored in the directory structure of RImmPort package
studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")

# the folder where the .rds files will be stored
rds_dir <- file.path(studies_dir, "Rds")

# list the studies that have been serialized
list.files(rds_dir)

# load the serialized data of study `SDY208` 
study_id <- 'SDY208'
dm_l <- loadSerializedStudyData(rds_dir, study_id, "Demographics")
head(dm_l[[1]])

#' Medical History Domain
#' 
#' @name Medical History Domain
#' @description The Medical History data of an ImmPort study is reformated to the CDISC SDTM Medical 
#' History (MH) domain model, and is a list of 2 data frames containing 1) Medical History 
#' data \code{\link{MH}} and 2) any supplemental Medical History data \code{\link{SUPPMH}}
NULL
#> NULL 



# call to globalVariables to prevent from generating NOTE: no visible binding for global variable <variable name>
# this hack is to satisfy CRAN (http://stackoverflow.com/questions/9439256/how-can-i-handle-r-cmd-check-no-visible-binding-for-global-variable-notes-when)
globalVariables(c("MHSEQ", "QNAM", "QVAL", "MHAGE", "MHAGEU", "MHTOD"))

# Get Medical History data of a specific study
# 
# The function \code{getMedicalHistory} queries the ImmPort database for Medical History data and 
# reformats it to the CDISC SDTM Medical History (MH) domain model 
# 
# @param data_src A connection handle to ImmPort (MySQL or SQLite) database instance or 
# a directory handle to folder where study RDS files are located
# @param study_id Identifier of a specific study
# @return a list of 2 data frames containing 1) Medical History data \code{\link{MH}} and 2) any supplemental 
#   Medical History data \code{\link{SUPPMH}}
# @examples
# \dontrun{
#   getMedicalHistory(data_src, "SDY1")
# }
#' @importFrom DBI dbGetQuery
#' @importFrom plyr rename
#' @importFrom data.table as.data.table is.data.table .N :=
getMedicalHistory <- function(data_src, study_id) {
    cat("loading Medical History data....")

    mh_cols <- c("STUDYID", "DOMAIN", "USUBJID","MHSEQ", "MHTERM", "MHCAT", "MHBODSYS", "MHAGE", "MHAGEU", 
               "MHTOD", "MHDY")
  
    suppmh_cols <- c("STUDYID", "RDOMAIN", "USUBJID", "IDVAR", "IDVARVAL", "QNAM", "QLABEL", "QVAL")
    # Note these cols should go to suppmh: MHAGE, MHAGEU and MHTOD
      
    sql_stmt <- paste("SELECT distinct
                        asmp.study_accession,
                        \"MH\" as domain,
                        asmc.subject_accession,
                        cast(0 as UNSIGNED INTEGER) as seq,
                        asmc.name_reported,
                        asmp.name_reported,
                        asmc.organ_or_body_system_reported,
                        asmc.age_at_onset_reported,
                        asmc.age_at_onset_unit_reported,
                        asmc.time_of_day,
                        asmc.study_day                    
                      FROM  assessment_component asmc
                      INNER JOIN
                      assessment_panel asmp ON asmc.assessment_panel_accession=asmp.assessment_panel_accession
                      WHERE asmp.study_accession in ('", study_id, "') AND 
                        asmp.assessment_type='Medical History'
                      ORDER BY asmc.subject_accession", sep = "")
    if ((class(data_src)[1] == 'MySQLConnection') || 
        (class(data_src)[1] == 'SQLiteConnection')) {
      mh_df <- dbGetQuery(data_src, statement = sql_stmt)
      colnames(mh_df) <- mh_cols
      suppmh_df <- data.frame()
      if (nrow(mh_df) > 0) {
        mh_df <- transform(mh_df, MHSEQ = as.integer(MHSEQ))
        mh_dt <- as.data.table(mh_df)
        if (is.data.table(mh_dt) == TRUE) {
          mh_dt[, `:=`(MHSEQ, seq_len(.N)), by = "USUBJID"]
        }
        mh_df <- as.data.frame(mh_dt)
  
        qnam_values = c("MHAGE", "MHAGEU", "MHTOD")
        qlabel_values= c("Age at Onset", "Age at Onset Units", "Time of Day")
      
        suppmh_df <- reshape2::melt(mh_df, id = c("STUDYID", "DOMAIN", "USUBJID", "MHSEQ"), 
                                    measure = qnam_values, 
                                    variable.name = "QNAM", 
                                    value.name = "QVAL")
        suppmh_df <- transform(suppmh_df, QLABEL = unlist(qlabel_values[QNAM]))
        suppmh_df <- plyr::rename(suppmh_df, c("DOMAIN" = "RDOMAIN", "MHSEQ" = "IDVARVAL"))
        suppmh_df$IDVAR <- "MHSEQ"
      
        suppmh_df <- suppmh_df[suppmh_cols]
        
        # remove rows that have empty QVAL values
        suppmh_df <- subset(suppmh_df,QVAL!="")      
        
        mh_df <- subset(mh_df, select = -c(MHAGE, MHAGEU, MHTOD))
      }
    } else {
      l <- loadSerializedStudyData(data_src, study_id, "Medical History")
      mh_df <- l[[1]]
      suppmh_df <- l[[2]]
    }
    
    cat("done", "\n")
    
    mh_l <- list()
    if (nrow(mh_df) > 0)
      mh_l <- list(mh_df=mh_df, suppmh_df=suppmh_df)
    
    mh_l
}

# Get count of Medical History data of a specific study
# 
# The function \code{getCountOfMedicalHistory} queries the ImmPort database for count 
# of Medical History data 
# 
# @param conn A connection handle to ImmPort database instance
# @param study_id Identifier of a specific study
# @return a count of Medical History data 
# @examples
# \dontrun{
#   # get count of study SDY1's Medical History data
#   count <- getCountOfMedicalHistory(conn, "SDY1")
# }
getCountOfMedicalHistory <- function(conn, study_id) {
    sql_stmt <- paste("SELECT count(*)
                      FROM  assessment_component asmc
                      INNER JOIN
                      assessment_panel asmp ON asmc.assessment_panel_accession=asmp.assessment_panel_accession
                      WHERE asmp.study_accession in ('", study_id, "') AND 
                        asmp.assessment_type='Medical History'", sep = "")
    
    count <- dbGetQuery(conn, statement = sql_stmt)
    
    count[1, 1]
} 

##' Medical History Domain Variables
##' @name MH
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name  } \tab \strong{Variable Label} \cr
##'     
##'     STUDYID \tab Study Identifier \cr
##'     DOMAIN  \tab Domain Abbreviation \cr
##'     USUBJID \tab Unique Subject Identifier \cr
##'     MHSEQ \tab Sequence Number \cr
##'     MHTERM \tab Reported Term for the Medical History \cr
##'     MHCAT \tab Category for Medical History \cr
##'     MHBODSYS \tab Body System or Organ Class \cr
##'     MHDY \tab Study Day of History Collection
##'   }
##' }
NULL
#> NULL 

##' Medical History Domain Supplemental Variables
##' @name SUPPMH
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name} \tab \strong{Variable Label} \cr
##'     STUDYID \tab Study Identifier \cr
##'     RDOMAIN  \tab Related Domain Abbreviation \cr
##'     USUBJID \tab Unique Subject Identifier \cr
##'     MHSEQ \tab Sequence Number \cr
##'     IDVAR \tab Identifying Variable \cr
##'     IDVARVAL \tab Identifying Variable Value \cr
##'     QNAM \tab Qualifier Variable Name \cr
##'     QLABEL \tab Qualifier Variable Label \cr
##'     QVAL \tab Data Value
##'   }
##' }
##' @note The following table enumerates the values in QNAM and QLABEL variables {
##'   \tabular{ll}{
##'     \strong{QNAM} \tab \strong{QLABEL} \cr
##'     MHAGE \tab Age at Onset \cr
##'     MHAGEU \tab Age at Onset Units \cr
##'     MHTOD \tab Time of Day
##'   }
##' }
NULL
#> NULL

# call to globalVariables to prevent from generating NOTE: no visible binding for global variable <variable name>
# this hack is to satisfy CRAN (http://stackoverflow.com/questions/9439256/how-can-i-handle-r-cmd-check-no-visible-binding-for-global-variable-notes-when)
globalVariables(c("sequence", "dataset_id", "study_time_of_specimen_collection", "unit_of_study_time_of_specimen_collection",
                  "study_time_t0_event", "study_time_t0_event_specify"))

#' @importFrom data.table as.data.table is.data.table .N := setorder
getArrayResults <- function(conn, study_id, measurement_type) {
    cat("loading Array Results data....")

  array_cols <- c("study_id", "subject_id", "sequence", "dataset_id", 
                  "experiment_title", "assay_purpose", "measurement_technique",
                  "experiment_sample_accession", "biosample_accession", "specimen_type", "specimen_subtype", 
                  "visit_name", "visit_min_start_day", "visit_max_start_day", "visit_order",
                  "study_time_of_specimen_collection", "unit_of_study_time_of_specimen_collection",
                  "study_time_t0_event", "study_time_t0_event_specify")

  tr_cols <- c("experiment_sample_accession",
               "specimen_treatment", 
               "treatment_amount_value", "treatment_amount_unit",
               "treatment_duration_value", "treatment_duration_unit",
               "treatment_temperature_value", "treatment_temperature_unit")
  
  sql_stmt <- paste("SELECT distinct
                        bs.study_accession,
                    bs.subject_accession,
                    cast(0 as UNSIGNED INTEGER) as sequence,
                    fi.name as dataset_id,
                    ex.name,
                    'Genetics Findings' as purpose,
                    ex.measurement_technique,
                    es2bs.expsample_accession,
                    bs.biosample_accession, 
                    bs.type,
                    bs.subtype,
                    pv.name as name_2,
                    pv.min_start_day,
                    pv.max_start_day,
                    pv.order_number,
                    bs.study_time_collected,
                    bs.study_time_collected_unit,
                    bs.study_time_t0_event,
                    bs.study_time_t0_event_specify
                    FROM  
                    biosample bs
                    INNER JOIN
                    expsample_2_biosample es2bs ON bs.biosample_accession=es2bs.biosample_accession
                    INNER JOIN
                    expsample es ON es2bs.expsample_accession=es.expsample_accession
                    INNER JOIN
                    planned_visit pv ON bs.planned_visit_accession=pv.planned_visit_accession
                    INNER JOIN
                    experiment ex ON es.experiment_accession=ex.experiment_accession
                    INNER JOIN
                    expsample_2_file_info es2fi ON es2bs.expsample_accession=es2fi.expsample_accession
                    INNER JOIN
                    file_info fi ON es2fi.file_info_id=fi.file_info_id                    
                    WHERE 
                    bs.study_accession in (\'", study_id,"\') AND
                    es2fi.file_info_id = fi.file_info_id AND
                    fi.detail like \"%Gene expression%\" AND
                    LOWER(fi.name) like \"%.cel%\"
                    ORDER BY bs.subject_accession",sep="")
  
  
  array_df <- DBI::dbGetQuery(conn, statement = sql_stmt)
  if (nrow(array_df) == 0) {
    
    sql_stmt <- paste("SELECT distinct
                         bs.study_accession,
                         bs.subject_accession,
                         cast(0 as UNSIGNED INTEGER) as sequence,
                         e2r.repository_accession as dataset_id,
                         ex.name,
                         'Genetics Findings' as purpose,
                         ex.measurement_technique,
                         es2bs.expsample_accession,
                         bs.biosample_accession, 
                         bs.type,
                         bs.subtype,
                         pv.name as name_2,
                         pv.min_start_day,
                         pv.max_start_day,
                         pv.order_number,
                         bs.study_time_collected,
                         bs.study_time_collected_unit,
                         bs.study_time_t0_event,
                         bs.study_time_t0_event_specify
                      FROM  
                        biosample bs
                      INNER JOIN
                      expsample_2_biosample es2bs ON bs.biosample_accession=es2bs.biosample_accession
                      INNER JOIN
                      expsample es ON es2bs.expsample_accession=es.expsample_accession
                      INNER JOIN
                      planned_visit pv ON bs.planned_visit_accession=pv.planned_visit_accession
                      INNER JOIN
                      experiment ex ON es.experiment_accession=ex.experiment_accession
                      INNER JOIN
                      expsample_public_repository e2r ON es2bs.expsample_accession=e2r.expsample_accession
                      WHERE 
                      bs.study_accession in (\'", study_id,"\') AND
                      e2r.repository_name='GEO' 
                      ORDER BY bs.subject_accession", sep = "")
    
    array_df <- DBI::dbGetQuery(conn, statement = sql_stmt)
    if (nrow(array_df) > 0) {
      array_df <- mutate(array_df, dataset_id = paste("urn:lsid:", "www.ncbi.nlm.nih.gov/geo", ":GEO:", dataset_id))
    } else {
      sql_stmt <- paste("SELECT distinct
                        bs.study_accession,
                        bs.subject_accession,
                        cast(0 as UNSIGNED INTEGER) as sequence,
                        fi.name as dataset_id,
                        ex.name,
                        'Genetics Findings' as purpose,
                        ex.measurement_technique,
                        es2bs.expsample_accession,
                        bs.biosample_accession, 
                        bs.type,
                        bs.subtype,
                        pv.name as name_2,
                        pv.min_start_day,
                        pv.max_start_day,
                        pv.order_number,
                        bs.study_time_collected,
                        bs.study_time_collected_unit,
                        bs.study_time_t0_event,
                        bs.study_time_t0_event_specify
                        FROM  
                        biosample bs
                        INNER JOIN
                        expsample_2_biosample es2bs ON bs.biosample_accession=es2bs.biosample_accession
                        INNER JOIN
                        expsample es ON es2bs.expsample_accession=es.expsample_accession
                        INNER JOIN
                        planned_visit pv ON bs.planned_visit_accession=pv.planned_visit_accession
                        INNER JOIN
                        experiment ex ON es.experiment_accession=ex.experiment_accession
                        INNER JOIN
                        expsample_2_file_info es2fi ON es2bs.expsample_accession=es2fi.expsample_accession
                        INNER JOIN
                        file_info fi ON es2fi.file_info_id=fi.file_info_id                    
                        WHERE 
                        bs.study_accession in (\'", study_id,"\') AND
                        es2fi.file_info_id = fi.file_info_id AND
                        fi.detail like \"%Gene expression%\" 
                        ORDER BY bs.subject_accession",sep="")
      
      
      array_df <- DBI::dbGetQuery(conn, statement = sql_stmt)
    }
  }

    colnames(array_df) <- array_cols
    if (nrow(array_df) > 0) {
      
      array_df$elapsed_time_of_specimen_collection = mapply(covertElaspsedTimeToISO8601Format, array_df$study_time_of_specimen_collection, 
                                                          array_df$unit_of_study_time_of_specimen_collection)
      
      array_df$time_point_reference = mapply(getTimePointReference, array_df$study_time_t0_event, 
                                           array_df$study_time_t0_event_specify)
      
      sql_stmt <- paste("
                      SELECT distinct
                        es2bs.expsample_accession,
                        tr.name,
                        tr.amount_value,
                        tr.amount_unit,
                        tr.duration_value,
                        tr.duration_unit,
                        tr.temperature_value,
                        tr.temperature_unit
                      FROM  
                        biosample bs
                      INNER JOIN
                        expsample_2_biosample es2bs ON bs.biosample_accession=es2bs.biosample_accession
                      INNER JOIN
                        expsample_2_treatment es2tr ON es2bs.expsample_accession=es2tr.expsample_accession
                      INNER JOIN
                        treatment tr ON es2tr.treatment_accession=tr.treatment_accession
                      WHERE 
                        bs.study_accession in (\'", study_id,"\')",sep="")
      
      tr_df <- dbGetQuery(conn,statement=sql_stmt)
      colnames(tr_df) <- tr_cols 
      
      if (nrow(tr_df) >0) {
        #tr_df <- aggregate(. ~ experiment_sample_accession,paste,collapse="||",data=tr_df)
        tr_df <- setDF(setDT(tr_df)[, lapply(.SD, paste, collapse="||"), by="experiment_sample_accession"])
        array_df <- merge(array_df ,tr_df, by="experiment_sample_accession", all.x = TRUE)
      } else {
        array_df["specimen_treatment"] = ""
        array_df["treatment_amount_value"] = ""
        array_df["treatment_amount_unit"] = ""
        array_df["treatment_duration_value"] = ""
        array_df["treatment_duration_unit"] = ""
        array_df["treatment_temperature_value"] = ""
        array_df["treatment_temperature_unit"] = ""
      }
      
      array_df <- transform(array_df, sequence = as.integer(sequence))
      setDT(array_df)[, `:=`(sequence, seq_len(.N)), by = "subject_id"]
      setorder(array_df, "subject_id")
      array_df <- as.data.frame(array_df)
      
      
#         array_df <- transform(array_df, result_id = as.integer(result_id))
#         arr_dt <- as.data.table(array_df)
#         if (is.data.table(arr_dt) == TRUE) {
#           arr_dt[, `:=`(result_id, seq_len(.N)), by = "subject_id"]
#         }
#         array_df <- as.data.frame(arr_dt)
# 
#         array_df <- ddply(array_df, .(study_id, subject_id, result_id), mutate, elapsed_time_of_specimen_collection = 
#                           covertElaspsedTimeToISO8601Format(study_time_of_specimen_collection, 
#                                                             unit_of_study_time_of_specimen_collection))
#         
#         array_df <- ddply(array_df, .(study_id, subject_id, result_id), mutate, time_point_reference = 
#                           getTimePointReference(study_time_t0_event, study_time_t0_event_specify))
        
    }
    
    
    cat("done", "\n")
    
    array_df
}

getCountOfArrayResults <- function(conn, study_id) {
  sql_stmt <- paste("SELECT count(*)
                      FROM 
                    biosample bs,
                    expsample_2_biosample be,
                    expsample_public_repository er
                    WHERE bs.study_accession in ('", study_id, "') AND
                    bs.biosample_accession=be.biosample_accession AND
                    be.expsample_accession=er.expsample_accession AND
                    er.repository_name='GEO'", sep = "")
  
  count <- dbGetQuery(conn, statement = sql_stmt)
  
  geo_count <- count[1, 1]
  
  sql_stmt <- paste("SELECT count(*)
                      FROM 
                        biosample bs,
                        expsample_2_biosample be,
                        expsample_2_file_info es2fi, 
                        file_info fi                      
                      WHERE 
                        bs.study_accession in ('", study_id, "') AND 
                        bs.biosample_accession=be.biosample_accession AND
                        be.expsample_accession=es2fi.expsample_accession AND
                        es2fi.data_format like \"%Gene_Expression%\" AND
                        es2fi.file_info_id = fi.file_info_id", 
                    sep = "")

  count <- dbGetQuery(conn, statement = sql_stmt)
  
  file_count <- count[1, 1]
  
  arr_count <- geo_count + file_count
  
  arr_count
} 

#' Exposure Domain
#' 
#' @name Exposure Domain
#' @description The Exposure data of an ImmPort study is reformated to the CDISC SDTM Exposure (EX) 
#' domain model, and is a list of 2 data frames containing 1) Exposure data \code{\link{EX}} 
#' and 2) any supplemental Exposure data \code{\link{SUPP}}
NULL
#> NULL 

# call to globalVariables to prevent from generating NOTE: no visible binding for global variable <variable name>
# this hack is to satisfy CRAN (http://stackoverflow.com/questions/9439256/how-can-i-handle-r-cmd-check-no-visible-binding-for-global-variable-notes-when)
globalVariables(c("EXSEQ"))

# Get Exposure data of a specific study
# 
# The function \code{getExposure} queries the ImmPort database for Exposure data and 
# reformats it to the CDISC SDTM Exposure (EX) domain model 
# 
# @param data_src A connection handle to ImmPort (MySQL or SQLite) database instance or 
# a directory handle to folder where study RDS files are located
# @param study_id Identifier of a specific study
# @return a list of 2 data frames containing 1) Exposure data \code{\link{EX}} and 2) any supplemental 
#   Exposure data \code{\link{SUPP}}
# @examples
# \dontrun{
#   getExposure(data_src, "SDY1")
# }
#' @importFrom DBI dbGetQuery
#' @importFrom data.table as.data.table is.data.table .N :=
getExposure <- function(data_src, study_id) {
    cat("loading Exposure data....")
    
    ex_cols <- c("STUDYID", "DOMAIN", "USUBJID", "EXSEQ", "EXTRT", "EXCAT", "EXDOSE", "EXDOSTXT", "EXDOSU", "EXDOSFRQ", 
               "EXROUTE", "EXSTDTC", "EXENDTC", "EXSTDY", "EXENDY")
  
  
    sql_stmt <- paste("SELECT distinct
                        sub.study_accession,
                        \"EX\" as domain,
                        sub.subject_accession,
                        cast(0 as UNSIGNED INTEGER) as seq,
                        sub.compound_name_reported,
                        sub.name_reported,
                        sub.dose,
                        sub.dose_reported,
                        sub.dose_units,
                        sub.dose_freq_per_interval,
                        sub.route_of_admin_reported,
                        sub.start_time,
                        sub.end_time,
                        sub.start_day,  
                        sub.end_day
                      FROM  intervention sub
                      WHERE sub.study_accession in ('", study_id, "') AND 
                        sub.compound_role='Intervention'                    
                      ORDER BY sub.subject_accession", sep = "")
    
    if ((class(data_src)[1] == 'MySQLConnection') || 
        (class(data_src)[1] == 'SQLiteConnection')) {
      ex_df <- dbGetQuery(data_src, statement = sql_stmt)
      colnames(ex_df) <- ex_cols
      suppex_df <- data.frame()
      
      if (nrow(ex_df) > 0) {
        ex_df <- transform(ex_df, EXSEQ = as.integer(EXSEQ))
        ex_dt <- as.data.table(ex_df)
        if (is.data.table(ex_dt) == TRUE) {
          ex_dt[, `:=`(EXSEQ, seq_len(.N)), by = "USUBJID"]
        }
        ex_df <- as.data.frame(ex_dt)
      }
    } else {
      l <- loadSerializedStudyData(data_src, study_id, "Exposure")
      ex_df <- l[[1]]
      suppex_df <- l[[2]]
    }

    cat("done", "\n")
    
    ex_l <- list()
    if (nrow(ex_df) > 0)
      ex_l <- list(ex_df=ex_df, suppex_df=suppex_df)
    
    ex_l
}

# Get count of Exposure data of a specific study
# 
# The function \code{getCountOfExposure} queries the ImmPort database for count 
# of Exposure data 
# 
# @param conn A connection handle to ImmPort database instance
# @param study_id Identifier of a specific study
# @return a count of Exposure data 
# @examples
# \dontrun{
#   # get count of study SDY1's Exposure data
#   count <- getCountOfExposure(conn, "SDY1")
# }
getCountOfExposure <- function(conn, study_id) {
    sql_stmt <- paste("SELECT count(*)
                       FROM  intervention sub
                       WHERE sub.study_accession in ('", study_id, "') AND 
                         sub.compound_role='Intervention'", sep = "")
    
    count <- dbGetQuery(conn, statement = sql_stmt)
    
    count[1, 1]
} 

##' Exposure Domain Variables
##' @name EX
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name  } \tab \strong{Variable Label} \cr
##'     STUDYID \tab Study Identifier \cr
##'     DOMAIN  \tab Domain Abbreviation \cr
##'     USUBJID \tab Unique Subject Identifier \cr
##'     EXSEQ \tab Sequence Number \cr
##'     EXTRT \tab Name of Treatment \cr
##'     EXCAT \tab Category of Treatment \cr
##'     EXDOSE \tab Dose \cr
##'     EXDOSTXT \tab Dose Description \cr
##'     EXDOSU \tab Dose Units \cr
##'     EXDOSFRQ \tab Dosing Frequency per Interval \cr
##'     EXROUTE \tab Route of Administration \cr
##'     EXSTDTC \tab Start Date/Time of Treatment \cr
##'     EXENDTC \tab End Date/Time of Treatment \cr
##'     EXSTDY \tab Study Day of Start of Treatment \cr
##'     EXENDY \tab Study Day of End of Treatment
##'   }
##' }
NULL
#> NULL 

#' Protein Quantification Domain
#' 
#' @name Protein Quantification Domain
#' @description The ImmPort study data generated from assays of types: ELISA and MBAA are grouped into the 
#' Cellular Quantification Domain. The data is reformated to a custom Protein Quantification domain model in 
#' CDISC SDTM standards, and is a list of 2 data frames containing 1) Protein Quantification data \code{\link{ZA}} 
#' and 2) any supplemental Protein Quantification data \code{\link{SUPP}}
NULL
#> NULL 

# call to globalVariables to prevent from generating NOTE: no visible binding for global variable <variable name>
# this hack is to satisfy CRAN (http://stackoverflow.com/questions/9439256/how-can-i-handle-r-cmd-check-no-visible-binding-for-global-variable-notes-when)
globalVariables(c("subject_id", "result_id", "experiment_title", "assay_purpose", "measurement_technique",
                  "analyte", "value", "unit", "specimen_type",
                  "specimen_subtype", "specimen_treatment", 
                  "treatment_amount_value", "treatment_amount_unit",
                  "treatment_duration_value", "treatment_duration_unit",
                  "treatment_temperature_value", "treatment_temperature_unit",
                  "visit_name", "visit_min_start_day", "visit_max_start_day", "visit_order",
                  "elapsed_time_of_specimen_collection", "time_point_reference",
                  "biosample_accession", "experiment_sample_accession", "file_name", 
                  "concentration_value_preferred", "concentration_unit_preferred", "concentration_value_reported", "concentration_unit_reported", 
                  "mfi", "mfi_coordinate", "QNAM", "QVAL", "ZAMFI", "ZAMFICRD", "ZASPECSB", "ZAREFIDP",
                  "VISITMIN", "VISITMAX",
                  "ZASPTRT", 
                  "ZATRTAMV", "ZATRTAMU",
                  "ZATRTDUV", "ZATRTDUU",
                  "ZATRTTMV", "ZATRTTMU"))

# Get Protein Quantification data of a specific study
# 
# The function \code{getProteinQuantification} queries the ImmPort database for Protein Quantification data and 
# reformats it to a custom Protein Quantification domain model in CDISC SDTM standards. 
# 
# @param data_src A data_srcection handle to ImmPort (MySQL or SQLite) database instance or 
# a directory handle to folder where study RDS files are located
# @param study_id Identifier of a specific study
# @param assay_type Assay Type **optional**
# @return a list of 2 data frames containing 1) Protein Quantification data \code{\link{ZA}} and 2) any supplemental 
#   Protein Quantification data \code{\link{SUPPZA}}
# @examples
# \dontrun{
#   # get all of study SDY1's Protein Quantification data
#   pq_l <- getProteinQuantification(data_src, "SDY1")
#   
#   # get study SDY1's Protein Quantification data that was generated using ELISA assay
#   pq_l <- getProteinQuantification(data_src, "SDY1", "ELISA")
# }
#' @importFrom dplyr %>% select
#' @importFrom reshape2 melt 
#' @importFrom plyr rename
getProteinQuantification <- function(data_src, study_id, assay_type="ALL") {
    cat("loading Protein Quantification data....")
  
    pq_cols <- c("STUDYID", "DOMAIN", "USUBJID", "ZASEQ", "ZATEST", "ZACAT", "ZAMETHOD", "ZAANALYT", "ZAORRES", 
                "ZAORRESU", "ZASPEC", "VISITNUM", "VISIT", "ZAELTM", "ZATPTREF", "ZAREFID", "ZAXFN")
  
    supppq_cols <- c("STUDYID", "RDOMAIN", "USUBJID", "IDVAR", "IDVARVAL", "QNAM", "QLABEL", "QVAL")
  
    
    pq_df = data.frame()
    supppq_df = data.frame()

    if ((class(data_src)[1] == 'MySQLConnection') || 
        (class(data_src)[1] == 'SQLiteConnection')) {
      if ((assay_type == "ALL") || (assay_type =="ELISA")) {
        # get ELISA results
        measurement_types <- list("Protein_Quantification", "Cytokine_Quantification")
        els_df <- getElisaResults(data_src, study_id, "")
        if (nrow(els_df) > 0) {
            els_df <- select(els_df, STUDYID = study_id, USUBJID = subject_id, ZASEQ = sequence, ZATEST = experiment_title, 
                ZACAT = assay_purpose, ZAMETHOD = measurement_technique, ZAANALYT = analyte, ZAORRES = value, ZAORRESU = unit, 
                ZASPEC = specimen_type, ZASPECSB = specimen_subtype, 
                ZASPTRT = specimen_treatment, 
                ZATRTAMV = treatment_amount_value, ZATRTAMU = treatment_amount_unit,
                ZATRTDUV = treatment_duration_value, ZATRTDUU = treatment_duration_unit,
                ZATRTTMV = treatment_temperature_value, ZATRTTMU = treatment_temperature_unit,
                VISIT = visit_name, VISITNUM = visit_order,  VISITMIN = visit_min_start_day, VISITMAX = visit_max_start_day, 
                ZAELTM = elapsed_time_of_specimen_collection, ZATPTREF = time_point_reference, 
                ZAREFID = experiment_sample_accession, ZAREFIDP = biosample_accession, ZAXFN = file_name)
            
            els_df$DOMAIN <- "ZA"

            qnam_values = c("ZASPECSB", "ZAREFIDP",
                            "VISITMIN", "VISITMAX",
                            "ZASPTRT", 
                            "ZATRTAMV", "ZATRTAMU",
                            "ZATRTDUV", "ZATRTDUU",
                            "ZATRTTMV", "ZATRTTMU")
            
            qlabel_values= c("Specimen Subtype", "Source Specimen Identifier",
                             "Planned Visit Minimum Start Day", "Planned Visit Maximum Start Day",
                             "Specimen Treatment", 
                             "Specimen Treatment Amount Value", "Specimen Treatment Amount Unit",
                             "Specimen Treatment Duration Value", "Specimen Treatment Duration Unit", 
                             "Specimen Treatment Temperature Value", "Specimen Treatment Temperature Unit")
            
            supp_els_df <- melt(els_df, 
                                 id = c("STUDYID", "DOMAIN", "USUBJID", "ZASEQ"), 
                                 measure = qnam_values, 
                                 variable.name = "QNAM", 
                                 value.name = "QVAL")
            supp_els_df <- transform(supp_els_df, QLABEL = unlist(qlabel_values[QNAM]))
            supp_els_df <- plyr::rename(supp_els_df, c("DOMAIN" = "RDOMAIN", "ZASEQ" = "IDVARVAL"))
            supp_els_df$IDVAR <- "ZASEQ"
            
            supp_els_df <- supp_els_df[supppq_cols]
            
            # remove rows that have empty QVAL values
            supp_els_df <- subset(supp_els_df,QVAL!="")      
            
            els_df <- subset(els_df, select = -c(ZASPECSB, ZAREFIDP, ZASPTRT, 
                                                 VISITMIN, VISITMAX,
                                                 ZATRTAMV, ZATRTAMU,
                                                 ZATRTDUV, ZATRTDUU,
                                                 ZATRTTMV, ZATRTTMU))
            
            els_df <- els_df[, pq_cols]
  
            pq_df <- rbind(pq_df, els_df)
            supppq_df <- rbind(supppq_df, supp_els_df)
            
        }
      }
      
      if ((assay_type == "ALL") || (assay_type =="MBAA")) {
        
        # get MBAA results
        
        # mbaa_column_names <- c('study_id', 'subject_id', 'result_id', 'analyte', 'concentration_unit',
        # 'concentration_value', 'mfi', 'mfi_coordinate', 'experiment_title', 'assay_purpose', 'measurement_technique',
        # 'biosample_accession', 'specimen_type', 'specimen_subtype', 'elapsed_time_of_specimen_collection',
        # 'time_point_reference', 'file_name')
        measurement_types <- list("Cytokine_Quantification")
        mbaa_df <- getMbaaResults(data_src, study_id, "")
        if (nrow(mbaa_df) > 0) {
            mbaa_df <- mbaa_df %>% 
              select(STUDYID = study_id, USUBJID = subject_id, ZASEQ = sequence, ZATEST = experiment_title, 
                ZACAT = assay_purpose, ZAMETHOD = measurement_technique, ZAANALYT = analyte, ZAORRES = concentration_value_preferred, 
                ZAORRESU = concentration_unit_preferred, ZASPEC = specimen_type, ZASPECSB = specimen_subtype, 
                ZASPTRT = specimen_treatment, 
                ZATRTAMV = treatment_amount_value, ZATRTAMU = treatment_amount_unit,
                ZATRTDUV = treatment_duration_value, ZATRTDUU = treatment_duration_unit,
                ZATRTTMV = treatment_temperature_value, ZATRTTMU = treatment_temperature_unit,
                VISIT = visit_name, VISITNUM = visit_order,  VISITMIN = visit_min_start_day, VISITMAX = visit_max_start_day, 
                ZAELTM = elapsed_time_of_specimen_collection, 
                ZATPTREF = time_point_reference, 
                ZAREFID = experiment_sample_accession, ZAREFIDP = biosample_accession, 
                ZAXFN = file_name, ZAMFI = mfi, ZAMFICRD = mfi_coordinate)
            
            mbaa_df$DOMAIN <- "ZA"
            
            qnam_values = c("ZAMFI", "ZAMFICRD", "ZASPECSB", "ZAREFIDP",
                            "VISITMIN", "VISITMAX",
                            "ZASPTRT", 
                            "ZATRTAMV", "ZATRTAMU",
                            "ZATRTDUV", "ZATRTDUU",
                            "ZATRTTMV", "ZATRTTMU")
            
            qlabel_values= c("MFI", "MFI Coordinate", "Specimen Subtype", "Source Specimen Identifier",
                             "Planned Visit Minimum Start Day", "Planned Visit Maximum Start Day",
                             "Specimen Treatment", 
                             "Specimen Treatment Amount Value", "Specimen Treatment Amount Unit",
                             "Specimen Treatment Duration Value", "Specimen Treatment Duration Unit", 
                             "Specimen Treatment Temperature Value", "Specimen Treatment Temperature Unit")
            
            supp_mbaa_df <- melt(mbaa_df, 
                                           id = c("STUDYID", "DOMAIN", "USUBJID", "ZASEQ"), 
                                           measure = qnam_values, 
                                           variable.name = "QNAM", 
                                           value.name = "QVAL")
            supp_mbaa_df <- transform(supp_mbaa_df, QLABEL = unlist(qlabel_values[QNAM]))
            supp_mbaa_df <- plyr::rename(supp_mbaa_df, c("DOMAIN" = "RDOMAIN", "ZASEQ" = "IDVARVAL"))
            supp_mbaa_df$IDVAR <- "ZASEQ"
            
            supp_mbaa_df <- supp_mbaa_df[supppq_cols]
            
            # remove rows that have empty QVAL values
            supp_mbaa_df <- subset(supp_mbaa_df,QVAL!="")      
            
            mbaa_df <- subset(mbaa_df, select = -c(ZAMFI, ZAMFICRD, ZASPECSB, ZAREFIDP,
                                                   VISITMIN, VISITMAX,
                                                   ZASPTRT, 
                                                   ZATRTAMV, ZATRTAMU,
                                                   ZATRTDUV, ZATRTDUU,
                                                   ZATRTTMV, ZATRTTMU))
            
            mbaa_df <- mbaa_df[, pq_cols]
            
            pq_df <- rbind(pq_df, mbaa_df)
            supppq_df <- rbind(supppq_df, supp_mbaa_df)
            
        }
      }
    } else {
      l <- loadSerializedStudyData(data_src, study_id, "Protein Quantification")
      if (assay_type == "ALL") {
        pq_df <- l[[1]]
        supppq_df <- l[[2]]
      } else {
        
      }
    }   

    cat("done", "\n")
    
    pq_l <- list()
    if (nrow(pq_df) > 0)
      pq_l <- list(za_df=pq_df, suppza_df=supppq_df)
    
    pq_l
} 

# Get count of Protein Quantification data of a specific study
# 
# The function \code{getCountOfProteinQuantification} queries the ImmPort database for count 
# of Protein Quantification data 
# 
# @param data_src A connection handle to ImmPort database instance
# @param assay_type Assay Type **optional**
# @param study_id Identifier of a specific study
# @return a count of Protein Quantification data 
# @examples
# \dontrun{
#   # get count of all of study SDY1's Protein Quantification data
#   count <- getCountOfProteinQuantification(data_src, "SDY1")
#   
#   # get count of study SDY1's Protein Quantification data that was generated using ELISA assay
#   count <- getCountOfProteinQuantification(data_src, "SDY1", "ELISA")
# }
getCountOfProteinQuantification <- function(data_src, study_id, assay_type="ALL") {
  count <- 0
  if ((assay_type == "ALL") || (assay_type =="ELISA")) 
    count <- count + getCountOfElisaResults(data_src, study_id)
  if ((assay_type == "ALL") || (assay_type =="MBAA")) 
    count <- count + getCountOfMbaaResults(data_src, study_id)
  
  count
}

##' Protein Quantification Domain Variables
##' @name ZA
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name  } \tab \strong{Variable Label} \cr
##'     STUDYID \tab Study Identifier \cr
##'     DOMAIN  \tab Domain Abbreviation \cr
##'     USUBJID \tab Unique Subject Identifier \cr
##'     ZASEQ \tab Sequence Number \cr
##'     ZATEST \tab Protein Quantification Test Name \cr
##'     ZACAT \tab Category for Protein Quantification \cr
##'     ZAMETHOD \tab Measurement Technique \cr
##'     ZAANALYT \tab Analyte \cr
##'     ZAORRES \tab Result or Finding in Original Units \cr
##'     ZAORRESU \tab Original Units \cr
##'     ZASPEC \tab Specimen Type \cr
##'     VISITNUM \tab Visit Number \cr
##'     VISIT \tab Visit Name \cr
##'     ZAELTM \tab Planned Elapsed Time from Time Point Ref \cr
##'     ZATPTREF \tab Time Point Reference \cr
##'     ZAREFID \tab Specimen Identifier \cr
##'     ZAXFN \tab Raw Data File or Life Science Identifier
##'   }
##' }
NULL
#> NULL 

##' Protein Quantification Domain Supplemental Variables
##' @name SUPPZA
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name} \tab \strong{Variable Label} \cr
##'     STUDYID \tab Study Identifier \cr
##'     RDOMAIN  \tab Related Domain Abbreviation \cr
##'     USUBJID \tab Unique Subject Identifier \cr
##'     IDVAR \tab Identifying Variable \cr
##'     IDVARVAL \tab Identifying Variable Value \cr
##'     QNAM \tab Qualifier Variable Name \cr
##'     QLABEL \tab Qualifier Variable Label \cr
##'     QVAL \tab Data Value
##'   }
##' }   
##' @note The following table enumerates the values in QNAM and QLABEL variables {
##'   \tabular{ll}{
##'     \strong{QNAM} \tab \strong{QLABEL} \cr
##'     ZAMFI \tab MFI \cr
##'     ZAMFICRD \tab MFI Coordinate \cr
##'     ZASPECSB \tab Specimen Subtype \cr
##'     ZAREFIDP \tab Source Specimen Identifier \cr
##'     VISITMIN \tab Planned Visit Minimum Start Day \cr
##'     VISITMAX \tab Planned Visit Maximum Start Day \cr
##'     ZASPTRT \tab Specimen Treatment \cr
##'     ZATRTAMV \tab Specimen Treatment Amount Value \cr
##'     ZATRTAMU \tab Specimen Treatment Amount Unit \cr
##'     ZATRTDUV \tab Specimen Treatment Duration Value \cr
##'     ZATRTDUU \tab Specimen Treatment Duration Unit \cr
##'     ZATRTTMV \tab Specimen Treatment Temperature Value \cr
##'     ZATRTTMU \tab Specimen Treatment Temperature Unit
##'   }
##' }
NULL
#> NULL

#' Demographics Domain
#' 
#' @name Demographics Domain
#' @description The Demographics data of an ImmPort study is reformated to the CDISC SDTM Demographics (DM) 
#' domain model, and is a list of 2 data frames containing 1) Demographics data \code{\link{DM}} 
#' and 2) any supplemental Demographics data \code{\link{SUPP}}
NULL
#> NULL 

# Get Demographics data of a specific study
# 
# The function \code{getDemographics} queries the ImmPort database for Demographics data and 
# reformats it to the CDISC SDTM Demographics (DM) domain model 
# 
# @param data_src A connection handle to ImmPort (MySQL or SQLite) database instance or 
# a directory handle to folder where study RDS files are located
# @param study_id Identifier of a specific study
# @return a list of 2 data frames containing 1) Demographics data \code{\link{DM}} and 2) any supplemental 
#   Demographics data \code{\link{SUPP}}
# @examples
# \dontrun{
#   getDemographics(data_src, "SDY1")
# }
getDemographics <- function(data_src,study_id) {
  cat("loading Demographics data....")

  dm_cols <- c("STUDYID", "DOMAIN","USUBJID", 
               "AGE", "AGEU", "SEX",
               "RACE", "ETHNIC",
               "SPECIES", "STRAIN", "SBSTRAIN",
               "ARMCD", "ARM")
  
  sql_stmt <- paste("
                                  SELECT distinct
                                  arm.study_accession,
                                  \"DM\" as domain,
                                  sub.subject_accession,
                                  ((arm2sub.min_subject_age+arm2sub.max_subject_age)/2) as age,
                                  arm2sub.age_unit,
                                  sub.gender,
                                  sub.race,
                                  sub.ethnicity,
                                  sub.species,
                                  sub.strain,
                                  sub.strain_characteristics,
                                  arm.arm_accession,
                                  arm.name as arm_name
                                  FROM subject sub
                                  INNER JOIN
                                  arm_2_subject arm2sub ON sub.subject_accession = arm2sub.subject_accession
                                  INNER JOIN
                                  arm_or_cohort arm ON arm2sub.arm_accession = arm.arm_accession
                                  WHERE arm.study_accession in (\'", study_id,"\')
                                  ORDER BY sub.subject_accession",sep="")
  
  if ((class(data_src)[1] == 'MySQLConnection') || 
      (class(data_src)[1] == 'SQLiteConnection')) {
    dm_df <- dbGetQuery(data_src,statement=sql_stmt)
    colnames(dm_df) <- dm_cols 
    suppdm_df <- data.frame()
  
#     if (nrow(dm_df) > 0) {
#     
#       if ('Homo sapiens' %in% dm_df$SPECIES) {
#         #remove "SPECIES", "STRAIN", "SBSTRAIN" columns
#         dm_df[,c("SPECIES", "STRAIN", "SBSTRAIN")] <- list(NULL)
#       } else {
#         #remove "RACE", "ETHNIC" columns
#         dm_df[,c("RACE", "ETHNIC")] <- list(NULL)    
#       }
#     }
  } else {
    l <- loadSerializedStudyData(data_src, study_id, "Demographics")
    dm_df <- l[[1]]
    suppdm_df <- l[[2]]
  }
  cat("done", "\n")
  
  dm_l <- list()
  if (nrow(dm_df) > 0)
    dm_l <- list(dm_df=dm_df, suppdm_df=suppdm_df)
  
  dm_l
}


# Get count of Demographics data of a specific study
# 
# The function \code{getCountOfDemographics} queries the ImmPort database for count 
# of Demographics data 
# 
# @param conn A connection handle to ImmPort database instance
# @param study_id Identifier of a specific study
# @return a count of Demographics data 
# @examples
# \dontrun{
#   # get count of study SDY1's Demographics data
#   count <- getCountOfDemographics(conn, "SDY1")
# }
getCountOfDemographics <- function(conn,study_id) {  
  sql_stmt <- paste("
                    SELECT count(*)
                      FROM subject sub
                      INNER JOIN
                      arm_2_subject arm2sub ON sub.subject_accession = arm2sub.subject_accession
                      INNER JOIN
                      arm_or_cohort arm ON arm2sub.arm_accession = arm.arm_accession
                      WHERE arm.study_accession in (\'", study_id,"\')",sep="")
  
  count <- dbGetQuery(conn,statement=sql_stmt)
  
  count[1,1]
}

##' Demographics Domain Variables
##' @name DM
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name  } \tab \strong{Variable Label} \cr
##'     STUDYID \tab Study Identifier \cr
##'     DOMAIN  \tab Domain Abbreviation \cr
##'     USUBJID \tab Unique Subject Identifier \cr
##'     AGE \tab Age \cr
##'     AGEU \tab Age Units \cr
##'     SEX \tab Sex \cr
##'     RACE \tab Race (only for human data) \cr
##'     ETHNIC \tab Ethnicity (only for human data) \cr
##'     SPECIES \tab Species (only for non-human data) \cr
##'     STRAIN \tab Strain/Substrain (only for non-human data) \cr
##'     SBSTRAIN \tab Strain/Substrain Details (only for non-human data) \cr
##'     ARMCD \tab Planned Arm Code \cr
##'     ARM \tab Description of Planned Arm
##'   }
##' }
NULL
#> NULL

##' Supplemental Variables
##' @name SUPP
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name} \tab \strong{Variable Label} \cr
##'     STUDYID \tab Study Identifier \cr
##'     RDOMAIN  \tab Related Domain Abbreviation \cr
##'     USUBJID \tab Unique Subject Identifier \cr
##'     IDVAR \tab Identifying Variable \cr
##'     IDVARVAL \tab Identifying Variable Value \cr
##'     QNAM \tab Qualifier Variable Name \cr
##'     QLABEL \tab Qualifier Variable Label \cr
##'     QVAL \tab Data Value
##'   }
##' }
NULL
#> NULL

#' Questionnaires Domain
#' 
#' @name Questionnaires Domain
#' @description The Questionnaires data of an ImmPort study is reformated to the CDISC SDTM 
#' Questionnaires (QS) domain model, and is a list of 2 data frames containing 1) Questionnaires 
#' data \code{\link{QS}} and 2) any supplemental Questionnaires data \code{\link{SUPP}}
NULL
#> NULL 

# call to globalVariables to prevent from generating NOTE: no visible binding for global variable <variable name>
# this hack is to satisfy CRAN (http://stackoverflow.com/questions/9439256/how-can-i-handle-r-cmd-check-no-visible-binding-for-global-variable-notes-when)
globalVariables(c("QSSEQ"))

# Get Questionnaires data of a specific study
# 
# The function \code{getQuestionnaires} queries the ImmPort database for Questionnaires data and 
# reformats it to the CDISC SDTM Questionnaires (QS) domain model 
# 
# @param data_src A connection handle to ImmPort (MySQL or SQLite) database instance or 
# a directory handle to folder where study RDS files are located
# @param study_id Identifier of a specific study
# @return a list of 2 data frames containing 1) Questionnaires data \code{\link{QS}} and 2) any supplemental 
#   Questionnaires data \code{\link{SUPP}}
# @examples
# \dontrun{
#   getQuestionnaires(data_src, "SDY1")
# }
#' @importFrom DBI dbGetQuery
#' @importFrom data.table as.data.table is.data.table .N :=
getQuestionnaires <- function(data_src, study_id) {
  cat("loading Questionnaires data....")
  
  qs_cols <- c("STUDYID", "DOMAIN", "USUBJID", "QSSEQ", "QSTEST", "QSCAT", 
               "QSORRES", "QSORRESU", "VISITNUM", "VISIT", "QSDY")
  
  
  sql_stmt <- paste("SELECT distinct
                      asmp.study_accession,
                      \"QS\" as domain,
                      asmc.subject_accession,
                      cast(0 as UNSIGNED INTEGER) as seq,
                      asmc.name_reported,
                      asmp.name_reported,
                      asmc.result_value_reported,
                      asmc.result_unit_reported,
                      pv.order_number,
                      pv.name,
                      asmc.study_day                    
                      FROM  assessment_component asmc
                      INNER JOIN
                      assessment_panel asmp ON asmc.assessment_panel_accession=asmp.assessment_panel_accession
                      INNER JOIN
                      planned_visit pv ON asmc.planned_visit_accession=pv.planned_visit_accession
                      WHERE (asmp.study_accession in ('", study_id, "')) AND 
                      (asmp.assessment_type='Questionnaire' OR asmp.assessment_type='Questionaire') 
                      ORDER BY asmc.subject_accession", sep = "")



  if ((class(data_src)[1] == 'MySQLConnection') || 
      (class(data_src)[1] == 'SQLiteConnection')) {
    qs_df <- dbGetQuery(data_src, statement = sql_stmt)
    colnames(qs_df) <- qs_cols
    suppqs_df <- data.frame()
    if (nrow(qs_df) > 0) {
      qs_df <- transform(qs_df, QSSEQ = as.integer(QSSEQ))
      qs_dt <- as.data.table(qs_df)
      if (is.data.table(qs_dt) == TRUE) {
        qs_dt[, `:=`(QSSEQ, seq_len(.N)), by = "USUBJID"]
      }
      qs_df <- as.data.frame(qs_dt)
    }
  } else {
    l <- loadSerializedStudyData(data_src, study_id, "Questionnaires")
    qs_df <- l[[1]]
    suppqs_df <- l[[2]]
  }
  
  cat("done", "\n")
  
  qs_l <- list()
  if (nrow(qs_df) > 0)
    qs_l <- list(qs_df=qs_df, suppqs_df=suppqs_df)
  
  qs_l
}

# Get count of Questionnaires data of a specific study
# 
# The function \code{getCountOfQuestionnaires} queries the ImmPort database for count 
# of Trial Arms data 
# 
# @param conn A connection handle to ImmPort database instance
# @param study_id Identifier of a specific study
# @return a count of Questionnaires data 
# @examples
# \dontrun{
#   # get count of study SDY1's Questionnaires data
#   count <- getCountOfQuestionnaires(conn, "SDY1")
# }
getCountOfQuestionnaires <- function(conn, study_id) {
  sql_stmt <- paste("SELECT count(*)
                      FROM  assessment_component asmc
                      INNER JOIN
                      assessment_panel asmp ON asmc.assessment_panel_accession=asmp.assessment_panel_accession 
                      WHERE (asmp.study_accession in ('", study_id, "')) AND 
                      (asmp.assessment_type='Questionnaire' OR asmp.assessment_type='Questionaire')", sep = "")
  
  count <- dbGetQuery(conn, statement = sql_stmt)
  
  count[1, 1]
} 

##' Questionnaires Domain Variables
##' @name QS
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name  } \tab \strong{Variable Label} \cr
##'     STUDYID \tab Study Identifier \cr
##'     DOMAIN  \tab Domain Abbreviation \cr
##'     USUBJID \tab Unique Subject Identifier \cr
##'     QSSEQ \tab Sequence Number \cr
##'     QSTEST \tab Questionnaires Test Name \cr
##'     QSCAT \tab Category for Questionnaires \cr
##'     QSORRES \tab Results or Findings in Original Units \cr
##'     QSORRESU \tab Original Units \cr
##'     VISITNUM \tab Visit Number \cr
##'     VISIT \tab Visit Name \cr
##'     QSDY \tab Study Day of Finding
##'   }
##' }
NULL
#> NULL 

#' Laboratory Test Results Domain
#' 
#' @name Laboratory Test Results Domain
#' @description The Laboratory Test Results data of an ImmPort study is reformated to the CDISC SDTM 
#' Laboratory Test Results (LB) domain model, and is a list of 2 data frames containing 1) Laboratory 
#' Test Results data \code{\link{LB}} and 2) any supplemental Laboratory Test Results data \code{\link{SUPPLB}}
NULL
#> NULL 

# call to globalVariables to prevent from generating NOTE: no visible binding for global variable <variable name>
# this hack is to satisfy CRAN (http://stackoverflow.com/questions/9439256/how-can-i-handle-r-cmd-check-no-visible-binding-for-global-variable-notes-when)
globalVariables(c("LBSEQ", "QNAM", "QVAL", "LBSPECSB", "VISITMIN", "VISITMAX", "STUDYID", "DOMAIN", "USUBJID",
                  "study_time_of_specimen_collection", "unit_of_study_time_of_specimen_collection",
                  "study_time_t0_event", "study_time_t0_event_specify"))

# Get Laboratory Test Results data of a specific study
# 
# The function \code{Laboratory Test Results} queries the ImmPort database for Laboratory Test Results data and 
# reformats it to the CDISC SDTM Laboratory Test Results (DM) domain model 
# 
# @param data_src A connection handle to ImmPort (MySQL or SQLite) database instance or 
# a directory handle to folder where study RDS files are located
# @param study_id Identifier of a specific study
# @return a list of 2 data frames containing 1) Laboratory Test Results data \code{\link{LB}} and 2) any supplemental 
#   Laboratory Test Results data \code{\link{SUPPLB}}
# @examples
# \dontrun{
#   getLaboratoryTestResults(data_src, "SDY1")
# }
#' @importFrom DBI dbGetQuery
#' @importFrom data.table as.data.table is.data.table .N :=
#' @importFrom plyr rename
#' @importFrom plyr ddply
getLaboratoryTestResults <- function(data_src, study_id) {
    cat("loading Laboratory Test Results data....")
  
    lb.cols <- c("STUDYID", "DOMAIN", "USUBJID", "LBSEQ", "LBTEST", "LBCAT", "LBORRES", "LBORRESU", "LBSPEC", "LBSPECSB",
                "VISITNUM", "VISIT", "VISITMIN", "VISITMAX", "study_time_of_specimen_collection", "unit_of_study_time_of_specimen_collection",
                "study_time_t0_event", "study_time_t0_event_specify", "LBREFID")
  
    supplb.cols <- c("STUDYID", "RDOMAIN", "USUBJID", "IDVAR", "IDVARVAL", "QNAM", "QLABEL", "QVAL")
  
  
    
    sql_stmt <- paste("SELECT distinct
                        bs.study_accession,
                        \"LB\" as domain,
                        bs.subject_accession,
                        cast(0 as UNSIGNED INTEGER) as seq,
                        lt.name_reported,
                        ltp.name_reported,
                        lt.result_value_reported,
                        lt.result_unit_reported,
                        bs.type,
                        bs.subtype,
                        pv.order_number,
                        pv.name,
                        pv.min_start_day,
                        pv.max_start_day,
                        bs.study_time_collected,
                        bs.study_time_collected_unit,
                        bs.study_time_t0_event,
                        bs.study_time_t0_event_specify,
                        bs.biosample_accession
                      FROM  
                        lab_test lt
                      INNER JOIN
                        lab_test_panel ltp ON lt.lab_test_panel_accession=ltp.lab_test_panel_accession
                      INNER JOIN
                        biosample bs ON lt.biosample_accession=bs.biosample_accession
                      INNER JOIN
                        planned_visit pv ON bs.planned_visit_accession=pv.planned_visit_accession
                      WHERE bs.study_accession in ('", study_id, "') 
                      ORDER BY bs.subject_accession", sep = "")
    
    if ((class(data_src)[1] == 'MySQLConnection') || 
        (class(data_src)[1] == 'SQLiteConnection')) {
      lb_df <- dbGetQuery(data_src, statement = sql_stmt)
      colnames(lb_df) <- lb.cols
      supplb_df <- data.frame()
      
      if (nrow(lb_df) > 0) {
          lb_df <- transform(lb_df, LBSEQ = as.integer(LBSEQ))
          lb_dt <- as.data.table(lb_df)
          if (is.data.table(lb_dt) == TRUE) {
            lb_dt[, `:=`(LBSEQ, seq_len(.N)), by = "USUBJID"]
          }
          lb_df <- as.data.frame(lb_dt)

          lb_df <- ddply(lb_df, .(STUDYID, DOMAIN, USUBJID, LBSEQ), mutate, LBELTM = 
                            covertElaspsedTimeToISO8601Format(study_time_of_specimen_collection, 
                                                              unit_of_study_time_of_specimen_collection))
          
          lb_df <- ddply(lb_df, .(STUDYID, DOMAIN, USUBJID, LBSEQ), mutate, LBTPTREF = 
                            getTimePointReference(study_time_t0_event, study_time_t0_event_specify))
          
   
          
          qnam_values = c("LBSPECSB", "VISITMIN", "VISITMAX")
          qlabel_values= c("Specimen Subtype", "Planned Visit Minimum Start Day", "Planned Visit Maximum Start Day")
          
          supplb_df <- reshape2::melt(lb_df, 
                                      id = c("STUDYID", "DOMAIN", "USUBJID", "LBSEQ"), 
                                      measure = qnam_values, 
                                      variable.name = "QNAM", 
                                      value.name = "QVAL")
          supplb_df <- transform(supplb_df, QLABEL = unlist(qlabel_values[QNAM]))
          supplb_df <- plyr::rename(supplb_df, c("DOMAIN" = "RDOMAIN", "LBSEQ" = "IDVARVAL"))
          supplb_df$IDVAR <- "LBSEQ"
          
          
          supplb_df <- supplb_df[supplb.cols]
          
          # remove rows that have empty QVAL values
          supplb_df <- subset(supplb_df,QVAL!="")      
  
          lb_df <- subset(lb_df, select = -c(LBSPECSB, VISITMIN, VISITMAX, study_time_of_specimen_collection, 
                                             unit_of_study_time_of_specimen_collection,
                                             study_time_t0_event, study_time_t0_event_specify))
          
  #         lb_dt[, `:=`(LBDTCU, NULL)]
  #         lb_dt[, `:=`(LBTPT0, NULL)]
  #         lb_dt[, `:=`(LBTPT0SP, NULL)]
  #         lb_dt[, `:=`(LBSPECID, NULL)]
  #         lb_df <- as.data.frame(lb_dt)
  #         supplb_df <- as.data.frame(slb_dt)
      }
    } else {
      l <- loadSerializedStudyData(data_src, study_id, "Laboratory Test Results")
      lb_df <- l[[1]]
      supplb_df <- l[[2]]
    }

    
    cat("done", "\n")
    
    lb_l <- list()
    if (nrow(lb_df) > 0)
      lb_l <- list(lb_df=lb_df, supplb_df=supplb_df)
    
    lb_l
}

# Get count of Laboratory Test Results data of a specific study
# 
# The function \code{getCountOfLaboratoryTestResults} queries the ImmPort database for count 
# of Laboratory Test Results data 
# 
# @param conn A connection handle to ImmPort database instance
# @param study_id Identifier of a specific study
# @return a count of Laboratory Test Results data 
# @examples
# \dontrun{
#   # get count of study SDY1's Laboratory Test Results data
#   count <- getCountOfLaboratoryTestResults(conn, "SDY1")
# }
getCountOfLaboratoryTestResults <- function(conn, study_id) {
    sql_stmt <- paste("SELECT count(*)
                      FROM  lab_test lt,
                            biosample bs
                      WHERE bs.study_accession in ('", study_id, "') AND 
                            lt.biosample_accession=bs.biosample_accession", sep = "")
    
    count <- dbGetQuery(conn, statement = sql_stmt)
    
    count[1, 1]
} 

##' Laboratory Test Results Domain Variables
##' @name LB
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name  } \tab \strong{Variable Label} \cr
##'     STUDYID \tab Study Identifier \cr
##'     DOMAIN  \tab Domain Abbreviation \cr
##'     USUBJID \tab Unique Subject Identifier \cr
##'     LBSEQ \tab Sequence Number \cr
##'     LBTEST \tab Lab Test or Examination Name \cr
##'     LBCAT \tab Category for Lab Test \cr
##'     LBORRES \tab Result or Finding in Original Units \cr
##'     LBORRESU \tab Original Units \cr
##'     LBSPEC \tab Specimen Type \cr
##'     LBREFID \tab Specimen Identifier \cr
##'     VISITNUM \tab Visit Number \cr
##'     VISIT \tab Visit Name \cr
##'     LBELTM \tab Planned Elapsed Time from Time Point Ref \cr
##'     LBTPTREF \tab Time Point Reference
##'   }
##' }
NULL
#> NULL

##' Laboratory Test Results Domain Supplemental Variables
##' @name SUPPLB
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name} \tab \strong{Variable Label} \cr
##'     STUDYID \tab Study Identifier \cr
##'     RDOMAIN  \tab Related Domain Abbreviation \cr
##'     USUBJID \tab Unique Subject Identifier \cr
##'     IDVAR \tab Identifying Variable \cr
##'     IDVARVAL \tab Identifying Variable Value \cr
##'     QNAM \tab Qualifier Variable Name \cr
##'     QLABEL \tab Qualifier Variable Label \cr
##'     QVAL \tab Data Value
##'   }
##' }
##' @note The following table enumerates the values in QNAM and QLABEL variables {
##'   \tabular{ll}{
##'     \strong{QNAM} \tab \strong{QLABEL} \cr
##'     LBSPECSB \tab Specimen Subtype \cr
##'     VISITMIN \tab Planned Visit Minimum Start Day \cr
##'     VISITMAX \tab Planned Visit Maximum Start Day
##'   }
##' }
NULL
#> NULL

#' Subject Visits Domain
#' 
#' @name Subject Visits Domain
#' @description Actual subject visits data of an ImmPort study is reformated to the CDISC SDTM Subject Visits (SV) 
#' domain model, and is a list of 2 data frames containing 1) Subject Visits data \code{\link{SV}} 
#' and 2) any supplemental Subject Visits data \code{\link{SUPP}}
NULL
#> NULL 

# Get Subject Visits data of a specific study
# 
# The function \code{getSubjectVisits} queries the ImmPort database for Subject Visits data and 
# reformats it to the CDISC SDTM Subject Visits (SV) domain model 
# 
# @param data_src A connection handle to ImmPort (MySQL or SQLite) database instance or 
# a directory handle to folder where study RDS files are located
# @param study_id Identifier of a specific study
# @return a list of 2 data frames containing 1) Subject Visits data \code{\link{SV}} and 2) any supplemental 
#   Subject Visits data \code{\link{SUPP}}
# @examples
# \dontrun{
#   getSubjectVisits(data_src, "SDY1")
# }
getSubjectVisits <- function(data_src, study_id) {
    cat("loading Subject Visits data....")

    sv_cols <- c("STUDYID", "DOMAIN", "USUBJID", "VISITNUM", "VISIT", "SVSTDY")
  
    subjectVisitsSQL <- paste("SELECT distinct
                                av.study_accession,
                                \"SV\" as domain,
                                av.subject_accession,
                                pv.order_number,
                                pv.visit_name,
                                av.study_day_visit_starts
                              FROM actual_visit av,
                                planned_visit pv
                              WHERE av.planned_visit_accession = pv.planned_visit_accession AND 
                                av.study_accession in ('", study_id, "')
                              ORDER BY av.subject_accession", sep = "")
    
    if ((class(data_src)[1] == 'MySQLConnection') || 
        (class(data_src)[1] == 'SQLiteConnection')) {
      sv_df <- dbGetQuery(data_src, statement = subjectVisitsSQL)
      colnames(sv_df) <- sv_cols
      suppsv_df <- data.frame()
      if (nrow(sv_df) > 0) {
      }
    } else {
      l <- loadSerializedStudyData(data_src, study_id, "Subject Visits")
      sv_df <- l[[1]]
      suppsv_df <- l[[2]]
    }
    
    cat("done", "\n")
    
    sv_l <- list()
    if (nrow(sv_df) > 0)
      sv_l <- list(sv_df=sv_df, suppsv_df=suppsv_df)
    
    sv_l
}

# Get count of Subject Visits data of a specific study
# 
# The function \code{getCountOfSubjectVisits} queries the ImmPort database for count 
# of Subject Visits data 
# 
# @param conn A connection handle to ImmPort database instance
# @param study_id Identifier of a specific study
# @return a count of Subject Visits data 
# @examples
# \dontrun{
#   # get count of study SDY1's Subject Visits data
#   count <- getCountOfSubjectVisits(conn, "SDY1")
# }
getCountOfSubjectVisits <- function(conn, study_id) {
    sql_stmt <- paste("SELECT count(*)
                      FROM actual_visit av,
                        planned_visit pv
                      WHERE av.planned_visit_accession = pv.planned_visit_accession
                        AND av.study_accession in ('", study_id, "')", sep = "")
    
    count <- dbGetQuery(conn, statement = sql_stmt)
    
    count[1, 1]
} 

##' Subject Visits Domain Variables
##' @name SV
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name  } \tab \strong{Variable Label} \cr
##'     STUDYID \tab Study Identifier \cr
##'     DOMAIN  \tab Domain Abbreviation \cr
##'     USUBJID \tab Unique Subject Identifier \cr
##'     VISITNUM \tab Visit Number \cr
##'     VISIT \tab Visit Name \cr
##'     SVSTDY \tab Study Day of Start of Visit
##'   }
##' }
NULL
#> NULL 

#' Trial Visits Domain
#' 
#' @name Trial Visits Domain
#' @description Information on the planned visits of an ImmPort study is reformated to the CDISC SDTM Trial Visits (TV) 
#' domain model, and is a list of 2 data frames containing 1) Trial Visits data \code{\link{TV}} 
#' and 2) any supplemental Trial Visits data \code{\link{SUPP}}
NULL
#> NULL 

# Get Trial Visits data of a specific study
# 
# The function \code{getTrialVisits} queries the ImmPort database for Trial Visits data and 
# reformats it to the CDISC SDTM Trial Visits (TV) domain model 
# 
# @param data_src A connection handle to ImmPort (MySQL or SQLite) database instance or 
# a directory handle to folder where study RDS files are located
# @param study_id Identifier of a specific study
# @return a list of 2 data frames containing 1) Trial Visits data \code{\link{TV}} and 2) any supplemental 
#   Trial Visits data \code{\link{SUPP}}
# @examples
# \dontrun{
#   getTrialVisits(data_src, "SDY1")
# }
getTrialVisits <- function(data_src, study_id) {
  cat("loading Trial Visits data....")
  
  tv_cols <- c("STUDYID", "DOMAIN", "VISITNUM", "VISIT", "ARMCD", "ARM", "TVSTRL", "TVENRL")
  
  trialVisitsSQL <- paste("SELECT distinct
                            pv.study_accession,
                            \"TV\" as domain,
                            pv.order_number,
                            pv.name,
                            ac.arm_accession,
                            ac.name,
                            pv.start_rule,
                            pv.end_rule
                            FROM planned_visit pv
                            INNER JOIN
                            planned_visit_2_arm pv2a ON pv2a.planned_visit_accession=pv.planned_visit_accession
                            INNER JOIN
                            arm_or_cohort ac ON ac.arm_accession=pv2a.arm_accession
                            WHERE pv.study_accession in ('", study_id, "')
                            ORDER BY pv.order_number", sep = "")
  
  if ((class(data_src)[1] == 'MySQLConnection') || 
      (class(data_src)[1] == 'SQLiteConnection')) {
    tv_df <- dbGetQuery(data_src, statement = trialVisitsSQL)
    colnames(tv_df) <- tv_cols
    supptv_df <- data.frame()
    if (nrow(tv_df) > 0) {
    }
  } else {
    l <- loadSerializedStudyData(data_src, study_id, "Trial Visits")
    tv_df <- l[[1]]
    supptv_df <- l[[2]]
  }
  
  cat("done", "\n")
  
  tv_l <- list()
  if (nrow(tv_df) > 0)
    tv_l <- list(tv_df=tv_df, supptv_df=supptv_df)
  
  tv_l
}

# Get count of Trial Visits data of a specific study
# 
# The function \code{getCountOfTrialVisits} queries the ImmPort database for count 
# of Trial Visits data 
# 
# @param conn A connection handle to ImmPort database instance
# @param study_id Identifier of a specific study
# @return a count of Trial Visits data 
# @examples
# \dontrun{
#   # get count of study SDY1's Trial Visits data
#   count <- getCountOfTrialVisits(conn, "SDY1")
# }
getCountOfTrialVisits <- function(conn, study_id) {
  sql_stmt <- paste("SELECT count(*)
                    FROM planned_visit pv
                    WHERE pv.study_accession in ('", study_id, "')", sep = "")
  
  count <- dbGetQuery(conn, statement = sql_stmt)
  
  count[1, 1]
} 

##' Trial Visits Domain Variables
##' @name TV
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name  } \tab \strong{Variable Label} \cr
##'     STUDYID \tab Study Identifier \cr
##'     DOMAIN  \tab Domain Abbreviation \cr
##'     VISITNUM \tab Visit Number \cr
##'     VISIT \tab Visit Name \cr
##'     ARMCD \tab Planned Arm Code \cr
##'     ARM \tab Name of Planned Arm \cr
##'     TVSTRL \tab Visit Start Rule \cr
##'     TVENRL \tab Visit End Rule
##'   }
##' }
NULL
#> NULL 

domain_names_codes <- c(
  c("Adverse Events", "AE"),
  c("Concomitant Medications", "CM"),
  c("Demographics", "DM"),
  c("Exposure", "EX"),
  c("Medical History", "MH"),
  c("Associated Persons Medical History", "APMH"),
  c("Laboratory Test Results", "LB"),
  c("Physical Examination", "PE"),
  c("Protocol Deviations", "DV"),
  c("Trial Arms", "TA"),
  c("Trial Visits", "TV"),
  c("Trial Inclusion Exclusion Criteria", "TI"),
  c("Trial Summary", "TS"),
  c("Substance Use", "SU"),
  c("Vital Signs", "VS"),
  c("Questionnaires", "QS"),
  c("Findings About", "FA"),
  c("Skin Response", "SR"),
  c("Genetics Findings", "PF"),
  c("Protein Quantification", "ZA"),
  c("Cellular Quantification", "ZB"),
  c("Nucleic Acid Quantification", "ZC"),
  c("Titer Assay Results", "ZD")
)

RImmPort.env <- new.env()
.datatable.aware=TRUE

domain_info <- structure(data.frame(
  matrix(unlist(domain_names_codes),length(domain_names_codes)/2,2,TRUE), stringsAsFactors = FALSE),
  names=c("Domain Name","Domain Code"))

##' Set ImmPort data ource
##' 
##' The function \code{setImmPortDataSource} sets the data source variable in RImmPort environment, 
##' to the connection handle to the MySQL or SQLite database, or to the file directory where the 
##' pre-created RImmPort-formatted files are stored.
##' 
##' @param data_src A connection handle to ImmPort (MySQL or SQLite) database instance or 
##' a directory handle to folder where study RImmPort-formatted (.rds) files located
##' @return 1 if successful
##' @examples
##' library(DBI)
##' library(sqldf)
##' studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")
##' db_dir <- file.path(studies_dir, "Db")
##' sqlite_conn <- dbConnect(SQLite(), dbname=file.path(db_dir, "ImmPort.sqlite"))
##' setImmPortDataSource(sqlite_conn)
##' @importFrom utils unzip
##' @export
setImmPortDataSource <- function(data_src){
  RImmPort.env$data_src <- data_src
  
  if (class(data_src) == "character") {
    if (file.exists(data_src) == FALSE) {
      stop("data source = ", data_src, " not found")
    }  
    # unzip study files into data directory
    zipfiles <- list.files(path = data_src, pattern = "\\.zip$")
    for (zf in zipfiles) {
      unzip(file.path(data_src, zf), exdir = data_src)
    }
  }
  
  return(1)
}

##' Special Purpose class
##' 
##' @field dm_l Demographics data \code{\link{DM}} and supplemental Demographics data \code{\link{SUPP}}
##' @examples
##' library(DBI)
##' library(sqldf)
##' studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")
##' db_dir <- file.path(studies_dir, "Db")
##' sqlite_conn <- dbConnect(SQLite(), dbname=file.path(db_dir, "ImmPort.sqlite"))
##' setImmPortDataSource(sqlite_conn)
##' sdy139 <- getStudy("SDY139")
##' dm_df <- sdy139$special_purpose$dm_l$dm_df
##' @importFrom methods  setRefClass
##' @importFrom methods  new
##' @export SpecialPurpose
##' @exportClass SpecialPurpose
SpecialPurpose <- setRefClass("SpecialPurpose", 
                              fields = list( 
                                dm_l="list"
                              ),
                              methods = list(
                                getSpecialPurpose = function(data_src, study_id) {
                                  dm_l <<- getDemographics(data_src, study_id)
                                }
                              ))
##' Interventions class
##' 
##' @field cm_l Concomitant Medications data \code{\link{CM}} and supplemental Concomitant Medications data \code{\link{SUPP}}
##' @field ex_l Exposure data \code{\link{EX}} and supplemental Exposure data \code{\link{SUPP}}
##' @field su_l Substance Use data \code{\link{SU}} and supplemental Substance Use data \code{\link{SUPP}}
##' @examples
##' library(DBI)
##' library(sqldf)
##' studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")
##' db_dir <- file.path(studies_dir, "Db")
##' sqlite_conn <- dbConnect(SQLite(), dbname=file.path(db_dir, "ImmPort.sqlite"))
##' setImmPortDataSource(sqlite_conn)
##' sdy139 <- getStudy("SDY139")
##' cm_df <- sdy139$interventions$cm_l$cm_df
##' @export Interventions
##' @exportClass Interventions
Interventions <- setRefClass("Interventions", 
                             fields = list(
                               cm_l="list",
                               ex_l="list",
                               su_l="list"
                             ),
                             methods = list(
                               getInterventions = function(data_src, study_id) {
                                 cm_l <<- getConcomitantMedications(data_src, study_id)
                                 ex_l <<- getExposure(data_src, study_id)
                                 su_l <<- getSubstanceUse(data_src, study_id)
                               }
                             ))
##' Events class
##' 
##' @field ae_l Adverse Events data \code{\link{AE}} and supplemental Adverse Events data \code{\link{SUPP}}
##' @field dv_l Protocol Deviations data \code{\link{DV}} and supplemental Protocol Deviations data \code{\link{SUPPDV}}
##' @field mh_l Medical History data \code{\link{MH}} and supplemental Medical History data \code{\link{SUPPMH}}
##' @field apmh_l Associated Persons Medical History data \code{\link{APMH}} and supplemental Associated Persons Medical History data \code{\link{SUPP}}
##' @examples
##' library(DBI)
##' library(sqldf)
##' studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")
##' db_dir <- file.path(studies_dir, "Db")
##' sqlite_conn <- dbConnect(SQLite(), dbname=file.path(db_dir, "ImmPort.sqlite"))
##' setImmPortDataSource(sqlite_conn)
##' sdy139 <- getStudy("SDY139")
##' ae_df <- sdy139$events$ae_l$ae_df
##' @export Events
##' @exportClass Events
Events <- setRefClass("Events", fields = list(
  ae_l="list",
  dv_l="list",
  mh_l="list",
  apmh_l="list"
),
methods = list(
  getEvents = function(data_src, study_id) {
    ae_l <<- getAdverseEvents(data_src, study_id)
    dv_l <<- getProtocolDeviations(data_src, study_id)
    mh_l <<- getMedicalHistory(data_src, study_id)
    apmh_l <<- getAssociatedPersonsMedicalHistory(data_src, study_id)
  }
))
##' Findings class
##' 
##' @field lb_l Laboratory Test Results data \code{\link{LB}} and supplemental Laboratory Test Results data \code{\link{SUPPLB}}
##' @field pe_l Physical Examination data \code{\link{PE}} and supplemental Physical Examination data \code{\link{SUPPPE}}
##' @field vs_l Vital Signs data \code{\link{VS}} and supplemental Vital Signs data \code{\link{SUPPVS}}
##' @field qs_l Questionnaires data \code{\link{QS}} and supplemental Questionnaires data \code{\link{SUPP}}
##' @field fa_l Findings About data \code{\link{FA}} and supplemental Findings About data \code{\link{SUPPFA}}
##' @field sr_l Skin Response data \code{\link{SR}} and supplemental Skin Response data \code{\link{SUPP}}
##' @field pf_l Genetics Findings data \code{\link{PF}} and supplemental Genetics Findings data \code{\link{SUPPPF}}
##' @field za_l Protein Quantification data \code{\link{ZA}} and supplemental Protein Quantification data \code{\link{SUPPZA}}
##' @field zb_l Cellular Quantification data \code{\link{ZB}} and supplemental Cellular Quantification data \code{\link{SUPP}}
##' @field zc_l Nucleic Acid Quantification data \code{\link{ZC}} and supplemental Nucleic Acid Quantification data \code{\link{SUPP}}
##' @field zd_l Titer Assay Results data \code{\link{ZD}} and supplemental Titer Assay Results data \code{\link{SUPP}}
##' @examples
##' library(DBI)
##' library(sqldf)
##' studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")
##' db_dir <- file.path(studies_dir, "Db")
##' sqlite_conn <- dbConnect(SQLite(), dbname=file.path(db_dir, "ImmPort.sqlite"))
##' setImmPortDataSource(sqlite_conn)
##' sdy139 <- getStudy("SDY139")
##' zb_df <- sdy139$findings$zb_l$zb_df
##' @export Findings
##' @exportClass Findings
Findings <- setRefClass("Findings", 
                        fields = list(
                          lb_l="list",
                          pe_l="list",
                          vs_l="list",
                          qs_l="list",
                          fa_l="list",
                          sr_l="list",
                          pf_l="list",
                          za_l="list",
                          zb_l="list",
                          zc_l="list",
                          zd_l="list"
                        ),
                        methods = list(
                          getFindings = function(data_src, study_id) {
                            lb_l <<- getLaboratoryTestResults(data_src, study_id)
                            pe_l <<- getPhysicalExamination(data_src, study_id)
                            vs_l <<- getVitalSigns(data_src, study_id)
                            qs_l <<- getQuestionnaires(data_src, study_id)
                            fa_l <<- getFindingsAbout(data_src, study_id)
                            sr_l <<- getSkinResponse(data_src, study_id)
                            pf_l <<- getGeneticsFindings(data_src, study_id)
                            za_l <<- getProteinQuantification(data_src, study_id)
                            zb_l <<- getCellularQuantification(data_src, study_id)
                            zc_l <<- getNucleicAcidQuantification(data_src, study_id)
                            zd_l <<- getTiterAssayResults(data_src, study_id)
                          }
                        ))
##' Trial Design class
##' 
##' @field ta_l Trial Arms data \code{\link{TA}} and supplemental Trial Arms data \code{\link{SUPP}}
##' @field tv_l Trial Visits data \code{\link{TA}} and supplemental Trial Visits data \code{\link{SUPP}}
##' @field ti_l Trial Inclusion Exclusion Criteria data \code{\link{TI}} and supplemental Trial Inclusion Exclusion Criteria data \code{\link{SUPP}}
##' @field ts_l Trial Summary data \code{\link{TS}} and supplemental Trial Summary data \code{\link{SUPP}}
##' @examples
##' library(DBI)
##' library(sqldf)
##' studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")
##' db_dir <- file.path(studies_dir, "Db")
##' sqlite_conn <- dbConnect(SQLite(), dbname=file.path(db_dir, "ImmPort.sqlite"))
##' setImmPortDataSource(sqlite_conn)
##' sdy139 <- getStudy("SDY139")
##' ts_df <- sdy139$trial_design$ts_l$ts_df
##' @export TrialDesign
##' @exportClass TrialDesign
TrialDesign <- setRefClass("TrialDesign", 
                           fields = list(
                             ta_l="list",
                             tv_l="list",
                             ti_l="list",
                             ts_l="list"
                           ),
                           methods = list(
                             getTrialDesign = function(data_src, study_id) {
                               ta_l <<- getTrialArms(data_src, study_id)
                               tv_l <<- getTrialVisits(data_src, study_id)
                               ti_l <<- getTrialInclusionExclusionCriteria(data_src, study_id)
                               ts_l <<- getTrialSummary(data_src, study_id)
                             }
                           ))

##' Study class
##' 
##' @field special_purpose \code{\link{SpecialPurpose}} 
##' @field interventions \code{\link{Interventions}} 
##' @field events \code{\link{Events}} 
##' @field findings \code{\link{Findings}} 
##' @field trial_design \code{\link{TrialDesign}} 
##' @examples
##' library(DBI)
##' library(sqldf)
##' studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")
##' db_dir <- file.path(studies_dir, "Db")
##' sqlite_conn <- dbConnect(SQLite(), dbname=file.path(db_dir, "ImmPort.sqlite"))
##' setImmPortDataSource(sqlite_conn)
##' sdy139 <- getStudy("SDY139")
##' @importFrom plyr ldply
##' @export Study
##' @exportClass Study
Study <- setRefClass("Study", fields = list(
  special_purpose="SpecialPurpose",
  interventions="Interventions",
  events="Events",
  findings="Findings",
  trial_design="TrialDesign"),
  methods = list(
    getTableOfContents = function() {
      contents_l <- list(
        r1=list(c1="Special Purpose", c2="Demographics", c3=""), 
        r4=list(c1="Interventions", c2="Concomitant Medications", c3=""), 
        r5=list(c1="Interventions", c2="Exposure", c3=""), 
        r7=list(c1="Interventions", c2="Substance Use", c3=""), 
        r8=list(c1="Events", c2="Adverse Events", c3=""), 
        r11=list(c1="Events", c2="Protocol Deviations", c3=""), 
        r13=list(c1="Events", c2="Medical History", c3=""), 
        r14=list(c1="Events", c2="Associated Persons Medical History", c3=""), 
        r20=list(c1="Findings", c2="Laboratory Test Results", c3=""),  
        r29=list(c1="Findings", c2="Vital Signs", c3=""), 
        r3o=list(c1="Findings", c2="Questionnaires", c3=""), 
        r31=list(c1="Findings", c2="Findings About", c3=""), 
        r32=list(c1="Findings", c2="Skin Response", c3=""), 
        r33=list(c1="Findings", c2="Physical Examination", c3=""), 
        r34=list(c1="Findings", c2="Genetics Findings", c3=""), 
        r35=list(c1="Findings", c2="Protein Quantification", c3=""), 
        r36=list(c1="Findings", c2="Cellular Quantification", c3=""), 
        r37=list(c1="Findings", c2="Nucleic Acid Quantification", c3=""), 
        r38=list(c1="Findings", c2="Titer Assay Results", c3=""), 
        r45=list(c1="Trial Design", c2="Trial Inclusion Exclusion Criteria", c3=""), 
        r46=list(c1="Trial Design", c2="Trial Arms", c3=""), 
        r47=list(c1="Trial Design", c2="Trial Visits", c3=""), 
        r48=list(c1="Trial Design", c2="Trial Summary", c3=""))
      
      contents_df <- ldply (contents_l, data.frame, stringsAsFactors = FALSE)
      
      contents_df$.id <- NULL
      colnames(contents_df) <- c("Class", "Domain", "Included?")
      
      
      
      if (length(special_purpose$dm_l) > 0)
        contents_df[contents_df$Domain == "Demographics",3] <- "yes"
      if (length(interventions$cm_l) > 0)
        contents_df[contents_df$Domain == "Concomitant Medications",3] <- "yes"
      if (length(interventions$ex_l) > 0)
        contents_df[contents_df$Domain == "Exposure",3] <- "yes"
      if (length(interventions$su_l) > 0)
        contents_df[contents_df$Domain == "Substance Use",3] <- "yes"
      if (length(events$ae_l) > 0)
        contents_df[contents_df$Domain == "Adverse Events",3] <- "yes"
      if (length(events$dv_l) > 0)
        contents_df[contents_df$Domain == "Protocol Deviations",3] <- "yes"
      if (length(events$mh_l) > 0)
        contents_df[contents_df$Domain == "Medical History",3] <- "yes"
      if (length(events$apmh_l) > 0)
        contents_df[contents_df$Domain == "Associated Persons Medical History",3] <- "yes"
      if (length(findings$lb_l) > 0)
        contents_df[contents_df$Domain == "Laboratory Test Results",3] <- "yes"
      if (length(findings$vs_l) > 0)
        contents_df[contents_df$Domain == "Vital Signs",3] <- "yes"
      if (length(findings$qs_l) > 0)
        contents_df[contents_df$Domain == "Questionnaires",3] <- "yes"
      if (length(findings$fa_l) > 0)
        contents_df[contents_df$Domain == "Findings About",3] <- "yes"
      if (length(findings$sr_l) > 0)
        contents_df[contents_df$Domain == "Skin Response",3] <- "yes"
      if (length(findings$pe_l) > 0)
        contents_df[contents_df$Domain == "Physical Examination",3] <- "yes"
      if (length(findings$pf_l) > 0)
        contents_df[contents_df$Domain == "Genetics Findings",3] <- "yes"
      if (length(findings$za_l) > 0)
        contents_df[contents_df$Domain == "Protein Quantification",3] <- "yes"      
      if (length(findings$zb_l) > 0)
        contents_df[contents_df$Domain == "Cellular Quantification",3] <- "yes"
      if (length(findings$zc_l) > 0)
        contents_df[contents_df$Domain == "Nucleic Acid Quantification",3] <- "yes"
      if (length(findings$zd_l) > 0)
        contents_df[contents_df$Domain == "Titer Assay Results",3] <- "yes"
      if (length(trial_design$ti_l) > 0)
        contents_df[contents_df$Domain == "Trial Inclusion Exclusion Criteria",3] <- "yes"      
      if (length(trial_design$ta_l) > 0)
        contents_df[contents_df$Domain == "Trial Arms",3] <- "yes"
      if (length(trial_design$tv_l) > 0)
        contents_df[contents_df$Domain == "Trial Visits",3] <- "yes"
      if (length(trial_design$ts_l) > 0)
        contents_df[contents_df$Domain == "Trial Summary",3] <- "yes"
      
      contents_df
    }
  ))

########################################################################


########################################################################

##' Get all data of a specific study from the ImmPort data source
##' 
##' The function \code{getStudy} queries the ImmPort data source for data of a specific study in 
##' all domains. The data is then structured into \code{Study} as classes, domains, variables and values.
##' 
##' @param study_id Identifier of a specific study
##' @return A study data object where in all data are structured as classes, domains, variables and values (in CDISC format)
##' @examples
##' library(DBI)
##' library(sqldf)
##' studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")
##' db_dir <- file.path(studies_dir, "Db")
##' sqlite_conn <- dbConnect(SQLite(), dbname=file.path(db_dir, "ImmPort.sqlite"))
##' setImmPortDataSource(sqlite_conn)
##' sdy139 <- getStudy("SDY139")
##' @export
getStudy <- function(study_id) {
  if (exists("data_src", envir = RImmPort.env)) {
    r <- get("data_src", envir = RImmPort.env)
  } else {
    stop("ImmPort data source is not set: See ?setImmPortDataSource() ")
  }
  
#   if (is.null(r <- get0("data_src", envir = RImmPort.env))) {
#     stop("ImmPort data source is not set: See ?setImmPortDataSource() ")
#   }
  
  data_src <- RImmPort.env$data_src
  
  cat("loading Study ID = ", study_id, "\n")
  
  study <- Study$new()
  
  study$special_purpose$getSpecialPurpose(data_src, study_id)
  study$interventions$getInterventions(data_src, study_id) 
  study$events$getEvents(data_src, study_id)
  study$findings$getFindings(data_src, study_id)
  study$trial_design$getTrialDesign(data_src, study_id)  
  
  cat("done loading Study ID = ", study_id, "\n")
  
  study
}

##' Get names of all domains and their codes
##' 
##' The function \code{getListOfDomains} returns a list of all domain names and codes
##' 
##' @return A list of of all domain names and codes
##' @examples
##'  domains_df <- getListOfDomains()
##' @export
getListOfDomains <- function() {
  domain_info
}

##' Get code of a specific domain 
##' 
##' The function \code{getListOfDomains} returns the code of a specific domain
##' 
##' @param domain Name of a specific domain
##' @return A list of of all domain names and codes
##' @examples
##'  domain <- "Demographics"
##'  code <- getDomainCode(domain)
##' @export
getDomainCode <- function(domain) {
  domain_info[which(domain_info[,1]==domain), 2]
}

##' Get specific domain data of one or more studies from the ImmPort database
##' 
##' @param domain Name of a specific domain
##' @param study_ids List of study indentifiers
##' @return a list of 1) domain data and 2) supplemental domain data of the studies
##' @examples
##' library(DBI)
##' library(sqldf)
##' studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")
##' db_dir <- file.path(studies_dir, "Db")
##' sqlite_conn <- dbConnect(SQLite(), dbname=file.path(db_dir, "ImmPort.sqlite"))
##' setImmPortDataSource(sqlite_conn)
##' dm_df <- getDomainDataOfStudies("Demographics", "SDY139")
##' @export
getDomainDataOfStudies <- function(domain, study_ids) {
  if (exists("data_src", envir = RImmPort.env)) {
    r <- get("data_src", envir = RImmPort.env)
  } else {
    stop("ImmPort data source is not set: See ?setImmPortDataSource() ")
  }

#   if (is.null(r <- get0("data_src", envir = RImmPort.env))) {
#     stop("ImmPort data source is not set: See ?setImmPortDataSource() ")
#   }
  
  data_src <- RImmPort.env$data_src
  
  if (domain %in% getListOfDomains()[,'Domain Name'] == FALSE) {
    stop(paste("domain = ", domain, " is not found in the list of supported domains; 
               Run getListOfDomains() for a complete list"))
  }
  
  data_l= list()
  data_df = data.frame()
  switch (domain,          
          "Adverse Events" = {
            data_l <- getAdverseEventsOfStudies(data_src, study_ids)
          },
          "Concomitant Medications" = {
            data_l <- getConcomitantMedicationsOfStudies(data_src, study_ids)
          },
          "Demographics" = {
            data_l <- getDemographicsOfStudies(data_src, study_ids)
          },
          "Exposure" = {
            data_l <- getExposureOfStudies(data_src, study_ids)
          },
          "Laboratory Test Results" = {
            data_l <- getLaboratoryTestResultsOfStudies(data_src, study_ids)
          },
          "Medical History" = {
            data_l <- getMedicalHistoryOfStudies(data_src, study_ids)
          },
          "Associated Persons Medical History" = {
            data_l <- getAssociatedPersonsMedicalHistoryOfStudies(data_src, study_ids)
          },
          "Physical Examination" = {
            data_l <- getPhysicalExaminationOfStudies(data_src, study_ids)
          },
          "Protocol Deviations" = {
            data_l <- getProtocolDeviationsOfStudies(data_src, study_ids)
          },
          "Trial Arms" = {
            data_l <- getTrialArmsOfStudies(data_src, study_ids)
          },
          "Trial Visits" = {
            data_l <- getTrialVisitsOfStudies(data_src, study_ids)
          },
          "Trial Inclusion Exclusion Criteria" = {
            data_l <- getTrialInclusionExclusionCriteriaOfStudies(data_src, study_ids)
          },
          "Trial Summary" = {
            data_l <- getTrialSummaryOfStudies(data_src, study_ids)
          },
          "Substance Use" = {
            data_l <- getSubstanceUseOfStudies(data_src, study_ids)
          },
          "Vital Signs" = {
            data_l <- getVitalSignsOfStudies(data_src, study_ids)
          },
          "Questionnaires" = {
            data_l <- getQuestionnairesOfStudies(data_src, study_ids)
          },
          "Findings About" = {
            data_l <- getFindingsAboutOfStudies(data_src, study_ids)
          },
          "Skin Response" = {
            data_l <- getSkinResponseOfStudies(data_src, study_ids)
          },
          "Genetics Findings" = {
            data_l <- getGeneticsFindingsOfStudies(data_src, study_ids)
          },
          "Protein Quantification" = {
            data_l <- getProteinQuantificationOfStudies(data_src, study_ids)
          },
          "Cellular Quantification" = {
            data_l <- getCellularQuantificationOfStudies(data_src, study_ids)
          },
          "Nucleic Acid Quantification" = {
            data_l <- getNucleicAcidQuantificationOfStudies(data_src, study_ids)
          },
          "Titer Assay Results" = {
            data_l <- getTiterAssayResultsOfStudies(data_src, study_ids)
          }
  )
  data_l
  }

getAdverseEventsOfStudies <- function(data_src, study_ids) {
  data_df <- data.frame()
  suppdata_df <- data.frame()
  for (study_id in study_ids) {
    data_l <- getAdverseEvents(data_src, study_id)
    if (length(data_l) > 0) {
      data_df <- rbind(data_df, data_l[[1]])
      suppdata_df <- rbind(suppdata_df, data_l[[2]])
    }
  }
  
  data_l <- list()
  if (nrow(data_df) > 0)
    data_l <- list(ae_df=data_df, suppae_df=suppdata_df)
  
  data_l
}

getTrialArmsOfStudies <- function(data_src, study_ids) {
  data_df <- data.frame()
  suppdata_df <- data.frame()
  for (study_id in study_ids) {
    data_l <- getTrialArms(data_src, study_id)
    if (length(data_l) > 0) {
      data_df <- rbind(data_df, data_l[[1]])
      suppdata_df <- rbind(suppdata_df, data_l[[2]])
    }
  }
  
  data_l <- list()
  if (nrow(data_df) > 0)
    data_l <- list(ta_df=data_df, suppta_df=suppdata_df)
  
  data_l
}

getTrialVisitsOfStudies <- function(data_src, study_ids) {
  data_df <- data.frame()
  suppdata_df <- data.frame()
  for (study_id in study_ids) {
    data_l <- getTrialVisits(data_src, study_id)
    if (length(data_l) > 0) {
      data_df <- rbind(data_df, data_l[[1]])
      suppdata_df <- rbind(suppdata_df, data_l[[2]])
    }
  }
  
  data_l <- list()
  if (nrow(data_df) > 0)
    data_l <- list(tv_df=data_df, supptv_df=suppdata_df)
  
  data_l
}

getConcomitantMedicationsOfStudies <- function(data_src, study_ids) {
  data_df <- data.frame()
  suppdata_df <- data.frame()
  for (study_id in study_ids) {
    data_l <- getConcomitantMedications(data_src, study_id)
    if (length(data_l) > 0) {
      data_df <- rbind(data_df, data_l[[1]])
      suppdata_df <- rbind(suppdata_df, data_l[[2]])
    }
  }
  
  data_l <- list()
  if (nrow(data_df) > 0)
    data_l <- list(cm_df=data_df, suppcm_df=suppdata_df)
  
  data_l
}

getDemographicsOfStudies <- function(data_src, study_ids) {
  data_df <- data.frame()
  suppdata_df <- data.frame()
  for (study_id in study_ids) {
    data_l <- getDemographics(data_src, study_id)
    if (length(data_l) > 0) {
      data_df <- rbind(data_df, data_l[[1]])
      suppdata_df <- rbind(suppdata_df, data_l[[2]])
    }
  }
  
  data_l <- list()
  if (nrow(data_df) > 0)
    data_l <- list(dm_df=data_df, suppdm_df=suppdata_df)
  
  data_l
}

getTrialInclusionExclusionCriteriaOfStudies <- function(data_src, study_ids) {
  data_df <- data.frame()
  suppdata_df <- data.frame()
  for (study_id in study_ids) {
    data_l <- getTrialInclusionExclusionCriteria(data_src, study_id)
    if (length(data_l) > 0) {
      data_df <- rbind(data_df, data_l[[1]])
      suppdata_df <- rbind(suppdata_df, data_l[[2]])
    }
  }
  
  data_l <- list()
  if (nrow(data_df) > 0)
    data_l <- list(ti_df=data_df, suppti_df=suppdata_df)
  
  data_l
}

getExposureOfStudies <- function(data_src, study_ids) {
  data_df <- data.frame()
  suppdata_df <- data.frame()
  for (study_id in study_ids) {
    data_l <- getExposure(data_src, study_id)
    if (length(data_l) > 0) {
      data_df <- rbind(data_df, data_l[[1]])
      suppdata_df <- rbind(suppdata_df, data_l[[2]])
    }
  }
  
  data_l <- list()
  if (nrow(data_df) > 0)
    data_l <- list(ex_df=data_df, suppex_df=suppdata_df)
  
  data_l
}

getLaboratoryTestResultsOfStudies <- function(data_src, study_ids) {
  data_df <- data.frame()
  suppdata_df <- data.frame()
  for (study_id in study_ids) {
    data_l <- getLaboratoryTestResults(data_src, study_id)
    if (length(data_l) > 0) {
      data_df <- rbind(data_df, data_l[[1]])
      suppdata_df <- rbind(suppdata_df, data_l[[2]])
    }
  }
  
  data_l <- list()
  if (nrow(data_df) > 0)
    data_l <- list(lb_df=data_df, supplb_df=suppdata_df)
  
  data_l
}

getMedicalHistoryOfStudies <- function(data_src, study_ids) {
  data_df <- data.frame()
  suppdata_df <- data.frame()
  for (study_id in study_ids) {
    data_l <- getMedicalHistory(data_src, study_id)
    if (length(data_l) > 0) {
      data_df <- rbind(data_df, data_l[[1]])
      suppdata_df <- rbind(suppdata_df, data_l[[2]])
    }
  }
  
  data_l <- list()
  if (nrow(data_df) > 0)
    data_l <- list(mh_df=data_df, suppmh_df=suppdata_df)
  
  data_l
}

getAssociatedPersonsMedicalHistoryOfStudies <- function(data_src, study_ids) {
  data_df <- data.frame()
  suppdata_df <- data.frame()
  for (study_id in study_ids) {
    data_l <- getAssociatedPersonsMedicalHistory(data_src, study_id)
    if (length(data_l) > 0) {
      data_df <- rbind(data_df, data_l[[1]])
      suppdata_df <- rbind(suppdata_df, data_l[[2]])
    }
  }
  
  data_l <- list()
  if (nrow(data_df) > 0)
    data_l <- list(apmh_df=data_df, suppapmh_df=suppdata_df)
  
  data_l
}

getPhysicalExaminationOfStudies <- function(data_src, study_ids) {
  data_df <- data.frame()
  suppdata_df <- data.frame()
  for (study_id in study_ids) {
    data_l <- getPhysicalExamination(data_src, study_id)
    if (length(data_l) > 0) {
      data_df <- rbind(data_df, data_l[[1]])
      suppdata_df <- rbind(suppdata_df, data_l[[2]])
    }
  }
  
  data_l <- list()
  if (nrow(data_df) > 0)
    data_l <- list(pe_df=data_df, supppe_df=suppdata_df)
  
  data_l
}

getProtocolDeviationsOfStudies <- function(data_src, study_ids) {
  data_df <- data.frame()
  suppdata_df <- data.frame()
  for (study_id in study_ids) {
    data_l <- getProtocolDeviations(data_src, study_id)
    if (length(data_l) > 0) {
      data_df <- rbind(data_df, data_l[[1]])
      suppdata_df <- rbind(suppdata_df, data_l[[2]])
    }
  }
  
  data_l <- list()
  if (nrow(data_df) > 0)
    data_l <- list(dv_df=data_df, suppdv_df=suppdata_df)
  
  data_l
}

getTrialSummaryOfStudies <- function(data_src, study_ids) {
  data_df <- data.frame()
  suppdata_df <- data.frame()
  for (study_id in study_ids) {
    data_l <- getTrialSummary(data_src, study_id)
    if (length(data_l) > 0) {
      data_df <- rbind(data_df, data_l[[1]])
      suppdata_df <- rbind(suppdata_df, data_l[[2]])
    }
  }
  
  data_l <- list()
  if (nrow(data_df) > 0)
    data_l <- list(ts_df=data_df, suppts_df=suppdata_df)
  
  data_l
}


getSubstanceUseOfStudies <- function(data_src, study_ids) {
  data_df <- data.frame()
  suppdata_df <- data.frame()
  for (study_id in study_ids) {
    data_l <- getSubstanceUse(data_src, study_id)
    if (length(data_l) > 0) {
      data_df <- rbind(data_df, data_l[[1]])
      suppdata_df <- rbind(suppdata_df, data_l[[2]])
    }
  }
  
  data_l <- list()
  if (nrow(data_df) > 0)
    data_l <- list(su_df=data_df, suppsu_df=suppdata_df)
  
  data_l
}

getVitalSignsOfStudies <- function(data_src, study_ids) {
  data_df <- data.frame()
  suppdata_df <- data.frame()
  for (study_id in study_ids) {
    data_l <- getVitalSigns(data_src, study_id)
    if (length(data_l) > 0) {
      data_df <- rbind(data_df, data_l[[1]])
      suppdata_df <- rbind(suppdata_df, data_l[[2]])
    }
  }
  
  data_l <- list()
  if (nrow(data_df) > 0)
    data_l <- list(vs_df=data_df, suppvs_df=suppdata_df)
  
  data_l
}

getQuestionnairesOfStudies <- function(data_src, study_ids) {
  data_df <- data.frame()
  suppdata_df <- data.frame()
  for (study_id in study_ids) {
    data_l <- getQuestionnaires(data_src, study_id)
    if (length(data_l) > 0) {
      data_df <- rbind(data_df, data_l[[1]])
      suppdata_df <- rbind(suppdata_df, data_l[[2]])
    }
  }
  
  data_l <- list()
  if (nrow(data_df) > 0)
    data_l <- list(qs_df=data_df, suppqs_df=suppdata_df)
  
  data_l
}

getFindingsAboutOfStudies <- function(data_src, study_ids) {
  data_df <- data.frame()
  suppdata_df <- data.frame()
  for (study_id in study_ids) {
    data_l <- getFindingsAbout(data_src, study_id)
    if (length(data_l) > 0) {
      data_df <- rbind(data_df, data_l[[1]])
      suppdata_df <- rbind(suppdata_df, data_l[[2]])
    }
  }
  
  data_l <- list()
  if (nrow(data_df) > 0)
    data_l <- list(fa_df=data_df, suppfa_df=suppdata_df)
  
  data_l
}

getSkinResponseOfStudies <- function(data_src, study_ids) {
  data_df <- data.frame()
  suppdata_df <- data.frame()
  for (study_id in study_ids) {
    data_l <- getSkinResponse(data_src, study_id)
    if (length(data_l) > 0) {
      data_df <- rbind(data_df, data_l[[1]])
      suppdata_df <- rbind(suppdata_df, data_l[[2]])
    }
  }
  
  data_l <- list()
  if (nrow(data_df) > 0)
    data_l <- list(sr_df=data_df, suppsr_df=suppdata_df)
  
  data_l
}

getGeneticsFindingsOfStudies <- function(data_src, study_ids, assay_type="ALL") {
  data_df <- data.frame()
  suppdata_df <- data.frame()
  for (study_id in study_ids) {
    data_l <- getGeneticsFindings(data_src, study_id, assay_type)
    if (length(data_l) > 0) {
      data_df <- rbind(data_df, data_l[[1]])
      suppdata_df <- rbind(suppdata_df, data_l[[2]])
    }
  }
  
  data_l <- list()
  if (nrow(data_df) > 0)
    data_l <- list(pf_df=data_df, supppf_df=suppdata_df)
  
  data_l
}

getProteinQuantificationOfStudies <- function(data_src, study_ids, assay_type="ALL") {
  data_df <- data.frame()
  suppdata_df <- data.frame()
  for (study_id in study_ids) {
    data_l <- getProteinQuantification(data_src, study_id, assay_type)
    if (length(data_l) > 0) {
      data_df <- rbind(data_df, data_l[[1]])
      suppdata_df <- rbind(suppdata_df, data_l[[2]])
    }
  }
  
  data_l <- list()
  if (nrow(data_df) > 0)
    data_l <- list(za_df=data_df, suppza_df=suppdata_df)
  
  data_l
}

getCellularQuantificationOfStudies <- function(data_src, study_ids, assay_type="ALL") {
  data_df <- data.frame()
  suppdata_df <- data.frame()
  for (study_id in study_ids) {
    data_l <- getCellularQuantification(data_src, study_id, assay_type)
    if (length(data_l) > 0) {
      data_df <- rbind(data_df, data_l[[1]])
      suppdata_df <- rbind(suppdata_df, data_l[[2]])
    }
  }
  
  data_l <- list()
  if (nrow(data_df) > 0)
    data_l <- list(zb_df=data_df, suppzb_df=suppdata_df)
  
  data_l
}

getNucleicAcidQuantificationOfStudies <- function(data_src, study_ids, assay_type="ALL") {
  data_df <- data.frame()
  suppdata_df <- data.frame()
  for (study_id in study_ids) {
    data_l <- getNucleicAcidQuantification(data_src, study_id, assay_type)
    if (length(data_l) > 0) {
      data_df <- rbind(data_df, data_l[[1]])
      suppdata_df <- rbind(suppdata_df, data_l[[2]])
    }
  }
  
  data_l <- list()
  if (nrow(data_df) > 0)
    data_l <- list(zc_df=data_df, suppzc_df=suppdata_df)
  
  data_l
}

getTiterAssayResultsOfStudies <- function(data_src, study_ids, assay_type="ALL") {
  data_df <- data.frame()
  suppdata_df <- data.frame()
  for (study_id in study_ids) {
    data_l <- getTiterAssayResults(data_src, study_id, assay_type)
    if (length(data_l) > 0) {
      data_df <- rbind(data_df, data_l[[1]])
      suppdata_df <- rbind(suppdata_df, data_l[[2]])
    }
  }
  
  data_l <- list()
  if (nrow(data_df) > 0)
    data_l <- list(zd_df=data_df, suppzd_df=suppdata_df)
  
  data_l
}


##' Get a list of Assay Types
##' 
##' The function \code{getListOfAssayTypes} returns a list of assay types that ImmPort studies have employed in their experimetal assays
##' 
##' @return A list of assay types
##' @examples
##'  at_l <- getListOfAssayTypes()
##' @export
getListOfAssayTypes <- function() {
  assay_type <- c(
    "ELISA",
    "ELISPOT",    
    "Array",    
    "PCR",    
    "HLA Typing",    
    "MBAA",    
    "HAI", 
    "Neut Ab Titer",
    "Flow"
  )
  assay_type
}


##' Get specific assay data of one or more studies from the ImmPort database
##' 
##' @param assay_type Assay Type
##' @param study_ids List of study indentifiers
##' @return a list of 1) domain data of specicifc assay technology and 2) any supplemental domain data of the studies
##' @author Ravi Shankar
##' @examples
##' library(DBI)
##' library(sqldf)
##' studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")
##' db_dir <- file.path(studies_dir, "Db")
##' sqlite_conn <- dbConnect(SQLite(), dbname=file.path(db_dir, "ImmPort.sqlite"))
##' setImmPortDataSource(sqlite_conn)
##' elispot_l <- getAssayDataOfStudies("SDY139", "ELISPOT")
##' if (length(elispot_l) > 0)
##'   names(elispot_l)
##' head(elispot_l$zb_df)
##' @export
getAssayDataOfStudies <- function(study_ids, assay_type) {
  if (exists("data_src", envir = RImmPort.env)) {
    r <- get("data_src", envir = RImmPort.env)
  } else {
    stop("ImmPort data source is not set: See ?setImmPortDataSource() ")
  }
  
#   if (is.null(r <- get0("data_src", envir = RImmPort.env))) {
#     stop("ImmPort data source is not set: See ?setImmPortDataSource() ")
#   }
  
  data_src <- RImmPort.env$data_src
  
  if (assay_type %in% getListOfAssayTypes() == FALSE) {
    stop("assay type is not found in the list of supported assay types; 
         Run getListOfAssayTypes() for a complete list")
  }
  
  pq_l <- getProteinQuantificationOfStudies(data_src, study_ids, assay_type)
  cq_l <- getCellularQuantificationOfStudies(data_src, study_ids, assay_type)
  nq_l <- getNucleicAcidQuantificationOfStudies(data_src, study_ids, assay_type)
  ta_l <- getTiterAssayResultsOfStudies(data_src, study_ids, assay_type)
  gf_l <- getGeneticsFindingsOfStudies(data_src, study_ids, assay_type)
  
  data_l <- c(pq_l, cq_l, nq_l, ta_l, gf_l)
  
  data_l
  }


########################################################################
##' Get a list of studies that have specific domain data
##' 
##' @param domain Name of a specific domain
##' @param all_study_ids List of study indentifiers to search on
##' @return List of study indentifiers
##' @examples
##' library(DBI)
##' library(sqldf)
##' studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")
##' db_dir <- file.path(studies_dir, "Db")
##' sqlite_conn <- dbConnect(SQLite(), dbname=file.path(db_dir, "ImmPort.sqlite"))
##' setImmPortDataSource(sqlite_conn)
##' study_ids <- getStudiesWithSpecificDomainData("Demographics")
##' @export
getStudiesWithSpecificDomainData <- function(domain, all_study_ids = c("ALL")) {
  study_ids = c()
  
  if (exists("data_src", envir = RImmPort.env)) {
    r <- get("data_src", envir = RImmPort.env)
  } else {
    stop("ImmPort data source is not set: See ?setImmPortDataSource() ")
  }
  
  #   if (is.null(r <- get0("data_src", envir = RImmPort.env))) {
  #     stop("ImmPort data source is not set: See ?setImmPortDataSource() ")
  #   }
  
  data_src <- RImmPort.env$data_src
  
  if (domain %in% getListOfDomains()[,'Domain Name'] == FALSE) {
    stop(paste("domain = ", domain, " is not found in the list of supported domains; 
               Run getListOfDomains() for a complete list"))
  }
  
  if (class(data_src) == "character") { # data source is .rds files
    if (file.exists(data_src) == FALSE) {
      stop("data source = ", data_src, " not found")
    }  
    
    domain_code <- getDomainCode(domain)
    if (all_study_ids[1] == "ALL")
      all_study_ids <- getListOfStudies()
    
    for (study_id in all_study_ids) {
      study_path <- file.path(data_src, study_id)
      if (file.exists(file.path(study_path, paste(tolower(domain_code),".rds", sep=""))))
        study_ids <- c(study_ids, study_id)
    }
  } else { # data source is MySQL db or SQLite db
    switch (domain,          
            "Adverse Events" = {
              study_ids <- getStudiesWithAdverseEvents(data_src)
            },
            "Trial Arms" = {
              study_ids <- getStudiesWithTrialArms(data_src)
            },
            "Trial Visits" = {
              study_ids <- getStudiesWithTrialVisits(data_src)
            },
            "Concomitant Medications" = {
              study_ids <- getStudiesWithConcomitantMedications(data_src)
            },
            "Demographics" = {
              study_ids <- getStudiesWithDemographics(data_src)
            },
            "Trial Inclusion Exclusion Criteria" = {
              study_ids <- getStudiesWithTrialInclusionExclusionCriteria(data_src)
            },
            "Exposure" = {
              study_ids <- getStudiesWithExposure(data_src)
            },
            "Laboratory Test Results" = {
              study_ids <- getStudiesWithLaboratoryTestResults(data_src)
            },
            "Medical History" = {
              study_ids <- getStudiesWithMedicalHistory(data_src)
            },
            "Associated Persons Medical History" = {
              study_ids <- getStudiesWithAssociatedPersonsMedicalHistory(data_src)
            },
            "Physical Examination" = {
              study_ids <- getStudiesWithPhysicalExamination(data_src)
            },
            "Protocol Deviations" = {
              study_ids <- getStudiesWithProtocolDeviations(data_src)
            },
            "Trial Summary" = {
              study_ids <- getStudiesWithTrialSummary(data_src)
            },
            "Substance Use" = {
              study_ids <- getStudiesWithSubstanceUse(data_src)
            },
            "Vital Signs" = {
              study_ids <- getStudiesWithVitalSigns(data_src)
            },
            "Questionnaires" = {
              study_ids <- getStudiesWithQuestionnaires(data_src)
            },
            "Findings About" = {
              study_ids <- getStudiesWithFindingsAbout(data_src)
            },
            "Skin Response" = {
              study_ids <- getStudiesWithSkinResponse(data_src)
            },        
            "Genetics Findings" = {
              study_ids <- getStudiesWithGeneticsFindings(data_src)
            },
            "Protein Quantification" = {
              study_ids <- getStudiesWithProteinQuantification(data_src)
            },
            "Cellular Quantification" = {
              study_ids <- getStudiesWithCellularQuantification(data_src)
            },
            "Nucleic Acid Quantification" = {
              study_ids <- getStudiesWithNucleicAcidQuantification(data_src)
            },
            "Titer Assay Results" = {
              study_ids <- getStudiesWithTiterAssayResults(data_src)
            }
    )
  }
  
  study_ids
  }

getStudiesWithAdverseEvents <- function(data_src) {
  all_study_ids <- getListOfStudies()
  study_ids = c()
  for (study_id in all_study_ids) {
    if (getCountOfAdverseEvents(data_src, study_id) > 0)
      # add to list
      study_ids = c(study_ids,study_id)
  }
  
  study_ids
}

getStudiesWithTrialArms <- function(data_src) {
  all_study_ids <- getListOfStudies()
  study_ids = c()
  for (study_id in all_study_ids) {
    if (getCountOfTrialArms(data_src, study_id) > 0)
      # add to list
      study_ids = c(study_ids,study_id)
  }
  
  study_ids
}

getStudiesWithTrialVisits <- function(data_src) {
  all_study_ids <- getListOfStudies()
  study_ids = c()
  for (study_id in all_study_ids) {
    if (getCountOfTrialVisits(data_src, study_id) > 0)
      # add to list
      study_ids = c(study_ids,study_id)
  }
  
  study_ids
}


getStudiesWithConcomitantMedications <- function(data_src) {
  all_study_ids <- getListOfStudies()
  study_ids = c()
  for (study_id in all_study_ids) {
    if (getCountOfConcomitantMedications(data_src, study_id) > 0)
      # add to list
      study_ids = c(study_ids,study_id)
  }
  
  study_ids
}

getStudiesWithDemographics <- function(data_src) {
  all_study_ids <- getListOfStudies()
  study_ids = c()
  for (study_id in all_study_ids) {
    if (getCountOfDemographics(data_src, study_id) > 0)
      # add to list
      study_ids = c(study_ids,study_id)
  }
  
  study_ids
}

getStudiesWithTrialInclusionExclusionCriteria <- function(data_src) {
  all_study_ids <- getListOfStudies()
  study_ids = c()
  for (study_id in all_study_ids) {
    if (getCountOfTrialInclusionExclusionCriteria(data_src, study_id) > 0)
      # add to list
      study_ids = c(study_ids,study_id)
  }
  
  study_ids
}

getStudiesWithExposure <- function(data_src) {
  all_study_ids <- getListOfStudies()
  study_ids = c()
  for (study_id in all_study_ids) {
    if (getCountOfExposure(data_src, study_id) > 0)
      # add to list
      study_ids = c(study_ids,study_id)
  }
  
  study_ids
}

getStudiesWithLaboratoryTestResults <- function(data_src) {
  all_study_ids <- getListOfStudies()
  study_ids = c()
  for (study_id in all_study_ids) {
    if (getCountOfLaboratoryTestResults(data_src, study_id) > 0)
      # add to list
      study_ids = c(study_ids,study_id)
  }
  
  study_ids
}

getStudiesWithMedicalHistory <- function(data_src) {
  all_study_ids <- getListOfStudies()
  study_ids = c()
  for (study_id in all_study_ids) {
    if (getCountOfMedicalHistory(data_src, study_id) > 0)
      # add to list
      study_ids = c(study_ids,study_id)
  }
  
  study_ids
}

getStudiesWithAssociatedPersonsMedicalHistory <- function(data_src) {
  all_study_ids <- getListOfStudies()
  study_ids = c()
  for (study_id in all_study_ids) {
    if (getCountOfAssociatedPersonsMedicalHistory(data_src, study_id) > 0)
      # add to list
      study_ids = c(study_ids,study_id)
  }
  
  study_ids
}
getStudiesWithPhysicalExamination <- function(data_src) {
  all_study_ids <- getListOfStudies()
  study_ids = c()
  for (study_id in all_study_ids) {
    if (getCountOfPhysicalExamination(data_src, study_id) > 0)
      # add to list
      study_ids = c(study_ids,study_id)
  }
  
  study_ids
}

getStudiesWithProtocolDeviations <- function(data_src) {
  all_study_ids <- getListOfStudies()
  study_ids = c()
  for (study_id in all_study_ids) {
    if (getCountOfProtocolDeviations(data_src, study_id) > 0)
      # add to list
      study_ids = c(study_ids,study_id)
  }
  
  study_ids
}

getStudiesWithTrialSummary <- function(data_src) {
  all_study_ids <- getListOfStudies()
  study_ids = c()
  for (study_id in all_study_ids) {
    if (getCountOfTrialSummary(data_src, study_id) > 0)
      # add to list
      study_ids = c(study_ids,study_id)
  }
  
  study_ids
}


getStudiesWithSubstanceUse <- function(data_src) {
  all_study_ids <- getListOfStudies()
  study_ids = c()
  for (study_id in all_study_ids) {
    if (getCountOfSubstanceUse(data_src, study_id) > 0)
      # add to list
      study_ids = c(study_ids,study_id)
  }
  
  study_ids
}

getStudiesWithVitalSigns <- function(data_src) {
  all_study_ids <- getListOfStudies()
  study_ids = c()
  for (study_id in all_study_ids) {
    if (getCountOfVitalSigns(data_src, study_id) > 0)
      # add to list
      study_ids = c(study_ids,study_id)
  }
  
  study_ids
}

getStudiesWithQuestionnaires <- function(data_src) {
  all_study_ids <- getListOfStudies()
  study_ids = c()
  for (study_id in all_study_ids) {
    if (getCountOfQuestionnaires(data_src, study_id) > 0)
      # add to list
      study_ids = c(study_ids,study_id)
  }
  
  study_ids
}

getStudiesWithFindingsAbout <- function(data_src) {
  all_study_ids <- getListOfStudies()
  study_ids = c()
  for (study_id in all_study_ids) {
    if (getCountOfFindingsAbout(data_src, study_id) > 0)
      # add to list
      study_ids = c(study_ids,study_id)
  }
  
  study_ids
}

getStudiesWithSkinResponse <- function(data_src) {
  all_study_ids <- getListOfStudies()
  study_ids = c()
  for (study_id in all_study_ids) {
    if (getCountOfSkinResponse(data_src, study_id) > 0)
      # add to list
      study_ids = c(study_ids,study_id)
  }
  
  study_ids
}

getStudiesWithGeneticsFindings <- function(data_src) {
  all_study_ids <- getListOfStudies()
  study_ids = c()
  for (study_id in all_study_ids) {
    if (getCountOfGeneticsFindings (data_src, study_id) > 0)
      # add to list
      study_ids = c(study_ids,study_id)
  }
  
  study_ids
}

getStudiesWithProteinQuantification <- function(data_src) {
  all_study_ids <- getListOfStudies()
  study_ids = c()
  for (study_id in all_study_ids) {
    if (getCountOfProteinQuantification(data_src, study_id) > 0)
      # add to list
      study_ids = c(study_ids,study_id)
  }
  
  study_ids
}

getStudiesWithCellularQuantification <- function(data_src) {
  all_study_ids <- getListOfStudies()
  study_ids = c()
  for (study_id in all_study_ids) {
    if (getCountOfCellularQuantification(data_src, study_id) > 0)
      # add to list
      study_ids = c(study_ids,study_id)
  }
  
  study_ids
}

getStudiesWithNucleicAcidQuantification <- function(data_src) {
  all_study_ids <- getListOfStudies()
  study_ids = c()
  for (study_id in all_study_ids) {
    if (getCountOfNucleicAcidQuantification (data_src, study_id) > 0)
      # add to list
      study_ids = c(study_ids,study_id)
  }
  
  study_ids
}

getStudiesWithTiterAssayResults <- function(data_src) {
  all_study_ids <- getListOfStudies()
  study_ids = c()
  for (study_id in all_study_ids) {
    if (getCountOfTiterAssayResults (data_src, study_id) > 0)
      # add to list
      study_ids = c(study_ids,study_id)
  }
  
  study_ids
}

########################################################################
##' Get a list of studies that have specific assay type data
##' 
##' @param assay_type Assay Type
##' @param all_study_ids List of study indentifiers to search on
##' @return List of study indentifiers
##' @examples
##' library(DBI)
##' library(sqldf)
##' studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")
##' db_dir <- file.path(studies_dir, "Db")
##' sqlite_conn <- dbConnect(SQLite(), dbname=file.path(db_dir, "ImmPort.sqlite"))
##' setImmPortDataSource(sqlite_conn)
##' study_ids <- getStudiesWithSpecificAssayData("ELISPOT")
##' @export
getStudiesWithSpecificAssayData <- function(assay_type, all_study_ids = c("ALL")) {
  if (exists("data_src", envir = RImmPort.env)) {
    r <- get("data_src", envir = RImmPort.env)
  } else {
    stop("ImmPort data source is not set: See ?setImmPortDataSource() ")
  }
  
  #   if (is.null(r <- get0("data_src", envir = RImmPort.env))) {
  #     stop("ImmPort data source is not set: See ?setImmPortDataSource() ")
  #   }
  
  data_src <- RImmPort.env$data_src
  
  if (assay_type %in% getListOfAssayTypes() == FALSE) {
    stop("assay type is not found in the list of supported assay types; 
         Run getListOfAssayTypes() for a complete list")
  }
  
  if (all_study_ids[1] == "ALL")
    all_study_ids <- getListOfStudies()
  
  study_ids = c()
  for (study_id in all_study_ids) {
    if (getCountOfCellularQuantification(data_src, study_id, assay_type) > 0)
      study_ids = c(study_ids,study_id)
    if (getCountOfGeneticsFindings(data_src, study_id, assay_type) > 0)
      study_ids = c(study_ids,study_id)
    if (getCountOfNucleicAcidQuantification(data_src, study_id, assay_type) > 0)
      study_ids = c(study_ids,study_id)
    if (getCountOfProteinQuantification(data_src, study_id, assay_type) > 0)
      study_ids = c(study_ids,study_id)
    if (getCountOfTiterAssayResults(data_src, study_id, assay_type) > 0)
      study_ids = c(study_ids,study_id)
  }
  
  study_ids
  }



########################################################################
########################################################################

##' Get a list of all studies 
##' 
##' @return List of study indentifiers
##' @examples
##' library(DBI)
##' library(sqldf)
##' studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")
##' db_dir <- file.path(studies_dir, "Db")
##' sqlite_conn <- dbConnect(SQLite(), dbname=file.path(db_dir, "ImmPort.sqlite"))
##' setImmPortDataSource(sqlite_conn)
##' study_ids <- getListOfStudies()
##' @export
getListOfStudies <- function() {
  if (exists("data_src", envir = RImmPort.env)) {
    r <- get("data_src", envir = RImmPort.env)
  } else {
    stop("ImmPort data source is not set: See ?setImmPortDataSource() ")
  }
  
  #   if (is.null(r <- get0("data_src", envir = RImmPort.env))) {
  #     stop("ImmPort data source is not set: See ?setImmPortDataSource() ")
  #   }
  
  data_src <- RImmPort.env$data_src
  if ((class(data_src)[1] == 'MySQLConnection') || 
      (class(data_src)[1] == 'SQLiteConnection')) {
    sql_stmt <- paste("
                      SELECT distinct
                      s.study_accession
                      FROM study s", sep="")
    
    study_ids_df <- dbGetQuery(data_src,statement=sql_stmt)
    study_ids <- study_ids_df[['study_accession']]
  } else {
    zip_files <- list.files(path = data_src, pattern = "\\.zip$")
    zip_files
    study_ids <- c()
    for (f in zip_files) {
      fname <- file_path_sans_ext(f)
      study_ids <- c(study_ids, fname)
    }
    
    #     study_dirs <- list.files(path = data_src, pattern = "_R$")
    #     study_ids <- c()
    #     for (sd in study_dirs) {
    #       study_id <- strsplit(sd, "-")[[1]][1]
    #       study_ids <- c(study_ids, study_id)
    #     }
  }
  
  study_ids
} 

##' Merge the Domain dataframe and Supplemental dataframe (long form) 
##' 
##' The Domain data list comprises of the the Domain datafrome that is in wide form, and any Supplemental
##' dataframe that is in long form. The function \code{mergeDomainAndSupplemental} transposes the Supplemental
##' dataframe into a wide form, and merges it with the Domain dataframe.
##' 
##' @param data_list A list of 1) Domain dataframe and 2) any Supplemental dataframe 
##' @return The merged dataframe
##' @examples
##' library(DBI)
##' library(sqldf)
##' studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")
##' db_dir <- file.path(studies_dir, "Db")
##' sqlite_conn <- dbConnect(SQLite(), dbname=file.path(db_dir, "ImmPort.sqlite"))
##' setImmPortDataSource(sqlite_conn)
##' l <- getDomainDataOfStudies("Cellular Quantification", "SDY208")
##' df <- mergeDomainAndSupplemental(l)
##' @importFrom reshape2 dcast 
##' @importFrom dplyr full_join 
##' @export
mergeDomainAndSupplemental <- function(data_list) {
  merged_df <- data.frame()
  
  if (length(data_list) > 0) {
    merged_df <- data_list[[1]]
    if (length(data_list) == 2) {
      supp_df <- data_list[[2]]
      if (nrow(supp_df) > 0) {
        wide_supp_df <- dcast(supp_df, STUDYID + RDOMAIN + USUBJID + IDVARVAL ~ QNAM, value.var="QVAL")
        names(wide_supp_df)[names(wide_supp_df)=="RDOMAIN"] <- "DOMAIN"
        names(wide_supp_df)[names(wide_supp_df)=="IDVARVAL"] <- supp_df$IDVAR[1]
        merged_df <- full_join(merged_df, wide_supp_df)
      }
    } 
  }
  
  merged_df
}

########################################################################
########################################################################

##' Serialize the Study Data
##' 
##' Load specific studies from the database and save it in .rds format in 
##' a local file directory 
##' 
##' @param study_ids List of study indentifiers
##' @param data_dir Path to a file folder where the .rds study files will be saved into
##' @return List of study indentifiers that were serialized successfully
##' @examples
##' library(DBI)
##' library(sqldf)
##' studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")
##' db_dir <- file.path(studies_dir, "Db")
##' sqlite_conn <- dbConnect(SQLite(), dbname=file.path(db_dir, "ImmPort.sqlite"))
##' setImmPortDataSource(sqlite_conn)
##' # the folder where the .rds files will be stored
##' rds_dir <- file.path(studies_dir, "Rds")
##' study_ids <- c('SDY139', 'SDY208')
##' serialzeStudyData(study_ids, rds_dir)
##' @export
serialzeStudyData  <- function(study_ids, data_dir) {
  if (exists("data_src", envir = RImmPort.env)) {
    r <- get("data_src", envir = RImmPort.env)
  } else {
    stop("ImmPort data source is not set: See ?setImmPortDataSource() ")
  }
  
  #   if (is.null(r <- get0("data_src", envir = RImmPort.env))) {
  #     stop("ImmPort data source is not set: See ?setImmPortDataSource() ")
  #   }
  
  data_src <- RImmPort.env$data_src
  
  domains <- getListOfDomains()[,'Domain Name']
  for (study_id in study_ids) {
    cat("Study ID = ", study_id, "\n")
    for (domain in domains) {
      domain_code <- getDomainCode(domain)
      l <- getDomainDataOfStudies(domain, study_id)
      study_path <- file.path(data_dir, study_id)
      d <- dir.create(study_path, showWarnings = FALSE)
      
      if (length(l) > 0) {
        saveRDS(l[[1]], file=file.path(study_path, paste(tolower(domain_code),".rds", sep=""))) 
        saveRDS(l[[2]], file=file.path(study_path, paste("supp", tolower(domain_code),".rds", sep="")))
      }
    } # next domain
  } # next study_id
  
  study_ids
}

##' Load the Serialized Data of a Study
##' 
##' Load the serialzed data (.rds) file of a specific domain of a study study from the directory where 
##' the file is located
##' 
##' @param study_id Study indentifier
##' @param data_dir Path to a file folder where the .rds study files reside
##' @param domain Domain of interest
##' @return A study data object where in all data are structured as classes, domains, variables and values (in CDISC format)
##' 
##' @examples
##' studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")
##' # the folder where the .rds files will be stored
##' rds_dir <- file.path(studies_dir, "Rds")
##' # load the serialized data of study `SDY208` 
##' loadSerializedStudyData(rds_dir, 'SDY208', "Demographics")
##' @export
loadSerializedStudyData <- function(data_dir, study_id, domain) {
  study_path <- file.path(data_dir, study_id)
  if (file.exists(study_path) == FALSE) {
    stop("study data for id = ", study_id, " not found")
  }  
  if (domain %in% getListOfDomains()[,'Domain Name'] == FALSE) {
    stop("domain is not found in the list of supported domains; 
         Run getListOfDomains() for a complete list")
  }  
  domain_df <- data.frame()
  suppdomain_df <- data.frame()
  
  domain_code <- getDomainCode(domain)
  
  domain_file_path <- file.path(study_path, paste(tolower(domain_code),".rds", sep=""))
  cat("\ndomain_file_path = ", file.path(study_path, paste(tolower(domain_code),".rds", sep="")), "\n")
  if (file.exists(domain_file_path))
    domain_df <- readRDS(file=file.path(study_path, paste(tolower(domain_code),".rds", sep="")))
  
  suppdomain_file_path <- file.path(study_path, paste("supp", tolower(domain_code),".rds", sep=""))
  cat("suppdomain_file_path = ", file.path(study_path, paste("supp", tolower(domain_code),".rds", sep="")), "\n")
  if (file.exists(suppdomain_file_path))
    suppdomain_df <- readRDS(file=file.path(study_path, paste("supp", tolower(domain_code),".rds", sep="")))
  
  list(domain_df, suppdomain_df)
}

covertElaspsedTimeToISO8601Format <- function(time, time_unit) {
  if (is.na(time) | is.na(time_unit)) 
    return(NA)
  
  if (is.null(time) |is.null(time_unit))
    return(NULL)
  
  
  if (time_unit %in% c("Years", "Months", "Days")) {
    if (time < 0) {
      eltm <- "-P"
      time <- abs(time)
    } else
      eltm <- "P"
  }  
  
  if (time_unit %in% c("Hours", "Minutes", "Seconds")) {
    if (time < 0) {
      eltm <- "-PT"
      time <- abs(time)
    } else
      eltm <- "PT"
  }

  switch (time_unit,          
          "Years" = {
            if (time%%1 == 0) { 
              # no fraction
              eltm <- paste(eltm, as.integer(time), "Y", sep="")
            } else { 
              # has fraction
              eltm <- paste(eltm, time, "Y", sep="")
            }
          },  
          "Months" = {
            if (time%%1 == 0) { 
              # no fraction
              eltm <- paste(eltm, as.integer(time), "M", sep="")
            } else { 
              # has fraction
              eltm <- paste(eltm, time, "M", sep="")
            }
          },  
          "Days" = {
            if (time%%1 == 0) { 
              # no fraction
              eltm <- paste(eltm, as.integer(time), "D", sep="")
            } else { 
              # has fraction
              eltm <- paste(eltm, time, "D", sep="")
            }
          },  
          "Hours" = {
            if (time%%1 == 0) { 
              # no fraction
              eltm <- paste(eltm, as.integer(time), "H", sep="")
            } else { 
              # has fraction
              eltm <- paste(eltm, time, "H", sep="")
            }
          },
          "Minutes" = {
            if (time%%1 == 0) { 
              # no fraction
              eltm <- paste(eltm, as.integer(time), "M", sep="")
            } else { 
              # has fraction
              eltm <- paste(eltm, time, "M", sep="")
            }
          },
          "Seconds" = {
            if (time%%1 == 0) { 
              # no fraction
              eltm <- paste(eltm, as.integer(time), "S", sep="")
            } else { 
              # has fraction
              eltm <- paste(eltm, time, "S", sep="")
            }
          },
          {
            eltm <- NA
          }
  )
  
  eltm
}

getTimePointReference <- function(time_event, time_event_specify) {
  if (time_event == "Other") 
    return(time_event_specify)
  else
    return(time_event)
}

#' Physical Examination Domain
#' 
#' @name Physical Examination Domain
#' @description The Physical Examination data of an ImmPort study is reformated to the CDISC SDTM 
#' Physical Examination (PE) domain model, and is a list of 2 data frames containing 1) Physical 
#' Examination data \code{\link{PE}} and 2) any supplemental Physical Examination data \code{\link{SUPPPE}}
NULL
#> NULL 

# call to globalVariables to prevent from generating NOTE: no visible binding for global variable <variable name>
# this hack is to satisfy CRAN (http://stackoverflow.com/questions/9439256/how-can-i-handle-r-cmd-check-no-visible-binding-for-global-variable-notes-when)
globalVariables(c("PESEQ", "QNAM", "QVAL", "PETOD"))

# Get Physical Examination data of a specific study
# 
# The function \code{getPhysicalExamination} queries the ImmPort database for Physical Examination data and 
# reformats it to the CDISC SDTM Physical Examination (PE) domain model 
# 
# @param data_src A connection handle to ImmPort (MySQL or SQLite) database instance or 
# a directory handle to folder where study RDS files are located
# @param study_id Identifier of a specific study
# @return a list of 2 data frames containing 1) Physical Examination data \code{\link{PE}} and 2) any supplemental 
#   Physical Examination data \code{\link{SUPPPE}}
# @author Ravi Shankar
# @examples
# \dontrun{
#   getPhysicalExamination(data_src, "SDY1")
# }
#' @importFrom DBI dbGetQuery
#' @importFrom plyr rename
#' @importFrom data.table as.data.table is.data.table .N :=
getPhysicalExamination <- function(data_src, study_id) {
    cat("loading Physical Examination data....")

    pe_cols <- c("STUDYID", "DOMAIN", "USUBJID", "PESEQ", "PETEST", "PECAT", "PEBODSYS", "PEORRES", "PEORRESU", "PELOC",
                "PETOD", "VISITNUM", "VISIT", "PEDY")
    supppe_cols <- c("STUDYID", "RDOMAIN", "USUBJID", "IDVAR", "IDVARVAL", "QNAM", "QLABEL", "QVAL")
  
  
    sql_stmt <- paste("SELECT distinct
                        asmp.study_accession,
                        \"PE\" as domain,
                      asmc.subject_accession,
                      cast(0 as UNSIGNED INTEGER) as seq,
                      asmc.name_reported,
                      asmp.name_reported,
                      asmc.organ_or_body_system_reported,
                      asmc.result_value_reported,
                      asmc.result_unit_reported,
                      asmc.location_of_finding_reported,
                      asmc.time_of_day,
                      pv.order_number,
                      pv.name,
                      asmc.study_day                    
                      FROM  assessment_component asmc
                      INNER JOIN
                      assessment_panel asmp ON asmc.assessment_panel_accession=asmp.assessment_panel_accession
                      INNER JOIN
                      planned_visit pv ON asmc.planned_visit_accession=pv.planned_visit_accession
                      WHERE (asmp.study_accession in ('", study_id, "')) AND 
                      (asmp.assessment_type='Physical Exam') AND
                      ((asmc.name_reported!='Heart Rate')  AND
                      (asmc.name_reported!='Diastolic Blood Pressure') AND
                      (asmc.name_reported!='Systolic Blood Pressure') AND
                      (asmc.name_reported!='Height') AND
                      (asmc.name_reported!='Weight') AND
                      (asmc.name_reported!='Respiration Rate') AND
                      (asmc.name_reported!='Temperature')) 
                      ORDER BY asmc.subject_accession", sep = "")
    
    if ((class(data_src)[1] == 'MySQLConnection') || 
        (class(data_src)[1] == 'SQLiteConnection')) {
      pe_df <- dbGetQuery(data_src, statement = sql_stmt)
      colnames(pe_df) <- pe_cols
      supppe_df <- data.frame()
      if (nrow(pe_df) > 0) {
        pe_df <- transform(pe_df, PESEQ = as.integer(PESEQ))
        pe_dt <- as.data.table(pe_df)
        if (is.data.table(pe_dt) == TRUE) {
          pe_dt[, `:=`(PESEQ, seq_len(.N)), by = "USUBJID"]
        }
        pe_df <- as.data.frame(pe_dt)
  
        qnam_values = c("PETOD")
        qlabel_values= c("Time of Day")
        
        supppe_df <- reshape2::melt(pe_df, id = c("STUDYID", "DOMAIN", "USUBJID", "PESEQ"), 
                                    measure = qnam_values, 
                                    variable.name = "QNAM", 
                                    value.name = "QVAL")
        supppe_df <- transform(supppe_df, QLABEL = unlist(qlabel_values[QNAM]))
        supppe_df <- plyr::rename(supppe_df, c("DOMAIN" = "RDOMAIN", "PESEQ" = "IDVARVAL"))
        supppe_df$IDVAR <- "PESEQ"
        
        supppe_df <- supppe_df[supppe_cols]
        
        # remove rows that have empty QVAL values
        supppe_df <- subset(supppe_df,QVAL!="")      
        
        pe_df <- subset(pe_df, select = -c(PETOD))
      }
    } else {
      l <- loadSerializedStudyData(data_src, study_id, "Physical Examination")
      pe_df <- l[[1]]
      supppe_df <- l[[2]]
    }

    cat("done", "\n")
    
    pe_l <- list()
    if (nrow(pe_df) > 0)
      pe_l <- list(pe_df=pe_df, supppe_df=supppe_df)
    
    pe_l
}

# Get count of Physical Examination data of a specific study
# 
# The function \code{getCountOfPhysicalExamination} queries the ImmPort database for count 
# of Physical Examination data 
# 
# @param conn A connection handle to ImmPort database instance
# @param study_id Identifier of a specific study
# @return a count of Physical Examination data 
# @examples
# \dontrun{
#   # get count of study SDY1's Physical Examination data
#   count <- getCountOfPhysicalExamination(conn, "SDY1")
# }
getCountOfPhysicalExamination <- function(conn, study_id) {
    sql_stmt <- paste("SELECT count(*)
                      FROM  assessment_component asmc
                      INNER JOIN
                      assessment_panel asmp ON asmc.assessment_panel_accession=asmp.assessment_panel_accession
                      WHERE asmp.study_accession in ('", study_id, "') AND 
                      (asmp.assessment_type='Physical Exam') AND
                      ((asmc.name_reported!='Heart Rate')  AND
                      (asmc.name_reported!='Diastolic Blood Pressure') AND
                      (asmc.name_reported!='Systolic Blood Pressure') AND
                      (asmc.name_reported!='Height') AND
                      (asmc.name_reported!='Weight') AND
                      (asmc.name_reported!='Respiration Rate') AND
                      (asmc.name_reported!='Temperature'))", sep = "")
    
    count <- dbGetQuery(conn, statement = sql_stmt)
    
    count[1, 1]
} 

##' Physical Examination Domain Variables
##' @name PE
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name  } \tab \strong{Variable Label} \cr
##'     STUDYID \tab Study Identifier \cr
##'     DOMAIN  \tab Domain Abbreviation \cr
##'     USUBJID \tab Unique Subject Identifier \cr
##'     PESEQ \tab Sequence Number \cr
##'     PETEST \tab Body System Examined \cr
##'     PECAT \tab Category for Examination \cr
##'     PEBODSYS \tab Body System or Organ Class \cr
##'     PEORRES \tab Verbatim Examination Finding \cr
##'     PEORRESU \tab Original Units \cr
##'     PELOC \tab Location of Physical Exam Finding \cr
##'     VISITNUM \tab Visit Number \cr
##'     VISIT \tab Visit Name \cr
##'     PEDY \tab Study Day of Examination
##'   }
##' }
NULL
#> NULL 

##' Physical Examination Domain Supplemental Variables
##' @name SUPPPE
##' @description {
##'   \tabular{ll}{
##'     \strong{Variable Name} \tab \strong{Variable Label} \cr
##'     STUDYID \tab Study Identifier \cr
##'     RDOMAIN  \tab Related Domain Abbreviation \cr
##'     USUBJID \tab Unique Subject Identifier \cr
##'     PESEQ \tab Sequence Number \cr
##'     IDVAR \tab Identifying Variable \cr
##'     IDVARVAL \tab Identifying Variable Value \cr
##'     QNAM \tab Qualifier Variable Name \cr
##'     QLABEL \tab Qualifier Variable Label \cr
##'     QVAL \tab Data Value
##'   }
##' }
##' @note The following table enumerates the values in QNAM and QLABEL variables {
##'   \tabular{ll}{
##'     \strong{QNAM} \tab \strong{QLABEL} \cr
##'     PETOD \tab Time of Day \cr
##'   }
##' }
NULL
#> NULL

# call to globalVariables to prevent from generating NOTE: no visible binding for global variable <variable name>
# this hack is to satisfy CRAN (http://stackoverflow.com/questions/9439256/how-can-i-handle-r-cmd-check-no-visible-binding-for-global-variable-notes-when)
globalVariables(c("study_time_of_specimen_collection", "unit_of_study_time_of_specimen_collection",
                  "study_time_t0_event", "study_time_t0_event_specify"))

#' @importFrom stats aggregate
getFcsResults <- function(conn,study_id, measurement_types) {
  cat("loading FCS Results data....")
  
#   old <- options(stringsAsFactors = FALSE)
#   on.exit(options(old), add = TRUE)
#   options(useFancyQuotes = FALSE)
#   measurement_types <- paste(mapply(sQuote, measurement_types), collapse=", ")
  
  fcs_cols <- c("study_id", "subject_id", "sequence",
                "experiment_title", "assay_purpose", "measurement_technique",
                "experiment_sample_accession",
                "biosample_accession", "specimen_type", "specimen_subtype", 
                "visit_name", "visit_min_start_day", "visit_max_start_day", "visit_order",
                "study_time_of_specimen_collection", "unit_of_study_time_of_specimen_collection",
                "study_time_t0_event", "study_time_t0_event_specify",
                "file_name",
                "base_parent_population", 
                "population_cell_number", "population_cell_number_unit",
                "population_defnition_reported", "population_name_reported")
  
  fcf_cols <- c("experiment_sample_accession",
                "control_files_names")
  
  tr_cols <- c("experiment_sample_accession",
               "specimen_treatment", 
               "treatment_amount_value", "treatment_amount_unit",
               "treatment_duration_value", "treatment_duration_unit",
               "treatment_temperature_value", "treatment_temperature_unit")

#   far_cols <- c("experiment_sample_accession",
#                 "base_parent_population", 
#                 "population_cell_number", "population_cell_number_unit",
#                 "population_defnition_reported", "population_name_reported")
  
  sql_stmt <- paste("
                    SELECT distinct
                      bs.study_accession,
                      bs.subject_accession,     
                      cast(0 as UNSIGNED INTEGER) as seq,
                      ex.name,
                      'Cellular Quantification' as purpose,                      
                      ex.measurement_technique,
                      es2bs.expsample_accession,
                      bs.biosample_accession,
                      bs.type,
                      bs.subtype,
                      pv.name,
                      pv.min_start_day,
                      pv.max_start_day,
                      pv.order_number,
                      bs.study_time_collected,
                      bs.study_time_collected_unit,
                      bs.study_time_t0_event,
                      bs.study_time_t0_event_specify,
                      fi.name,
                      \"\", \"\", \"\", \"\", \"\"
                    
                    FROM  
                      biosample bs
                    INNER JOIN
                      expsample_2_biosample es2bs ON bs.biosample_accession=es2bs.biosample_accession
                    INNER JOIN
                      expsample es ON es2bs.expsample_accession=es.expsample_accession
                    INNER JOIN
                      planned_visit pv ON bs.planned_visit_accession=pv.planned_visit_accession
                    INNER JOIN
                      experiment ex ON es.experiment_accession=ex.experiment_accession
                    INNER JOIN
                      expsample_2_file_info es2fi ON es2bs.expsample_accession=es2fi.expsample_accession
                    INNER JOIN
                      file_info fi ON es2fi.file_info_id=fi.file_info_id                    
                    WHERE 
                      bs.study_accession in (\'", study_id,"\') AND
                      (fi.detail LIKE \'%Flow cytometry result%\' OR fi.detail LIKE \'%CyTOF result%\') AND 
                      fi.detail IN (\'Flow cytometry result\', \'CyTOF result\')  
                    ORDER BY bs.subject_accession",sep="")

  fcs_df <- dbGetQuery(conn,statement=sql_stmt)
  if (nrow(fcs_df) > 0) {
    colnames(fcs_df) <- fcs_cols 
    
    fcs_df$elapsed_time_of_specimen_collection = mapply(covertElaspsedTimeToISO8601Format, fcs_df$study_time_of_specimen_collection, 
                                                        fcs_df$unit_of_study_time_of_specimen_collection)
    
    fcs_df$time_point_reference = mapply(getTimePointReference, fcs_df$study_time_t0_event, 
                                         fcs_df$study_time_t0_event_specify)
    
#     fcs_df <- transform(fcs_df, sequence = as.integer(sequence))
#     setDT(fcs_df)[, `:=`(sequence, seq_len(.N)), by = "subject_id"]
#     fcs_df <- as.data.frame(fcs_df)
#     fcs_df <- ddply(fcs_df, .(study_id, subject_id, sequence), mutate, elapsed_time_of_specimen_collection = 
#             covertElaspsedTimeToISO8601Format(study_time_of_specimen_collection, 
#                                               unit_of_study_time_of_specimen_collection))
#     
#     fcs_df <- ddply(fcs_df, .(study_id, subject_id, sequence), mutate, time_point_reference = 
#                       getTimePointReference(study_time_t0_event, study_time_t0_event_specify))

    sql_stmt <- paste("
                      SELECT distinct
                        es2bs.expsample_accession,
                        fi.name
                      FROM  
                        biosample bs
                      INNER JOIN
                        expsample_2_biosample es2bs ON bs.biosample_accession=es2bs.biosample_accession
                      INNER JOIN
                        expsample_2_file_info es2fi ON es2bs.expsample_accession=es2fi.expsample_accession
                      INNER JOIN
                        file_info fi ON es2fi.file_info_id=fi.file_info_id                    
                      WHERE 
                        bs.study_accession in (\'", study_id,"\') AND
                        fi.detail IN (\'Flow cytometry compensation or control\')  
                      ORDER BY bs.subject_accession",sep="")
    
    fcf_df <- dbGetQuery(conn,statement=sql_stmt)
    colnames(fcf_df) <- fcf_cols 
    if (nrow(fcf_df) >0) {
      fcf_df <- aggregate(control_files_names~experiment_sample_accession,paste,collapse="||",data=fcf_df)
      fcs_df <- merge(fcs_df ,fcf_df, by="experiment_sample_accession")
    } else {
      fcs_df["control_files_names"] = ""
    }
    
    sql_stmt <- paste("
                      SELECT distinct
                        es2bs.expsample_accession,
                        tr.name,
                        tr.amount_value,
                        tr.amount_unit,
                        tr.duration_value,
                        tr.duration_unit,
                        tr.temperature_value,
                        tr.temperature_unit
                      FROM  
                        biosample bs
                      INNER JOIN
                        expsample_2_biosample es2bs ON bs.biosample_accession=es2bs.biosample_accession
                      INNER JOIN
                        expsample_2_treatment es2tr ON es2bs.expsample_accession=es2tr.expsample_accession
                      INNER JOIN
                        treatment tr ON es2tr.treatment_accession=tr.treatment_accession
                      WHERE 
                        bs.study_accession in (\'", study_id,"\')",sep="")
    
    tr_df <- dbGetQuery(conn,statement=sql_stmt)
    colnames(tr_df) <- tr_cols 
    
    if (nrow(tr_df) >0) {
#      tr_df <- aggregate(. ~ experiment_sample_accession,paste,collapse="||",data=tr_df)
      tr_df <- setDF(setDT(tr_df)[, lapply(.SD, paste, collapse="||"), by="experiment_sample_accession"])
      fcs_df <- merge(fcs_df ,tr_df, by="experiment_sample_accession", all.x = TRUE)
    } else {
      fcs_df["specimen_treatment"] = ""
      fcs_df["treatment_amount_value"] = ""
      fcs_df["treatment_amount_unit"] = ""
      fcs_df["treatment_duration_value"] = ""
      fcs_df["treatment_duration_unit"] = ""
      fcs_df["treatment_temperature_value"] = ""
      fcs_df["treatment_temperature_unit"] = ""
    }
    
    fcs_df <- transform(fcs_df, sequence = as.integer(sequence))
    setDT(fcs_df)[, `:=`(sequence, seq_len(.N)), by = "subject_id"]
    setorder(fcs_df, "subject_id")
    fcs_df <- as.data.frame(fcs_df)
    
    
#     sql_stmt <- paste("
#                       SELECT distinct
#                       far.expsample_accession,
#                       far.base_parent_population, 
#                       far.population_cell_number, 
#                       far.population_cell_number_unit,
#                       far.population_defnition_reported, 
#                       far.population_name_reported
#                       FROM  
#                       fcs_analyzed_result far
#                       WHERE 
#                       far.study_accession in (\'", study_id,"\')",sep="")
#     
#     
#     far_df <- dbGetQuery(conn,statement=sql_stmt)
#     colnames(far_df) <- far_cols 
#     fcs_df <- merge(fcs_df ,far_df, all=TRUE)
  }
  
  cat("done", "\n")
  fcs_df
}

getCountOfFcsResults <- function(conn,study_id) {  
  sql_stmt <- paste("
                    SELECT count(*)
                    FROM biosample bs,
					          expsample es,
                    experiment ex,
                    expsample_2_biosample es2bs,
                    expsample_2_file_info es2fi,
                    file_info fi                    
                    WHERE bs.study_accession in (\'", study_id,"\') AND 
                    bs.biosample_accession=es2bs.biosample_accession AND
                    es2bs.expsample_accession=es.expsample_accession AND 
                    es.experiment_accession=ex.experiment_accession AND
                    es2bs.expsample_accession=es2fi.expsample_accession AND 
                    es2fi.file_info_id=fi.file_info_id AND 
                    (fi.detail LIKE \'%Flow cytometry result%\' OR fi.detail LIKE \'%CyTOF result%\') AND 
                    fi.detail IN (\'Flow cytometry result\', \'CyTOF result\')", sep="")
  
  count <- dbGetQuery(conn,statement=sql_stmt)
  
  count[1,1]
}

---
title: "RImmPort: Enabling ready-for-analysis immunology research data"
author: "Ravi Shankar"
date: "`r Sys.Date()`"
output: 
    rmarkdown::pdf_document:
        toc: true
        toc_depth: 4
        number_sections: true
vignette: >
  %\VignetteIndexEntry{RImmPort: Enabling ready-for-analysis immunology research data}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

*****
# Introduction

Publicly available raw individual-level clinical trial data has created tremendous opportunity to evaluate new research hypotheses that were not originally formulated in the studies; by reanalyzing data from a study, by performing cross analysis of multiple studies, or by combining study data with other public research datasets. But such analysis of disparate data presupposes a) uniform representation of clinical trial data using data standards, and b) easy access to such standard representations of clinical trial data in analytical environments. 
`ImmPort`, the Immunology Database and Analysis Portal (immport.niaid.nih.gov) system, warehouses clinical study data in all areas of immunology that is generated by scientific researchers supported by the National Institute of Allergy and Infectious Diseases (`NIAID`). Currently, more than 100 studies are publicly available in ImmPort. The `RImmPort` package simplifies access to ImmPort data for analysis, as the name implies, in the R statistical environment. It provides a standards-based interface to the ImmPort study data that is in a proprietary format. 

# Overview of ImmPort

`ImmPort`, the Immunology Database and Analysis Portal (immport.niaid.nih.gov) system, warehouses clinical trials data in all areas of immunology that is generated primarily by investigators funded by the US National Institute of
Allergy and Infectious Diseases (NIAID). With more than 100 datasets now publicly available and hundreds of downloads per month, ImmPort is an important source for raw data and protocols from clinical trials, mechanistic studies, and novel methods for cellular and molecular measurements. The different types of study-related data that are found in ImmPort include: 

- Study Summary
- Arms
- Subject Demographics
- Assessments
- Concomitant Medications
- Study Interventions
- Laboratory Test Results 
- Mechanistic Assay Results 
- Adverse Events

The [Open ImmPort](http://www.immport.org/) provides interface to explore metadata of all studies that are publicly available, in order to locate the studies of interest. The [ImmPort](https://immport.niaid.nih.gov/) website houses all the study data. Users can download any of the data after registering at the ImmPort website (registration is free). The study data is available in 2 formats: MySQL format and Tab Separated Value (TSV) format. The RImmPort package works with both the formats. The [schema](http://immport.org/immport-open/public/schema/schemaDefinition/study) and the [entity-relationship diagrams](http://immport.org/immport-open/public/schema/schemaDiagram/AllTables) document ImmPort's proprietary database model that is employed in the MySQL format of study data and is also reflected in the Tab format. Study data may be downloaded for each individual study, or the entire set of data for all studies may be downloaded as one file. In the case of MySQL format, users need to run a private instance of MySQL database, load the downloaded study data into that database instance, and then query the data for analysis. In the case of Tab format, users will read the tab-delimited files into their analytical environment and then perform data analysis.

# Overview of RImmPort 

`RImmPort` package simplifies access to ImmPort data for analysis, as the name implies, in the R statistical environment. Essentially,it provides a standards-based interface to the proprietary MySQL-formatted or Tab-formatted ImmPort data. It comprises of four main components: 1) an RImmPort data model that encapsulates ImmPort study data. The model leverages of study data standards from the Clinical Data Interchange Standards Consortium (CDISC), and incorporates terms and semantics found in these standards, 2) foundational methods to query and load different types of data of a specific study in ImmPort, 3) methods to search and integrate specific types of study data of multiple studies, and 4) utility methods to export and import study data in RImmPort format. 
![RImmPort Components](RImmPort_Components.png)

The RImmPort workflow is illustrated in the following figure. User creates a private MySQL database instance, downloads study data of interest from ImmPort website, and loads the data into the private database. In R, user connects to the private ImmPort database, and calls the methods in the RImmPort library, to load a specific study from the database into R.

![RImmPort Data Workflow](RImmPort_Process.png)

Using RImmPort, an entire study can be loaded into R with a single command. For example, a researcher interested in analyzing a specific study ImmPort Identifier:SDY1, can use RImmPort to easily access different types of individual-level data -subject demographics, clinical assessments, adverse events, results of flow cytometry and ELISA experiments on 4211 biosamples collected at different time points over 12 weeks from 159 subjects. 

\pagebreak

# Overview of CDISC SDTM Data Standard

The Clinical Data Interchange Standards Consortium ([CDISC](http://www.cdisc.org/)) has been developing a suite of data standards, supporting different stages of the clinical research process: study design, study conduct, data analysis and reporting. The Study Data Tabulation Model ([SDTM](http://www.cdisc.org/sdtm/)) defines a data tabulation standard that can be used to structure study data when submitting to regulatory agencies such as the United States Food and Drug Administration (FDA). In SDTM, the data is structured in a hierarchy, as Classes, Domains, Variables and Values. Here is a list of foundational classes and a partial set of domains under each class:

- Special Purpose Class
    - Demographics (DM) Domain
    - Subject Visits (SV) Domain
- Interventions Class
    - Concomitant Medications (CM) Domain
    - Exposure (EX) Domain
    - Substance Use (SU) Domain
- Events Class
    - Adverse Events (AE) Domain
    - Medical History (MH) Domain
- Findings Class
    - Laboratory Test Results (LB) Domain
    - Vital Signs (VS) Domain
    - Physical Examination (PE) Domain
- Trial Design Class
    - Trial Summary (TS) Domain
    - Trial Arms (TA) Domain

Each Domain defines a standard set of Variables that are appropriate for that Domain, and should be used to structure data of that domain. As an example, the table shows a partial list of Variables for the Demographics (DE) Domain:

| Variable Name | Variable Label |
|:-------|:-----|
| STUDYID | Study Identifier  |
| DOMAIN  | Domain Abbreviation |
| USUBJID | Unique Subject Identifier |
| AGE | Age |
| AGEU | Age Units |
| SEX | Sex |
| RACE | Race |
| ARMCD | Planned Arm Code |

Continuing with this example, Demographics data of a specific study can be tabulated using the SDTM Demographics Domain:

| row | STUDYID | DOMAIN | USUBJID | AGE | AGEU | SEX | RACE | ARMCD |
|:------:|:-----:|:-----:|:-----:|:-----:|:-----:|:-----:|:-----:|
| 1 | SDY1  | DM | SUB73366 | 47 | Years | Male | White | ARM4 |
| 2 | SDY1  | DM | SUB73367 | 37 | Years | Female |Asian | ARM3 |
| 3 | SDY1  | DM | SUB73368 | 47 | Years | Female |Multiple | ARM3 |

If the study data has variables that are not in the standard set, SDTM provides a Name-Value pair mechanism to create Supplemental Domain data. In the example, the standard variable RACE captures subject's race. If the study has collected data on all applicable races of a subject, then the Supplemental Demographics Domain data, can be tabulated as follows, with RACE1 and RACE2 as non-standard Variables:

| row | STUDYID | RDOMAIN | USUBJID | QNAM | QLABEL | QVALUE | 
|:------:|:-----:|:-----:|:-----:|:-----:|:-----:|:-----:|:-----:|
| 1 | SDY1  | DM | SUB73368 | RACE1 | Race 1 | Black or African American | 
| 2 | SDY1  | DM | SUB73368 | RACE2 | Race 2 | American Indian or Alaska Native |

Thus, all of the study data can be structured as SDTM Domain data tables, and any supplemental Domain data tables. For new types of research data that does not naturally map to an existing SDTM domain, SDTM allows creating custom Domains. The custom Domain can then be proposed to the SDTM standards committee, to be developed into a standard.



\pagebreak


# RImmPort Data Model

The RImmPort data model implements the SDTM data standards in encapsulating the different types of the ImmPort study data. The model comprises of the following Classes and Domains (codes in parentheses):

- Special Purpose 
    - Demographics (DM) - describes each subject in a clinical study
    - Subject Visits (SV) - collates the timing information on subject visits 
- Interventions 
    - Concomitant Medications (CM) - concomitant and prior medications/therapies used by the subject
    - Exposure (EX) - subject's exposure to protocol specified study treatment
    - Substance Use (SU) - substance use information
- Events 
    - Adverse Events (AE) - adverse event information
    - Protocol Deviations (DV) - protocol violations and deviations during the course of the study
    - Medical History (MH) - subject's prior medical history at the start of the trial
    - Associated Persons Medical History (APMH) - medical history of persons associated with the subject
- Findings 
    - Laboratory Test Results (LB) - laboratory test findings including, but not limited to hematology, clinical chemistry and urinalysis data.
    - Vital Signs (VS) - measurements including but not limited to blood pressure, temperature, respiration, body surface area, BMI, height and weight.
    - Questionnaires (QS) - information on questionnaires
    - Physical Examination (PE) - findings collected during a physical examination of the subject
    - Findings About (FA) - a dataset used to capture the findings about an event or intervention that cannot be represented within an event or intervention record or as a supplemental.
    - Skin Response (SR) - skin assessment results
    - Genetics Findings (PF) - genetics findings (Array and HLA Typing assays)
    - Protein Quantification (ZA) -  non-standard domain for protein quantification data (ELISA and MBAA assays)
    - Cellular Quantification (ZB) - non-standard domain for cellular quantification data (Flow and ELISPOT assays)
    - Nucleic Acid Quantification (ZC) - non-standard domain for nucleic acid quantification data (PCR assays)
    - Titer Assay Results (ZD) -  non-standard  domain for titer assay results data (HAI and Neut Ab Titer assays)
- Trial Design 
    - Trial Arms (TA) - all the planned arms in the trial
    - Trial Inclusion Exclusion Criteria (TI) - all the inclusion and exclusion criteria for the trial
    - Trial Summary (TS) - information about the planned and actual trial characteristics

## RImmPort `Study` reference class

The `Study` reference class and its components (shown below) form the core of the RImmPort data model, and is designed to parallel SDTM's Class, Domain, Variable and Value model.  


```{r eval=FALSE}

# Truncated code to improve clarity - for illustration purpose only

Study <- setRefClass("Study", fields = list(
  special_purpose="SpecialPurpose",
  interventions="Interventions",
  events="Events",
  findings="Findings",
  trial_design="TrialDesign"),
  ...
))

SpecialPurpose <- setRefClass("SpecialPurpose", 
                             fields = list(
                               dm_l="list",
                               sv_l="list"),  
                             ...

Interventions <- setRefClass("Interventions", 
                                fields = list(
                                  cm_l="list",
                                  ex_l="list",
                                  su_l="list"),  
                             ...

Events <- setRefClass("Events", fields = list(
                                  ae_l="list",
                                  dv_l="list",
                                  mh_l="list",
                                  apmh_l="list"),  
                      ...

Findings <- setRefClass("Findings", 
                        fields = list(
                                lb_l="list",
                                pe_l="list",
                                vs_l="list",
                                qs_l="list",
                                fa_l="list",
                                sr_l="list",
                                pf_l="list",
                                za_l="list",
                                zb_l="list",
                                zc_l="list",
                                zd_l="list"),
                        ...

TrialDesign <- setRefClass("TrialDesign", 
                        fields = list(
                          ta_l="list",
                          ti_l="list",
                          ts_l="list"),
                        ...
                        

```

### Notes on `Study` reference class and its components
- There is a reference class for each of the five SDTM Classes (SpecialPurpose, Interventions, Events, Findings, and TrialDesign). 
- The Domains are listed as fields of respective reference classes. For example, the field `dm_l` in the `SpecialPurpose` reference class is associated with the Demographics domain. The convention in naming the Domain field is `<lower-case Domain code>_l`, for e.g., `dm_l` for Demographics domain. 
- All the Domain fields (`dm_l`, `sv_l`, `lb_l`, etc.) are of type `list`. When the `'Study` reference class is instantiated with data of a specific study, each domain field will contain a list of 2 named dataframes, Domain data and any supplemental Domain data. For.e.g., `dm_l` is a list of `dm_f` (Demographics data), and `suppdm_f` (supplemental Demographics data). 
- In a specific study, if there is specific Domain data, but no corresponding supplemental Domain data, then there will be an empty supplemental dataframe. For e.g., if there is no supplemental Demographics data, then `suppdm_df` will be an empty dataframe.
- In a specifc study, if there is no data for a specific domain, then the Domain field list will be empty. For e.g., if there no Substance Use data, then the `su_l` will be an empty list.
- RImmPort function `getStudy()` instantiates the `Study` reference class with data of a specific study in the ImmPort data source The hierarchical structure of the `Study` instance can then be traversed to access different types of study data (see Section `Get all data of a specific study`).



\pagebreak


# RImmPort Functions

RImmPort supports a set of functions to load different types of study data. The functions generally comprise of 3 steps: 1) query study data from the ImmPort data source, 2) map the data to CDISC SDTM-based RImmPort model, and 3) load the data into the R environment. The documentation on all these functions can be found in the RImmPort reference manual (`RImmPort-manual.pdf`). The documentation can also be accessed from the R console using the `help (?)` function, for e.g., `?getStudy`.

## Foundational Functions
The foundational functions enable loading different types of study data of a specific ImmPort study. An intitial step, before invoking any of the "get data" functions, is setting the ImmPort data source that these functions operate upon. As mentioned earlier, ImmPort data comes in 2 formats, MySQL and Tab, and RImmPort can work with either one. User can set up a MySQL data source by creating a MySQL database and loading the database with ImmPort study data that is in MySQL format. For the Tab data source, RImmPort provides a utility function to create a private SQLite database and load the database with ImmPort study data that is in Tab format. The `setImmPortDataSource` function takes in as input a connection handle to either the MySQL database or the SQLite database, and sets that database as the ImmPort data source that other RImmPort functions use.

### Load the RImmPort library
```{r}
library(RImmPort)
library(DBI)
library(sqldf)
library(plyr)
```

### Set the MySQL database as ImmPort data source

```{r eval=FALSE}

# provide appropriate MySQL database connection parameters
mysql_conn <- dbConnect(MySQL(), user="username", password="password", 
                   dbname="database",host="host")

# set the data source as the ImmPort MySQL database.

```{r  eval=FALSE}
setImmPortDataSource(mysql_conn)
```
## Option 2: ImmPort SQLite database

### Download zip files of ImmPort data, in Tab format. e.g.'SDY139' and 'SDY208'
```{r  eval=FALSE}
# get the directory where ImmPort sample data is stored in the directory structure of RImmPort package
studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")

# set tab_dir to the folder where the zip files are located
tab_dir <- file.path(studies_dir, "Tab")
list.files(tab_dir)
```

### Build a local SQLite ImmPort database instance. 
```{r  eval=FALSE}
# set db_dir to the folder where the database file 'ImmPort.sqlite' should be stored
db_dir <- file.path(studies_dir, "Db")
```
```{r   eval=FALSE}
# build a new ImmPort SQLite database with the data in the downloaded zip files
buildNewSqliteDb(tab_dir, db_dir) 
```
```{r  eval=FALSE}
list.files(db_dir)
```

### Set the SQLite database as ImmPort data source

```{r}
# get the directory of a sample SQLite database that has been bundled into the RImmPort package
db_dir <- system.file("extdata", "ImmPortStudies", "Db", package = "RImmPort")

# connect to the database
sqlite_conn <- dbConnect(SQLite(), dbname=file.path(db_dir, "ImmPort.sqlite"))

# set the ImmPort SQLite database as the ImmPort data source
setImmPortDataSource(sqlite_conn)
```

### NOTE: In rest of this document, all RImmPort functions will use the SQLite ImmPort database as the ImmPort data source.

### Get all data of a specific study
The `getStudy` queries the ImmPort database for the entire dataset of a specifc study, and instantiates the `Study` reference class with that data. 

```{r}
# view documentation on Study
?Study

# get all study ids
getListOfStudies()

# load the entire data of study: `SDY139`
study_id <- 'SDY139'
sdy139 <- getStudy(study_id)

# access Demographics data of SDY139
dm_df <- sdy139$special_purpose$dm_l$dm_df
head(dm_df)

# access Concomitant Medications data of SDY139
cm_df <- sdy139$interventions$cm_l$cm_df
head(cm_df)

# get Trial Title from Trial Summary
ts_df <- sdy139$trial_design$ts_l$ts_df
title <- ts_df$TSVAL[ts_df$TSPARMCD== "TITLE"]
title
```

### Get specific domain data of a specific study
The `getDomainDataOfStudies` function takes as inputs, the name of the Domain of interest, and one or more study identifiers.  The function returns a list of 2 named dataframes, Domain data and any supplemental Domain data; for e.g.,`dm_f` (Demographics data), and `suppdm_f` (supplemental Demographics data). The Domain name should be exact to what is found in the list of Domain names. 

```{r}

# get the list of names of all supported Domains
getListOfDomains()

?"Demographics Domain"

# get domain code of Demographics domain
domain_name <- "Demographics"
getDomainCode(domain_name)

dm_l <- getDomainDataOfStudies(domain_name, "SDY139")
if (length(dm_l) > 0) 
  names(dm_l)
head(dm_l$dm_df)

```

## Search and Integrate Functions
RImmPort supports methods to search and integrate specific types of study data of multiple studies.

### Get studies with specifc domain data
The `getStudiesWithSpecificDomainData` takes as input the name of Domain of interest, and outputs a list of studies that have the specific Domain data.

```{r}
# get list of studies with Cellular Quantification data
domain_name <- "Cellular Quantification"
study_ids_l <- getStudiesWithSpecificDomainData(domain_name)
study_ids_l
```

### Get specifc domain data of a set of studies
The `getDomainDataOfStudies` function takes as inputs, the name of the Domain of interest, and a list of study identifiers, and outputs a Domain dataframe and any supplemental Domain dataframe that contain integrated Domain data. 

```{r}
# get Cellular Quantification data of studies `SDY139` and `SDY208`

# get domain code of Cellular Quantification domain
domain_name <- "Cellular Quantification"
getDomainCode(domain_name)

study_ids <- c("SDY139", "SDY208")
domain_name <- "Cellular Quantification"
zb_l <- getDomainDataOfStudies(domain_name, study_ids)
if (length(zb_l) > 0) 
  names(zb_l)
head(zb_l$zb_df)
```

### Get the list of assay types  
The function `getListOfAssayTypes` returns a list of assay types that ImmPort has data for.

```{r}
getListOfAssayTypes()
```

### Get specific assay data of one or more studies

The results of assays that were performed in the study are organized into 5 specialized Findings domains: Genetics Findings (PF), Protein Quantification (ZA), Cellular Quantification (ZB), Nucleic Acid Quantification (ZC) and Titer Assay Results (ZD). There can be a many-to-many relationship between the 5 domains and the assay types. The RImmPort function `getAssayDataOfStudies()` takes as input an assay type and and a list of study identifiers, and outputs a list of dataframes of the 5 Findings domains that have the assay data.

```{r}

# get 'ELISPOT' data of study `SDY139`
assay_type <- "ELISPOT"
study_id = "SDY139"
elispot_l <- getAssayDataOfStudies(study_id, assay_type)
if (length(elispot_l) > 0)
  names(elispot_l)
head(elispot_l$zb_df)

```

## Utility functions
RImmPort has a set of utility methods to export and import study data in RImmPort format, and to build the SQLite database from Tab formatted ImmPort downloads.

### Serialize study data in RImmPort format
The function `serialzeStudyData()` serializes the entire RImmPort-formatted study data as .rds files
```{r eval=FALSE}
# get the directory where ImmPort sample data is stored in the directory structure of RImmPort package
studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")

# serialize all of the data of studies `SDY139` and `SDY208'
study_ids <- c('SDY139', 'SDY208')

# the folder where the .rds files will be stored
rds_dir <- file.path(studies_dir, "Rds")

serialzeStudyData(study_ids, rds_dir)
list.files(rds_dir)

```

### Load serialized study data into the R environment
The function `loadSerializedStudyData()` loads the serialzed data (.rds) files of a specific domain of a study from the directory where the files are located
```{r}
# get the directory where ImmPort sample data is stored in the directory structure of RImmPort package
studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")

# the folder where the .rds files will be stored
rds_dir <- file.path(studies_dir, "Rds")

# list the studies that have been serialized
list.files(rds_dir)

# load the serialized data of study `SDY208` 
study_id <- 'SDY208'
dm_l <- loadSerializedStudyData(rds_dir, study_id, "Demographics")
head(dm_l[[1]])

```

### Build a private SQLite ImmPort database instance. 
The funciton `buildNewSqliteDb` reads the Tab-formatted study data zip files that the user has downloaded from the ImmPort website, and creates a SQLite database.
```{r}
# get the directory where ImmPort sample data is stored in the directory structure of RImmPort package
studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")

# set tab_dir to the folder where the zip files are located
tab_dir <- file.path(studies_dir, "Tab")
list.files(tab_dir)

# set db_dir to the folder where the database file 'ImmPort.sqlite' should be stored
db_dir <- file.path(studies_dir, "Db")
```
```{r eval=FALSE}
# build a new ImmPort SQLite database with the data in the downloaded zip files
buildNewSqliteDb(tab_dir, db_dir) 
```
```{r}
list.files(db_dir)
```

# Conclusion

By basing RImmPort on open formalism and by making it available in open source platforms, we ensure that clinical study data in ImmPort is ready for analysis, thus enabling innovative bioinformatics research in immunology.

---
title: "RImmPort: Quick Start Guide"
author: "Ravi Shankar"
date: "`r Sys.Date()`"
output: 
    rmarkdown::pdf_document:
        number_sections: true
vignette: >
  %\VignetteIndexEntry{RImmPort: Quick Start Guide}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

*****
# Introduction
ImmPort study data is available for download in two formats currently: MySQL and TSV (Tab) formats. The RImmPort workflow is as follows: 
1) MySQL formatted study data: 
       User downloads one or more studies in MySQL zip files. 
       Unzips the files. 
       Loads local database instance. 
       Connects to the database. 
       Sets the ImmPort data source to the connection handle. 
       Invokes RImmPort functions.
2) Tab: 
       User downloads one or more studies in Tab format. 
       Passes the folder where the zip files are located to an RImmPort function that builds SQLite database. 
       Connects to the database. 
       Sets the ImmPort data source to the connection handle. 
       Invokes RImmPort functions.

User downloads study data of interest from the ImmPort website ( http://www.immport.org ) **. Depending on the file format MySQL or Tab the data is loaded into a local MySQL and SQLite database respectively. The user installs the RImmPort package, loads the RImmPort library, connects to the ImmPort database, and calls RImmPort methods to load study data from the database into R. Please refer to RImmPort_Article.pdf for a detailed discussion on RImmPort.

** User need to regsiter to the ImmPort website for downloading the datasets.

# Initial Steps

- Download MySQL or Tab formatted data of studies of interest from the ImmPort website
- If working with MySQL-format, load the data in to a local MySQL database
- Install and load RImmPort package, and other required packages.

# Load the RImmPort library

```{r}
library(RImmPort)
library(DBI)
library(sqldf)
library(plyr)

```
# Setup ImmPort data source that all RImmPort functions will use

## Option 1: ImmPort MySQL database

### Download zip files of ImmPort study data in MySQL format. e.g.'SDY139' and 'SDY208'
### Load the data into a local MySQL database

### Connect to the ImmPort MySQL database.
```{r eval=FALSE}

# provide appropriate connection parameters
mysql_conn <- dbConnect(MySQL(), user="username", password="password", 
                   dbname="database",host="host")

```

### Set the data source as the ImmPort MySQL database.

```{r  eval=FALSE}
setImmPortDataSource(mysql_conn)
```

## Option 2: ImmPort SQLite database

### Download zip files of ImmPort data, in Tab format. e.g.'SDY139' and 'SDY208'
```{r  eval=FALSE}
# get the directory where ImmPort sample data is stored in the directory structure of RImmPort package
studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")

# set tab_dir to the folder where the zip files are located
tab_dir <- file.path(studies_dir, "Tab")
list.files(tab_dir)
```

### Build a local SQLite ImmPort database instance. 
```{r  eval=FALSE}
# set db_dir to the folder where the database file 'ImmPort.sqlite' should be stored
db_dir <- file.path(studies_dir, "Db")
```
```{r  eval=FALSE}
# build a new ImmPort SQLite database with the data in the downloaded zip files
buildNewSqliteDb(tab_dir, db_dir) 
```
```{r  eval=FALSE}
list.files(db_dir)
```

### Connect to the ImmPort SQLite database 
```{r}
# get the directory of a sample SQLite database that has been bundled into the RImmPort package
db_dir <- system.file("extdata", "ImmPortStudies", "Db", package = "RImmPort")

# connect to the private instance of the ImmPort database
sqlite_conn <- dbConnect(SQLite(), dbname=file.path(db_dir, "ImmPort.sqlite"))
```

### Set the data source to the ImmPort SQLite DB
```{r}
setImmPortDataSource(sqlite_conn)
```

# NOTE: In rest of the script, all RImmPort functions will use the SQLite ImmPort database as the data source.

# Get all study ids
```{r}
getListOfStudies()
```

# Get all data of a specific study
The `getStudyFromDatabase` queries the ImmPort database for the entire dataset of a specific study, and instantiates the `Study` reference class with that data. 
```{r}
?Study

# load all the data of study: `SDY139`
study_id <- 'SDY139'
sdy139 <- getStudy(study_id)

# access Demographics data of SDY139
dm_df <- sdy139$special_purpose$dm_l$dm_df
head(dm_df)

# access Concomitant Medications data of SDY139
cm_df <- sdy139$interventions$cm_l$cm_df
head(cm_df)

# get Trial Title from Trial Summary
ts_df <- sdy139$trial_design$ts_l$ts_df
title <- ts_df$TSVAL[ts_df$TSPARMCD== "TITLE"]
title
```

# Get the list of Domain names. 
Note that some RImmPort functions take a domain name as input.

```{r}

# get the list of names of all supported Domains
getListOfDomains()

?"Demographics Domain"

```

# Get list of studies with specifc domain data
The Domain name should be exact to what is found in the list of Domain names.
```{r}
# get list of studies with Cellular Quantification data
domain_name <- "Cellular Quantification"
study_ids_l <- getStudiesWithSpecificDomainData(domain_name)
study_ids_l
```

# Get specifc domain data of one or more studies
The Domain name should be exact to what is found in the list of Domain names. 
```{r}
# get Cellular Quantification data of studies `SDY139` and `SDY208`

# get domain code of Cellular Quantification domain
domain_name <- "Cellular Quantification"
getDomainCode(domain_name)

study_ids <- c("SDY139", "SDY208")
domain_name <- "Cellular Quantification"
zb_l <- getDomainDataOfStudies(domain_name, study_ids)
if (length(zb_l) > 0) 
  names(zb_l)
head(zb_l$zb_df)
```

# Get the list of assay types from ImmPort studies
```{r}
getListOfAssayTypes()
```

# Get specific assay data of one or more Immport studies
The assay type should be exact to what is found in the list of supported assay types. 
```{r}

# get 'ELISPOT' data of study `SDY139`
assay_type <- "ELISPOT"
study_id = "SDY139"
elispot_l <- getAssayDataOfStudies(study_id, assay_type)
if (length(elispot_l) > 0)
  names(elispot_l)
head(elispot_l$zb_df)

```

# Serialize RImmPort-formatted study data as .rds files
```{r eval=FALSE}

# serialize all of the data of studies `SDY139` and `SDY208'
study_ids <- c('SDY139', 'SDY208')

# the folder where the .rds files will be stored
rds_dir <- file.path(studies_dir, "Rds")

serialzeStudyData(study_ids, rds_dir)
list.files(rds_dir)

```

# Load the serialzed data (.rds) files of a specific domain of a study from the directory where the files are located
```{r}
# get the directory where ImmPort sample data is stored in the directory structure of RImmPort package
studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")

# the folder where the .rds files will be stored
rds_dir <- file.path(studies_dir, "Rds")

# list the studies that have been serialized
list.files(rds_dir)

# load the serialized data of study `SDY208` 
study_id <- 'SDY208'
dm_l <- loadSerializedStudyData(rds_dir, study_id, "Demographics")
head(dm_l[[1]])

```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Study.R
\docType{class}
\name{Events-class}
\alias{Events}
\alias{Events-class}
\title{Events class}
\description{
Events class
}
\section{Fields}{

\describe{
\item{\code{ae_l}}{Adverse Events data \code{\link{AE}} and supplemental Adverse Events data \code{\link{SUPP}}}

\item{\code{dv_l}}{Protocol Deviations data \code{\link{DV}} and supplemental Protocol Deviations data \code{\link{SUPPDV}}}

\item{\code{mh_l}}{Medical History data \code{\link{MH}} and supplemental Medical History data \code{\link{SUPPMH}}}

\item{\code{apmh_l}}{Associated Persons Medical History data \code{\link{APMH}} and supplemental Associated Persons Medical History data \code{\link{SUPP}}}
}}
\examples{
library(DBI)
library(sqldf)
studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")
db_dir <- file.path(studies_dir, "Db")
sqlite_conn <- dbConnect(SQLite(), dbname=file.path(db_dir, "ImmPort.sqlite"))
setImmPortDataSource(sqlite_conn)
sdy139 <- getStudy("SDY139")
ae_df <- sdy139$events$ae_l$ae_df
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TrialVisits.R
\name{Trial Visits Domain}
\alias{Trial Visits Domain}
\title{Trial Visits Domain}
\description{
Information on the planned visits of an ImmPort study is reformated to the CDISC SDTM Trial Visits (TV) 
domain model, and is a list of 2 data frames containing 1) Trial Visits data \code{\link{TV}} 
and 2) any supplemental Trial Visits data \code{\link{SUPP}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Study.R
\name{loadSerializedStudyData}
\alias{loadSerializedStudyData}
\title{Load the Serialized Data of a Study}
\usage{
loadSerializedStudyData(data_dir, study_id, domain)
}
\arguments{
\item{data_dir}{Path to a file folder where the .rds study files reside}

\item{study_id}{Study indentifier}

\item{domain}{Domain of interest}
}
\value{
A study data object where in all data are structured as classes, domains, variables and values (in CDISC format)
}
\description{
Load the serialzed data (.rds) file of a specific domain of a study study from the directory where 
the file is located
}
\examples{
studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")
# the folder where the .rds files will be stored
rds_dir <- file.path(studies_dir, "Rds")
# load the serialized data of study `SDY208` 
loadSerializedStudyData(rds_dir, 'SDY208', "Demographics")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/VitalSigns.R
\name{Vital Signs Domain}
\alias{Vital Signs Domain}
\title{Vital Signs Domain}
\description{
The Vital Signs data of an ImmPort study is reformated to the CDISC SDTM Vital Signs (VS) 
domain model, and is a list of 2 data frames containing 1) Vital Signs data \code{\link{VS}} 
and 2) any supplemental Vital Signs data \code{\link{SUPPVS}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Questionnaires.R
\name{QS}
\alias{QS}
\title{Questionnaires Domain Variables}
\description{
{
  \tabular{ll}{
    \strong{Variable Name  } \tab \strong{Variable Label} \cr
    STUDYID \tab Study Identifier \cr
    DOMAIN  \tab Domain Abbreviation \cr
    USUBJID \tab Unique Subject Identifier \cr
    QSSEQ \tab Sequence Number \cr
    QSTEST \tab Questionnaires Test Name \cr
    QSCAT \tab Category for Questionnaires \cr
    QSORRES \tab Results or Findings in Original Units \cr
    QSORRESU \tab Original Units \cr
    VISITNUM \tab Visit Number \cr
    VISIT \tab Visit Name \cr
    QSDY \tab Study Day of Finding
  }
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SubjectVisits.R
\name{SV}
\alias{SV}
\title{Subject Visits Domain Variables}
\description{
{
  \tabular{ll}{
    \strong{Variable Name  } \tab \strong{Variable Label} \cr
    STUDYID \tab Study Identifier \cr
    DOMAIN  \tab Domain Abbreviation \cr
    USUBJID \tab Unique Subject Identifier \cr
    VISITNUM \tab Visit Number \cr
    VISIT \tab Visit Name \cr
    SVSTDY \tab Study Day of Start of Visit
  }
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SubstanceUse.R
\name{Substance Use Domain}
\alias{Substance Use Domain}
\title{Substance Use Domain}
\description{
The Substance Use data of an ImmPort study is reformated to the CDISC SDTM Substance Use (SU) 
domain model, and is a list of 2 data frames containing 1) Substance Use data \code{\link{SU}} 
and 2) any supplemental Substance Use data \code{\link{SUPP}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Study.R
\name{setImmPortDataSource}
\alias{setImmPortDataSource}
\title{Set ImmPort data ource}
\usage{
setImmPortDataSource(data_src)
}
\arguments{
\item{data_src}{A connection handle to ImmPort (MySQL or SQLite) database instance or 
a directory handle to folder where study RImmPort-formatted (.rds) files located}
}
\value{
1 if successful
}
\description{
The function \code{setImmPortDataSource} sets the data source variable in RImmPort environment, 
to the connection handle to the MySQL or SQLite database, or to the file directory where the 
pre-created RImmPort-formatted files are stored.
}
\examples{
library(DBI)
library(sqldf)
studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")
db_dir <- file.path(studies_dir, "Db")
sqlite_conn <- dbConnect(SQLite(), dbname=file.path(db_dir, "ImmPort.sqlite"))
setImmPortDataSource(sqlite_conn)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TrialVisits.R
\name{TV}
\alias{TV}
\title{Trial Visits Domain Variables}
\description{
{
  \tabular{ll}{
    \strong{Variable Name  } \tab \strong{Variable Label} \cr
    STUDYID \tab Study Identifier \cr
    DOMAIN  \tab Domain Abbreviation \cr
    VISITNUM \tab Visit Number \cr
    VISIT \tab Visit Name \cr
    ARMCD \tab Planned Arm Code \cr
    ARM \tab Name of Planned Arm \cr
    TVSTRL \tab Visit Start Rule \cr
    TVENRL \tab Visit End Rule
  }
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SubjectVisits.R
\name{Subject Visits Domain}
\alias{Subject Visits Domain}
\title{Subject Visits Domain}
\description{
Actual subject visits data of an ImmPort study is reformated to the CDISC SDTM Subject Visits (SV) 
domain model, and is a list of 2 data frames containing 1) Subject Visits data \code{\link{SV}} 
and 2) any supplemental Subject Visits data \code{\link{SUPP}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PhysicalExamination.R
\name{Physical Examination Domain}
\alias{Physical Examination Domain}
\title{Physical Examination Domain}
\description{
The Physical Examination data of an ImmPort study is reformated to the CDISC SDTM 
Physical Examination (PE) domain model, and is a list of 2 data frames containing 1) Physical 
Examination data \code{\link{PE}} and 2) any supplemental Physical Examination data \code{\link{SUPPPE}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ImmPortSqlite.R
\name{buildNewSqliteDb}
\alias{buildNewSqliteDb}
\title{buildNewSqliteDb}
\usage{
buildNewSqliteDb(data_dir, db_dir)
}
\arguments{
\item{data_dir}{File directory where the study TSV files are stored}

\item{db_dir}{File directory where the sqlite database will be stored}
}
\value{
The SQLite database name
}
\description{
The function \code{buildSqliteDb} builds a sqlite db of ImmPort study data. It takes in as input the 
study files in the TSV (Tab) format.
}
\examples{
studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")
# set tab_dir to the folder where the zip files are located
tab_dir <- file.path(studies_dir, "Tab")
# set db_dir to the folder where the database file 'ImmPort.sqlite' should be stored
db_dir <- file.path(studies_dir, "Db")
# build a new ImmPort SQLite database with the data in the downloaded zip files
# dbname <- buildNewSqliteDb(tab_dir, db_dir) 
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/CellularQuantification.R
\name{ZB}
\alias{ZB}
\title{Cellular Quantification Domain Variables}
\description{
{
  \tabular{ll}{
    \strong{Variable Name  } \tab \strong{Variable Label} \cr
    STUDYID \tab Study Identifier \cr
    DOMAIN  \tab Domain Abbreviation \cr
    USUBJID \tab Unique Subject Identifier \cr
    ZBSEQ \tab Sequence Number \cr
    ZBTEST \tab Cellular Quantification Test Name \cr
    ZBCAT \tab Category for Cellular Quantification \cr
    ZBMETHOD \tab Measurement Technique \cr
    ZBPOPDEF \tab Cell Population Definition \cr
    ZBPOPNAM \tab Cell Population Name \cr
    ZBORRES \tab Result or Finding in Original Units \cr
    ZBORRESU \tab Original Units \cr
    ZBBASPOP \tab Base Parent Population \cr
    ZBSPEC \tab Specimen Type \cr
    VISITNUM \tab Visit Number \cr
    VISIT \tab Visit Name \cr
    ZBELTM \tab Planned Elapsed Time from Time Point Ref \cr
    ZBTPTREF \tab Time Point Reference \cr
    ZBREFID \tab Specimen Identifier \cr
    ZBXFN \tab Raw Data File or Life Science Identifier
  }
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Study.R
\docType{class}
\name{Interventions-class}
\alias{Interventions}
\alias{Interventions-class}
\title{Interventions class}
\description{
Interventions class
}
\section{Fields}{

\describe{
\item{\code{cm_l}}{Concomitant Medications data \code{\link{CM}} and supplemental Concomitant Medications data \code{\link{SUPP}}}

\item{\code{ex_l}}{Exposure data \code{\link{EX}} and supplemental Exposure data \code{\link{SUPP}}}

\item{\code{su_l}}{Substance Use data \code{\link{SU}} and supplemental Substance Use data \code{\link{SUPP}}}
}}
\examples{
library(DBI)
library(sqldf)
studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")
db_dir <- file.path(studies_dir, "Db")
sqlite_conn <- dbConnect(SQLite(), dbname=file.path(db_dir, "ImmPort.sqlite"))
setImmPortDataSource(sqlite_conn)
sdy139 <- getStudy("SDY139")
cm_df <- sdy139$interventions$cm_l$cm_df
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GeneticsFindings.R
\name{SUPPPF}
\alias{SUPPPF}
\title{Genetics Findings Domain Supplemental Variables}
\description{
{
  \tabular{ll}{
    \strong{Variable Name} \tab \strong{Variable Label} \cr
    STUDYID \tab Study Identifier \cr
    RDOMAIN  \tab Related Domain Abbreviation \cr
    USUBJID \tab Unique Subject Identifier \cr
    IDVAR \tab Identifying Variable \cr
    IDVARVAL \tab Identifying Variable Value \cr
    QNAM \tab Qualifier Variable Name \cr
    QLABEL \tab Qualifier Variable Label \cr
    QVAL \tab Data Value
  }
}
}
\note{
The following table enumerates the values in QNAM and QLABEL variables {
  \tabular{ll}{
    \strong{QNAM} \tab \strong{QLABEL} \cr
    PFPOPAR \tab Geographic Area of the Population \cr
    PFSPECSB \tab Specimen Subtype \cr
    PFREFIDP \tab Source Specimen Identifier \cr
    VISITMIN \tab Planned Visit Minimum Start Day \cr
    VISITMAX \tab Planned Visit Maximum Start Day \cr
    PFSPTRT \tab Specimen Treatment \cr
    PFTRTAMV \tab Specimen Treatment Amount Value \cr
    PFTRTAMU \tab Specimen Treatment Amount Unit \cr
    PFTRTDUV \tab Specimen Treatment Duration Value \cr
    PFTRTDUU \tab Specimen Treatment Duration Unit \cr
    PFTRTTMV \tab Specimen Treatment Temperature Value \cr
    PFTRTTMU \tab Specimen Treatment Temperature Unit
  }
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TrialInclusionExclusionCriteria.R
\name{Trial Inclusion Exclusion Criteria Domain}
\alias{Trial Inclusion Exclusion Criteria Domain}
\title{Trial Inclusion Exclusion Criteria Domain}
\description{
The Trial Inclusion Exclusion Criteria data of an ImmPort study is reformated to the 
CDISC SDTM Trial Inclusion Exclusion Criteria (TI) domain model, and is a list of 2 data frames 
containing 1) Trial Inclusion Exclusion Criteria data \code{\link{TI}} 
and 2) any supplemental Trial Inclusion Exclusion Criteria data \code{\link{SUPP}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AdverseEvents.R
\name{Adverse Events Domain}
\alias{Adverse Events Domain}
\title{Adverse Events Domain}
\description{
The Adverse Events data of an ImmPort study is reformated to the CDISC SDTM Adverse 
Events (AE) domain model, and is a list of 2 data frames containing 1) Adverse Events data \code{\link{AE}} 
and 2) any supplemental Adverse Events data \code{\link{SUPP}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TiterAssayResults.R
\name{ZD}
\alias{ZD}
\title{Titer Assay Results Domain Variables}
\description{
{
  \tabular{ll}{
    \strong{Variable Name  } \tab \strong{Variable Label} \cr
    STUDYID \tab Study Identifier \cr
    DOMAIN  \tab Domain Abbreviation \cr
    USUBJID \tab Unique Subject Identifier \cr
    ZDSEQ \tab Sequence Number \cr
    ZDTEST \tab Titer Assay Results Test Name \cr
    ZDCAT \tab Category for Titer Assay Results \cr
    ZDMETHOD \tab Measurement Technique \cr
    ZDSTRAIN \tab Virus Strain \cr
    ZDORRES \tab Result or Finding in Original Units \cr
    ZDORRESU \tab Original Units \cr
    ZDSPEC \tab Specimen Type \cr
    ZDREFID \tab Specimen Identifier \cr
    VISITNUM \tab Visit Number \cr
    VISIT \tab Visit Name \cr
    ZDELTM \tab Planned Elapsed Time from Time Point Ref \cr
    ZDTPTREF \tab Time Point Reference \cr
    ZDXFN \tab Raw Data File or Life Science Identifier
  }
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PhysicalExamination.R
\name{PE}
\alias{PE}
\title{Physical Examination Domain Variables}
\description{
{
  \tabular{ll}{
    \strong{Variable Name  } \tab \strong{Variable Label} \cr
    STUDYID \tab Study Identifier \cr
    DOMAIN  \tab Domain Abbreviation \cr
    USUBJID \tab Unique Subject Identifier \cr
    PESEQ \tab Sequence Number \cr
    PETEST \tab Body System Examined \cr
    PECAT \tab Category for Examination \cr
    PEBODSYS \tab Body System or Organ Class \cr
    PEORRES \tab Verbatim Examination Finding \cr
    PEORRESU \tab Original Units \cr
    PELOC \tab Location of Physical Exam Finding \cr
    VISITNUM \tab Visit Number \cr
    VISIT \tab Visit Name \cr
    PEDY \tab Study Day of Examination
  }
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TrialArms.R
\name{TA}
\alias{TA}
\title{Trial Arms Domain Variables}
\description{
{
  \tabular{ll}{
    \strong{Variable Name  } \tab \strong{Variable Label} \cr
    STUDYID \tab Study Identifier \cr
    DOMAIN  \tab Domain Abbreviation \cr
    ARMCD \tab Planned Arm Code \cr
    ARM \tab Name of Planned Arm \cr
    ARMDESC \tab Description of Planned Arm \cr
    ARMRULE \tab Population Selection Rule
  }
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ProtocolDeviations.R
\name{Protocol Deviations Domain}
\alias{Protocol Deviations Domain}
\title{Protocol Deviations Domain}
\description{
The Protocol Deviations data of an ImmPort study is reformated to the CDISC SDTM 
Protocol Deviations (DV) domain model, and is a list of 2 data frames containing 1) Protocol 
Deviations data \code{\link{DV}} and 2) any supplemental Protocol Deviations data \code{\link{SUPPDV}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Study.R
\name{getStudiesWithSpecificAssayData}
\alias{getStudiesWithSpecificAssayData}
\title{Get a list of studies that have specific assay type data}
\usage{
getStudiesWithSpecificAssayData(assay_type, all_study_ids = c("ALL"))
}
\arguments{
\item{assay_type}{Assay Type}

\item{all_study_ids}{List of study indentifiers to search on}
}
\value{
List of study indentifiers
}
\description{
Get a list of studies that have specific assay type data
}
\examples{
library(DBI)
library(sqldf)
studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")
db_dir <- file.path(studies_dir, "Db")
sqlite_conn <- dbConnect(SQLite(), dbname=file.path(db_dir, "ImmPort.sqlite"))
setImmPortDataSource(sqlite_conn)
study_ids <- getStudiesWithSpecificAssayData("ELISPOT")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TrialSummary.R
\name{TS}
\alias{TS}
\title{Trial Summary Domain Variables}
\description{
{
  \tabular{ll}{
    \strong{Variable Name} \tab \strong{Variable Label} \cr
    STUDYID \tab Study Identifier \cr
    DOMAIN  \tab Domain Abbreviation \cr
    TSSEQ \tab Sequence Number \cr
    TSPARMCD \tab Trial Summary Parameter Short Name \cr
    TSPARM \tab Trial Summary Parameter \cr
    TSVAL \tab Parameter Value
  }
}
}
\note{
The following table enumerates the values in TSPARMCD and TSPARM variables {
  \tabular{ll}{
    \strong{TSPARMCD} \tab \strong{TSPARM} \cr
    TITLE \tab Trial Title \cr
    DESCR \tab Trial Description \cr
    INDIC \tab Trial Indication \cr
    TRT \tab Investigational Therapy or Treatment \cr
    HYPOTHS \tab Trial Hypotheses \cr
    SSTDTC \tab Study Start Date \cr
    SENDTC \tab Study End Date \cr
    PLANSUB \tab Planned Number of Subjects \cr
    ACTSUB \tab Actual Number of Subjects \cr
    AGEMAX \tab Planned Maximum Age of Subjects \cr
    AGEMIN \tab Planned Minimum Age of Subjects \cr
    AGEU \tab Age Units \cr
    SEXPOP \tab Sex of Participants \cr
    SPONSOR \tab Clinical Study Sponsor \cr
    PUBRLDAT \tab Public Release Date \cr
    ISTRIAL \tab Study Type \cr
    RESFOCUS \tab Trial Research Focus 
  }
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Study.R
\name{serialzeStudyData}
\alias{serialzeStudyData}
\title{Serialize the Study Data}
\usage{
serialzeStudyData(study_ids, data_dir)
}
\arguments{
\item{study_ids}{List of study indentifiers}

\item{data_dir}{Path to a file folder where the .rds study files will be saved into}
}
\value{
List of study indentifiers that were serialized successfully
}
\description{
Load specific studies from the database and save it in .rds format in 
a local file directory
}
\examples{
library(DBI)
library(sqldf)
studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")
db_dir <- file.path(studies_dir, "Db")
sqlite_conn <- dbConnect(SQLite(), dbname=file.path(db_dir, "ImmPort.sqlite"))
setImmPortDataSource(sqlite_conn)
# the folder where the .rds files will be stored
rds_dir <- file.path(studies_dir, "Rds")
study_ids <- c('SDY139', 'SDY208')
serialzeStudyData(study_ids, rds_dir)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Study.R
\docType{class}
\name{TrialDesign-class}
\alias{TrialDesign}
\alias{TrialDesign-class}
\title{Trial Design class}
\description{
Trial Design class
}
\section{Fields}{

\describe{
\item{\code{ta_l}}{Trial Arms data \code{\link{TA}} and supplemental Trial Arms data \code{\link{SUPP}}}

\item{\code{tv_l}}{Trial Visits data \code{\link{TA}} and supplemental Trial Visits data \code{\link{SUPP}}}

\item{\code{ti_l}}{Trial Inclusion Exclusion Criteria data \code{\link{TI}} and supplemental Trial Inclusion Exclusion Criteria data \code{\link{SUPP}}}

\item{\code{ts_l}}{Trial Summary data \code{\link{TS}} and supplemental Trial Summary data \code{\link{SUPP}}}
}}
\examples{
library(DBI)
library(sqldf)
studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")
db_dir <- file.path(studies_dir, "Db")
sqlite_conn <- dbConnect(SQLite(), dbname=file.path(db_dir, "ImmPort.sqlite"))
setImmPortDataSource(sqlite_conn)
sdy139 <- getStudy("SDY139")
ts_df <- sdy139$trial_design$ts_l$ts_df
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TrialInclusionExclusionCriteria.R
\name{TI}
\alias{TI}
\title{Trial Inclusion Exclusion Criteria Domain Variables}
\description{
{
  \tabular{ll}{
    \strong{Variable Name  } \tab \strong{Variable Label} \cr
    STUDYID \tab Study Identifier \cr
    DOMAIN  \tab Domain Abbreviation \cr
    IETEST \tab Inclusion/Exclusion Criterion \cr
    IECAT \tab Inclusion/Exclusion Category
  }
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/CellularQuantification.R
\name{Cellular Quantification Domain}
\alias{Cellular Quantification Domain}
\title{Cellular Quantification Domain}
\description{
The ImmPort study data generated from assays of types: Flow and ELISPOT are grouped into the 
Cellular Quantification Domain. The data is reformated to a custom Cellular Quantification domain model in 
CDISC SDTM standards, and is a list of 2 data frames containing 1) Cellular Quantification data \code{\link{ZB}} and 2) any supplemental 
  Cellular Quantification data \code{\link{SUPP}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MedicalHistory.R
\name{SUPPMH}
\alias{SUPPMH}
\title{Medical History Domain Supplemental Variables}
\description{
{
  \tabular{ll}{
    \strong{Variable Name} \tab \strong{Variable Label} \cr
    STUDYID \tab Study Identifier \cr
    RDOMAIN  \tab Related Domain Abbreviation \cr
    USUBJID \tab Unique Subject Identifier \cr
    MHSEQ \tab Sequence Number \cr
    IDVAR \tab Identifying Variable \cr
    IDVARVAL \tab Identifying Variable Value \cr
    QNAM \tab Qualifier Variable Name \cr
    QLABEL \tab Qualifier Variable Label \cr
    QVAL \tab Data Value
  }
}
}
\note{
The following table enumerates the values in QNAM and QLABEL variables {
  \tabular{ll}{
    \strong{QNAM} \tab \strong{QLABEL} \cr
    MHAGE \tab Age at Onset \cr
    MHAGEU \tab Age at Onset Units \cr
    MHTOD \tab Time of Day
  }
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/FindingsAbout.R
\name{FA}
\alias{FA}
\title{Findings About Domain Variables}
\description{
{
  \tabular{ll}{
    \strong{Variable Name  } \tab \strong{Variable Label} \cr
    STUDYID \tab Study Identifier \cr
    DOMAIN  \tab Domain Abbreviation \cr
    USUBJID \tab Unique Subject Identifier \cr
    FASEQ \tab Sequence Number \cr
    FATEST \tab Findings About Test Name \cr
    FAOBJ \tab Object of the Observation \cr
    FACAT \tab Category for Findings About \cr
    FAORRES \tab Results or Findings in Original Units \cr
    FAORRESU \tab Original Units \cr
    FALOC \tab Location of the Finding About \cr
    VISITNUM \tab Visit Number \cr
    VISIT \tab Visit Name \cr
    FADY \tab Study Day of Collection
  }
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GeneticsFindings.R
\name{PF}
\alias{PF}
\title{Genetics Findings Domain Variables}
\description{
{
  \tabular{ll}{
    \strong{Variable Name  } \tab \strong{Variable Label} \cr
    STUDYID \tab Study Identifier \cr
    DOMAIN  \tab Domain Abbreviation \cr
    USUBJID \tab Unique Subject Identifier \cr
    PFSEQ \tab Sequence Number \cr
    PFGRPID \tab Group Identifier \cr
    PFTEST \tab  Test Name \cr
    PFCAT \tab Category for Test \cr
    PFMETHOD \tab Method of the Test \cr
    PFGENRI \tab Genetic Region of Interest \cr
    PFORRES \tab Result or Finding in Original Units \cr
    PFALLELC \tab Allele (Chromosome) Identifier \cr
    PFSPEC \tab Specimen Type \cr
    PFREFID \tab Reference ID (Specimen Identifier) \cr
    VISITNUM \tab Visit Number \cr
    VISIT \tab Visit Name \cr
    PFELTM \tab Planned Elapsed Time from Time Point Ref \cr
    PFTPTREF \tab Time Point Reference \cr
    PFXFN \tab Raw Data File or Life Science Identifier
  }
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AdverseEvents.R
\name{AE}
\alias{AE}
\title{Adverse Events Domain Variables}
\description{
{
  \tabular{ll}{
    \strong{Variable Name  } \tab \strong{Variable Label} \cr
    STUDYID \tab Study Identifier \cr
    DOMAIN  \tab Domain Abbreviation \cr
    USUBJID \tab Unique Subject Identifier \cr
    AESEQ \tab Sequence Number \cr
    AESPID \tab Sponsor-Defined Identifier \cr
    AETERM \tab Reported Term for the Adverse Event \cr
    AEMODIFY \tab Modified Reported Term \cr
    AEBODYSYS \tab Body System or Organ Class \cr
    AELOC \tab Location of Event \cr
    AESEV \tab Severity/Intensity \cr
    AEACN \tab Action Taken with Study Treatment \cr
    AEACNOTH \tab Other Action Taken \cr
    AEREL \tab Causality \cr
    AERELNST \tab Relationship to Non-Study Treatment \cr
    AEOUT \tab Outcome of Adverse Event \cr
    AESTDY \tab Study Day of Start of Adverse Event \cr
    AEENDY \tab Study Day of End of Adverse Event
  }
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Study.R
\docType{class}
\name{Study-class}
\alias{Study}
\alias{Study-class}
\title{Study class}
\description{
Study class
}
\section{Fields}{

\describe{
\item{\code{special_purpose}}{\code{\link{SpecialPurpose}}}

\item{\code{interventions}}{\code{\link{Interventions}}}

\item{\code{events}}{\code{\link{Events}}}

\item{\code{findings}}{\code{\link{Findings}}}

\item{\code{trial_design}}{\code{\link{TrialDesign}}}
}}
\examples{
library(DBI)
library(sqldf)
studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")
db_dir <- file.path(studies_dir, "Db")
sqlite_conn <- dbConnect(SQLite(), dbname=file.path(db_dir, "ImmPort.sqlite"))
setImmPortDataSource(sqlite_conn)
sdy139 <- getStudy("SDY139")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Study.R
\name{mergeDomainAndSupplemental}
\alias{mergeDomainAndSupplemental}
\title{Merge the Domain dataframe and Supplemental dataframe (long form)}
\usage{
mergeDomainAndSupplemental(data_list)
}
\arguments{
\item{data_list}{A list of 1) Domain dataframe and 2) any Supplemental dataframe}
}
\value{
The merged dataframe
}
\description{
The Domain data list comprises of the the Domain datafrome that is in wide form, and any Supplemental
dataframe that is in long form. The function \code{mergeDomainAndSupplemental} transposes the Supplemental
dataframe into a wide form, and merges it with the Domain dataframe.
}
\examples{
library(DBI)
library(sqldf)
studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")
db_dir <- file.path(studies_dir, "Db")
sqlite_conn <- dbConnect(SQLite(), dbname=file.path(db_dir, "ImmPort.sqlite"))
setImmPortDataSource(sqlite_conn)
l <- getDomainDataOfStudies("Cellular Quantification", "SDY208")
df <- mergeDomainAndSupplemental(l)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Demographics.R
\name{Demographics Domain}
\alias{Demographics Domain}
\title{Demographics Domain}
\description{
The Demographics data of an ImmPort study is reformated to the CDISC SDTM Demographics (DM) 
domain model, and is a list of 2 data frames containing 1) Demographics data \code{\link{DM}} 
and 2) any supplemental Demographics data \code{\link{SUPP}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Study.R
\name{getDomainCode}
\alias{getDomainCode}
\title{Get code of a specific domain}
\usage{
getDomainCode(domain)
}
\arguments{
\item{domain}{Name of a specific domain}
}
\value{
A list of of all domain names and codes
}
\description{
The function \code{getListOfDomains} returns the code of a specific domain
}
\examples{
 domain <- "Demographics"
 code <- getDomainCode(domain)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NucleicAcidQuantification.R
\name{ZC}
\alias{ZC}
\title{Nucleic Acid Quantification Domain Variables}
\description{
{
  \tabular{ll}{
    \strong{Variable Name  } \tab \strong{Variable Label} \cr
    STUDYID \tab Study Identifier \cr
    DOMAIN  \tab Domain Abbreviation \cr
    USUBJID \tab Unique Subject Identifier \cr
    ZCSEQ \tab Sequence Number \cr
    ZCTEST \tab Nucleic Acid Quantification Test Name \cr
    ZCCAT \tab Category for Nucleic Acid Quantification \cr
    ZCMETHOD \tab Measurement Technique \cr
    ZCENTRZD \tab Entrez Gene ID \cr
    ZCGENNAM \tab Gene Name \cr
    ZCGENSYM \tab Gene Symbol \cr
    ZCORRES \tab Result or Finding in Original Units \cr
    ZCORRESU \tab Original Units \cr
    ZCSPEC \tab Specimen Type \cr
    ZCREFID \tab Specimen Identifier \cr
    VISITNUM \tab Visit Number \cr
    VISIT \tab Visit Name \cr
    ZCELTM \tab Planned Elapsed Time from Time Point Ref \cr
    ZCTPTREF \tab Time Point Reference
  }
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ProtocolDeviations.R
\name{DV}
\alias{DV}
\title{Protocol Deviations Domain Variables}
\description{
{
  \tabular{ll}{
    \strong{Variable Name  } \tab \strong{Variable Label} \cr
    STUDYID \tab Study Identifier \cr
    DOMAIN  \tab Domain Abbreviation \cr
    USUBJID \tab Unique Subject Identifier \cr
    DVSEQ \tab Sequence Number \cr
    DVTERM \tab Protocol Deviation Term
  }
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Study.R
\name{getListOfAssayTypes}
\alias{getListOfAssayTypes}
\title{Get a list of Assay Types}
\usage{
getListOfAssayTypes()
}
\value{
A list of assay types
}
\description{
The function \code{getListOfAssayTypes} returns a list of assay types that ImmPort studies have employed in their experimetal assays
}
\examples{
 at_l <- getListOfAssayTypes()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/FindingsAbout.R
\name{Findings About Domain}
\alias{Findings About Domain}
\title{Findings About Domain}
\description{
The Findings About data of an ImmPort study is reformated to the CDISC SDTM Findings 
About (FA) domain model, and is a list of 2 data frames containing 1) Findings About data \code{\link{FA}} 
and 2) any supplemental Findings About data \code{\link{SUPPFA}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SkinResponse.R
\name{SR}
\alias{SR}
\title{Skin Response Domain Variables}
\description{
{
  \tabular{ll}{
    \strong{Variable Name  } \tab \strong{Variable Label} \cr
    STUDYID \tab Study Identifier \cr
    DOMAIN  \tab Domain Abbreviation \cr
    USUBJID \tab Unique Subject Identifier \cr
    SRSEQ \tab Sequence Number \cr
    SRTEST \tab Skin Response Test or Examination Name \cr
    SROBJ \tab Object of the Observation \cr
    SRCAT \tab Category for Test \cr
    SRORRES \tab Results or Findings in Original Units \cr
    SRORRESU \tab Original Units \cr
    SRLOC \tab Location used for Measurement \cr
    VISITNUM \tab Visit Number \cr
    VISIT \tab Visit Name \cr
    SRDY \tab Study Day of Visit/Collection/Exam
  }
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ProteinQuantification.R
\name{ZA}
\alias{ZA}
\title{Protein Quantification Domain Variables}
\description{
{
  \tabular{ll}{
    \strong{Variable Name  } \tab \strong{Variable Label} \cr
    STUDYID \tab Study Identifier \cr
    DOMAIN  \tab Domain Abbreviation \cr
    USUBJID \tab Unique Subject Identifier \cr
    ZASEQ \tab Sequence Number \cr
    ZATEST \tab Protein Quantification Test Name \cr
    ZACAT \tab Category for Protein Quantification \cr
    ZAMETHOD \tab Measurement Technique \cr
    ZAANALYT \tab Analyte \cr
    ZAORRES \tab Result or Finding in Original Units \cr
    ZAORRESU \tab Original Units \cr
    ZASPEC \tab Specimen Type \cr
    VISITNUM \tab Visit Number \cr
    VISIT \tab Visit Name \cr
    ZAELTM \tab Planned Elapsed Time from Time Point Ref \cr
    ZATPTREF \tab Time Point Reference \cr
    ZAREFID \tab Specimen Identifier \cr
    ZAXFN \tab Raw Data File or Life Science Identifier
  }
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Study.R
\name{getDomainDataOfStudies}
\alias{getDomainDataOfStudies}
\title{Get specific domain data of one or more studies from the ImmPort database}
\usage{
getDomainDataOfStudies(domain, study_ids)
}
\arguments{
\item{domain}{Name of a specific domain}

\item{study_ids}{List of study indentifiers}
}
\value{
a list of 1) domain data and 2) supplemental domain data of the studies
}
\description{
Get specific domain data of one or more studies from the ImmPort database
}
\examples{
library(DBI)
library(sqldf)
studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")
db_dir <- file.path(studies_dir, "Db")
sqlite_conn <- dbConnect(SQLite(), dbname=file.path(db_dir, "ImmPort.sqlite"))
setImmPortDataSource(sqlite_conn)
dm_df <- getDomainDataOfStudies("Demographics", "SDY139")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Demographics.R
\name{DM}
\alias{DM}
\title{Demographics Domain Variables}
\description{
{
  \tabular{ll}{
    \strong{Variable Name  } \tab \strong{Variable Label} \cr
    STUDYID \tab Study Identifier \cr
    DOMAIN  \tab Domain Abbreviation \cr
    USUBJID \tab Unique Subject Identifier \cr
    AGE \tab Age \cr
    AGEU \tab Age Units \cr
    SEX \tab Sex \cr
    RACE \tab Race (only for human data) \cr
    ETHNIC \tab Ethnicity (only for human data) \cr
    SPECIES \tab Species (only for non-human data) \cr
    STRAIN \tab Strain/Substrain (only for non-human data) \cr
    SBSTRAIN \tab Strain/Substrain Details (only for non-human data) \cr
    ARMCD \tab Planned Arm Code \cr
    ARM \tab Description of Planned Arm
  }
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Exposure.R
\name{Exposure Domain}
\alias{Exposure Domain}
\title{Exposure Domain}
\description{
The Exposure data of an ImmPort study is reformated to the CDISC SDTM Exposure (EX) 
domain model, and is a list of 2 data frames containing 1) Exposure data \code{\link{EX}} 
and 2) any supplemental Exposure data \code{\link{SUPP}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ConcomitantMedications.R
\name{Concomitant Medications Domain}
\alias{Concomitant Medications Domain}
\title{Concomitant Medications Domain}
\description{
The Concomitant Medications data of an ImmPort study is reformated to the CDISC SDTM 
Concomitant Medications (CM) domain model, and is a list of 2 data frames containing 
1) Concomitant Medications data \code{\link{CM}} and 2) any supplemental Concomitant 
Medications data \code{\link{SUPP}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GeneticsFindings.R
\name{Genetics Findings Domain}
\alias{Genetics Findings Domain}
\title{Genetics Findings Domain}
\description{
The ImmPort study data generated from assays of types: HLA Typing and Array are grouped into the 
Genetics Findings Domain. The data is reformated to  a PharmacoGenomics and Genetics Findings (PF) model in 
CDISC SDTM standards, and is a list of 2 data frames containing 1) Genetics Findings data \code{\link{PF}} 
and 2) any supplemental Genetics Findings data \code{\link{SUPP}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Study.R
\name{getListOfStudies}
\alias{getListOfStudies}
\title{Get a list of all studies}
\usage{
getListOfStudies()
}
\value{
List of study indentifiers
}
\description{
Get a list of all studies
}
\examples{
library(DBI)
library(sqldf)
studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")
db_dir <- file.path(studies_dir, "Db")
sqlite_conn <- dbConnect(SQLite(), dbname=file.path(db_dir, "ImmPort.sqlite"))
setImmPortDataSource(sqlite_conn)
study_ids <- getListOfStudies()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ConcomitantMedications.R
\name{CM}
\alias{CM}
\title{Concomitant Medications Domain Variables}
\description{
{
  \tabular{ll}{
    \strong{Variable Name  } \tab \strong{Variable Label} \cr
    STUDYID \tab Study Identifier \cr
    DOMAIN  \tab Domain Abbreviation \cr
    USUBJID \tab Unique Subject Identifier \cr
    CMSEQ \tab Sequence Number \cr
    CMTRT \tab Reported Name of Drug, Med, or Therapy \cr
    CMCAT \tab Category for Medication \cr
    CMDOSE \tab Dose per Administration \cr
    CMDOSTXT \tab Dose Description \cr
    CMDOSU \tab Dose Units \cr
    CMDOSFREQ \tab Dosing Frequency per Interval  \cr
    CMROUTE \tab Route of Administration \cr
    CMSTDTC \tab Start Date/Time of Medication \cr
    CMENDTC \tab End Date/Time of Medication \cr
    CMSTDY \tab Study Day of Start of Medication \cr
    CMENDY \tab Study Day of End of Medication
  }
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Study.R
\name{getStudy}
\alias{getStudy}
\title{Get all data of a specific study from the ImmPort data source}
\usage{
getStudy(study_id)
}
\arguments{
\item{study_id}{Identifier of a specific study}
}
\value{
A study data object where in all data are structured as classes, domains, variables and values (in CDISC format)
}
\description{
The function \code{getStudy} queries the ImmPort data source for data of a specific study in 
all domains. The data is then structured into \code{Study} as classes, domains, variables and values.
}
\examples{
library(DBI)
library(sqldf)
studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")
db_dir <- file.path(studies_dir, "Db")
sqlite_conn <- dbConnect(SQLite(), dbname=file.path(db_dir, "ImmPort.sqlite"))
setImmPortDataSource(sqlite_conn)
sdy139 <- getStudy("SDY139")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SubstanceUse.R
\name{SU}
\alias{SU}
\title{Substance Use Domain Variables}
\description{
{
  \tabular{ll}{
    \strong{Variable Name  } \tab \strong{Variable Label} \cr
    STUDYID \tab Study Identifier \cr
    DOMAIN  \tab Domain Abbreviation \cr
    USUBJID \tab Unique Subject Identifier \cr
    SUSEQ \tab Sequence Number \cr
    SUTRT \tab Reported Name of Substance \cr
    SUCAT \tab Category of Substance Use \cr
    SUDOSE \tab Substance Use Consumption \cr
    SUDOSTXT \tab Substance Use Consumption Text \cr
    SUDOSU \tab Consumption Units \cr
    SUDOSFRQ \tab Use Frequency per Interval \cr
    SUROUTE \tab Route of Administration \cr
    SUSTDTC \tab Start Date/Time of Substance Use \cr
    SUENDTC \tab End Date/Time of Substance Use \cr
    SUSTDY \tab Study Day of Start of Substance Use \cr
    SUENDY \tab Study Day of End of Substance Use
  }
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/VitalSigns.R
\name{VS}
\alias{VS}
\title{Vital Signs Domain Variables}
\description{
{
  \tabular{ll}{
    \strong{Variable Name  } \tab \strong{Variable Label} \cr
    STUDYID \tab Study Identifier \cr
    DOMAIN  \tab Domain Abbreviation \cr
    USUBJID \tab Unique Subject Identifier \cr
    VSSEQ \tab Sequence Number \cr
    VSTEST \tab Vital Signs Test Name \cr
    VSCAT \tab Category for Vital Signs \cr
    VSORRES \tab Result or Finding in Original Units \cr
    VSORRESU \tab Original Units \cr
    VSLOC \tab Location of Vital Signs Measurement \cr
    VISITNUM \tab Visit Number \cr
    VISIT \tab Visit Name \cr
    VSDY \tab Study Day of Vital Signs
  }
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MedicalHistory.R
\name{Medical History Domain}
\alias{Medical History Domain}
\title{Medical History Domain}
\description{
The Medical History data of an ImmPort study is reformated to the CDISC SDTM Medical 
History (MH) domain model, and is a list of 2 data frames containing 1) Medical History 
data \code{\link{MH}} and 2) any supplemental Medical History data \code{\link{SUPPMH}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RImmPort.R
\docType{package}
\name{RImmPort}
\alias{RImmPort}
\alias{RImmPort-package}
\title{RImmPort: Enabling ready-for-analysis immunology research data}
\description{
The `RImmPort` package simplifies access to ImmPort data for analysis, 
as the name implies, in the R statistical environment. It provides a 
standards-based interface to the ImmPort study data that is in a proprietary format.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Study.R
\name{getAssayDataOfStudies}
\alias{getAssayDataOfStudies}
\title{Get specific assay data of one or more studies from the ImmPort database}
\usage{
getAssayDataOfStudies(study_ids, assay_type)
}
\arguments{
\item{study_ids}{List of study indentifiers}

\item{assay_type}{Assay Type}
}
\value{
a list of 1) domain data of specicifc assay technology and 2) any supplemental domain data of the studies
}
\description{
Get specific assay data of one or more studies from the ImmPort database
}
\examples{
library(DBI)
library(sqldf)
studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")
db_dir <- file.path(studies_dir, "Db")
sqlite_conn <- dbConnect(SQLite(), dbname=file.path(db_dir, "ImmPort.sqlite"))
setImmPortDataSource(sqlite_conn)
elispot_l <- getAssayDataOfStudies("SDY139", "ELISPOT")
if (length(elispot_l) > 0)
  names(elispot_l)
head(elispot_l$zb_df)
}
\author{
Ravi Shankar
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TrialSummary.R
\name{Trial Summary Domain}
\alias{Trial Summary Domain}
\title{Trial Summary Domain}
\description{
The Trial Summary data of an ImmPort study is reformated to the CDISC SDTM Trial Summary (TS) 
domain model, and is a list of 2 data frames containing 1) Trial Summary data \code{\link{TS}} 
and 2) any supplemental Trial Summary data \code{\link{SUPP}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NucleicAcidQuantification.R
\name{Nucleic Acid Quantification Domain}
\alias{Nucleic Acid Quantification Domain}
\title{Nucleic Acid Quantification Domain}
\description{
The ImmPort study data generated from assays of types: PCR are grouped into the 
Nucleic Acid Quantification Domain. The data is reformated to a custom Nucleic Acid Quantification domain model in 
CDISC SDTM standards, and is a list of 2 data frames containing 1) Nucleic Acid Quantification data \code{\link{ZC}} and 2) any supplemental 
  Nucleic Acid Quantification data \code{\link{SUPP}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LaboratoryTestResults.R
\name{Laboratory Test Results Domain}
\alias{Laboratory Test Results Domain}
\title{Laboratory Test Results Domain}
\description{
The Laboratory Test Results data of an ImmPort study is reformated to the CDISC SDTM 
Laboratory Test Results (LB) domain model, and is a list of 2 data frames containing 1) Laboratory 
Test Results data \code{\link{LB}} and 2) any supplemental Laboratory Test Results data \code{\link{SUPPLB}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ProtocolDeviations.R
\name{SUPPDV}
\alias{SUPPDV}
\title{Protocol Deviations Domain Supplemental Variables}
\description{
{
  \tabular{ll}{
    \strong{Variable Name} \tab \strong{Variable Label} \cr
    STUDYID \tab Study Identifier \cr
    RDOMAIN  \tab Related Domain Abbreviation \cr
    USUBJID \tab Unique Subject Identifier \cr
    IDVAR \tab Identifying Variable \cr
    IDVARVAL \tab Identifying Variable Value \cr
    QNAM \tab Qualifier Variable Name \cr
    QLABEL \tab Qualifier Variable Label \cr
    QVAL \tab Data Value
  }
}
}
\note{
The following table enumerates the values in QNAM and QLABEL variables {
  \tabular{ll}{
    \strong{QNAM} \tab \strong{QLABEL} \cr
    DVRELAE \tab Is Deviation Related to an Adverse Event? \cr
    DVREASON \tab Reason for Deviation \cr
    DVRESOL \tab Resulotion of Deviation \cr
    DVCONT \tab Did Subject continued in Study? \cr
    DVSTDY \tab Study Day of Start of Deviation \cr
    DVENDY \tab Study Day of End of Deviation
  }
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MedicalHistory.R
\name{MH}
\alias{MH}
\title{Medical History Domain Variables}
\description{
{
  \tabular{ll}{
    \strong{Variable Name  } \tab \strong{Variable Label} \cr
    
    STUDYID \tab Study Identifier \cr
    DOMAIN  \tab Domain Abbreviation \cr
    USUBJID \tab Unique Subject Identifier \cr
    MHSEQ \tab Sequence Number \cr
    MHTERM \tab Reported Term for the Medical History \cr
    MHCAT \tab Category for Medical History \cr
    MHBODSYS \tab Body System or Organ Class \cr
    MHDY \tab Study Day of History Collection
  }
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LaboratoryTestResults.R
\name{SUPPLB}
\alias{SUPPLB}
\title{Laboratory Test Results Domain Supplemental Variables}
\description{
{
  \tabular{ll}{
    \strong{Variable Name} \tab \strong{Variable Label} \cr
    STUDYID \tab Study Identifier \cr
    RDOMAIN  \tab Related Domain Abbreviation \cr
    USUBJID \tab Unique Subject Identifier \cr
    IDVAR \tab Identifying Variable \cr
    IDVARVAL \tab Identifying Variable Value \cr
    QNAM \tab Qualifier Variable Name \cr
    QLABEL \tab Qualifier Variable Label \cr
    QVAL \tab Data Value
  }
}
}
\note{
The following table enumerates the values in QNAM and QLABEL variables {
  \tabular{ll}{
    \strong{QNAM} \tab \strong{QLABEL} \cr
    LBSPECSB \tab Specimen Subtype \cr
    VISITMIN \tab Planned Visit Minimum Start Day \cr
    VISITMAX \tab Planned Visit Maximum Start Day
  }
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Study.R
\docType{class}
\name{SpecialPurpose-class}
\alias{SpecialPurpose}
\alias{SpecialPurpose-class}
\title{Special Purpose class}
\description{
Special Purpose class
}
\section{Fields}{

\describe{
\item{\code{dm_l}}{Demographics data \code{\link{DM}} and supplemental Demographics data \code{\link{SUPP}}}
}}
\examples{
library(DBI)
library(sqldf)
studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")
db_dir <- file.path(studies_dir, "Db")
sqlite_conn <- dbConnect(SQLite(), dbname=file.path(db_dir, "ImmPort.sqlite"))
setImmPortDataSource(sqlite_conn)
sdy139 <- getStudy("SDY139")
dm_df <- sdy139$special_purpose$dm_l$dm_df
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TiterAssayResults.R
\name{Titer Assay Results Domain}
\alias{Titer Assay Results Domain}
\title{Titer Assay Results Domain}
\description{
The ImmPort study data generated from assays of types: HAI and Neut Ab Titer are grouped into the 
Titer Assay Results Domain. The data is reformated to a custom Titer Assay Results domain model in 
CDISC SDTM standards, and is a list of 2 data frames containing 1) Titer Assay Results data \code{\link{ZD}} 
and 2) any supplemental Titer Assay Results data \code{\link{SUPP}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AssociatedPersonsMedicalHistory.R
\name{Associated Persons Medical History Domain}
\alias{Associated Persons Medical History Domain}
\title{Associated Persons Medical History Domain}
\description{
The Associated Persons Medical History data of an ImmPort study is reformated to the CDISC 
SDTM AAssociated Persons Medical History (APMH) domain model, and is a list of 2 data frames 
containing 1) Associated Persons Medical History data \code{\link{APMH}} and 2) any supplemental 
Associated Persons Medical History data \code{\link{SUPP}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Study.R
\name{getListOfDomains}
\alias{getListOfDomains}
\title{Get names of all domains and their codes}
\usage{
getListOfDomains()
}
\value{
A list of of all domain names and codes
}
\description{
The function \code{getListOfDomains} returns a list of all domain names and codes
}
\examples{
 domains_df <- getListOfDomains()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ProteinQuantification.R
\name{Protein Quantification Domain}
\alias{Protein Quantification Domain}
\title{Protein Quantification Domain}
\description{
The ImmPort study data generated from assays of types: ELISA and MBAA are grouped into the 
Cellular Quantification Domain. The data is reformated to a custom Protein Quantification domain model in 
CDISC SDTM standards, and is a list of 2 data frames containing 1) Protein Quantification data \code{\link{ZA}} 
and 2) any supplemental Protein Quantification data \code{\link{SUPP}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AssociatedPersonsMedicalHistory.R
\name{APMH}
\alias{APMH}
\title{Associated Persons Medical History Domain Variables}
\description{
{
  \tabular{ll}{
    \strong{Variable Name  } \tab \strong{Variable Label} \cr
    
    STUDYID \tab Study Identifier \cr
    DOMAIN  \tab Domain Abbreviation \cr
    APID \tab Associated Persons Identifier \cr
    MHSEQ \tab Sequence Number \cr
    RSUBJID \tab Related Subject \cr
    SREL \tab Subject Relationship \cr
    MHTERM \tab Reported Term for the Medical History \cr
    MHCAT \tab Category for Medical History \cr
    MHBODSYS \tab Body System or Organ Class \cr
    MHDTC \tab Date/Time of History Collection \cr
    MHDY \tab RStudy Day of History Collection
  }
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Questionnaires.R
\name{Questionnaires Domain}
\alias{Questionnaires Domain}
\title{Questionnaires Domain}
\description{
The Questionnaires data of an ImmPort study is reformated to the CDISC SDTM 
Questionnaires (QS) domain model, and is a list of 2 data frames containing 1) Questionnaires 
data \code{\link{QS}} and 2) any supplemental Questionnaires data \code{\link{SUPP}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SkinResponse.R
\name{Skin Response Domain}
\alias{Skin Response Domain}
\title{Skin Response Domain}
\description{
The Skin Response data of an ImmPort study is reformated to the CDISC SDTM Skin Response (SR) 
domain model, and is a list of 2 data frames containing 1) Skin Response data \code{\link{SR}} 
and 2) any supplemental Skin Response data \code{\link{SUPP}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Study.R
\docType{class}
\name{Findings-class}
\alias{Findings}
\alias{Findings-class}
\title{Findings class}
\description{
Findings class
}
\section{Fields}{

\describe{
\item{\code{lb_l}}{Laboratory Test Results data \code{\link{LB}} and supplemental Laboratory Test Results data \code{\link{SUPPLB}}}

\item{\code{pe_l}}{Physical Examination data \code{\link{PE}} and supplemental Physical Examination data \code{\link{SUPPPE}}}

\item{\code{vs_l}}{Vital Signs data \code{\link{VS}} and supplemental Vital Signs data \code{\link{SUPPVS}}}

\item{\code{qs_l}}{Questionnaires data \code{\link{QS}} and supplemental Questionnaires data \code{\link{SUPP}}}

\item{\code{fa_l}}{Findings About data \code{\link{FA}} and supplemental Findings About data \code{\link{SUPPFA}}}

\item{\code{sr_l}}{Skin Response data \code{\link{SR}} and supplemental Skin Response data \code{\link{SUPP}}}

\item{\code{pf_l}}{Genetics Findings data \code{\link{PF}} and supplemental Genetics Findings data \code{\link{SUPPPF}}}

\item{\code{za_l}}{Protein Quantification data \code{\link{ZA}} and supplemental Protein Quantification data \code{\link{SUPPZA}}}

\item{\code{zb_l}}{Cellular Quantification data \code{\link{ZB}} and supplemental Cellular Quantification data \code{\link{SUPP}}}

\item{\code{zc_l}}{Nucleic Acid Quantification data \code{\link{ZC}} and supplemental Nucleic Acid Quantification data \code{\link{SUPP}}}

\item{\code{zd_l}}{Titer Assay Results data \code{\link{ZD}} and supplemental Titer Assay Results data \code{\link{SUPP}}}
}}
\examples{
library(DBI)
library(sqldf)
studies_dir <- system.file("extdata", "ImmPortStudies", package = "RImmPort")
db_dir <- file.path(studies_dir, "Db")
sqlite_conn <- dbConnect(SQLite(), dbname=file.path(db_dir, "ImmPort.sqlite"))
setImmPortDataSource(sqlite_conn)
sdy139 <- getStudy("SDY139")
zb_df <- sdy139$findings$zb_l$zb_df
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TrialArms.R
\name{Trial Arms Domain}
\alias{Trial Arms Domain}
\title{Trial Arms Domain}
\description{
The Trial Arms data of an ImmPort study is reformated to the CDISC SDTM Trial Arms (TA) 
domain model, and is a list of 2 data frames containing 1) Trial Arms data \code{\link{TA}} 
and 2) any supplemental Trial Arms data \code{\link{SUPP}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LaboratoryTestResults.R
\name{LB}
\alias{LB}
\title{Laboratory Test Results Domain Variables}
\description{
{
  \tabular{ll}{
    \strong{Variable Name  } \tab \strong{Variable Label} \cr
    STUDYID \tab Study Identifier \cr
    DOMAIN  \tab Domain Abbreviation \cr
    USUBJID \tab Unique Subject Identifier \cr
    LBSEQ \tab Sequence Number \cr
    LBTEST \tab Lab Test or Examination Name \cr
    LBCAT \tab Category for Lab Test \cr
    LBORRES \tab Result or Finding in Original Units \cr
    LBORRESU \tab Original Units \cr
    LBSPEC \tab Specimen Type \cr
    LBREFID \tab Specimen Identifier \cr
    VISITNUM \tab Visit Number \cr
    VISIT \tab Visit Name \cr
    LBELTM \tab Planned Elapsed Time from Time Point Ref \cr
    LBTPTREF \tab Time Point Reference
  }
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Exposure.R
\name{EX}
\alias{EX}
\title{Exposure Domain Variables}
\description{
{
  \tabular{ll}{
    \strong{Variable Name  } \tab \strong{Variable Label} \cr
    STUDYID \tab Study Identifier \cr
    DOMAIN  \tab Domain Abbreviation \cr
    USUBJID \tab Unique Subject Identifier \cr
    EXSEQ \tab Sequence Number \cr
    EXTRT \tab Name of Treatment \cr
    EXCAT \tab Category of Treatment \cr
    EXDOSE \tab Dose \cr
    EXDOSTXT \tab Dose Description \cr
    EXDOSU \tab Dose Units \cr
    EXDOSFRQ \tab Dosing Frequency per Interval \cr
    EXROUTE \tab Route of Administration \cr
    EXSTDTC \tab Start Date/Time of Treatment \cr
    EXENDTC \tab End Date/Time of Treatment \cr
    EXSTDY \tab Study Day of Start of Treatment \cr
    EXENDY \tab Study Day of End of Treatment
  }
}
}
